# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""
Probabilistic distributions.
"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_dist_bundle3', [dirname(__file__)])
        except ImportError:
            import _dist_bundle3
            return _dist_bundle3
        if fp is not None:
            try:
                _mod = imp.load_module('_dist_bundle3', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _dist_bundle3 = swig_import_helper()
    del swig_import_helper
else:
    import _dist_bundle3
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _dist_bundle3.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self): return _dist_bundle3.SwigPyIterator_value(self)
    def incr(self, n=1): return _dist_bundle3.SwigPyIterator_incr(self, n)
    def decr(self, n=1): return _dist_bundle3.SwigPyIterator_decr(self, n)
    def distance(self, *args): return _dist_bundle3.SwigPyIterator_distance(self, *args)
    def equal(self, *args): return _dist_bundle3.SwigPyIterator_equal(self, *args)
    def copy(self): return _dist_bundle3.SwigPyIterator_copy(self)
    def next(self): return _dist_bundle3.SwigPyIterator_next(self)
    def __next__(self): return _dist_bundle3.SwigPyIterator___next__(self)
    def previous(self): return _dist_bundle3.SwigPyIterator_previous(self)
    def advance(self, *args): return _dist_bundle3.SwigPyIterator_advance(self, *args)
    def __eq__(self, *args): return _dist_bundle3.SwigPyIterator___eq__(self, *args)
    def __ne__(self, *args): return _dist_bundle3.SwigPyIterator___ne__(self, *args)
    def __iadd__(self, *args): return _dist_bundle3.SwigPyIterator___iadd__(self, *args)
    def __isub__(self, *args): return _dist_bundle3.SwigPyIterator___isub__(self, *args)
    def __add__(self, *args): return _dist_bundle3.SwigPyIterator___add__(self, *args)
    def __sub__(self, *args): return _dist_bundle3.SwigPyIterator___sub__(self, *args)
    def __iter__(self): return self
SwigPyIterator_swigregister = _dist_bundle3.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

GCC_VERSION = _dist_bundle3.GCC_VERSION
class TestFailed:
    """TestFailed is used to raise an uniform exception in tests."""

    __type = "TestFailed"

    def __init__(self, reason=""):
        self.reason = reason

    def type(self):
        return TestFailed.__type

    def what(self):
        return self.reason

    def __str__(self):
        return TestFailed.__type + ": " + self.reason

    def __lshift__(self, ch):
        self.reason += ch
        return self

import openturns.base
import openturns.common
import openturns.wrapper
import openturns.typ
import openturns.statistics
import openturns.graph
import openturns.func
import openturns.geom
import openturns.diff
import openturns.optim
import openturns.solver
import openturns.algo
import openturns.experiment
import openturns.model_copula
class Poisson(openturns.model_copula.DiscreteDistribution):
    """
    Poisson distribution.

    Available constructors:
        Poisson(*lambda=1.0*)

    Parameters
    ----------
    lambda : float, :math:`\\lambda > 0`
        Mean and variance value.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        \\Prob{X = k} = \\frac{\\lambda^k}{k!}\\;e^{-\\lambda}, \\,  k \\in \\Nset

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\lambda \\\\
            \\Var{X} & = & sqrt{\\lambda}
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Poisson(10.)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Poisson, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Poisson, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Poisson_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Poisson___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Poisson___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Poisson___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Poisson_getRealization(self)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Poisson_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Poisson_computeCDF(self, *args)

    def computeComplementaryCDF(self, *args):
        """
        Compute the complementary cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            Complementary CDF input(s).

        Returns
        -------
        C : float, :class:`~openturns.NumericalPoint`
            Complementary CDF value(s) at input(s) `X`.

        Notes
        -----
        The complementary cumulative distribution function.

        .. math::

            1 - F_{\\vect{X}}(\\vect{x}) = 1 - \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i}, \\quad \\vect{x} \\in \\supp{\\vect{X}}

        .. warning::
            This is not the survival function (except for 1-dimensional
            distributions).

        See Also
        --------
        computeSurvivalFunction
        """
        return _dist_bundle3.Poisson_computeComplementaryCDF(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Poisson_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Poisson_computeCDFGradient(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.Poisson_computeCharacteristicFunction(self, *args)

    def computeLogCharacteristicFunction(self, *args):
        """
        Compute the logarithm of the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Logarithm of the characteristic function value at input `t`.

        Notes
        -----
        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.

        See Also
        --------
        computeCharacteristicFunction
        """
        return _dist_bundle3.Poisson_computeLogCharacteristicFunction(self, *args)

    def computeGeneratingFunction(self, *args):
        """
        Compute the probability-generating function.

        Parameters
        ----------
        z : float or complex
            Probability-generating function input.

        Returns
        -------
        g : float
            Probability-generating function value at input `X`.

        Notes
        -----
        The probability-generating function is defined as follows:

        .. math::

            G_X(z) = \\Expect{z^X}, \\quad z \\in \\Cset

        This function only exists for discrete distributions. OpenTURNS implements
        this method for univariate distributions only.

        See Also
        --------
        isDiscrete
        """
        return _dist_bundle3.Poisson_computeGeneratingFunction(self, *args)

    def computeLogGeneratingFunction(self, *args):
        """
        Compute the logarithm of the probability-generating function.

        Parameters
        ----------
        z : float or complex
            Probability-generating function input.

        Returns
        -------
        lg : float
            Logarithm of the probability-generating function value at input `X`.

        Notes
        -----
        This function only exists for discrete distributions. OpenTURNS implements
        this method for univariate distributions only.

        See Also
        --------
        isDiscrete, computeGeneratingFunction
        """
        return _dist_bundle3.Poisson_computeLogGeneratingFunction(self, *args)

    def getSupport(self, *args):
        """
        Accessor to the distribution's support.

        Parameters
        ----------
        interval : :class:`~openturns.Interval`
            An interval to intersect with the distribution's support.

        Returns
        -------
        support : :class:`~openturns.Interval`
            The intersection of the distribution's support with the given `interval`.

        Notes
        -----
        The mathematical support :math:`\\supp{\\vect{X}}` of the distribution is
        the interval (or collection of intervals) where the PDF is non-zero.

        This is yet implemented for discrete distributions only.

        See Also
        --------
        getRange
        """
        return _dist_bundle3.Poisson_getSupport(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Poisson_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Poisson_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Poisson_getKurtosis(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Poisson_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Poisson_setParametersCollection(self, *args)

    def setLambda(self, *args):
        """
        Accessor to the distribution's mean and variance value.

        Parameters
        ----------
        lambda : float
            Distribution's mean and variance value.
        """
        return _dist_bundle3.Poisson_setLambda(self, *args)

    def getLambda(self):
        """
        Accessor to the distribution's mean and variance value.

        Returns
        -------
        lambda : float
            Distribution's mean and variance value.
        """
        return _dist_bundle3.Poisson_getLambda(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_Poisson(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Poisson
    __del__ = lambda self : None;
Poisson_swigregister = _dist_bundle3.Poisson_swigregister
Poisson_swigregister(Poisson)

class PoissonFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PoissonFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PoissonFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.PoissonFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.PoissonFactory_build(self, *args)
    def buildAsPoisson(self, *args): return _dist_bundle3.PoissonFactory_buildAsPoisson(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_PoissonFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_PoissonFactory
    __del__ = lambda self : None;
PoissonFactory_swigregister = _dist_bundle3.PoissonFactory_swigregister
PoissonFactory_swigregister(PoissonFactory)

class ProductDistribution(openturns.model_copula.ContinuousDistribution):
    """
    Product distribution.

    Helper class for defining the push-forward distribution of a given univariate distribution by a given scalar function.

    Available constructors:
        ProductDistribution(*distX, distY*)

    Parameters
    ----------

    distX : :class:`~openturns.Distribution`, univariate
        Independant of `distY`

    distY : :class:`~openturns.Distribution`, univariate
        Independant of `distX`

    Returns
    -------
    distZ : :class:`~openturns.Distribution`, univariate
        :math:`distZ` is the distribution of the random variable :math:`Z = XY` when :math:`(X,Y)` is a random vector with independant copula and respective marginal distributions `distX` and `distY`.


    Notes
    -----
    We note :math:`Z=XY` the scalar random variable which distribution is :math:`f_Z`.
     
    .. math::

        \\displaystyle f_Z(z) = \\int_{\\Rset} f_X (t) f_{Y}(\\dfrac{z}{t}) \\, \\dfrac{dt}{|t|}

    with :math:`f_X`,  and :math:`f_Y` the probability density functions of :math:`X`  and :math:`Y`.

    Its first moments, if finite, are defined as: 

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{Z} & = &  \\Expect{X} \\Expect{Y} \\\\
            \\Var{Z} & = & \\Expect{X}^2 \\Var{Y} +  \\Expect{Y}^2 \\Var{X} + \\Var{X}  \\Var{Y} 
        \\end{eqnarray*}


    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distX = ot.Normal(-1.0, 1.0)
    >>> distY = ot.Uniform(-1.0, 1.0)
    >>> distZ = ot.ProductDistribution(distX, distY)


    Draw the PDF:

    >>> pdfdistZ = distZ.drawPDF()

    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProductDistribution, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProductDistribution, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.ProductDistribution_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.ProductDistribution___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.ProductDistribution___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.ProductDistribution___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.ProductDistribution_getRealization(self)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.ProductDistribution_computePDF(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.ProductDistribution_computeCharacteristicFunction(self, *args)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.ProductDistribution_getParametersCollection(self)

    def setLeft(self, *args): return _dist_bundle3.ProductDistribution_setLeft(self, *args)
    def getLeft(self):
        """
        Accessor to the left distribution of the product.

        Returns
        -------
        distX :  :class:`~openturns.Distribution`.
        """
        return _dist_bundle3.ProductDistribution_getLeft(self)

    def setRight(self, *args): return _dist_bundle3.ProductDistribution_setRight(self, *args)
    def getRight(self):
        """
        Accessor to the right distribution of the product.

        Returns
        -------
        distY :  :class:`~openturns.Distribution`.
        """
        return _dist_bundle3.ProductDistribution_getRight(self)

    def isContinuous(self):
        """
        Test whether the distribution is continuous or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.ProductDistribution_isContinuous(self)

    def isDiscrete(self):
        """
        Test whether the distribution is discrete or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.ProductDistribution_isDiscrete(self)

    def isIntegral(self):
        """
        Test whether the distribution is integer-valued or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.ProductDistribution_isIntegral(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_ProductDistribution(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_ProductDistribution
    __del__ = lambda self : None;
ProductDistribution_swigregister = _dist_bundle3.ProductDistribution_swigregister
ProductDistribution_swigregister(ProductDistribution)

class RandomMixture(openturns.model_copula.DistributionImplementation):
    """
    RandomMixture distribution.

    Available constructors:
        RandomMixture(*coll, cst*)

        RandomMixture(*coll, weights, cst*)

        RandomMixture(*coll, weightsMatrix*)

        RandomMixture(*coll, weightsMatrix, constant*)


    Parameters
    ----------
    coll : DistributionCollection
        The collection of distributions that model the random vector.
    cst : float
        Constant coefficient of the affine expression in dimension 1.
        Default value is zero.
    weights :  1d array like
        Weights of the affine combination in dimension 1.
    constant :  1d array like
        Constant vector of the affine expression.
        Its size should be equal to the dimension of the distribution.
        Default value is (0,...,0).
    weightsMatrix :  2d array like
        Weights of the affine combination.

    Notes
    -----
    Create an affine combination of input random variables of form:
        :math:`Y = y_0 + M X`
    where: :math:`\\vect{Y}` of size :math:`d\\, :math:`d\\in \\{1,2,3\\}`
           :math:`\\vect{X}' is a :math:`n`-random vector with independent components, i.e. a
           collection of univariate distributions,

           :math:`\\mat{M}` is a :math:`d \\times n` deterministic matrix, i.e. the linear
           operator of the affine transformation,

           :math:`\\vect{y}_0` a constant and deterministic vector,  i.e the constant
           part of the affine transformation.

    As the univariate random variables :math:`X_i` are independent, the
    characteristic function of :math:`\\vect{Y}`, denoted :math:`\\phi_Y`, is
    easily defined from the characteristic function of :math:`X_k` denoted
    :math:`\\phi_{X_k}` as follows :

    .. math::

        \\phi(z_1,...,z_d) =  \\prod_{j=1}^d {\\exp(\\imath z_j {y_0}_j)} \\prod_{k=1}^n \\phi_{X_k}((\\Tr{\\mat{M}} z)_k)

    It is possible to evaluate its density probability function once the
    characteristic function evaluated, using the Poisson summation formula:

    .. math::

        \\sum_{j_1 \\in \\mathbb{Z}}\\hdots \\sum_{j_d \\in \\mathbb{Z}} p(y_1 + 2\\pi j_1/h_1,\\hdots,y_d + 2\\pi j_d/h_d) = (h_1\\hdots h_d)/(2^d \\pi^d) \\sum_{k_1 \\in \\mathbb{Z}}\\hdots \\sum_{k_d \\in \\mathbb{Z}} \\phi(k_1 h_1,\\hdots,k_d h_d)\\exp(-\\imath(k_1 h_1+\\hdots+k_d h_d))

    For :math:`h_i` small enough, the nested sums of the left term are reduced
    to the central term :math:`j_1=\\hdots=j_d = 0`.
    Thus, the density is approximated by:

    .. math::

        p(y_1,\\hdots,y_d) = (h_1\\hdots h_d)/(2^d \\pi^d) \\sum_{|k_1| \\leq N}\\hdots \\sum_{|k_d| \\leq N} \\phi(k_1 h_1,\\hdots,k_d h_d)\\exp(-\\imath(k_1 h_1+\\hdots+k_d h_d))

    The nested sums of the right term are computed by blocks of form
    :math:`2^b \\leq k < 2^{b+1}`, and are truncated when the contribution of a
    block becomes lower than a threshold, which can be changed by
    setPDFPrecision method.
    Two other methods also may change the number of iterations; setBlockMin
    sets the block number from which truncation is possible, which means that
    computations are always performed for blocks lower than this parameter,
    even if their contributions are very small.  On the other hand, setBlockMax
    sets the maximum number of blocks, which can be useful to make sure that
    computations run in a limited time.

    Note that the total number of evaluations of the characteristic function to
    compute up to block :math:`b` is equivalent to :math:`2^{dim \\times (b+1)}`, so
    it is important to ensure that this number has some reasonable value.

    Note finally that the characteristic function evaluations are independent
    from :math:`\\vect{y}=(y_1,\\hdots,y_d)`: these values are stored in a cache.


    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{\\vect{Y}}  & = & \\vect{y}_0 + \\mat{M}\\Expect{\\vect{X}} \\\\
            \\Cov{Y}  & = & \\mat{M} \\Cov{X} \\Tr{\\mat{M}}
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.RandomMixture([ot.Normal(), ot.Uniform()])

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RandomMixture, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RandomMixture, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.RandomMixture_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.RandomMixture___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.RandomMixture___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.RandomMixture___str__(self, offset)
    def getDistributionCollection(self):
        """
        Return the list of distributions used.

        In dimension 1, some analytical aggregations may be performed on
        distributions to improve performance, and collection may differ from the
        one originally given by user.

        Returns
        -------
        coll : DistributionCollection
            The collection of univariate distributions used for the combination

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # Sum of two Uniform here is a Triangular
        >>> coll = distribution.getDistributionCollection()
        >>> print(coll)
        [Triangular(a = -2, m = 0, b = 2)]
        """
        return _dist_bundle3.RandomMixture_getDistributionCollection(self)

    def getFFTAlgorithm(self): return _dist_bundle3.RandomMixture_getFFTAlgorithm(self)
    def setFFTAlgorithm(self, *args): return _dist_bundle3.RandomMixture_setFFTAlgorithm(self, *args)
    def setConstant(self, *args):
        """
        Set the constant term of the affine combination.

        Parameters
        ----------
        vect : :class:`~openturns.NumericalPoint` or 1d array like
            The constant term

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # Set the new constant term is 0
        >>> distribution.setConstant([1.0])
        """
        return _dist_bundle3.RandomMixture_setConstant(self, *args)

    def getConstant(self):
        """
        Return the vector of the affine combination.

        Returns
        -------
        out : :class:`~openturns.NumericalPoint`
            The constant term

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # Constant term is 0
        >>> cst = distribution.getConstant()
        >>> print(cst)
        [0]
        """
        return _dist_bundle3.RandomMixture_getConstant(self)

    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.RandomMixture_getRealization(self)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.RandomMixture_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.RandomMixture_computePDF(self, *args)

    def getMarginal(self, *args):
        """
        Accessor to marginal distributions.

        Parameters
        ----------
        i : int or list of ints, :math:`1 \\leq i \\leq n`
            Component(s) indice(s).

        Returns
        -------
        distribution : :class:`~openturns.Distribution`
            The marginal distribution of the selected component(s).
        """
        return _dist_bundle3.RandomMixture_getMarginal(self, *args)

    def computeComplementaryCDF(self, *args):
        """
        Compute the complementary cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            Complementary CDF input(s).

        Returns
        -------
        C : float, :class:`~openturns.NumericalPoint`
            Complementary CDF value(s) at input(s) `X`.

        Notes
        -----
        The complementary cumulative distribution function.

        .. math::

            1 - F_{\\vect{X}}(\\vect{x}) = 1 - \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i}, \\quad \\vect{x} \\in \\supp{\\vect{X}}

        .. warning::
            This is not the survival function (except for 1-dimensional
            distributions).

        See Also
        --------
        computeSurvivalFunction
        """
        return _dist_bundle3.RandomMixture_computeComplementaryCDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.RandomMixture_computeCDF(self, *args)

    def computeProbability(self, *args):
        """
        Compute the interval probability.

        Parameters
        ----------
        interval : :class:`~openturns.Interval`
            An interval, possibly multivariate.

        Returns
        -------
        P : float
            Interval probability.

        Notes
        -----
        This computes the probability that the random vector :math:`\\vect{X}` lies in
        the hyper-rectangular region formed by the vectors :math:`\\vect{a}` and
        :math:`\\vect{b}`:

        .. math::

            \\Prob{\\bigcap\\limits_{i=1}^n a_i < X_i \\leq b_i} =
                \\sum\\limits_{\\vect{c}} (-1)^{n(\\vect{c})}
                    F_{\\vect{X}}\\left(\\vect{c}\\right)

        where the sum runs over the :math:`2^n` vectors such that
        :math:`\\vect{c} = \\Tr{(c_i, i = 1, \\ldots, n)}` with :math:`c_i \\in [a_i, b_i]`,
        and :math:`n(\\vect{c})` is the number of components in
        :math:`\\vect{c}` such that :math:`c_i = a_i`.
        """
        return _dist_bundle3.RandomMixture_computeProbability(self, *args)

    def computeQuantile(self, *args):
        """
        Compute the quantile function.

        Parameters
        ----------
        p : float, :math:`0 < p < 1`
            Quantile function input (a probability).

        Returns
        -------
        X : :class:`~openturns.NumericalPoint`
            Quantile at probability level `p`.

        Notes
        -----
        The quantile function is also known as the inverse cumulative distribution
        function:

        .. math::

            Q_{\\vect{X}}(p) = F_{\\vect{X}}^{-1}(p),
                              \\quad p \\in [0; 1]
        """
        return _dist_bundle3.RandomMixture_computeQuantile(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.RandomMixture_computeCharacteristicFunction(self, *args)

    def computeLogCharacteristicFunction(self, *args):
        """
        Compute the logarithm of the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Logarithm of the characteristic function value at input `t`.

        Notes
        -----
        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.

        See Also
        --------
        computeCharacteristicFunction
        """
        return _dist_bundle3.RandomMixture_computeLogCharacteristicFunction(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.RandomMixture_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.RandomMixture_computeCDFGradient(self, *args)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.RandomMixture_getParametersCollection(self)

    def getWeights(self):
        """
        Return the weights of the combination as a Matrix.

        Returns
        -------
        out : :class:`~openturns.Matrix`
            The element of affine transformation

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # weights
        >>> w = distribution.getWeights()
        >>> print(w)
        [[ 1 ]]
        """
        return _dist_bundle3.RandomMixture_getWeights(self)

    def getPositionIndicator(self):
        """**(ditch me?)**"""
        return _dist_bundle3.RandomMixture_getPositionIndicator(self)

    def getDispersionIndicator(self):
        """**(ditch me?)**"""
        return _dist_bundle3.RandomMixture_getDispersionIndicator(self)

    def setBlockMin(self, *args):
        """
        Set the blockMin parameter.

        Parameters
        ----------
        blockMin : int
            Number of minimal evaluations of blocks for characteristic function evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> distribution.setBlockMin(4)
        """
        return _dist_bundle3.RandomMixture_setBlockMin(self, *args)

    def getBlockMin(self):
        """
        Return the blockMin parameter.

        Returns
        -------
        blockMin : int
            Number of minimal evaluations of blocks for characteristic function evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # blockMin
        >>> blockMin = distribution.getBlockMin()
        >>> print(blockMin)
        3
        """
        return _dist_bundle3.RandomMixture_getBlockMin(self)

    def setBlockMax(self, *args):
        """
        Set the blockMax parameter.

        Returns
        -------
        blockMax : int
            Number of maximal evaluations of blocks for characteristic function
            evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> distribution.setBlockMax(14)
        """
        return _dist_bundle3.RandomMixture_setBlockMax(self, *args)

    def getBlockMax(self):
        """
        Return the blockMax parameter.

        Returns
        -------
        blockMax : int
            Number of maximal evaluations of blocks for characteristic function evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # blockMax
        >>> blockMax = distribution.getBlockMax()
        >>> print(blockMax)
        16
        """
        return _dist_bundle3.RandomMixture_getBlockMax(self)

    def setMaxSize(self, *args):
        """
        Set the maximum size of cache for characteristic function evaluations.

        Parameters
        ----------
        size : int
            Maximum size of cache for characteristic function evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> size = pow(2,15)
        >>> distribution.setMaxSize(size)
        """
        return _dist_bundle3.RandomMixture_setMaxSize(self, *args)

    def getMaxSize(self):
        """
        Return the maximum size of cache for characteristic function evaluations.

        Returns
        -------
        size : int
            Maximum size of cache for characteristic function evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # default cache size
        >>> size = distribution.getMaxSize()
        >>> print(size)
        65536
        """
        return _dist_bundle3.RandomMixture_getMaxSize(self)

    def setAlpha(self, *args):
        """
        Set the a priori range of PDF and CDF arguments in terms of standard deviation.

        Parameters
        ----------
        alpha : float
            A Priori range of PDF/CDF

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> alpha = 8.0
        >>> distribution.setAlpha(alpha)
        """
        return _dist_bundle3.RandomMixture_setAlpha(self, *args)

    def getAlpha(self):
        """
        Return the priori range of PDF and CDF argument.

        It is expressed in dispersionIndicator units.

        Returns
        -------
        alpha : float
            A Priori range of PDF/CDF

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # alpha
        >>> alpha = distribution.getAlpha()
        >>> print(alpha)
        5.0
        """
        return _dist_bundle3.RandomMixture_getAlpha(self)

    def setBeta(self, *args):
        """
        Set the distance of the a priori range at which the PDF is negligible.

        Parameters
        ----------
        beta : float
            Distance from the boundary of the a priori range

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> beta = 8.0
        >>> distribution.setBeta(beta)
        """
        return _dist_bundle3.RandomMixture_setBeta(self, *args)

    def getBeta(self):
        """
        Return the distance of the a priori range at which the PDF is negligible.

        Returns
        -------
        beta : float
            Distance from the boundary of the a priori range

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # beta
        >>> beta = distribution.getBeta()
        >>> print(beta)
        8.5
        """
        return _dist_bundle3.RandomMixture_getBeta(self)

    def setReferenceBandwidth(self, *args):
        """
        Set the reference bandwidth.

        Parameters
        ----------
        bw : :class:`~openturns.NumericalPoint` or 1d array like
            The reference bandwidth

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> bw = [0.75]
        >>> distribution.setReferenceBandwidth(bw)
        """
        return _dist_bundle3.RandomMixture_setReferenceBandwidth(self, *args)

    def getReferenceBandwidth(self):
        """
        Return the reference bandwidth.

        It is the maximum bandwidth that allows an accurate computation
        of the PDF over the range :math:`[mean \\pm \\beta\\sigma]`.

        Returns
        -------
        out : :class:`~openturns.NumericalPoint`
            The reference bandwidth

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> # bw
        >>> bw = distribution.getReferenceBandwidth()
        >>> print(bw)
        [0.785398]
        """
        return _dist_bundle3.RandomMixture_getReferenceBandwidth(self)

    def setPDFPrecision(self, *args):
        """
        Set the requested precision for PDF computation.

        Parameters
        ----------
        eps : float
            Precision for density evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> eps = 1.e-12
        >>> distribution.setPDFPrecision(eps)
        """
        return _dist_bundle3.RandomMixture_setPDFPrecision(self, *args)

    def setCDFPrecision(self, *args):
        """
        Set the requested precision for CDF computation.

        Parameters
        ----------
        eps : float
            Precision for cumulative function evaluations

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Uniform(-1.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> eps = 1.e-12
        >>> distribution.setCDFPrecision(eps)
        """
        return _dist_bundle3.RandomMixture_setCDFPrecision(self, *args)

    def project(self, *args):
        """
        Project a RandomMixture distribution over a collection of DistributionFactory.

        Uses sampling and Kolmogorov distance.

        Parameters
        ----------
        coll : :class:`~openturns.DistributionFactoryCollection`
            The collection of factories
        kolmogorovNorm: :class:`~openturns.NumericalPoint`
            The Kolmogorov norms
        size : int
            Size of projection

        Returns
        -------
        out : tuple of size 2:
            First element is a collection of :class:`~openturns.Distribution`,
            and second element is a :class:`~openturns.NumericalPoint` containing
            the Kolmogorov norm of the projection over its factory.

        Examples
        --------
        >>> import openturns as ot
        >>> distribution = ot.RandomMixture([ot.Normal(0.0, 1.0), ot.Uniform(-1.0, 1.0)])
        >>> coll = [ot.NormalFactory(), ot.UniformFactory()]
        >>> dist, kolmogorovNorm = distribution.project(coll)

        """
        return _dist_bundle3.RandomMixture_project(self, *args)

    def hasIndependentCopula(self):
        """
        Test whether the distribution's copula is independent.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.RandomMixture_hasIndependentCopula(self)

    def hasEllipticalCopula(self):
        """
        Test whether the distribution's copula is elliptical or not.

        Returns
        -------
        test : bool
            Answer.

        See Also
        --------
        isElliptical
        """
        return _dist_bundle3.RandomMixture_hasEllipticalCopula(self)

    def isElliptical(self):
        """
        Test whether the distribution is elliptical or not.

        Returns
        -------
        test : bool
            Answer.

        Notes
        -----
        A multivariate distribution is said to be *elliptical* if its characteristic
        function is of the form:

        .. math::

            \\phi(\\vect{t}) = \\exp\\left(i \\Tr{\\vect{t}} \\vect{\\mu}\\right)
                             \\Psi\\left(\\Tr{\\vect{t}} \\mat{\\Sigma} \\vect{t}\\right),
                             \\quad \\vect{t} \\in \\Rset^n

        for specified vector :math:`\\vect{\\mu}` and positive-definite matrix
        :math:`\\mat{\\Sigma}`. The function :math:`\\Psi` is known as the
        *characteristic generator* of the elliptical distribution.
        """
        return _dist_bundle3.RandomMixture_isElliptical(self)

    def isContinuous(self):
        """
        Test whether the distribution is continuous or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.RandomMixture_isContinuous(self)

    def isDiscrete(self):
        """
        Test whether the distribution is discrete or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.RandomMixture_isDiscrete(self)

    def isIntegral(self):
        """
        Test whether the distribution is integer-valued or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.RandomMixture_isIntegral(self)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.RandomMixture_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.RandomMixture_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.RandomMixture_getKurtosis(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_RandomMixture(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_RandomMixture
    __del__ = lambda self : None;
RandomMixture_swigregister = _dist_bundle3.RandomMixture_swigregister
RandomMixture_swigregister(RandomMixture)

class Rayleigh(openturns.model_copula.ContinuousDistribution):
    """
    Rayleigh distribution.

    Available constructors:
        Rayleigh(*sigma=1.0, gamma=0.*)

    Parameters
    ----------
    sigma : float, :math:`\\sigma > 0`
        Scale parameter :math:`\\sigma`.
    gamma : float
        Location parameter :math:`\\gamma`.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = \\frac{(x - \\gamma)} {\\sigma^2}
                 exp \\left(-\\frac{(x - \\gamma)^2}{2\\sigma^2}\\right)
                 \\quad x \\in [\\gamma,+\\infty[

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\sigma sqrt{\\frac{\\pi}{2}} + \\gamma \\\\
            \\Var{X} & = & \\frac{4 - \\pi}{2} \\sigma^2
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Poisson(10.)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Rayleigh, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Rayleigh, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Rayleigh_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Rayleigh___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Rayleigh___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Rayleigh___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Rayleigh_getRealization(self)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Rayleigh_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Rayleigh_computePDF(self, *args)

    def computeLogPDF(self, *args):
        """
        Compute the logarithm of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            Logarithm of the PDF value(s) at input(s) `X`.
        """
        return _dist_bundle3.Rayleigh_computeLogPDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Rayleigh_computeCDF(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.Rayleigh_computeCharacteristicFunction(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Rayleigh_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Rayleigh_computeCDFGradient(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Rayleigh_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Rayleigh_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Rayleigh_getKurtosis(self)

    def getStandardMoment(self, *args):
        """
        Accessor to the componentwise standard moments.

        Parameters
        ----------
        k : int
            The standard moment's order.

        Returns
        -------
        m : :class:`~openturns.NumericalPoint`
            Componentwise standard moment of order `k`.

        Notes
        -----
        Standard moments are centered with respect to the first-order moment and
        normalized with respect to the standard deviation:

        .. math::

            \\overline{\\vect{m}}^{(k)}_0 =
                \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                             {\\sigma_i}\\right)^k},
                \\quad i = 1, \\ldots, n\\right)}

        See Also
        --------
        getMean, getStandardDeviation
        """
        return _dist_bundle3.Rayleigh_getStandardMoment(self, *args)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.Rayleigh_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Rayleigh_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Rayleigh_setParametersCollection(self, *args)

    def setSigma(self, *args):
        """
        Accessor to the distribution's scale parameter :math:`\\sigma`.

        Parameters
        ----------
        sigma : float, :math:`\\sigma > 0`
            Scale parameter :math:`\\sigma`.
        """
        return _dist_bundle3.Rayleigh_setSigma(self, *args)

    def getSigma(self):
        """
        Accessor to the distribution's scale parameter :math:`\\sigma`.

        Returns
        -------
        sigma : float
            Scale parameter :math:`\\sigma`.
        """
        return _dist_bundle3.Rayleigh_getSigma(self)

    def setGamma(self, *args):
        """
        Accessor to the distribution's location parameter :math:`\\gamma`.

        Parameters
        ----------
        gamma : float
            Location parameter :math:`\\gamma`.
        """
        return _dist_bundle3.Rayleigh_setGamma(self, *args)

    def getGamma(self):
        """
        Accessor to the distribution's location parameter :math:`\\gamma`.

        Returns
        -------
        gamma : float
            Location parameter :math:`\\gamma`.
        """
        return _dist_bundle3.Rayleigh_getGamma(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_Rayleigh(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Rayleigh
    __del__ = lambda self : None;
Rayleigh_swigregister = _dist_bundle3.Rayleigh_swigregister
Rayleigh_swigregister(Rayleigh)

class RayleighFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RayleighFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RayleighFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.RayleighFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.RayleighFactory_build(self, *args)
    def buildAsRayleigh(self, *args): return _dist_bundle3.RayleighFactory_buildAsRayleigh(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_RayleighFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_RayleighFactory
    __del__ = lambda self : None;
RayleighFactory_swigregister = _dist_bundle3.RayleighFactory_swigregister
RayleighFactory_swigregister(RayleighFactory)

class Rice(openturns.model_copula.ContinuousDistribution):
    """
    Rice distribution.

    Available constructors:
        Rice(*sigma=1.0, nu=0.*)

    Parameters
    ----------
    sigma : float, :math:`\\sigma > 0`
        Scale parameter.
    nu : float, :math:`\\nu \\geq 0`
        Location parameter.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = 2\\frac{x}{\\sigma^2}p_{\\chi^2(2,\\frac{\\nu^2}{\\sigma^2})}
                 \\left(\\frac{x^2}{\\sigma^2}\\right),
                 \\quad x \\in [0; +\\infty[

    where :math:`p_{\\chi^2(\\nu, \\lambda)}` is the probability density function of a
    :class:`~openturns.NonCentralChiSquare` distribution.

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\sigma \\sqrt{\\frac{\\pi}{2}}
                             L_{1/2}\\left(-\\frac{\\nu^2}{2\\sigma^2}\\right) \\\\
            \\Var{X} & = & 2\\sigma^2 + \\nu^2 - \\frac{\\pi\\sigma^2}{2}
                          L_{1/2}^2\\left(\\frac{-\\nu^2}{2\\sigma^2}\\right)
        \\end{eqnarray*}

    where :math:`L_q(x)` denotes a Laguerre polynomial.

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Rice()

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Rice, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Rice, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Rice_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Rice___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Rice___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Rice___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Rice_getRealization(self)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Rice_computePDF(self, *args)

    def computeLogPDF(self, *args):
        """
        Compute the logarithm of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            Logarithm of the PDF value(s) at input(s) `X`.
        """
        return _dist_bundle3.Rice_computeLogPDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Rice_computeCDF(self, *args)

    def computeComplementaryCDF(self, *args):
        """
        Compute the complementary cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            Complementary CDF input(s).

        Returns
        -------
        C : float, :class:`~openturns.NumericalPoint`
            Complementary CDF value(s) at input(s) `X`.

        Notes
        -----
        The complementary cumulative distribution function.

        .. math::

            1 - F_{\\vect{X}}(\\vect{x}) = 1 - \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i}, \\quad \\vect{x} \\in \\supp{\\vect{X}}

        .. warning::
            This is not the survival function (except for 1-dimensional
            distributions).

        See Also
        --------
        computeSurvivalFunction
        """
        return _dist_bundle3.Rice_computeComplementaryCDF(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Rice_getStandardDeviation(self)

    def getStandardMoment(self, *args):
        """
        Accessor to the componentwise standard moments.

        Parameters
        ----------
        k : int
            The standard moment's order.

        Returns
        -------
        m : :class:`~openturns.NumericalPoint`
            Componentwise standard moment of order `k`.

        Notes
        -----
        Standard moments are centered with respect to the first-order moment and
        normalized with respect to the standard deviation:

        .. math::

            \\overline{\\vect{m}}^{(k)}_0 =
                \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                             {\\sigma_i}\\right)^k},
                \\quad i = 1, \\ldots, n\\right)}

        See Also
        --------
        getMean, getStandardDeviation
        """
        return _dist_bundle3.Rice_getStandardMoment(self, *args)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.Rice_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Rice_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Rice_setParametersCollection(self, *args)

    def setSigma(self, *args):
        """
        Accessor to the distribution's scale parameter :math:`\\sigma`.

        Parameters
        ----------
        sigma : float, :math:`\\sigma > 0`
            Scale parameter :math:`\\sigma`.
        """
        return _dist_bundle3.Rice_setSigma(self, *args)

    def getSigma(self):
        """
        Accessor to the distribution's scale parameter :math:`\\sigma`.

        Returns
        -------
        sigma : float
            Scale parameter :math:`\\sigma`.
        """
        return _dist_bundle3.Rice_getSigma(self)

    def setNu(self, *args):
        """
        Accessor to the distribution's location parameter :math:`\\nu`.

        Parameters
        ----------
        nu : float, :math:`\\nu >= 0`
            Location parameter :math:`\\nu`.
        """
        return _dist_bundle3.Rice_setNu(self, *args)

    def getNu(self):
        """
        Accessor to the distribution's location parameter :math:`\\nu`.

        Returns
        -------
        nu : float
            Location parameter :math:`\\nu`.
        """
        return _dist_bundle3.Rice_getNu(self)

    def setMaximumIteration(self, *args): return _dist_bundle3.Rice_setMaximumIteration(self, *args)
    def getMaximumIteration(self): return _dist_bundle3.Rice_getMaximumIteration(self)
    def __init__(self, *args): 
        this = _dist_bundle3.new_Rice(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Rice
    __del__ = lambda self : None;
Rice_swigregister = _dist_bundle3.Rice_swigregister
Rice_swigregister(Rice)

class RiceFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RiceFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RiceFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.RiceFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.RiceFactory_build(self, *args)
    def buildAsRice(self, *args): return _dist_bundle3.RiceFactory_buildAsRice(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_RiceFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_RiceFactory
    __del__ = lambda self : None;
RiceFactory_swigregister = _dist_bundle3.RiceFactory_swigregister
RiceFactory_swigregister(RiceFactory)

class Skellam(openturns.model_copula.DiscreteDistribution):
    """
    Skellam distribution.

    Available constructors:
        Skellam(*lambda1=1.0, lambda2=1.0*)

    Parameters
    ----------
    lambda1 : float, :math:`\\lambda_1 > 0`
        First :class:`~openturns.Poisson` distribution's parameter.

    lambda2 : float, :math:`\\lambda_2 > 0`
        Second :class:`~openturns.Poisson` distribution's parameter.

    Notes
    -----
    The Skellan distribution takes its values in :math:`\\Zset`.
    It is the distribution of :math:`(X_1 - X_2)` for :math:`(X_1, X_2)` independant
    and respectively distributed according to Poisson(:math:`\\lambda_i`).

    Its probability density function is defined as:

    .. math::

        \\Prob{X = k} = 2 \\Prob{Y = 2 \\lambda_1},
                       \\quad \\forall k \\in \\Zset

    where Y is distributed according to the :class:`~openturns.NonCentralChiSquare`
    distribution :math:`\\chi^2_{\\nu, \\delta}`, with :math:`\\nu=2(k+1)` and
    :math:`\\delta=2\\lambda_2`.

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\lambda_1 - \\lambda_2 \\\\
            \\Var{X} & = & \\lambda_1 + \\lambda_2
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Skellam(10., 5.)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Skellam, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Skellam, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Skellam_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Skellam___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Skellam___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Skellam___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Skellam_getRealization(self)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Skellam_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Skellam_computeCDF(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Skellam_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Skellam_computeCDFGradient(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.Skellam_computeCharacteristicFunction(self, *args)

    def computeLogCharacteristicFunction(self, *args):
        """
        Compute the logarithm of the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Logarithm of the characteristic function value at input `t`.

        Notes
        -----
        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.

        See Also
        --------
        computeCharacteristicFunction
        """
        return _dist_bundle3.Skellam_computeLogCharacteristicFunction(self, *args)

    def computeGeneratingFunction(self, *args):
        """
        Compute the probability-generating function.

        Parameters
        ----------
        z : float or complex
            Probability-generating function input.

        Returns
        -------
        g : float
            Probability-generating function value at input `X`.

        Notes
        -----
        The probability-generating function is defined as follows:

        .. math::

            G_X(z) = \\Expect{z^X}, \\quad z \\in \\Cset

        This function only exists for discrete distributions. OpenTURNS implements
        this method for univariate distributions only.

        See Also
        --------
        isDiscrete
        """
        return _dist_bundle3.Skellam_computeGeneratingFunction(self, *args)

    def computeLogGeneratingFunction(self, *args):
        """
        Compute the logarithm of the probability-generating function.

        Parameters
        ----------
        z : float or complex
            Probability-generating function input.

        Returns
        -------
        lg : float
            Logarithm of the probability-generating function value at input `X`.

        Notes
        -----
        This function only exists for discrete distributions. OpenTURNS implements
        this method for univariate distributions only.

        See Also
        --------
        isDiscrete, computeGeneratingFunction
        """
        return _dist_bundle3.Skellam_computeLogGeneratingFunction(self, *args)

    def computeScalarQuantile(self, *args):
        """
        Compute the quantile function for univariate distributions.

        Parameters
        ----------
        p : float, :math:`0 < p < 1`
            Quantile function input (a probability).

        Returns
        -------
        X : float
            Quantile at probability level `p`.

        Notes
        -----
        The quantile function is also known as the inverse cumulative distribution
        function:

        .. math::

            Q_X(p) = F_X^{-1}(p), \\quad p \\in [0; 1]

        See Also
        --------
        computeQuantile
        """
        return _dist_bundle3.Skellam_computeScalarQuantile(self, *args)

    def getSupport(self, *args):
        """
        Accessor to the distribution's support.

        Parameters
        ----------
        interval : :class:`~openturns.Interval`
            An interval to intersect with the distribution's support.

        Returns
        -------
        support : :class:`~openturns.Interval`
            The intersection of the distribution's support with the given `interval`.

        Notes
        -----
        The mathematical support :math:`\\supp{\\vect{X}}` of the distribution is
        the interval (or collection of intervals) where the PDF is non-zero.

        This is yet implemented for discrete distributions only.

        See Also
        --------
        getRange
        """
        return _dist_bundle3.Skellam_getSupport(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Skellam_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Skellam_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Skellam_getKurtosis(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Skellam_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Skellam_setParametersCollection(self, *args)

    def setLambda1Lambda2(self, *args):
        """
        Accessor to the Poisson distributions' parameters.

        Namely :math:`\\lambda_1` and :math:`\\lambda_2`.

        Parameters
        ----------
        lambda1 : float, :math:`\\lambda_1 >0`
            First Poisson distribution's parameter :math:`\\lambda_1`.
        lambda2 : float, :math:`\\lambda_2 >0`
            Second Poisson distribution's parameter :math:`\\lambda_2`.
        """
        return _dist_bundle3.Skellam_setLambda1Lambda2(self, *args)

    def setLambda1(self, *args):
        """
        Accessor to the first Poisson distribution's parameter :math:`\\lambda_1`.

        Parameters
        ----------
        lambda1 : float, :math:`\\lambda_1 >0`
            First Poisson distribution's parameter :math:`\\lambda_1`.
        """
        return _dist_bundle3.Skellam_setLambda1(self, *args)

    def getLambda1(self):
        """
        Accessor to the first Poisson distribution's parameter :math:`\\lambda_1`.

        Returns
        -------
        lambda1 : float
            First Poisson distribution's parameter :math:`\\lambda_1`.
        """
        return _dist_bundle3.Skellam_getLambda1(self)

    def setLambda2(self, *args):
        """
        Accessor to the second Poisson distribution's parameter :math:`\\lambda_2`.

        Parameters
        ----------
        lambda2 : float, :math:`\\lambda_2 >0`
            Second Poisson distribution's parameter :math:`\\lambda_2`.
        """
        return _dist_bundle3.Skellam_setLambda2(self, *args)

    def getLambda2(self):
        """
        Accessor to the second Poisson distribution's parameter :math:`\\lambda_2`.

        Returns
        -------
        lambda2 : float
            Second Poisson distribution's parameter :math:`\\lambda_2`.
        """
        return _dist_bundle3.Skellam_getLambda2(self)

    def setMaximumIteration(self, *args): return _dist_bundle3.Skellam_setMaximumIteration(self, *args)
    def getMaximumIteration(self): return _dist_bundle3.Skellam_getMaximumIteration(self)
    def __init__(self, *args): 
        this = _dist_bundle3.new_Skellam(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Skellam
    __del__ = lambda self : None;
Skellam_swigregister = _dist_bundle3.Skellam_swigregister
Skellam_swigregister(Skellam)

class SkellamFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SkellamFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SkellamFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.SkellamFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.SkellamFactory_build(self, *args)
    def buildAsSkellam(self, *args): return _dist_bundle3.SkellamFactory_buildAsSkellam(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_SkellamFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_SkellamFactory
    __del__ = lambda self : None;
SkellamFactory_swigregister = _dist_bundle3.SkellamFactory_swigregister
SkellamFactory_swigregister(SkellamFactory)

class Student(openturns.model_copula.EllipticalDistribution):
    """
    Student distribution.

    Available constructors:
        Student(*nu=3.0, d=1*)

        Student(*nu, mu, sigma=1.0*)

        Student(*nu, mu, sigma, R*)

    Parameters
    ----------
    d : int, :math:`d \\geq 1`
        Dimension.
    nu : float, :math:`\\nu > 0`
        Generalised number degrees of freedom.
    mu : float :math:`\\mu`, :class:`~openturns.NumericalPoint` or 1d-array, :math:`\\vect{\\mu} \\in \\Rset^d`, optional
        If :math:`\\nu > 1`: mean.

        If :math:`\\nu = 1`: location parameter.

        Default is :math:`\\vect{\\mu} = (0, \\dots, 0) \\in \\Rset^d`.
    sigma : float :math:`\\sigma`, :class:`~openturns.NumericalPoint` or 1d-array, :math:`\\vect{\\sigma} \\in \\Rset^{*d}_+`, optional
        Scale parameter.

        Default is :math:`\\vect{\\sigma} = (1, \\dots, 1) \\in \\Rset^d`.
    R : :class:`~openturns.CorrelationMatrix` :math:`\\mat{R} \\in \\Rset^d \\times \\Rset^d`, optional
        If :math:`\\nu > 2`: correlation matrix.

        If :math:`\\nu \\leq 2`: generalized correlation matrix.

        Default is :math:`\\mat{R} = I_d \\in \\Rset^d \\times \\Rset^d`.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = \\frac{\\Gamma \\left(\\frac{\\nu + d}{2}\\right)}
                      {(\\pi \\nu) ^ {\\frac{d}{2}} \\Gamma \\left(\\frac{\\nu}{2}\\right)}
                 \\frac{\\left| \\mathrm{det}(\\mat{R}) \\right| ^ {-1/2}}
                      {\\prod_{k = 1} ^ d \\sigma_k}
                 \\left(1 + \\frac{\\vect{z} ^ t \\mat{R} ^ {-1} \\vect{z}}{\\nu}
                 \\right) ^ {-\\frac{\\nu + d}{2}}, \\quad x \\in \\Rset

    with :math:`\\nu > 0, d \\geq 1, \\mat{R} \\in \\Rset^d \\times \\Rset^d,
    \\sigma_k > 0, k=1, \\dots, d` .

    where :math:`\\vect{z}=\\mat{\\Delta}^{-1}\\left(\\vect{x}-\\vect{\\mu}\\right)`, 
    :math:`\\mat{\\Delta} = \\mat{\\mathrm{diag}}(\\vect{\\sigma})` and :math:`\\Gamma`
    denotes Euler's Gamma function :class:`~openturns.SpecFunc_Gamma`.

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\vect{\\Expect{X}} & = & \\vect{\\mu} \\quad \\text{ if }\\nu>1\\\\
            \\mat{\\Cov{X}} & = & \\displaystyle \\frac{\\nu}{\\nu-2}
                                \\mat{\\Delta}^t\\,\\mat{R}\\,\\mat{\\Delta}
                              \\quad \\text{ if }\\nu>2
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Student(5.0, -0.5, 2.0)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.EllipticalDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Student, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.EllipticalDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Student, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Student_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Student___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Student___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Student___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Student_getRealization(self)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Student_computeCDF(self, *args)

    def computeProbability(self, *args):
        """
        Compute the interval probability.

        Parameters
        ----------
        interval : :class:`~openturns.Interval`
            An interval, possibly multivariate.

        Returns
        -------
        P : float
            Interval probability.

        Notes
        -----
        This computes the probability that the random vector :math:`\\vect{X}` lies in
        the hyper-rectangular region formed by the vectors :math:`\\vect{a}` and
        :math:`\\vect{b}`:

        .. math::

            \\Prob{\\bigcap\\limits_{i=1}^n a_i < X_i \\leq b_i} =
                \\sum\\limits_{\\vect{c}} (-1)^{n(\\vect{c})}
                    F_{\\vect{X}}\\left(\\vect{c}\\right)

        where the sum runs over the :math:`2^n` vectors such that
        :math:`\\vect{c} = \\Tr{(c_i, i = 1, \\ldots, n)}` with :math:`c_i \\in [a_i, b_i]`,
        and :math:`n(\\vect{c})` is the number of components in
        :math:`\\vect{c}` such that :math:`c_i = a_i`.
        """
        return _dist_bundle3.Student_computeProbability(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Student_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Student_computeCDFGradient(self, *args)

    def computeRadialDistributionCDF(self, *args):
        """
        Compute the cumulative distribution function of the squared radius.

        For the underlying standard spherical distribution (for elliptical
        distributions only).

        Parameters
        ----------
        r2 : float, :math:`0 \\leq r^2`
            Squared radius.

        Returns
        -------
        F : float
            CDF value at input `r2`.

        Notes
        -----
        This is the CDF of the sum of the squared independent, standard, identically
        distributed components:

        .. math::

            R^2 = \\sqrt{\\sum\\limits_{i=1}^n U_i^2}
        """
        return _dist_bundle3.Student_computeRadialDistributionCDF(self, *args)

    def computeConditionalPDF(self, *args):
        """
        Compute the conditional probability density function.

        Conditional PDF of the last component with respect to the other fixed components.

        Parameters
        ----------
        Xn : float
            Conditional PDF input (last component).
        Xcond : :class:`~openturns.NumericalPoint` or 1d-array with dimension :math:`n-1`
            Conditionning values for the other components.

        Returns
        -------
        f : float
            Conditional PDF value at input `Xn`, `Xcond`.

        See Also
        --------
        computePDF, computeConditionalCDF
        """
        return _dist_bundle3.Student_computeConditionalPDF(self, *args)

    def computeConditionalCDF(self, *args):
        """
        Compute the conditional cumulative distribution function.

        Parameters
        ----------
        Xn : float
            Conditional CDF input (last component).
        Xcond : :class:`~openturns.NumericalPoint` or 1d-array with dimension :math:`n-1`
            Conditionning values for the other components.

        Returns
        -------
        F : float
            Conditional CDF value at input `Xn`, `Xcond`.

        Notes
        -----
        The conditional cumulative distribution function of the last component with
        respect to the other fixed components is defined as follows:

        .. math::

            F_{X_n \\mid X_1, \\ldots, X_{n - 1}}(x_n) =
                \\Prob{X_n \\leq x_n \\mid X_1=x_1, \\ldots, X_{n-1}=x_{n-1}},
                \\quad x_n \\in \\supp{X_n}
        """
        return _dist_bundle3.Student_computeConditionalCDF(self, *args)

    def computeConditionalQuantile(self, *args):
        """
        Compute the conditional quantile function of the last component.

        Conditional quantile with respect to the other fixed components.

        Parameters
        ----------
        p : float, :math:`0 < p < 1`
            Conditional quantile function input.
        Xcond : :class:`~openturns.NumericalPoint` or 1d-array with dimension :math:`n-1`
            Conditionning values for the other components.

        Returns
        -------
        X1 : float
            Conditional quantile at input `p`, `Xcond`.

        See Also
        --------
        computeQuantile, computeConditionalCDF
        """
        return _dist_bundle3.Student_computeConditionalQuantile(self, *args)

    def getMarginal(self, *args):
        """
        Accessor to marginal distributions.

        Parameters
        ----------
        i : int or list of ints, :math:`1 \\leq i \\leq n`
            Component(s) indice(s).

        Returns
        -------
        distribution : :class:`~openturns.Distribution`
            The marginal distribution of the selected component(s).
        """
        return _dist_bundle3.Student_getMarginal(self, *args)

    def getMean(self):
        """
        Accessor to the mean.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Mean.

        Notes
        -----
        The mean is the first-order moment:

        .. math::

            \\vect{\\mu} = \\Tr{\\left(\\Expect{X_i}, \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Student_getMean(self)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Student_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Student_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Student_getKurtosis(self)

    def getCovariance(self):
        """
        Accessor to the covariance matrix.

        Returns
        -------
        Sigma : :class:`~openturns.CovarianceMatrix`
            Covariance matrix.

        Notes
        -----
        The covariance is the second-order standard moment. It is defined as:

        .. math::

            \\mat{\\Sigma} & = \\Cov{\\vect{X}} \\\\
                         & = \\Expect{\\left(\\vect{X} - \\vect{\\mu}\\right)
                                     \\Tr{\\left(\\vect{X} - \\vect{\\mu}\\right)}}
        """
        return _dist_bundle3.Student_getCovariance(self)

    def getStandardMoment(self, *args):
        """
        Accessor to the componentwise standard moments.

        Parameters
        ----------
        k : int
            The standard moment's order.

        Returns
        -------
        m : :class:`~openturns.NumericalPoint`
            Componentwise standard moment of order `k`.

        Notes
        -----
        Standard moments are centered with respect to the first-order moment and
        normalized with respect to the standard deviation:

        .. math::

            \\overline{\\vect{m}}^{(k)}_0 =
                \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                             {\\sigma_i}\\right)^k},
                \\quad i = 1, \\ldots, n\\right)}

        See Also
        --------
        getMean, getStandardDeviation
        """
        return _dist_bundle3.Student_getStandardMoment(self, *args)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.Student_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Student_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Student_setParametersCollection(self, *args)

    def hasIndependentCopula(self):
        """
        Test whether the distribution's copula is independent.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.Student_hasIndependentCopula(self)

    def setNu(self, *args):
        """
        Accessor to the distribution's generalised number degrees of freedom.

        Parameters
        ----------
        nu : float, :math:`\\nu > 0`
            Generalised number degrees of freedom.
        """
        return _dist_bundle3.Student_setNu(self, *args)

    def getNu(self):
        """
        Accessor to the distribution's generalised number degrees of freedom.

        Returns
        -------
        nu : float
            Generalised number degrees of freedom.
        """
        return _dist_bundle3.Student_getNu(self)

    def setMu(self, *args):
        """
        Accessor to the distribution's mean.

        Parameters
        ----------
        mu : float
            Mean.
        """
        return _dist_bundle3.Student_setMu(self, *args)

    def getMu(self):
        """
        Accessor to the distribution's mean.

        Returns
        -------
        mu : float
            Mean.
            Only defined when the dimension is 1
            (else, use the :func:`getMean()` method inherited from the
            EllipticalDistribution class).
        """
        return _dist_bundle3.Student_getMu(self)

    def computeDensityGenerator(self, *args):
        """
        Compute the probability density function of the characteristic generator.

        PDF of the characteristic generator of the elliptical distribution.

        Parameters
        ----------
        beta2 : float
            Density generator input.

        Returns
        -------
        p : float
            Density generator value at input `X`.

        Notes
        -----
        This is the function :math:`\\phi` such that the probability density function
        rewrites:

        .. math::

            f_{\\vect{X}}(\\vect{x}) =
                \\phi\\left(\\Tr{\\left(\\vect{x} - \\vect{\\mu}\\right)}
                              \\mat{\\Sigma}^{-1}
                              \\left(\\vect{x} - \\vect{\\mu}\\right)
                    \\right),
                \\quad \\vect{x} \\in \\supp{\\vect{X}}

        This function only exists for elliptical distributions.

        See Also
        --------
        isElliptical, computePDF
        """
        return _dist_bundle3.Student_computeDensityGenerator(self, *args)

    def computeDensityGeneratorDerivative(self, *args):
        """
        Compute the first-order derivative of the probability density function.

        PDF of the characteristic generator of the elliptical distribution.

        Parameters
        ----------
        beta2 : float
            Density generator input.

        Returns
        -------
        p : float
            Density generator first-order derivative value at input `X`.

        Notes
        -----
        This function only exists for elliptical distributions.

        See Also
        --------
        isElliptical, computeDensityGenerator
        """
        return _dist_bundle3.Student_computeDensityGeneratorDerivative(self, *args)

    def computeDensityGeneratorSecondDerivative(self, *args):
        """
        Compute the second-order derivative of the probability density function.

        PDF of the characteristic generator of the elliptical distribution.

        Parameters
        ----------
        beta2 : float
            Density generator input.

        Returns
        -------
        p : float
            Density generator second-order derivative value at input `X`.

        Notes
        -----
        This function only exists for elliptical distributions.

        See Also
        --------
        isElliptical, computeDensityGenerator
        """
        return _dist_bundle3.Student_computeDensityGeneratorSecondDerivative(self, *args)

    def __init__(self, *args): 
        this = _dist_bundle3.new_Student(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Student
    __del__ = lambda self : None;
Student_swigregister = _dist_bundle3.Student_swigregister
Student_swigregister(Student)

class StudentFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StudentFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StudentFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.StudentFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.StudentFactory_build(self, *args)
    def buildAsStudent(self, *args): return _dist_bundle3.StudentFactory_buildAsStudent(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_StudentFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_StudentFactory
    __del__ = lambda self : None;
StudentFactory_swigregister = _dist_bundle3.StudentFactory_swigregister
StudentFactory_swigregister(StudentFactory)

class Trapezoidal(openturns.model_copula.ContinuousDistribution):
    """
    Trapezoidal distribution.

    Available constructors:
        Trapezoidal(*a=-2.0, b=-1.0, c=1.0, d=2.0*)

    Parameters
    ----------
    a : float, :math:`a < d`
        Lower bound.
    b : float, :math:`a \\leq b < c`
        Level start.
    c : float, :math:`b < c \\leq d`
        Level end.
    d : float, :math:`c \\leq d`
        Upper bound.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = \\left\\{
                     \\begin{array}{ll}
                     \\displaystyle h \\frac{x - a}{b - a} & a \\leq x < b \\\\
                     \\displaystyle h                     & b \\leq x < c \\\\
                     \\displaystyle h \\frac{d - x}{d - c} & c \\leq x \\leq d \\\\
                     \\end{array}
                 \\right., \\quad x \\in [a, d]

    with: :math:`h=\\frac{2}{d+c-a-b}`

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\frac{h}{6}(d^2 + cd + c^2 - b^2 - ab - a^2)  \\\\
            \\Var{X} & = &  \\frac{h^2}{72}(d^4 + 2cd^3 - 3bd^3 - 3ad^3 ...\\\\
                        & & - 3bcd^2 - 3acd^2 + 4b^2d^2 + 4abd^2 ...\\\\
                        & & + 4a^2d^2 + 2c^3d - 3bc^2d - 3ac^2d ...\\\\
                        & & + 4b^2cd + 4abcd + 4a^2cd - 3b^3d - 3ab^2d ...\\\\
                        & & - 3a^2bd - 3a^3d + c^4 - 3bc^3 - 3ac^3 + 4b^2c^2 ...\\\\
                        & & + 4abc^2 + 4a^2c^2 - 3b^3c - 3ab^2c - 3a^2bc ...\\\\
                        & & - 3a^3c + b^4 + 2ab^3 + 2a^3b + a^4)
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Trapezoidal(1.0, 2.3, 4.5, 5.0)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Trapezoidal, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Trapezoidal, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Trapezoidal_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Trapezoidal___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Trapezoidal___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Trapezoidal___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Trapezoidal_getRealization(self)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Trapezoidal_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Trapezoidal_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Trapezoidal_computeCDF(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.Trapezoidal_computeCharacteristicFunction(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Trapezoidal_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Trapezoidal_computeCDFGradient(self, *args)

    def getRoughness(self):
        """
        Accessor to roughness of the distribution.

        Returns
        -------
        r : float
            Distribution's roughness.

        Notes
        -----
        The roughness of the distribution is defined as the :math:`\\cL^2`-norm of its
        PDF:

        .. math::

            r = \\int_{\\supp{\\vect{X}}} f_{\\vect{X}}(\\vect{x})^2 \\di{\\vect{x}}

        See Also
        --------
        computePDF
        """
        return _dist_bundle3.Trapezoidal_getRoughness(self)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Trapezoidal_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Trapezoidal_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Trapezoidal_getKurtosis(self)

    def getStandardMoment(self, *args):
        """
        Accessor to the componentwise standard moments.

        Parameters
        ----------
        k : int
            The standard moment's order.

        Returns
        -------
        m : :class:`~openturns.NumericalPoint`
            Componentwise standard moment of order `k`.

        Notes
        -----
        Standard moments are centered with respect to the first-order moment and
        normalized with respect to the standard deviation:

        .. math::

            \\overline{\\vect{m}}^{(k)}_0 =
                \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                             {\\sigma_i}\\right)^k},
                \\quad i = 1, \\ldots, n\\right)}

        See Also
        --------
        getMean, getStandardDeviation
        """
        return _dist_bundle3.Trapezoidal_getStandardMoment(self, *args)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.Trapezoidal_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Trapezoidal_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Trapezoidal_setParametersCollection(self, *args)

    def setA(self, *args):
        """
        Accessor to the distribution's lower bound.

        Returns
        -------
        a : float, :math:`a \\leq b < c \\leq d`
            Lower bound.
        """
        return _dist_bundle3.Trapezoidal_setA(self, *args)

    def getA(self):
        """
        Accessor to the distribution's lower bound.

        Returns
        -------
        a : float
            Lower bound.
        """
        return _dist_bundle3.Trapezoidal_getA(self)

    def setB(self, *args):
        """
        Accessor to the distribution's level start.

        Returns
        -------
        b : float, :math:`a \\leq b < c \\leq d`
            Level start.
        """
        return _dist_bundle3.Trapezoidal_setB(self, *args)

    def getB(self):
        """
        Accessor to the distribution's level start.

        Returns
        -------
        b : float
            Level start.
        """
        return _dist_bundle3.Trapezoidal_getB(self)

    def setC(self, *args):
        """
        Accessor to the distribution's level end.

        Returns
        -------
        c : float, :math:`a \\leq b < c \\leq d`
            Level end.
        """
        return _dist_bundle3.Trapezoidal_setC(self, *args)

    def getC(self):
        """
        Accessor to the distribution's level end.

        Returns
        -------
        c : float
            Level end.
        """
        return _dist_bundle3.Trapezoidal_getC(self)

    def setD(self, *args):
        """
        Accessor to the distribution's upper bound.

        Returns
        -------
        d : float, :math:`a \\leq b < c \\leq d`
            Upper bound.
        """
        return _dist_bundle3.Trapezoidal_setD(self, *args)

    def getD(self):
        """
        Accessor to the distribution's upper bound.

        Returns
        -------
        d : float
            Upper bound.
        """
        return _dist_bundle3.Trapezoidal_getD(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_Trapezoidal(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Trapezoidal
    __del__ = lambda self : None;
Trapezoidal_swigregister = _dist_bundle3.Trapezoidal_swigregister
Trapezoidal_swigregister(Trapezoidal)

class TrapezoidalFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TrapezoidalFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TrapezoidalFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.TrapezoidalFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.TrapezoidalFactory_build(self, *args)
    def buildAsTrapezoidal(self, *args): return _dist_bundle3.TrapezoidalFactory_buildAsTrapezoidal(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_TrapezoidalFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_TrapezoidalFactory
    __del__ = lambda self : None;
TrapezoidalFactory_swigregister = _dist_bundle3.TrapezoidalFactory_swigregister
TrapezoidalFactory_swigregister(TrapezoidalFactory)

class Triangular(openturns.model_copula.ContinuousDistribution):
    """
    Triangular distribution.

    Available constructors:
        Triangular(*a=-1.0, m=0., b=1.0*)

    Parameters
    ----------
    a : float
        Lower bound.
    m : float, :math:`a \\leq m \\leq b`
        Mode.
    b : float, :math:`a < b`
        Upper bound.


    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = \\left\\{
                     \\begin{array}{ll}
                     \\displaystyle \\frac{2(x - a)}{(m - a)(b - a)}
                                   & a \\leq x \\leq m \\\\
                     \\displaystyle \\frac{2(b - x)}{(b - m)(b - a)}
                                   & m \\leq x \\leq b
                     \\end{array}
                 \\right., \\quad x \\in [a, b]

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & =  & \\frac{1}{3}\\,(a+m+b) \\\\
            \\Var{X} & = & \\frac{1}{18} (a^2+b^2+m^2-ab-am-bm)
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Triangular(1.0, 2.5, 4.0)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Triangular, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Triangular, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Triangular_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Triangular___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Triangular___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Triangular___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Triangular_getRealization(self)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Triangular_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Triangular_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Triangular_computeCDF(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.Triangular_computeCharacteristicFunction(self, *args)

    def computeLogCharacteristicFunction(self, *args):
        """
        Compute the logarithm of the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Logarithm of the characteristic function value at input `t`.

        Notes
        -----
        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.

        See Also
        --------
        computeCharacteristicFunction
        """
        return _dist_bundle3.Triangular_computeLogCharacteristicFunction(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Triangular_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Triangular_computeCDFGradient(self, *args)

    def getRoughness(self):
        """
        Accessor to roughness of the distribution.

        Returns
        -------
        r : float
            Distribution's roughness.

        Notes
        -----
        The roughness of the distribution is defined as the :math:`\\cL^2`-norm of its
        PDF:

        .. math::

            r = \\int_{\\supp{\\vect{X}}} f_{\\vect{X}}(\\vect{x})^2 \\di{\\vect{x}}

        See Also
        --------
        computePDF
        """
        return _dist_bundle3.Triangular_getRoughness(self)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Triangular_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Triangular_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Triangular_getKurtosis(self)

    def getStandardMoment(self, *args):
        """
        Accessor to the componentwise standard moments.

        Parameters
        ----------
        k : int
            The standard moment's order.

        Returns
        -------
        m : :class:`~openturns.NumericalPoint`
            Componentwise standard moment of order `k`.

        Notes
        -----
        Standard moments are centered with respect to the first-order moment and
        normalized with respect to the standard deviation:

        .. math::

            \\overline{\\vect{m}}^{(k)}_0 =
                \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                             {\\sigma_i}\\right)^k},
                \\quad i = 1, \\ldots, n\\right)}

        See Also
        --------
        getMean, getStandardDeviation
        """
        return _dist_bundle3.Triangular_getStandardMoment(self, *args)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.Triangular_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Triangular_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Triangular_setParametersCollection(self, *args)

    def setAMB(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        a : float
            Lower bound.
        m : float, :math:`a \\leq m \\leq b`
            Mode.
        b : float, :math:`a < b`
            Upper bound.
        """
        return _dist_bundle3.Triangular_setAMB(self, *args)

    def getA(self):
        """
        Accessor to the distribution's lower bound.

        Returns
        -------
        a : float
            Lower bound.
        """
        return _dist_bundle3.Triangular_getA(self)

    def getM(self):
        """
        Accessor to the distribution's mode.

        Returns
        -------
        m : float
            Mode.
        """
        return _dist_bundle3.Triangular_getM(self)

    def getB(self):
        """
        Accessor to the distribution's upper bound.

        Returns
        -------
        b : float
            Upper bound.
        """
        return _dist_bundle3.Triangular_getB(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_Triangular(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Triangular
    __del__ = lambda self : None;
Triangular_swigregister = _dist_bundle3.Triangular_swigregister
Triangular_swigregister(Triangular)

class TriangularFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TriangularFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TriangularFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.TriangularFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.TriangularFactory_build(self, *args)
    def buildAsTriangular(self, *args): return _dist_bundle3.TriangularFactory_buildAsTriangular(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_TriangularFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_TriangularFactory
    __del__ = lambda self : None;
TriangularFactory_swigregister = _dist_bundle3.TriangularFactory_swigregister
TriangularFactory_swigregister(TriangularFactory)

class TruncatedDistribution(openturns.model_copula.DistributionImplementation):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TruncatedDistribution, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TruncatedDistribution, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.TruncatedDistribution_getClassName(self)

    LOWER = _dist_bundle3.TruncatedDistribution_LOWER
    UPPER = _dist_bundle3.TruncatedDistribution_UPPER
    def __eq__(self, *args): return _dist_bundle3.TruncatedDistribution___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.TruncatedDistribution___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.TruncatedDistribution___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.TruncatedDistribution_getRealization(self)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.TruncatedDistribution_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.TruncatedDistribution_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.TruncatedDistribution_computeCDF(self, *args)

    def computeComplementaryCDF(self, *args):
        """
        Compute the complementary cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            Complementary CDF input(s).

        Returns
        -------
        C : float, :class:`~openturns.NumericalPoint`
            Complementary CDF value(s) at input(s) `X`.

        Notes
        -----
        The complementary cumulative distribution function.

        .. math::

            1 - F_{\\vect{X}}(\\vect{x}) = 1 - \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i}, \\quad \\vect{x} \\in \\supp{\\vect{X}}

        .. warning::
            This is not the survival function (except for 1-dimensional
            distributions).

        See Also
        --------
        computeSurvivalFunction
        """
        return _dist_bundle3.TruncatedDistribution_computeComplementaryCDF(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.TruncatedDistribution_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.TruncatedDistribution_computeCDFGradient(self, *args)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.TruncatedDistribution_getParametersCollection(self)

    def setDistribution(self, *args): return _dist_bundle3.TruncatedDistribution_setDistribution(self, *args)
    def getDistribution(self): return _dist_bundle3.TruncatedDistribution_getDistribution(self)
    def setLowerBound(self, *args): return _dist_bundle3.TruncatedDistribution_setLowerBound(self, *args)
    def getLowerBound(self): return _dist_bundle3.TruncatedDistribution_getLowerBound(self)
    def setFiniteLowerBound(self, *args): return _dist_bundle3.TruncatedDistribution_setFiniteLowerBound(self, *args)
    def getFiniteLowerBound(self): return _dist_bundle3.TruncatedDistribution_getFiniteLowerBound(self)
    def setUpperBound(self, *args): return _dist_bundle3.TruncatedDistribution_setUpperBound(self, *args)
    def getUpperBound(self): return _dist_bundle3.TruncatedDistribution_getUpperBound(self)
    def setFiniteUpperBound(self, *args): return _dist_bundle3.TruncatedDistribution_setFiniteUpperBound(self, *args)
    def getFiniteUpperBound(self): return _dist_bundle3.TruncatedDistribution_getFiniteUpperBound(self)
    def setThresholdRealization(self, *args): return _dist_bundle3.TruncatedDistribution_setThresholdRealization(self, *args)
    def getThresholdRealization(self): return _dist_bundle3.TruncatedDistribution_getThresholdRealization(self)
    def isContinuous(self):
        """
        Test whether the distribution is continuous or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.TruncatedDistribution_isContinuous(self)

    def isDiscrete(self):
        """
        Test whether the distribution is discrete or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.TruncatedDistribution_isDiscrete(self)

    def isIntegral(self):
        """
        Test whether the distribution is integer-valued or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.TruncatedDistribution_isIntegral(self)

    def getSupport(self, *args):
        """
        Accessor to the distribution's support.

        Parameters
        ----------
        interval : :class:`~openturns.Interval`
            An interval to intersect with the distribution's support.

        Returns
        -------
        support : :class:`~openturns.Interval`
            The intersection of the distribution's support with the given `interval`.

        Notes
        -----
        The mathematical support :math:`\\supp{\\vect{X}}` of the distribution is
        the interval (or collection of intervals) where the PDF is non-zero.

        This is yet implemented for discrete distributions only.

        See Also
        --------
        getRange
        """
        return _dist_bundle3.TruncatedDistribution_getSupport(self, *args)

    def __init__(self, *args): 
        this = _dist_bundle3.new_TruncatedDistribution(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_TruncatedDistribution
    __del__ = lambda self : None;
TruncatedDistribution_swigregister = _dist_bundle3.TruncatedDistribution_swigregister
TruncatedDistribution_swigregister(TruncatedDistribution)

class TruncatedNormal(openturns.model_copula.ContinuousDistribution):
    """
    TruncatedNormal distribution.

    Available constructors:
        TruncatedNormal(*mu=0., sigma=1.0, a=-1.0, b=1.0*)

    Parameters
    ----------
    mu : float
        Mean.
    sigma : float, :math:`\\sigma > 0`
        Standard deviation.
    a : float
        Lower bound.
    b : float, :math:`a < b`
        Upper bound.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = \\frac{1}{\\sigma}
                 \\frac{ \\phi \\left(\\frac{x - \\mu}{\\sigma}\\right)}
                      { \\Phi \\left(\\frac{b - \\mu}{\\sigma}\\right)
                      - \\Phi \\left(\\frac{a - \\mu}{\\sigma}\\right)},
                 \\quad x \\in [a; b]

    where :math:`\\phi` and :math:`\\Phi` are, respectively, the probability density
    distribution function and the cumulative distribution function of a standard
    normal distribution.

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\mu + \\frac{\\phi(\\frac{a - \\mu}{\\sigma})
                                       - \\phi(\\frac{b - \\mu}{\\sigma})}
                                        {\\Phi(\\frac{b - \\mu}{\\sigma})
                                       - \\Phi(\\frac{a - \\mu}{\\sigma})}\\sigma \\\\
            \\Var{X} & = & \\sigma
                      \\left[1
                        +\\frac{\\frac{a - \\mu}{\\sigma} \\phi(\\frac{a - \\mu}{\\sigma})
                             - \\frac{b - \\mu}{\\sigma} \\phi(\\frac{b - \\mu}{\\sigma})}
                              {\\Phi(\\frac{b - \\mu}{\\sigma})
                             - \\Phi(\\frac{a - \\mu}{\\sigma})}
                        -\\left(
                         \\frac{\\phi(\\frac{a - \\mu}{\\sigma})
                             - \\phi(\\frac{b - \\mu}{\\sigma})}
                              {\\Phi(\\frac{b - \\mu}{\\sigma})
                             - \\Phi(\\frac{a - \\mu}{\\sigma})}
                          \\right)^2
                      \\right]^\\frac{1}{2}
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.TruncatedNormal(0.5, 3.0, -2.0, 2.0)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TruncatedNormal, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TruncatedNormal, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.TruncatedNormal_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.TruncatedNormal___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.TruncatedNormal___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.TruncatedNormal___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.TruncatedNormal_getRealization(self)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.TruncatedNormal_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.TruncatedNormal_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.TruncatedNormal_computeCDF(self, *args)

    def computeComplementaryCDF(self, *args):
        """
        Compute the complementary cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            Complementary CDF input(s).

        Returns
        -------
        C : float, :class:`~openturns.NumericalPoint`
            Complementary CDF value(s) at input(s) `X`.

        Notes
        -----
        The complementary cumulative distribution function.

        .. math::

            1 - F_{\\vect{X}}(\\vect{x}) = 1 - \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i}, \\quad \\vect{x} \\in \\supp{\\vect{X}}

        .. warning::
            This is not the survival function (except for 1-dimensional
            distributions).

        See Also
        --------
        computeSurvivalFunction
        """
        return _dist_bundle3.TruncatedNormal_computeComplementaryCDF(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.TruncatedNormal_computeCharacteristicFunction(self, *args)

    def computeLogCharacteristicFunction(self, *args):
        """
        Compute the logarithm of the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Logarithm of the characteristic function value at input `t`.

        Notes
        -----
        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.

        See Also
        --------
        computeCharacteristicFunction
        """
        return _dist_bundle3.TruncatedNormal_computeLogCharacteristicFunction(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.TruncatedNormal_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.TruncatedNormal_computeCDFGradient(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.TruncatedNormal_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.TruncatedNormal_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.TruncatedNormal_getKurtosis(self)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.TruncatedNormal_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.TruncatedNormal_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.TruncatedNormal_setParametersCollection(self, *args)

    def setMu(self, *args):
        """
        Accessor to the distribution's mean.

        Parameters
        ----------
        mu : float
            Mean.
        """
        return _dist_bundle3.TruncatedNormal_setMu(self, *args)

    def getMu(self):
        """
        Accessor to the distribution's mean.

        Returns
        -------
        mu : float
            Mean.
        """
        return _dist_bundle3.TruncatedNormal_getMu(self)

    def setSigma(self, *args):
        """
        Accessor to the distribution's standard deviation.

        Parameters
        ----------
        sigma : float, :math:`\\sigma > 0`
            Standard deviation.
        """
        return _dist_bundle3.TruncatedNormal_setSigma(self, *args)

    def getSigma(self):
        """
        Accessor to the distribution's standard deviation.

        Returns
        -------
        sigma : float
            Standard deviation.
        """
        return _dist_bundle3.TruncatedNormal_getSigma(self)

    def setA(self, *args):
        """
        Accessor to the distribution's lower bound.

        Parameters
        ----------
        a : float, :math:`a < b`
            Lower bound.
        """
        return _dist_bundle3.TruncatedNormal_setA(self, *args)

    def getA(self):
        """
        Accessor to the distribution's lower bound.

        Returns
        -------
        a : float
            Lower bound.
        """
        return _dist_bundle3.TruncatedNormal_getA(self)

    def setB(self, *args):
        """
        Accessor to the distribution's upper bound.

        Parameters
        ----------
        b : float, :math:`b > a`
            Upper bound.
        """
        return _dist_bundle3.TruncatedNormal_setB(self, *args)

    def getB(self):
        """
        Accessor to the distribution's upper bound.

        Returns
        -------
        b : float
            Upper bound.
        """
        return _dist_bundle3.TruncatedNormal_getB(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_TruncatedNormal(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_TruncatedNormal
    __del__ = lambda self : None;
TruncatedNormal_swigregister = _dist_bundle3.TruncatedNormal_swigregister
TruncatedNormal_swigregister(TruncatedNormal)

class TruncatedNormalFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TruncatedNormalFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TruncatedNormalFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.TruncatedNormalFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.TruncatedNormalFactory_build(self, *args)
    def buildAsTruncatedNormal(self, *args): return _dist_bundle3.TruncatedNormalFactory_buildAsTruncatedNormal(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_TruncatedNormalFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_TruncatedNormalFactory
    __del__ = lambda self : None;
TruncatedNormalFactory_swigregister = _dist_bundle3.TruncatedNormalFactory_swigregister
TruncatedNormalFactory_swigregister(TruncatedNormalFactory)

class Uniform(openturns.model_copula.ContinuousDistribution):
    """
    Uniform distribution.

    Available constructors:
        Uniform(*a=-1.0, b=1.0*)

    Parameters
    ----------
    a : float
        Lower bound.
    b : float, :math:`b > a`
        Upper bound.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = \\frac{1}{b-a}, \\quad x \\in [a; b]

    with :math:`a < b`.

    Its first moments are defined as:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\frac{a+b}{2} \\\\
            \\Var{X} & = & \\frac{(b-a)^2}{12}
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Uniform(2., 3.)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Uniform, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Uniform, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Uniform_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Uniform___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Uniform___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Uniform___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Uniform_getRealization(self)

    def getSample(self, *args):
        """
        Accessor to a pseudo-random sample from the distribution.

        Parameters
        ----------
        size : int
            Sample size.

        Returns
        -------
        sample : :class:`~openturns.NumericalSample`
            A pseudo-random sample of the distribution.

        See Also
        --------
        getRealization, RandomGenerator
        """
        return _dist_bundle3.Uniform_getSample(self, *args)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Uniform_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Uniform_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Uniform_computeCDF(self, *args)

    def computeComplementaryCDF(self, *args):
        """
        Compute the complementary cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            Complementary CDF input(s).

        Returns
        -------
        C : float, :class:`~openturns.NumericalPoint`
            Complementary CDF value(s) at input(s) `X`.

        Notes
        -----
        The complementary cumulative distribution function.

        .. math::

            1 - F_{\\vect{X}}(\\vect{x}) = 1 - \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i}, \\quad \\vect{x} \\in \\supp{\\vect{X}}

        .. warning::
            This is not the survival function (except for 1-dimensional
            distributions).

        See Also
        --------
        computeSurvivalFunction
        """
        return _dist_bundle3.Uniform_computeComplementaryCDF(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.Uniform_computeCharacteristicFunction(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Uniform_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Uniform_computeCDFGradient(self, *args)

    def getRoughness(self):
        """
        Accessor to roughness of the distribution.

        Returns
        -------
        r : float
            Distribution's roughness.

        Notes
        -----
        The roughness of the distribution is defined as the :math:`\\cL^2`-norm of its
        PDF:

        .. math::

            r = \\int_{\\supp{\\vect{X}}} f_{\\vect{X}}(\\vect{x})^2 \\di{\\vect{x}}

        See Also
        --------
        computePDF
        """
        return _dist_bundle3.Uniform_getRoughness(self)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Uniform_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Uniform_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Uniform_getKurtosis(self)

    def getStandardMoment(self, *args):
        """
        Accessor to the componentwise standard moments.

        Parameters
        ----------
        k : int
            The standard moment's order.

        Returns
        -------
        m : :class:`~openturns.NumericalPoint`
            Componentwise standard moment of order `k`.

        Notes
        -----
        Standard moments are centered with respect to the first-order moment and
        normalized with respect to the standard deviation:

        .. math::

            \\overline{\\vect{m}}^{(k)}_0 =
                \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                             {\\sigma_i}\\right)^k},
                \\quad i = 1, \\ldots, n\\right)}

        See Also
        --------
        getMean, getStandardDeviation
        """
        return _dist_bundle3.Uniform_getStandardMoment(self, *args)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.Uniform_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Uniform_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Uniform_setParametersCollection(self, *args)

    def isElliptical(self):
        """
        Test whether the distribution is elliptical or not.

        Returns
        -------
        test : bool
            Answer.

        Notes
        -----
        A multivariate distribution is said to be *elliptical* if its characteristic
        function is of the form:

        .. math::

            \\phi(\\vect{t}) = \\exp\\left(i \\Tr{\\vect{t}} \\vect{\\mu}\\right)
                             \\Psi\\left(\\Tr{\\vect{t}} \\mat{\\Sigma} \\vect{t}\\right),
                             \\quad \\vect{t} \\in \\Rset^n

        for specified vector :math:`\\vect{\\mu}` and positive-definite matrix
        :math:`\\mat{\\Sigma}`. The function :math:`\\Psi` is known as the
        *characteristic generator* of the elliptical distribution.
        """
        return _dist_bundle3.Uniform_isElliptical(self)

    def setA(self, *args):
        """
        Accessor to the distribution's lower bound.

        Parameters
        ----------
        a : float, :math:`a < b`
            Lower bound.
        """
        return _dist_bundle3.Uniform_setA(self, *args)

    def getA(self):
        """
        Accessor to the distribution's lower bound.

        Returns
        -------
        a : float
            Lower bound.
        """
        return _dist_bundle3.Uniform_getA(self)

    def setB(self, *args):
        """
        Accessor to the distribution's upper bound.

        Parameters
        ----------
        b : float, :math:`a < b`
            Upper bound.
        """
        return _dist_bundle3.Uniform_setB(self, *args)

    def getB(self):
        """
        Accessor to the distribution's upper bound.

        Returns
        -------
        b : float
            Upper bound.
        """
        return _dist_bundle3.Uniform_getB(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_Uniform(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Uniform
    __del__ = lambda self : None;
Uniform_swigregister = _dist_bundle3.Uniform_swigregister
Uniform_swigregister(Uniform)

class UniformFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UniformFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UniformFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.UniformFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.UniformFactory_build(self, *args)
    def buildAsUniform(self, *args): return _dist_bundle3.UniformFactory_buildAsUniform(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_UniformFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_UniformFactory
    __del__ = lambda self : None;
UniformFactory_swigregister = _dist_bundle3.UniformFactory_swigregister
UniformFactory_swigregister(UniformFactory)

class UserDefinedPair(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UserDefinedPair, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UserDefinedPair, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.UserDefinedPair_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.UserDefinedPair___eq__(self, *args)
    def setX(self, *args): return _dist_bundle3.UserDefinedPair_setX(self, *args)
    def setP(self, *args): return _dist_bundle3.UserDefinedPair_setP(self, *args)
    def getX(self): return _dist_bundle3.UserDefinedPair_getX(self)
    def getP(self): return _dist_bundle3.UserDefinedPair_getP(self)
    def __repr__(self): return _dist_bundle3.UserDefinedPair___repr__(self)
    def __init__(self, *args): 
        this = _dist_bundle3.new_UserDefinedPair(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_UserDefinedPair
    __del__ = lambda self : None;
UserDefinedPair_swigregister = _dist_bundle3.UserDefinedPair_swigregister
UserDefinedPair_swigregister(UserDefinedPair)

class UserDefinedPairCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, UserDefinedPairCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, UserDefinedPairCollection, name)
    __swig_destroy__ = _dist_bundle3.delete_UserDefinedPairCollection
    __del__ = lambda self : None;
    def clear(self): return _dist_bundle3.UserDefinedPairCollection_clear(self)
    def __len__(self): return _dist_bundle3.UserDefinedPairCollection___len__(self)
    def __eq__(self, *args): return _dist_bundle3.UserDefinedPairCollection___eq__(self, *args)
    def __contains__(self, *args): return _dist_bundle3.UserDefinedPairCollection___contains__(self, *args)
    def __getitem__(self, *args): return _dist_bundle3.UserDefinedPairCollection___getitem__(self, *args)
    def __setitem__(self, *args): return _dist_bundle3.UserDefinedPairCollection___setitem__(self, *args)
    def __delitem__(self, *args): return _dist_bundle3.UserDefinedPairCollection___delitem__(self, *args)
    def at(self, *args): return _dist_bundle3.UserDefinedPairCollection_at(self, *args)
    def add(self, *args): return _dist_bundle3.UserDefinedPairCollection_add(self, *args)
    def getSize(self): return _dist_bundle3.UserDefinedPairCollection_getSize(self)
    def resize(self, *args): return _dist_bundle3.UserDefinedPairCollection_resize(self, *args)
    def isEmpty(self): return _dist_bundle3.UserDefinedPairCollection_isEmpty(self)
    def __repr__(self): return _dist_bundle3.UserDefinedPairCollection___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.UserDefinedPairCollection___str__(self, offset)
    def __init__(self, *args): 
        this = _dist_bundle3.new_UserDefinedPairCollection(*args)
        try: self.this.append(this)
        except: self.this = this
UserDefinedPairCollection_swigregister = _dist_bundle3.UserDefinedPairCollection_swigregister
UserDefinedPairCollection_swigregister(UserDefinedPairCollection)

class UserDefined(openturns.model_copula.DiscreteDistribution):
    """
    UserDefined distribution.

    Available constructors:
        UserDefined(*coll=ot.UserDefinedPairCollection(1)*)

        UserDefined(*sample*)

        UserDefined(*sample, weights*)

    Parameters
    ----------
    coll : :class:`~openturns.UserDefinedPairCollection`
        `n` lists of `d` points :math:`x_{ij}, i = 1, \\ldots, n, j = 1, \\ldots, d`
        associated with their weight :math:`p_i`.
        If not :math:`\\sum_1^n  p_i = 1.0`, the weights are normalized.
    sample : :class:`~openturns.NumericalSample`
        `n` lists of `d` points :math:`x_{ij}, i = 1, \\ldots, n, j = 1, \\ldots, d`.
    weights : :class:`~openturns.NumericalPoint`
        List of `n` weights :math:`p_i, i = 1, \\ldots, n`.
        If not :math:`\\sum_1^n  p_i = 1.0`, the weights are normalized.

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        \\Prob{X = x_{ij}} = p_i, \\quad i = 1,\\ldots,n

    where :math:`j =1, \\ldots, d`, `d` the distribution's dimension and
    `n` the size of the multivariate d-dimensional distribution.

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X_j} & = & \\Tr{(\\sum_{i=1}^n x_i p_i)}\\\\
            \\Var{X_j} & = & \\Expect{X_j} - (\\Expect{X_j})^2
        \\end{eqnarray*}

    with :math:`j =1, \\ldots, d` and `d` the distribution's dimension.

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> sample = ot.NumericalSample(4, 3)
    >>> for i in range(4):
    ...     for j in range(3):
    ...         sample[i, j] = 10 * (i + 1) + 0.1 * (j + 1)

    >>> distribution = ot.UserDefined(sample, [0.3,0.2,0.25,0.25])

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UserDefined, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UserDefined, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.UserDefined_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.UserDefined___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.UserDefined___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.UserDefined___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.UserDefined_getRealization(self)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.UserDefined_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.UserDefined_computeCDF(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.UserDefined_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.UserDefined_computeCDFGradient(self, *args)

    def computeRange(self): return _dist_bundle3.UserDefined_computeRange(self)
    def getSupport(self, *args):
        """
        Accessor to the distribution's support.

        Parameters
        ----------
        interval : :class:`~openturns.Interval`
            An interval to intersect with the distribution's support.

        Returns
        -------
        support : :class:`~openturns.Interval`
            The intersection of the distribution's support with the given `interval`.

        Notes
        -----
        The mathematical support :math:`\\supp{\\vect{X}}` of the distribution is
        the interval (or collection of intervals) where the PDF is non-zero.

        This is yet implemented for discrete distributions only.

        See Also
        --------
        getRange
        """
        return _dist_bundle3.UserDefined_getSupport(self, *args)

    def isIntegral(self):
        """
        Test whether the distribution is integer-valued or not.

        Returns
        -------
        test : bool
            Answer.
        """
        return _dist_bundle3.UserDefined_isIntegral(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.UserDefined_getParametersCollection(self)

    def setPairCollection(self, *args):
        """
        Accessor to the distribution's :math:`coll` parameter.

        Parameters
        ----------
        coll : :class:`~openturns.UserDefinedPairCollection`
            Collection of points with their associated weight.
        """
        return _dist_bundle3.UserDefined_setPairCollection(self, *args)

    def getPairCollection(self):
        """
        Accessor to the distribution's :math:`coll` parameter.

        Returns
        -------
        coll : :class:`~openturns.UserDefinedPairCollection`
            Collection of points with their associated weight.
        """
        return _dist_bundle3.UserDefined_getPairCollection(self)

    def getMarginal(self, *args):
        """
        Accessor to marginal distributions.

        Parameters
        ----------
        i : int or list of ints, :math:`1 \\leq i \\leq n`
            Component(s) indice(s).

        Returns
        -------
        distribution : :class:`~openturns.Distribution`
            The marginal distribution of the selected component(s).
        """
        return _dist_bundle3.UserDefined_getMarginal(self, *args)

    def compactSupport(self, *args):
        """
        Compact the support of the distribution.

        Compact by concatenating points of distance less than :math:`\\varepsilon`
        and adding their weights.

        Notes
        -----
        The :math:`\\varepsilon` has a default value stored in the ResourceMap: to
        change the default value the new value :math:`1.3e-3`, use the command:

        >>> import openturns as ot
        >>> ot.ResourceMap.SetAsNumericalScalar('DiscreteDistribution-SupportEpsilon', 1e-3)

        The method is always used for any univariate distributions and for upper
        dimensions, it is only used when the number of points defining the support is
        less than a limit specified in the ResourceMap in the key
        'UserDefined-SmallSize'. By default, the size limit is equal to :math:`1e4`.

        """
        return _dist_bundle3.UserDefined_compactSupport(self, *args)

    def __init__(self, *args): 
        this = _dist_bundle3.new_UserDefined(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_UserDefined
    __del__ = lambda self : None;
UserDefined_swigregister = _dist_bundle3.UserDefined_swigregister
UserDefined_swigregister(UserDefined)

class UserDefinedFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UserDefinedFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UserDefinedFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.UserDefinedFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.UserDefinedFactory_build(self, *args)
    def buildAsUserDefined(self, *args): return _dist_bundle3.UserDefinedFactory_buildAsUserDefined(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_UserDefinedFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_UserDefinedFactory
    __del__ = lambda self : None;
UserDefinedFactory_swigregister = _dist_bundle3.UserDefinedFactory_swigregister
UserDefinedFactory_swigregister(UserDefinedFactory)

class Weibull(openturns.model_copula.ContinuousDistribution):
    """
    Weibull distribution.

    Available constructors:
        Weibull(*arg1=1.0, arg2=1.0, gamma=0., ot.Weibull.ALPHABETA*)

    Parameters
    ----------
    arg1 : float
        If `parameters_set == ot.Weibull.ALPHABETA`: shape parameter :math:`\\alpha > 0`.

        If `parameters_set == ot.Weibull.MUSIGMA`: mean.
    arg2 : float
        If `parameters_set == ot.Weibull.ALPHABETA`: scale parameter :math:`\\beta > 0`.

        If `parameters_set == ot.Weibull.MUSIGMA`: standard deviation :math:`\\sigma > 0`.
    gamma : float, optional
        Location parameter :math:`\\gamma < \\mu`.
    parameters_set : int, optional
        Integer telling which parameters set is used for defining the
        distribution (amongst `ot.Weibull.ALPHABETA, ot.Weibull.MUSIGMA`).

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        f_X(x) = \\frac{\\beta}{\\alpha}
                 \\left(\\frac{x - \\gamma}{\\alpha} \\right) ^ {\\beta-1}
                 e^{\\left(-\\left(\\frac{x - \\gamma}{\\alpha}\\right)^{\\beta}\\right)},
                 \\quad x \\in [\\gamma; +\\infty[

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & = & \\alpha \\,\\Gamma\\left(1 + \\frac{1}{\\beta}\\right)
                           + \\gamma \\\\
            \\Var{X} & = & \\alpha^2 \\Gamma\\left(1 + \\frac{2}{\\beta}\\right) -
                         \\Gamma^2 \\left(1 + \\frac{1}{\\beta}\\right)
        \\end{eqnarray*}

    where :math:`\\Gamma` denotes Euler's Gamma function
    :class:`~openturns.SpecFunc_Gamma`.

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.Weibull(2.0, 1.5, -0.5, 1)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Weibull, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Weibull, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Weibull_getClassName(self)

    ALPHABETA = _dist_bundle3.Weibull_ALPHABETA
    MUSIGMA = _dist_bundle3.Weibull_MUSIGMA
    def __eq__(self, *args): return _dist_bundle3.Weibull___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Weibull___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Weibull___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Weibull_getRealization(self)

    def computeDDF(self, *args):
        """
        Compute the derivative density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`, :class:`~openturns.NumericalSample`
            DDF value(s) at input(s) `X`.

        Notes
        -----
        The derivative density function is the gradient of the probability density
        function with respect to :math:`\\vect{x}`:

        .. math::

            \\vect{\\nabla}_{\\vect{x}} f_{\\vect{X}}(\\vect{x}) =
                \\Tr{\\left(\\frac{\\partial f_{\\vect{X}}(\\vect{x})}{\\partial x_i},
                          \\quad i = 1, \\ldots, n\\right)},
                \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Weibull_computeDDF(self, *args)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Weibull_computePDF(self, *args)

    def computeLogPDF(self, *args):
        """
        Compute the logarithm of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            Logarithm of the PDF value(s) at input(s) `X`.
        """
        return _dist_bundle3.Weibull_computeLogPDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Weibull_computeCDF(self, *args)

    def computeComplementaryCDF(self, *args):
        """
        Compute the complementary cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            Complementary CDF input(s).

        Returns
        -------
        C : float, :class:`~openturns.NumericalPoint`
            Complementary CDF value(s) at input(s) `X`.

        Notes
        -----
        The complementary cumulative distribution function.

        .. math::

            1 - F_{\\vect{X}}(\\vect{x}) = 1 - \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i}, \\quad \\vect{x} \\in \\supp{\\vect{X}}

        .. warning::
            This is not the survival function (except for 1-dimensional
            distributions).

        See Also
        --------
        computeSurvivalFunction
        """
        return _dist_bundle3.Weibull_computeComplementaryCDF(self, *args)

    def computeCharacteristicFunction(self, *args):
        """
        Compute the characteristic function.

        Parameters
        ----------
        t : float
            Characteristic function input.

        Returns
        -------
        phi : complex
            Characteristic function value at input `t`.

        Notes
        -----
        The characteristic function is defined as:

        .. math::
            \\phi_X(t) = \\mathbb{E}\\left[\\exp(- i t X)\\right],
                        \\quad t \\in \\Rset

        OpenTURNS features a generic implementation of the characteristic function for
        all its univariate distributions (both continuous and discrete). This default
        implementation might be time consuming, especially as the modulus of `t` gets
        high. Only some univariate distributions benefit from dedicated more efficient
        implementations.
        """
        return _dist_bundle3.Weibull_computeCharacteristicFunction(self, *args)

    def computePDFGradient(self, *args):
        """
        Compute the gradient of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            PDF input.

        Returns
        -------
        dfdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the PDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Weibull_computePDFGradient(self, *args)

    def computeCDFGradient(self, *args):
        """
        Compute the gradient of the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array
            CDF input.

        Returns
        -------
        dFdtheta : :class:`~openturns.NumericalPoint`
            Partial derivatives of the CDF with respect to the distribution
            parameters at input `X`.
        """
        return _dist_bundle3.Weibull_computeCDFGradient(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Weibull_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Weibull_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.Weibull_getKurtosis(self)

    def getStandardMoment(self, *args):
        """
        Accessor to the componentwise standard moments.

        Parameters
        ----------
        k : int
            The standard moment's order.

        Returns
        -------
        m : :class:`~openturns.NumericalPoint`
            Componentwise standard moment of order `k`.

        Notes
        -----
        Standard moments are centered with respect to the first-order moment and
        normalized with respect to the standard deviation:

        .. math::

            \\overline{\\vect{m}}^{(k)}_0 =
                \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                             {\\sigma_i}\\right)^k},
                \\quad i = 1, \\ldots, n\\right)}

        See Also
        --------
        getMean, getStandardDeviation
        """
        return _dist_bundle3.Weibull_getStandardMoment(self, *args)

    def getStandardRepresentative(self):
        """
        Accessor to the standard representative distribution in the parametric family.

        Returns
        -------
        std_repr_dist : :class:`~openturns.Distribution`
            Standard representative distribution.

        Notes
        -----
        The standard representative distribution is the one associated with the
        standard moments.
        """
        return _dist_bundle3.Weibull_getStandardRepresentative(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Weibull_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Weibull_setParametersCollection(self, *args)

    def setBeta(self, *args):
        """
        Accessor to the distribution's scale parameter :math:`\\beta`.

        Parameters
        ----------
        beta : float, :math:`\\beta > 0`
            Scale parameter :math:`\\beta`.
        """
        return _dist_bundle3.Weibull_setBeta(self, *args)

    def getBeta(self):
        """
        Accessor to the distribution's scale parameter :math:`\\beta`.

        Returns
        -------
        beta : float
            Scale parameter :math:`\\beta`.
        """
        return _dist_bundle3.Weibull_getBeta(self)

    def setAlpha(self, *args):
        """
        Accessor to the distribution's shape parameter :math:`\\alpha`.

        Parameters
        ----------
        alpha : float, :math:`\\alpha > 0`
            Shape parameter :math:`\\alpha`.
        """
        return _dist_bundle3.Weibull_setAlpha(self, *args)

    def getAlpha(self):
        """
        Accessor to the distribution's shape parameter :math:`\\alpha`.

        Returns
        -------
        alpha : float
            Shape parameter :math:`\\alpha`.
        """
        return _dist_bundle3.Weibull_getAlpha(self)

    def setMuSigma(self, *args):
        """
        Accessor to the distribution's mean and standard deviation.

        Parameters
        ----------
        mu : float
            Mean.
        sigma : float, :math:`\\sigma > 0`
            Standard deviation.
        """
        return _dist_bundle3.Weibull_setMuSigma(self, *args)

    def getMu(self):
        """
        Accessor to the distribution's mean.

        Returns
        -------
        mu : float
            Mean.
        """
        return _dist_bundle3.Weibull_getMu(self)

    def getSigma(self):
        """
        Accessor to the distribution's standard deviation.

        Returns
        -------
        sigma : float, :math:`\\sigma > 0`
            Standard deviation.
        """
        return _dist_bundle3.Weibull_getSigma(self)

    def setGamma(self, *args):
        """
        Accessor to the distribution's location parameter :math:`\\gamma`.

        Parameters
        ----------
        gamma : float
            Location parameter :math:`\\gamma`.
        """
        return _dist_bundle3.Weibull_setGamma(self, *args)

    def getGamma(self):
        """
        Accessor to the distribution's shift parameter :math:`\\gamma`.

        Returns
        -------
        gamma : float
            Location parameter :math:`\\gamma`.
        """
        return _dist_bundle3.Weibull_getGamma(self)

    def __init__(self, *args): 
        this = _dist_bundle3.new_Weibull(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Weibull
    __del__ = lambda self : None;
Weibull_swigregister = _dist_bundle3.Weibull_swigregister
Weibull_swigregister(Weibull)

class WeibullFactory(openturns.model_copula.DistributionImplementationFactory):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WeibullFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DistributionImplementationFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WeibullFactory, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.WeibullFactory_getClassName(self)

    def build(self, *args): return _dist_bundle3.WeibullFactory_build(self, *args)
    def buildAsWeibull(self, *args): return _dist_bundle3.WeibullFactory_buildAsWeibull(self, *args)
    def __init__(self, *args): 
        this = _dist_bundle3.new_WeibullFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_WeibullFactory
    __del__ = lambda self : None;
WeibullFactory_swigregister = _dist_bundle3.WeibullFactory_swigregister
WeibullFactory_swigregister(WeibullFactory)

class Wishart(openturns.model_copula.ContinuousDistribution):
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Wishart, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.ContinuousDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Wishart, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.Wishart_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.Wishart___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.Wishart___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.Wishart___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.Wishart_getRealization(self)

    def getRealizationAsMatrix(self): return _dist_bundle3.Wishart_getRealizationAsMatrix(self)
    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Wishart_computePDF(self, *args)

    def computeLogPDF(self, *args):
        """
        Compute the logarithm of the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            Logarithm of the PDF value(s) at input(s) `X`.
        """
        return _dist_bundle3.Wishart_computeLogPDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.Wishart_computeCDF(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.Wishart_getStandardDeviation(self)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Wishart_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.Wishart_setParametersCollection(self, *args)

    def setV(self, *args): return _dist_bundle3.Wishart_setV(self, *args)
    def getV(self): return _dist_bundle3.Wishart_getV(self)
    def setNu(self, *args): return _dist_bundle3.Wishart_setNu(self, *args)
    def getNu(self): return _dist_bundle3.Wishart_getNu(self)
    def __init__(self, *args): 
        this = _dist_bundle3.new_Wishart(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_Wishart
    __del__ = lambda self : None;
Wishart_swigregister = _dist_bundle3.Wishart_swigregister
Wishart_swigregister(Wishart)

class ZipfMandelbrot(openturns.model_copula.DiscreteDistribution):
    """
    ZipfMandelbrot distribution.

    Available constructors:
        ZipfMandelbrot(*N=1.0, q=0., s=1.0*)

    Parameters
    ----------
    N : int, :math:`N > 0`
    q : float, :math:`q \\geq 0`
    s : float, :math:`s > 0`

    Notes
    -----
    Its probability density function is defined as:

    .. math::

        \\Prob{X = k} = \\frac{1}{(k+q)^s H(N,q,s)},
                       \\quad \\forall k \\in [1, N]

    where :math:`H(N,q,s)` is the Generalized Harmonic Number:
    :math:`H(N,q,s) = \\sum_{i=1}^{N} \\frac{1}{(i+q)^s}`.

    Its first moments are:

    .. math::
        :nowrap:

        \\begin{eqnarray*}
            \\Expect{X} & =  & \\frac{H_{N,q,s-1}}{H_{N,q,s}}-q \\\\
            \\Var{X} & = & \\frac{\\displaystyle \\sum_{i=1}^N
                                    \\frac{(i - \\Expect{X})^2}{(i+q)^s}}{H_{N,q,s}}
        \\end{eqnarray*}

    Examples
    --------
    Create a distribution:

    >>> import openturns as ot
    >>> distribution = ot.ZipfMandelbrot(15, 1.2, 2.)

    Draw a sample:

    >>> sample = distribution.getSample(10)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ZipfMandelbrot, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.model_copula.DiscreteDistribution]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ZipfMandelbrot, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _dist_bundle3.ZipfMandelbrot_getClassName(self)

    def __eq__(self, *args): return _dist_bundle3.ZipfMandelbrot___eq__(self, *args)
    def __repr__(self): return _dist_bundle3.ZipfMandelbrot___repr__(self)
    def __str__(self, offset=""): return _dist_bundle3.ZipfMandelbrot___str__(self, offset)
    def getRealization(self):
        """
        Accessor to a pseudo-random realization from the distribution.

        Returns
        -------
        point : :class:`~openturns.NumericalPoint`
            A pseudo-random realization of the distribution.

        See Also
        --------
        getSample, RandomGenerator
        """
        return _dist_bundle3.ZipfMandelbrot_getRealization(self)

    def computePDF(self, *args):
        """
        Compute the probability density function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            PDF input(s).

        Returns
        -------
        f : float, :class:`~openturns.NumericalPoint`
            PDF value(s) at input(s) `X`.

        Notes
        -----
        The probability density function is defined as follows:

        .. math::

            f_{\\vect{X}}(\\vect{x}) = \\frac{\\partial^n F_{\\vect{X}}(\\vect{x})}
                                          {\\prod_{i=1}^n \\partial x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.ZipfMandelbrot_computePDF(self, *args)

    def computeCDF(self, *args):
        """
        Compute the cumulative distribution function.

        Parameters
        ----------
        X : :class:`~openturns.NumericalPoint` or 1d-array, :class:`~openturns.NumericalSample` or 2d-array
            CDF input(s).

        Returns
        -------
        F : float, :class:`~openturns.NumericalPoint`
            CDF value(s) at input(s) `X`.

        Notes
        -----
        The cumulative distribution function is defined as:

        .. math::

            F_{\\vect{X}}(\\vect{x}) = \\Prob{\\bigcap_{i=1}^n X_i \\leq x_i},
                                     \\quad \\vect{x} \\in \\supp{\\vect{X}}
        """
        return _dist_bundle3.ZipfMandelbrot_computeCDF(self, *args)

    def getStandardDeviation(self):
        """
        Accessor to the componentwise standard deviation.

        The standard deviation is the square root of the variance.

        Returns
        -------
        sigma : :class:`~openturns.NumericalPoint`
            Componentwise standard deviation.

        See Also
        --------
        getCovariance
        """
        return _dist_bundle3.ZipfMandelbrot_getStandardDeviation(self)

    def getSkewness(self):
        """
        Accessor to the componentwise skewness.

        Returns
        -------
        d : :class:`~openturns.NumericalPoint`
            Componentwise skewness.

        Notes
        -----
        The skewness is the third-order standard moment:

        .. math::

            \\vect{\\delta} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^3},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.ZipfMandelbrot_getSkewness(self)

    def getKurtosis(self):
        """
        Accessor to the componentwise kurtosis.

        Returns
        -------
        k : :class:`~openturns.NumericalPoint`
            Componentwise kurtosis.

        Notes
        -----
        The kurtosis is the fourth-order standard moment:

        .. math::

            \\vect{\\kappa} = \\Tr{\\left(\\Expect{\\left(\\frac{X_i - \\mu_i}
                                                         {\\sigma_i}\\right)^4},
                                      \\quad i = 1, \\ldots, n\\right)}
        """
        return _dist_bundle3.ZipfMandelbrot_getKurtosis(self)

    def setQ(self, *args):
        """
        Accessor to the parameter :math:`q`.

        Parameters
        ----------
        q : float, :math:`q >= 0`
        """
        return _dist_bundle3.ZipfMandelbrot_setQ(self, *args)

    def getQ(self):
        """
        Accessor to the parameter :math:`q`.

        Returns
        -------
        q : float
        """
        return _dist_bundle3.ZipfMandelbrot_getQ(self)

    def setS(self, *args):
        """
        Accessor to the parameter :math:`s`.

        Parameters
        ----------
        s : float, :math:`s > 0`
        """
        return _dist_bundle3.ZipfMandelbrot_setS(self, *args)

    def getS(self):
        """
        Accessor to the parameter :math:`s`.

        Returns
        -------
        s : float
        """
        return _dist_bundle3.ZipfMandelbrot_getS(self)

    def setN(self, *args):
        """
        Accessor to the parameter :math:`N`.

        Parameters
        ----------
        N : int, :math:`N > 0`
        """
        return _dist_bundle3.ZipfMandelbrot_setN(self, *args)

    def getN(self):
        """
        Accessor to the parameter :math:`N`.

        Returns
        -------
        N : int
        """
        return _dist_bundle3.ZipfMandelbrot_getN(self)

    def getSupport(self, *args):
        """
        Accessor to the distribution's support.

        Parameters
        ----------
        interval : :class:`~openturns.Interval`
            An interval to intersect with the distribution's support.

        Returns
        -------
        support : :class:`~openturns.Interval`
            The intersection of the distribution's support with the given `interval`.

        Notes
        -----
        The mathematical support :math:`\\supp{\\vect{X}}` of the distribution is
        the interval (or collection of intervals) where the PDF is non-zero.

        This is yet implemented for discrete distributions only.

        See Also
        --------
        getRange
        """
        return _dist_bundle3.ZipfMandelbrot_getSupport(self, *args)

    def getParametersCollection(self):
        """
        Accessor to the distribution's parameters.

        Returns
        -------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.ZipfMandelbrot_getParametersCollection(self)

    def setParametersCollection(self, *args):
        """
        Accessor to the distribution's parameters.

        Parameters
        ----------
        parameters : :class:`~openturns.NumericalPointWithDescription`
            Dictionary-like object with parameters names and values.
        """
        return _dist_bundle3.ZipfMandelbrot_setParametersCollection(self, *args)

    def __init__(self, *args): 
        this = _dist_bundle3.new_ZipfMandelbrot(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _dist_bundle3.delete_ZipfMandelbrot
    __del__ = lambda self : None;
ZipfMandelbrot_swigregister = _dist_bundle3.ZipfMandelbrot_swigregister
ZipfMandelbrot_swigregister(ZipfMandelbrot)

# This file is compatible with both classic and new-style classes.


