# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""
Function primitives.
"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_func', [dirname(__file__)])
        except ImportError:
            import _func
            return _func
        if fp is not None:
            try:
                _mod = imp.load_module('_func', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _func = swig_import_helper()
    del swig_import_helper
else:
    import _func
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _func.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self): return _func.SwigPyIterator_value(self)
    def incr(self, n=1): return _func.SwigPyIterator_incr(self, n)
    def decr(self, n=1): return _func.SwigPyIterator_decr(self, n)
    def distance(self, *args): return _func.SwigPyIterator_distance(self, *args)
    def equal(self, *args): return _func.SwigPyIterator_equal(self, *args)
    def copy(self): return _func.SwigPyIterator_copy(self)
    def next(self): return _func.SwigPyIterator_next(self)
    def __next__(self): return _func.SwigPyIterator___next__(self)
    def previous(self): return _func.SwigPyIterator_previous(self)
    def advance(self, *args): return _func.SwigPyIterator_advance(self, *args)
    def __eq__(self, *args): return _func.SwigPyIterator___eq__(self, *args)
    def __ne__(self, *args): return _func.SwigPyIterator___ne__(self, *args)
    def __iadd__(self, *args): return _func.SwigPyIterator___iadd__(self, *args)
    def __isub__(self, *args): return _func.SwigPyIterator___isub__(self, *args)
    def __add__(self, *args): return _func.SwigPyIterator___add__(self, *args)
    def __sub__(self, *args): return _func.SwigPyIterator___sub__(self, *args)
    def __iter__(self): return self
SwigPyIterator_swigregister = _func.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

GCC_VERSION = _func.GCC_VERSION
class TestFailed:
    """TestFailed is used to raise an uniform exception in tests."""

    __type = "TestFailed"

    def __init__(self, reason=""):
        self.reason = reason

    def type(self):
        return TestFailed.__type

    def what(self):
        return self.reason

    def __str__(self):
        return TestFailed.__type + ": " + self.reason

    def __lshift__(self, ch):
        self.reason += ch
        return self

import openturns.common
import openturns.wrapper
import openturns.typ
import openturns.geom
import openturns.graph
class EnumerateFunctionImplementation(openturns.common.PersistentObject):
    """
    Enumerate function.

    Available constructors:
        EnumerateFunction(*dim=1*)

        EnumerateFunction(*dim, q*)

        EnumerateFunction(*weight, q*)

    Parameters
    ----------
    dim : positive int
        If *dim* is the only argument mentioned, it is used to create
        a :class:`~openturns.LinearEnumerateFunction` object of dimension *dim*.
        If *q* is also mentioned, it is used to create
        a :class:`~openturns.HyperbolicAnisotropicEnumerateFunction` object of
        dimension *dim* and parameter *q*.
    q : float
        The q-quasi-norm parameter used to create a
        :class:`~openturns.HyperbolicAnisotropicEnumerateFunction` object.
    weight : float sequence
        The weights of the indices in each dimension used to create a
        :class:`~openturns.HyperbolicAnisotropicEnumerateFunction` object.

    Notes
    -----
    *EnumerateFunction* represents a bijection from :math:`\\Nset` to
    :math:`\\Nset^{dim}`. This bijection is based on a particular procedure of
    enumerating the set of multi-indices. It begins from the multi-index
    :math:`\\{0,0,\\dots,0\\}`.

    We associate a multi-index :math:`\\{j_{p1}, j_{p2},\\dots, j_{pdim}\\}` for every
    integer :math:`i_p` in :math:`\\Nset`:

    For more details, let us consider any :math:`i_p, i_q \\in \\Nset`:

    if :math:`|i_p-i_q|\\leq 1` then
    :math:`|\\sum_{k=1}^{dim} (j_{pk}- j_{qk})| \\leq 1`. This proposition provides a
    necessary but unsufficient condition for the construction of the bijection.
    Another assumption was done indicating the way of iteration.
    Below an example showing this assumption.

    Example for :math:`dim=2`:

    .. math::

        phi(0) &= [0 ~ 0] \\\\
        phi(1) &= [1 ~ 0] \\\\
        phi(2) &= [0 ~ 1] \\\\
        phi(3) &= [2 ~ 0] \\\\
        phi(4) &= [1 ~ 1] \\\\
        phi(5) &= [0 ~ 2] \\\\
        phi(6) &= [3 ~ 0]

    For the functional expansion (respectively polynomial chaos expansion), the
    multi-index :math:`\\vect{i_p}` represents the collection of degrees of the
    selected orthogonal functions (respectively orthogonal polynomials). In fact,
    after the selection of the type of orthogonal functions (respectively
    orthogonal polynomials) for the construction of the orthogonal basis, the
    *EnumerateFunction* characterizes the term of the basis by providing the
    degrees of the univariate functions (respectively univariate polynomials).

    In order to know the degree of the :math:`k^{th}` polynomial of the
    multivariate basis, it is enough to sum all the integers given in the list.

    Examples
    --------
    >>> import openturns as ot
    >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
    >>> for i in range(6):
    ...     print(enumerateFunction(i))
    [0,0]
    [1,0]
    [0,1]
    [2,0]
    [1,1]
    [0,2]
    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, EnumerateFunctionImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, EnumerateFunctionImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.EnumerateFunctionImplementation_getClassName(self)

    def __repr__(self): return _func.EnumerateFunctionImplementation___repr__(self)
    def __call__(self, *args): return _func.EnumerateFunctionImplementation___call__(self, *args)
    def inverse(self, *args):
        """
        Get the antecedent of a indices list in the *EnumerateFunction*.

        Parameters
        ----------
        multiIndex : list of int
            List of indices.

        Returns
        -------
        antecedent : int
            Represents the antecedent of the *multiIndex* in the *EnumerateFunction*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     print(str(i)+' '+str(enumerateFunction(i)))
        0 [0,0]
        1 [1,0]
        2 [0,1]
        3 [2,0]
        4 [1,1]
        5 [0,2]
        >>> print(enumerateFunction.inverse([1,1]))
        4
        """
        return _func.EnumerateFunctionImplementation_inverse(self, *args)

    def getStrataCardinal(self, *args):
        """
        Get the number of members of the basis associated to a given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynom degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strata *strataIndex*. In
            the context of product of polynomial basis, this is the number of polynoms
            of the basis which total degree is *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [3, 4, 5]:
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCardinal(2))
        3
        """
        return _func.EnumerateFunctionImplementation_getStrataCardinal(self, *args)

    def getStrataCumulatedCardinal(self, *args):
        """
        Get the cardinal of the cumulated strata above or equal to the given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynomial degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strates inferior or equal
            to *strataIndex*. In the context of product of polynomial basis, this is
            the number of polynomials of the basis which total degree is inferior or
            equal to *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        0 [0,0]
        1 [1,0]
        1 [0,1]
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCumulatedCardinal(2))
        6
        """
        return _func.EnumerateFunctionImplementation_getStrataCumulatedCardinal(self, *args)

    def getMaximumDegreeStrataIndex(self, *args):
        """
        Get the index of the strata of degree inferior to a given value.

        Parameters
        ----------
        maximumDegree : int
            Degree.

        Returns
        -------
        index : int
            Index of the strata of degree :math:`max < maximumDegree`.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [1, 2]:
        ...     indices = enumerateFunction(i)
        ...     strataIndex = sum(indices) + 1
        ...     print(str(int(strataIndex))+' '+str(indices))
        2 [1,0]
        2 [0,1]
        >>> print(enumerateFunction.getMaximumDegreeStrataIndex(2))
        2
        """
        return _func.EnumerateFunctionImplementation_getMaximumDegreeStrataIndex(self, *args)

    def getMaximumDegreeCardinal(self, *args):
        """
        Get the cardinal of indices of degree inferior or equal to a given value.

        Parameters
        ----------
        maximumDegree : int
            Number of polynoms of the basis.

        Returns
        -------
        cardinal : int
            Cardinal of indices of degree :math:`max \\leq maximumDegree`.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        0 [0,0]
        1 [1,0]
        1 [0,1]
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getMaximumDegreeCardinal(2))
        6
        """
        return _func.EnumerateFunctionImplementation_getMaximumDegreeCardinal(self, *args)

    def setDimension(self, *args):
        """
        Set the dimension of the *EnumerateFunction*.

        Parameters
        ----------
        dim : int, :math:`dim \\geq 0`
            Dimension of the *EnumerateFunction*.
        """
        return _func.EnumerateFunctionImplementation_setDimension(self, *args)

    def getDimension(self):
        """
        Return the dimension of the *EnumerateFunction*.

        Returns
        -------
        dim : int, :math:`dim \\geq 0`
            Dimension of the *EnumerateFunction*.
        """
        return _func.EnumerateFunctionImplementation_getDimension(self)

    def __init__(self, *args): 
        this = _func.new_EnumerateFunctionImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_EnumerateFunctionImplementation
    __del__ = lambda self : None;
EnumerateFunctionImplementation_swigregister = _func.EnumerateFunctionImplementation_swigregister
EnumerateFunctionImplementation_swigregister(EnumerateFunctionImplementation)

class EnumerateFunctionImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, EnumerateFunctionImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, EnumerateFunctionImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_EnumerateFunctionImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.EnumerateFunctionImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.EnumerateFunctionImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.EnumerateFunctionImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.EnumerateFunctionImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_EnumerateFunctionImplementationTypedInterfaceObject
    __del__ = lambda self : None;
EnumerateFunctionImplementationTypedInterfaceObject_swigregister = _func.EnumerateFunctionImplementationTypedInterfaceObject_swigregister
EnumerateFunctionImplementationTypedInterfaceObject_swigregister(EnumerateFunctionImplementationTypedInterfaceObject)

class EnumerateFunction(EnumerateFunctionImplementationTypedInterfaceObject):
    """
    Enumerate function.

    Available constructors:
        EnumerateFunction(*dim=1*)

        EnumerateFunction(*dim, q*)

        EnumerateFunction(*weight, q*)

    Parameters
    ----------
    dim : positive int
        If *dim* is the only argument mentioned, it is used to create
        a :class:`~openturns.LinearEnumerateFunction` object of dimension *dim*.
        If *q* is also mentioned, it is used to create
        a :class:`~openturns.HyperbolicAnisotropicEnumerateFunction` object of
        dimension *dim* and parameter *q*.
    q : float
        The q-quasi-norm parameter used to create a
        :class:`~openturns.HyperbolicAnisotropicEnumerateFunction` object.
    weight : float sequence
        The weights of the indices in each dimension used to create a
        :class:`~openturns.HyperbolicAnisotropicEnumerateFunction` object.

    Notes
    -----
    *EnumerateFunction* represents a bijection from :math:`\\Nset` to
    :math:`\\Nset^{dim}`. This bijection is based on a particular procedure of
    enumerating the set of multi-indices. It begins from the multi-index
    :math:`\\{0,0,\\dots,0\\}`.

    We associate a multi-index :math:`\\{j_{p1}, j_{p2},\\dots, j_{pdim}\\}` for every
    integer :math:`i_p` in :math:`\\Nset`:

    For more details, let us consider any :math:`i_p, i_q \\in \\Nset`:

    if :math:`|i_p-i_q|\\leq 1` then
    :math:`|\\sum_{k=1}^{dim} (j_{pk}- j_{qk})| \\leq 1`. This proposition provides a
    necessary but unsufficient condition for the construction of the bijection.
    Another assumption was done indicating the way of iteration.
    Below an example showing this assumption.

    Example for :math:`dim=2`:

    .. math::

        phi(0) &= [0 ~ 0] \\\\
        phi(1) &= [1 ~ 0] \\\\
        phi(2) &= [0 ~ 1] \\\\
        phi(3) &= [2 ~ 0] \\\\
        phi(4) &= [1 ~ 1] \\\\
        phi(5) &= [0 ~ 2] \\\\
        phi(6) &= [3 ~ 0]

    For the functional expansion (respectively polynomial chaos expansion), the
    multi-index :math:`\\vect{i_p}` represents the collection of degrees of the
    selected orthogonal functions (respectively orthogonal polynomials). In fact,
    after the selection of the type of orthogonal functions (respectively
    orthogonal polynomials) for the construction of the orthogonal basis, the
    *EnumerateFunction* characterizes the term of the basis by providing the
    degrees of the univariate functions (respectively univariate polynomials).

    In order to know the degree of the :math:`k^{th}` polynomial of the
    multivariate basis, it is enough to sum all the integers given in the list.

    Examples
    --------
    >>> import openturns as ot
    >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
    >>> for i in range(6):
    ...     print(enumerateFunction(i))
    [0,0]
    [1,0]
    [0,1]
    [2,0]
    [1,1]
    [0,2]
    """
    __swig_setmethods__ = {}
    for _s in [EnumerateFunctionImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, EnumerateFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [EnumerateFunctionImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, EnumerateFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.EnumerateFunction_getClassName(self)

    def __repr__(self): return _func.EnumerateFunction___repr__(self)
    def __str__(self, offset=""): return _func.EnumerateFunction___str__(self, offset)
    def __call__(self, *args): return _func.EnumerateFunction___call__(self, *args)
    def inverse(self, *args):
        """
        Get the antecedent of a indices list in the *EnumerateFunction*.

        Parameters
        ----------
        multiIndex : list of int
            List of indices.

        Returns
        -------
        antecedent : int
            Represents the antecedent of the *multiIndex* in the *EnumerateFunction*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     print(str(i)+' '+str(enumerateFunction(i)))
        0 [0,0]
        1 [1,0]
        2 [0,1]
        3 [2,0]
        4 [1,1]
        5 [0,2]
        >>> print(enumerateFunction.inverse([1,1]))
        4
        """
        return _func.EnumerateFunction_inverse(self, *args)

    def getStrataCardinal(self, *args):
        """
        Get the number of members of the basis associated to a given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynom degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strata *strataIndex*. In
            the context of product of polynomial basis, this is the number of polynoms
            of the basis which total degree is *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [3, 4, 5]:
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCardinal(2))
        3
        """
        return _func.EnumerateFunction_getStrataCardinal(self, *args)

    def getStrataCumulatedCardinal(self, *args):
        """
        Get the cardinal of the cumulated strata above or equal to the given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynomial degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strates inferior or equal
            to *strataIndex*. In the context of product of polynomial basis, this is
            the number of polynomials of the basis which total degree is inferior or
            equal to *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        0 [0,0]
        1 [1,0]
        1 [0,1]
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCumulatedCardinal(2))
        6
        """
        return _func.EnumerateFunction_getStrataCumulatedCardinal(self, *args)

    def getMaximumDegreeStrataIndex(self, *args):
        """
        Get the index of the strata of degree inferior to a given value.

        Parameters
        ----------
        maximumDegree : int
            Degree.

        Returns
        -------
        index : int
            Index of the strata of degree :math:`max < maximumDegree`.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [1, 2]:
        ...     indices = enumerateFunction(i)
        ...     strataIndex = sum(indices) + 1
        ...     print(str(int(strataIndex))+' '+str(indices))
        2 [1,0]
        2 [0,1]
        >>> print(enumerateFunction.getMaximumDegreeStrataIndex(2))
        2
        """
        return _func.EnumerateFunction_getMaximumDegreeStrataIndex(self, *args)

    def getMaximumDegreeCardinal(self, *args):
        """
        Get the cardinal of indices of degree inferior or equal to a given value.

        Parameters
        ----------
        maximumDegree : int
            Number of polynoms of the basis.

        Returns
        -------
        cardinal : int
            Cardinal of indices of degree :math:`max \\leq maximumDegree`.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        0 [0,0]
        1 [1,0]
        1 [0,1]
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getMaximumDegreeCardinal(2))
        6
        """
        return _func.EnumerateFunction_getMaximumDegreeCardinal(self, *args)

    def setDimension(self, *args):
        """
        Set the dimension of the *EnumerateFunction*.

        Parameters
        ----------
        dim : int, :math:`dim \\geq 0`
            Dimension of the *EnumerateFunction*.
        """
        return _func.EnumerateFunction_setDimension(self, *args)

    def getDimension(self):
        """
        Return the dimension of the *EnumerateFunction*.

        Returns
        -------
        dim : int, :math:`dim \\geq 0`
            Dimension of the *EnumerateFunction*.
        """
        return _func.EnumerateFunction_getDimension(self)

    def __init__(self, *args): 
        this = _func.new_EnumerateFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_EnumerateFunction
    __del__ = lambda self : None;
EnumerateFunction_swigregister = _func.EnumerateFunction_swigregister
EnumerateFunction_swigregister(EnumerateFunction)

class LinearEnumerateFunction(EnumerateFunctionImplementation):
    """
    Linear enumerate function.

    Available constructors:
        LinearEnumerateFunction(*dim=1*)

    Parameters
    ----------
    dim : int
        Dimension.

    Notes
    -----
    Given an input random vector :math:`\\vect{X}` with prescribed probability
    density function (PDF) :math:`f_{\\vect{X}}(\\vect{x})`, it is possible to build
    up a *polynomial chaos* (PC) basis
    :math:`\\{\\psi_{\\vect{\\alpha}},\\vect{\\alpha} \\in \\Nset^{n_X}\\}`. Of interest is
    the definition of enumeration strategies for exploring this basis, i.e. of
    suitable *enumeration functions* :math:`\\tau` from :math:`\\Nset` to
    :math:`\\Nset^{n_X}`, which creates a one-to-one mapping between an integer
    :math:`j` and a multi-index :math:`\\Nset^{n_X}`.

    Let us first define the *total degree* of any multi-index :math:`\\vect{\\alpha}`
    in :math:`\\Nset^{n_X}` by :math:`\\sum_{i=1}^{n_X} \\alpha_i`. A natural choice to
    sort the PC basis (i.e. the multi-indices :math:`\\vect{\\alpha}`)
    is the lexicographical order with a constraint of increasing total degree.
    Mathematically speaking, a bijective enumeration function :math:`\\tau` is
    defined by:

    .. math::

        \\begin{array}{llcl}
          \\tau \\, : & \\Nset & \\longrightarrow & \\Nset^{n_X} \\\\
          &  j & \\longmapsto & \\{\\alpha_1,\\dots, \\alpha_{n_X}\\} \\,
                     \\equiv \\, \\{\\tau_1(j),\\dots,\\tau_{n_X}(j)\\} \\\\
        \\end{array}

    such that:

    .. math::

        \\tau(0) = \\{0,\\dots,0\\}

    and

    .. math::

        \\forall 1 \\leq j<k  \\quad \\, , \\quad \\, \\left\\{
        \\begin{array}{l}
          \\displaystyle{\\sum_{i=1}^{n_X} \\tau_i(j) < \\sum_{i=1}^{n_X} \\tau_i(k)}  \\\\
          \\\\
          \\mbox{ or} \\\\
          \\\\
          \\displaystyle{\\exists \\; m \\in \\{1,\\dots,n_X\\} \\; : \\;
              \\left(\\forall i \\leq m , \\; \\tau_i(j) = \\tau_i(k) \\; \\right)
              \\, \\, \\, \\mbox{ and } \\, \\, \\,
              \\left(\\tau_m(j) < \\tau_m(k) \\right)} \\\\
        \\end{array}
        \\right.

    Such an enumeration strategy is illustrated in a two-dimensional case
    (i.e. :math:`n_X=2`) in the figure below:

    .. plot:: pyplots/LinearEnumerateFunction.py
        :include-source: False

    This corresponds to the following enumeration of the multi-indices:

    ===== =====================
      j   :math:`\\vect{\\alpha} = \\{\\alpha_1,\\alpha_2\\}`
    ===== =====================
      0       {0, 0}
      1       {1, 0}
      2       {0, 1}
      3       {2, 0}
      4       {1, 1}
      5       {0, 2}
      6       {3, 0}
      7       {2, 1}
      8       {1, 2}
      9       {0, 3}
    ===== =====================

    See also
    --------
    EnumerateFunction, HyperbolicAnisotropicEnumerateFunction

    Examples
    --------
    >>> import openturns as ot
    >>> # 4-dimensional case
    >>> enumerateFunction = ot.LinearEnumerateFunction(4)
    >>> for i in range(9):
    ...     print(enumerateFunction(i))
    [0,0,0,0]
    [1,0,0,0]
    [0,1,0,0]
    [0,0,1,0]
    [0,0,0,1]
    [2,0,0,0]
    [1,1,0,0]
    [1,0,1,0]
    [1,0,0,1]
    """
    __swig_setmethods__ = {}
    for _s in [EnumerateFunctionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearEnumerateFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [EnumerateFunctionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearEnumerateFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearEnumerateFunction_getClassName(self)

    def __repr__(self): return _func.LinearEnumerateFunction___repr__(self)
    def __call__(self, *args): return _func.LinearEnumerateFunction___call__(self, *args)
    def inverse(self, *args):
        """
        Get the antecedent of a indices list in the *EnumerateFunction*.

        Parameters
        ----------
        multiIndex : list of int
            List of indices.

        Returns
        -------
        antecedent : int
            Represents the antecedent of the *multiIndex* in the *EnumerateFunction*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     print(str(i)+' '+str(enumerateFunction(i)))
        0 [0,0]
        1 [1,0]
        2 [0,1]
        3 [2,0]
        4 [1,1]
        5 [0,2]
        >>> print(enumerateFunction.inverse([1,1]))
        4
        """
        return _func.LinearEnumerateFunction_inverse(self, *args)

    def getStrataCardinal(self, *args):
        """
        Get the number of members of the basis associated to a given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynom degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strata *strataIndex*. In
            the context of product of polynomial basis, this is the number of polynoms
            of the basis which total degree is *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [3, 4, 5]:
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCardinal(2))
        3
        """
        return _func.LinearEnumerateFunction_getStrataCardinal(self, *args)

    def getStrataCumulatedCardinal(self, *args):
        """
        Get the cardinal of the cumulated strata above or equal to the given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynomial degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strates inferior or equal
            to *strataIndex*. In the context of product of polynomial basis, this is
            the number of polynomials of the basis which total degree is inferior or
            equal to *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        0 [0,0]
        1 [1,0]
        1 [0,1]
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCumulatedCardinal(2))
        6
        """
        return _func.LinearEnumerateFunction_getStrataCumulatedCardinal(self, *args)

    def getMaximumDegreeStrataIndex(self, *args):
        """
        Get the index of the strata of degree inferior to a given value.

        Parameters
        ----------
        maximumDegree : int
            Degree.

        Returns
        -------
        index : int
            Index of the strata of degree :math:`max < maximumDegree`.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [1, 2]:
        ...     indices = enumerateFunction(i)
        ...     strataIndex = sum(indices) + 1
        ...     print(str(int(strataIndex))+' '+str(indices))
        2 [1,0]
        2 [0,1]
        >>> print(enumerateFunction.getMaximumDegreeStrataIndex(2))
        2
        """
        return _func.LinearEnumerateFunction_getMaximumDegreeStrataIndex(self, *args)

    def __init__(self, *args): 
        this = _func.new_LinearEnumerateFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearEnumerateFunction
    __del__ = lambda self : None;
LinearEnumerateFunction_swigregister = _func.LinearEnumerateFunction_swigregister
LinearEnumerateFunction_swigregister(LinearEnumerateFunction)

class HyperbolicAnisotropicEnumerateFunction(EnumerateFunctionImplementation):
    __swig_setmethods__ = {}
    for _s in [EnumerateFunctionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HyperbolicAnisotropicEnumerateFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [EnumerateFunctionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HyperbolicAnisotropicEnumerateFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.HyperbolicAnisotropicEnumerateFunction_getClassName(self)

    def __repr__(self): return _func.HyperbolicAnisotropicEnumerateFunction___repr__(self)
    def __call__(self, *args): return _func.HyperbolicAnisotropicEnumerateFunction___call__(self, *args)
    def inverse(self, *args):
        """
        Get the antecedent of a indices list in the *EnumerateFunction*.

        Parameters
        ----------
        multiIndex : list of int
            List of indices.

        Returns
        -------
        antecedent : int
            Represents the antecedent of the *multiIndex* in the *EnumerateFunction*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     print(str(i)+' '+str(enumerateFunction(i)))
        0 [0,0]
        1 [1,0]
        2 [0,1]
        3 [2,0]
        4 [1,1]
        5 [0,2]
        >>> print(enumerateFunction.inverse([1,1]))
        4
        """
        return _func.HyperbolicAnisotropicEnumerateFunction_inverse(self, *args)

    def getStrataCardinal(self, *args):
        """
        Get the number of members of the basis associated to a given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynom degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strata *strataIndex*. In
            the context of product of polynomial basis, this is the number of polynoms
            of the basis which total degree is *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [3, 4, 5]:
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCardinal(2))
        3
        """
        return _func.HyperbolicAnisotropicEnumerateFunction_getStrataCardinal(self, *args)

    def getStrataCumulatedCardinal(self, *args):
        """
        Get the cardinal of the cumulated strata above or equal to the given strata.

        Parameters
        ----------
        strataIndex : int
            Index of the strata in the hierarchical basis. In the context of product of
            polynomial basis, this is the total polynomial degree.

        Returns
        -------
        cardinal : int
            Number of members of the basis associated to the strates inferior or equal
            to *strataIndex*. In the context of product of polynomial basis, this is
            the number of polynomials of the basis which total degree is inferior or
            equal to *strataIndex*.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in range(6):
        ...     indices = enumerateFunction(i)
        ...     degree = sum(indices)
        ...     print(str(int(degree))+' '+str(indices))
        0 [0,0]
        1 [1,0]
        1 [0,1]
        2 [2,0]
        2 [1,1]
        2 [0,2]
        >>> print(enumerateFunction.getStrataCumulatedCardinal(2))
        6
        """
        return _func.HyperbolicAnisotropicEnumerateFunction_getStrataCumulatedCardinal(self, *args)

    def getMaximumDegreeStrataIndex(self, *args):
        """
        Get the index of the strata of degree inferior to a given value.

        Parameters
        ----------
        maximumDegree : int
            Degree.

        Returns
        -------
        index : int
            Index of the strata of degree :math:`max < maximumDegree`.

        Examples
        --------
        >>> import openturns as ot
        >>> enumerateFunction = ot.EnumerateFunction(ot.LinearEnumerateFunction(2))
        >>> for i in [1, 2]:
        ...     indices = enumerateFunction(i)
        ...     strataIndex = sum(indices) + 1
        ...     print(str(int(strataIndex))+' '+str(indices))
        2 [1,0]
        2 [0,1]
        >>> print(enumerateFunction.getMaximumDegreeStrataIndex(2))
        2
        """
        return _func.HyperbolicAnisotropicEnumerateFunction_getMaximumDegreeStrataIndex(self, *args)

    def setQ(self, *args): return _func.HyperbolicAnisotropicEnumerateFunction_setQ(self, *args)
    def getQ(self): return _func.HyperbolicAnisotropicEnumerateFunction_getQ(self)
    def setWeight(self, *args): return _func.HyperbolicAnisotropicEnumerateFunction_setWeight(self, *args)
    def getWeight(self): return _func.HyperbolicAnisotropicEnumerateFunction_getWeight(self)
    def __init__(self, *args): 
        this = _func.new_HyperbolicAnisotropicEnumerateFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_HyperbolicAnisotropicEnumerateFunction
    __del__ = lambda self : None;
HyperbolicAnisotropicEnumerateFunction_swigregister = _func.HyperbolicAnisotropicEnumerateFunction_swigregister
HyperbolicAnisotropicEnumerateFunction_swigregister(HyperbolicAnisotropicEnumerateFunction)

OT_TYPECHECK_FIELDIMPLEMENTATION = _func.OT_TYPECHECK_FIELDIMPLEMENTATION
class FieldImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FieldImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FieldImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.FieldImplementation_getClassName(self)

    def getValueAtIndex(self, *args): return _func.FieldImplementation_getValueAtIndex(self, *args)
    def setValueAtIndex(self, *args): return _func.FieldImplementation_setValueAtIndex(self, *args)
    def getValueAtNearestPosition(self, *args): return _func.FieldImplementation_getValueAtNearestPosition(self, *args)
    def setValueAtNearestPosition(self, *args): return _func.FieldImplementation_setValueAtNearestPosition(self, *args)
    def getValueAtNearestTime(self, *args): return _func.FieldImplementation_getValueAtNearestTime(self, *args)
    def setValueAtNearestTime(self, *args): return _func.FieldImplementation_setValueAtNearestTime(self, *args)
    def setDescription(self, *args): return _func.FieldImplementation_setDescription(self, *args)
    def getDescription(self): return _func.FieldImplementation_getDescription(self)
    def getMesh(self): return _func.FieldImplementation_getMesh(self)
    def getTimeGrid(self): return _func.FieldImplementation_getTimeGrid(self)
    def __eq__(self, *args): return _func.FieldImplementation___eq__(self, *args)
    def __repr__(self): return _func.FieldImplementation___repr__(self)
    def __str__(self, offset=""): return _func.FieldImplementation___str__(self, offset)
    def getSize(self): return _func.FieldImplementation_getSize(self)
    def getSpatialDimension(self): return _func.FieldImplementation_getSpatialDimension(self)
    def getDimension(self): return _func.FieldImplementation_getDimension(self)
    def getSample(self): return _func.FieldImplementation_getSample(self)
    def getValues(self): return _func.FieldImplementation_getValues(self)
    def setValues(self, *args): return _func.FieldImplementation_setValues(self, *args)
    def __len__(self): return _func.FieldImplementation___len__(self)
    def __contains__(self, *args): return _func.FieldImplementation___contains__(self, *args)
    def asSample(self): return _func.FieldImplementation_asSample(self)
    def asDeformedMesh(self): return _func.FieldImplementation_asDeformedMesh(self)
    def getSpatialMean(self): return _func.FieldImplementation_getSpatialMean(self)
    def getTemporalMean(self): return _func.FieldImplementation_getTemporalMean(self)
    def drawMarginal(self, index=0, interpolate=True): return _func.FieldImplementation_drawMarginal(self, index, interpolate)
    def draw(self): return _func.FieldImplementation_draw(self)
    def exportToVTKFile(self, *args): return _func.FieldImplementation_exportToVTKFile(self, *args)
    def __getitem__(self, *args): return _func.FieldImplementation___getitem__(self, *args)
    def __setitem__(self, *args): return _func.FieldImplementation___setitem__(self, *args)
    def __init__(self, *args): 
        this = _func.new_FieldImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_FieldImplementation
    __del__ = lambda self : None;
FieldImplementation_swigregister = _func.FieldImplementation_swigregister
FieldImplementation_swigregister(FieldImplementation)

class FieldImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FieldImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FieldImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_FieldImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.FieldImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.FieldImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.FieldImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.FieldImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_FieldImplementationTypedInterfaceObject
    __del__ = lambda self : None;
FieldImplementationTypedInterfaceObject_swigregister = _func.FieldImplementationTypedInterfaceObject_swigregister
FieldImplementationTypedInterfaceObject_swigregister(FieldImplementationTypedInterfaceObject)

class Field(FieldImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [FieldImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Field, name, value)
    __swig_getmethods__ = {}
    for _s in [FieldImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Field, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.Field_getClassName(self)

    def getValueAtIndex(self, *args): return _func.Field_getValueAtIndex(self, *args)
    def setValueAtIndex(self, *args): return _func.Field_setValueAtIndex(self, *args)
    def getValueAtNearestPosition(self, *args): return _func.Field_getValueAtNearestPosition(self, *args)
    def setValueAtNearestPosition(self, *args): return _func.Field_setValueAtNearestPosition(self, *args)
    def setDescription(self, *args): return _func.Field_setDescription(self, *args)
    def getDescription(self): return _func.Field_getDescription(self)
    def getMesh(self): return _func.Field_getMesh(self)
    def getTimeGrid(self): return _func.Field_getTimeGrid(self)
    def __eq__(self, *args): return _func.Field___eq__(self, *args)
    def __len__(self): return _func.Field___len__(self)
    def __getitem__(self, *args): return _func.Field___getitem__(self, *args)
    def __setitem__(self, *args): return _func.Field___setitem__(self, *args)
    def __repr__(self): return _func.Field___repr__(self)
    def __str__(self, offset=""): return _func.Field___str__(self, offset)
    def getSize(self): return _func.Field_getSize(self)
    def getSpatialDimension(self): return _func.Field_getSpatialDimension(self)
    def getDimension(self): return _func.Field_getDimension(self)
    def getSample(self): return _func.Field_getSample(self)
    def getValues(self): return _func.Field_getValues(self)
    def setValues(self, *args): return _func.Field_setValues(self, *args)
    def asDeformedMesh(self): return _func.Field_asDeformedMesh(self)
    def getSpatialMean(self): return _func.Field_getSpatialMean(self)
    def getTemporalMean(self): return _func.Field_getTemporalMean(self)
    def drawMarginal(self, index=0, interpolate=True): return _func.Field_drawMarginal(self, index, interpolate)
    def draw(self): return _func.Field_draw(self)
    def exportToVTKFile(self, *args): return _func.Field_exportToVTKFile(self, *args)
    def __init__(self, *args): 
        this = _func.new_Field(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_Field
    __del__ = lambda self : None;
Field_swigregister = _func.Field_swigregister
Field_swigregister(Field)

class TimeSeries(FieldImplementation):
    __swig_setmethods__ = {}
    for _s in [FieldImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeSeries, name, value)
    __swig_getmethods__ = {}
    for _s in [FieldImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeSeries, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.TimeSeries_getClassName(self)

    def __repr__(self): return _func.TimeSeries___repr__(self)
    def __str__(self, offset=""): return _func.TimeSeries___str__(self, offset)
    def __eq__(self, *args): return _func.TimeSeries___eq__(self, *args)
    def contains(self, *args): return _func.TimeSeries_contains(self, *args)
    def add(self, *args): return _func.TimeSeries_add(self, *args)
    def __init__(self, *args): 
        this = _func.new_TimeSeries(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_TimeSeries
    __del__ = lambda self : None;
TimeSeries_swigregister = _func.TimeSeries_swigregister
TimeSeries_swigregister(TimeSeries)

class ProcessSample(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProcessSample, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProcessSample, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ProcessSample_getClassName(self)

    def add(self, *args): return _func.ProcessSample_add(self, *args)
    def __getitem__(self, *args): return _func.ProcessSample___getitem__(self, *args)
    def __setitem__(self, *args): return _func.ProcessSample___setitem__(self, *args)
    def __repr__(self): return _func.ProcessSample___repr__(self)
    def __str__(self, offset=""): return _func.ProcessSample___str__(self, offset)
    def getTimeGrid(self): return _func.ProcessSample_getTimeGrid(self)
    def getMesh(self): return _func.ProcessSample_getMesh(self)
    def getSize(self): return _func.ProcessSample_getSize(self)
    def getDimension(self): return _func.ProcessSample_getDimension(self)
    def computeMean(self): return _func.ProcessSample_computeMean(self)
    def computeTemporalMean(self): return _func.ProcessSample_computeTemporalMean(self)
    def computeSpatialMean(self): return _func.ProcessSample_computeSpatialMean(self)
    def computeQuantilePerComponent(self, *args): return _func.ProcessSample_computeQuantilePerComponent(self, *args)
    def drawMarginal(self, index=0): return _func.ProcessSample_drawMarginal(self, index)
    def __init__(self, *args): 
        this = _func.new_ProcessSample(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ProcessSample
    __del__ = lambda self : None;
ProcessSample_swigregister = _func.ProcessSample_swigregister
ProcessSample_swigregister(ProcessSample)

class SpecFunc(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpecFunc, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SpecFunc, name)
    __repr__ = _swig_repr
    __swig_getmethods__["IsNaN"] = lambda x: _func.SpecFunc_IsNaN
    if _newclass:IsNaN = staticmethod(_func.SpecFunc_IsNaN)
    __swig_getmethods__["IsInf"] = lambda x: _func.SpecFunc_IsInf
    if _newclass:IsInf = staticmethod(_func.SpecFunc_IsInf)
    __swig_getmethods__["IsNormal"] = lambda x: _func.SpecFunc_IsNormal
    if _newclass:IsNormal = staticmethod(_func.SpecFunc_IsNormal)
    __swig_getmethods__["BesselI0"] = lambda x: _func.SpecFunc_BesselI0
    if _newclass:BesselI0 = staticmethod(_func.SpecFunc_BesselI0)
    __swig_getmethods__["LogBesselI0"] = lambda x: _func.SpecFunc_LogBesselI0
    if _newclass:LogBesselI0 = staticmethod(_func.SpecFunc_LogBesselI0)
    __swig_getmethods__["BesselI1"] = lambda x: _func.SpecFunc_BesselI1
    if _newclass:BesselI1 = staticmethod(_func.SpecFunc_BesselI1)
    __swig_getmethods__["LogBesselI1"] = lambda x: _func.SpecFunc_LogBesselI1
    if _newclass:LogBesselI1 = staticmethod(_func.SpecFunc_LogBesselI1)
    __swig_getmethods__["LargeCaseDeltaLogBesselI10"] = lambda x: _func.SpecFunc_LargeCaseDeltaLogBesselI10
    if _newclass:LargeCaseDeltaLogBesselI10 = staticmethod(_func.SpecFunc_LargeCaseDeltaLogBesselI10)
    __swig_getmethods__["DeltaLogBesselI10"] = lambda x: _func.SpecFunc_DeltaLogBesselI10
    if _newclass:DeltaLogBesselI10 = staticmethod(_func.SpecFunc_DeltaLogBesselI10)
    __swig_getmethods__["LogBesselK"] = lambda x: _func.SpecFunc_LogBesselK
    if _newclass:LogBesselK = staticmethod(_func.SpecFunc_LogBesselK)
    __swig_getmethods__["BesselK"] = lambda x: _func.SpecFunc_BesselK
    if _newclass:BesselK = staticmethod(_func.SpecFunc_BesselK)
    __swig_getmethods__["BesselKDerivative"] = lambda x: _func.SpecFunc_BesselKDerivative
    if _newclass:BesselKDerivative = staticmethod(_func.SpecFunc_BesselKDerivative)
    __swig_getmethods__["Beta"] = lambda x: _func.SpecFunc_Beta
    if _newclass:Beta = staticmethod(_func.SpecFunc_Beta)
    __swig_getmethods__["IncompleteBeta"] = lambda x: _func.SpecFunc_IncompleteBeta
    if _newclass:IncompleteBeta = staticmethod(_func.SpecFunc_IncompleteBeta)
    __swig_getmethods__["IncompleteBetaInverse"] = lambda x: _func.SpecFunc_IncompleteBetaInverse
    if _newclass:IncompleteBetaInverse = staticmethod(_func.SpecFunc_IncompleteBetaInverse)
    __swig_getmethods__["RegularizedIncompleteBeta"] = lambda x: _func.SpecFunc_RegularizedIncompleteBeta
    if _newclass:RegularizedIncompleteBeta = staticmethod(_func.SpecFunc_RegularizedIncompleteBeta)
    __swig_getmethods__["RegularizedIncompleteBetaInverse"] = lambda x: _func.SpecFunc_RegularizedIncompleteBetaInverse
    if _newclass:RegularizedIncompleteBetaInverse = staticmethod(_func.SpecFunc_RegularizedIncompleteBetaInverse)
    __swig_getmethods__["LnBeta"] = lambda x: _func.SpecFunc_LnBeta
    if _newclass:LnBeta = staticmethod(_func.SpecFunc_LnBeta)
    __swig_getmethods__["LogBeta"] = lambda x: _func.SpecFunc_LogBeta
    if _newclass:LogBeta = staticmethod(_func.SpecFunc_LogBeta)
    __swig_getmethods__["Dawson"] = lambda x: _func.SpecFunc_Dawson
    if _newclass:Dawson = staticmethod(_func.SpecFunc_Dawson)
    __swig_getmethods__["Debye"] = lambda x: _func.SpecFunc_Debye
    if _newclass:Debye = staticmethod(_func.SpecFunc_Debye)
    __swig_getmethods__["DiLog"] = lambda x: _func.SpecFunc_DiLog
    if _newclass:DiLog = staticmethod(_func.SpecFunc_DiLog)
    __swig_getmethods__["Faddeeva"] = lambda x: _func.SpecFunc_Faddeeva
    if _newclass:Faddeeva = staticmethod(_func.SpecFunc_Faddeeva)
    __swig_getmethods__["FaddeevaIm"] = lambda x: _func.SpecFunc_FaddeevaIm
    if _newclass:FaddeevaIm = staticmethod(_func.SpecFunc_FaddeevaIm)
    __swig_getmethods__["IGamma1pm1"] = lambda x: _func.SpecFunc_IGamma1pm1
    if _newclass:IGamma1pm1 = staticmethod(_func.SpecFunc_IGamma1pm1)
    __swig_getmethods__["GammaCorrection"] = lambda x: _func.SpecFunc_GammaCorrection
    if _newclass:GammaCorrection = staticmethod(_func.SpecFunc_GammaCorrection)
    __swig_getmethods__["Gamma"] = lambda x: _func.SpecFunc_Gamma
    if _newclass:Gamma = staticmethod(_func.SpecFunc_Gamma)
    __swig_getmethods__["LnGamma"] = lambda x: _func.SpecFunc_LnGamma
    if _newclass:LnGamma = staticmethod(_func.SpecFunc_LnGamma)
    __swig_getmethods__["LogGamma1p"] = lambda x: _func.SpecFunc_LogGamma1p
    if _newclass:LogGamma1p = staticmethod(_func.SpecFunc_LogGamma1p)
    __swig_getmethods__["LogGamma"] = lambda x: _func.SpecFunc_LogGamma
    if _newclass:LogGamma = staticmethod(_func.SpecFunc_LogGamma)
    __swig_getmethods__["IncompleteGamma"] = lambda x: _func.SpecFunc_IncompleteGamma
    if _newclass:IncompleteGamma = staticmethod(_func.SpecFunc_IncompleteGamma)
    __swig_getmethods__["IncompleteGammaInverse"] = lambda x: _func.SpecFunc_IncompleteGammaInverse
    if _newclass:IncompleteGammaInverse = staticmethod(_func.SpecFunc_IncompleteGammaInverse)
    __swig_getmethods__["RegularizedIncompleteGamma"] = lambda x: _func.SpecFunc_RegularizedIncompleteGamma
    if _newclass:RegularizedIncompleteGamma = staticmethod(_func.SpecFunc_RegularizedIncompleteGamma)
    __swig_getmethods__["RegularizedIncompleteGammaInverse"] = lambda x: _func.SpecFunc_RegularizedIncompleteGammaInverse
    if _newclass:RegularizedIncompleteGammaInverse = staticmethod(_func.SpecFunc_RegularizedIncompleteGammaInverse)
    __swig_getmethods__["DiGamma"] = lambda x: _func.SpecFunc_DiGamma
    if _newclass:DiGamma = staticmethod(_func.SpecFunc_DiGamma)
    __swig_getmethods__["Psi"] = lambda x: _func.SpecFunc_Psi
    if _newclass:Psi = staticmethod(_func.SpecFunc_Psi)
    __swig_getmethods__["DiGammaInv"] = lambda x: _func.SpecFunc_DiGammaInv
    if _newclass:DiGammaInv = staticmethod(_func.SpecFunc_DiGammaInv)
    __swig_getmethods__["TriGamma"] = lambda x: _func.SpecFunc_TriGamma
    if _newclass:TriGamma = staticmethod(_func.SpecFunc_TriGamma)
    __swig_getmethods__["HyperGeom_1_1"] = lambda x: _func.SpecFunc_HyperGeom_1_1
    if _newclass:HyperGeom_1_1 = staticmethod(_func.SpecFunc_HyperGeom_1_1)
    __swig_getmethods__["HyperGeom_2_1"] = lambda x: _func.SpecFunc_HyperGeom_2_1
    if _newclass:HyperGeom_2_1 = staticmethod(_func.SpecFunc_HyperGeom_2_1)
    __swig_getmethods__["HyperGeom_2_2"] = lambda x: _func.SpecFunc_HyperGeom_2_2
    if _newclass:HyperGeom_2_2 = staticmethod(_func.SpecFunc_HyperGeom_2_2)
    __swig_getmethods__["Erf"] = lambda x: _func.SpecFunc_Erf
    if _newclass:Erf = staticmethod(_func.SpecFunc_Erf)
    __swig_getmethods__["ErfI"] = lambda x: _func.SpecFunc_ErfI
    if _newclass:ErfI = staticmethod(_func.SpecFunc_ErfI)
    __swig_getmethods__["ErfC"] = lambda x: _func.SpecFunc_ErfC
    if _newclass:ErfC = staticmethod(_func.SpecFunc_ErfC)
    __swig_getmethods__["ErfCX"] = lambda x: _func.SpecFunc_ErfCX
    if _newclass:ErfCX = staticmethod(_func.SpecFunc_ErfCX)
    __swig_getmethods__["ErfInverse"] = lambda x: _func.SpecFunc_ErfInverse
    if _newclass:ErfInverse = staticmethod(_func.SpecFunc_ErfInverse)
    __swig_getmethods__["LambertW"] = lambda x: _func.SpecFunc_LambertW
    if _newclass:LambertW = staticmethod(_func.SpecFunc_LambertW)
    __swig_getmethods__["Log1p"] = lambda x: _func.SpecFunc_Log1p
    if _newclass:Log1p = staticmethod(_func.SpecFunc_Log1p)
    __swig_getmethods__["Expm1"] = lambda x: _func.SpecFunc_Expm1
    if _newclass:Expm1 = staticmethod(_func.SpecFunc_Expm1)
    __swig_getmethods__["Log1MExp"] = lambda x: _func.SpecFunc_Log1MExp
    if _newclass:Log1MExp = staticmethod(_func.SpecFunc_Log1MExp)
    __swig_getmethods__["NextPowerOfTwo"] = lambda x: _func.SpecFunc_NextPowerOfTwo
    if _newclass:NextPowerOfTwo = staticmethod(_func.SpecFunc_NextPowerOfTwo)
    __swig_getmethods__["Acosh"] = lambda x: _func.SpecFunc_Acosh
    if _newclass:Acosh = staticmethod(_func.SpecFunc_Acosh)
    __swig_getmethods__["Asinh"] = lambda x: _func.SpecFunc_Asinh
    if _newclass:Asinh = staticmethod(_func.SpecFunc_Asinh)
    __swig_getmethods__["Atanh"] = lambda x: _func.SpecFunc_Atanh
    if _newclass:Atanh = staticmethod(_func.SpecFunc_Atanh)
    __swig_getmethods__["Cbrt"] = lambda x: _func.SpecFunc_Cbrt
    if _newclass:Cbrt = staticmethod(_func.SpecFunc_Cbrt)
    def __init__(self, *args): 
        this = _func.new_SpecFunc(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_SpecFunc
    __del__ = lambda self : None;
SpecFunc_swigregister = _func.SpecFunc_swigregister
SpecFunc_swigregister(SpecFunc)
cvar = _func.cvar
SpecFunc.ISQRT2PI = _func.cvar.SpecFunc_ISQRT2PI
SpecFunc.SQRT2PI = _func.cvar.SpecFunc_SQRT2PI
SpecFunc.LOGSQRT2PI = _func.cvar.SpecFunc_LOGSQRT2PI
SpecFunc.EulerConstant = _func.cvar.SpecFunc_EulerConstant
SpecFunc.PI2_6 = _func.cvar.SpecFunc_PI2_6
SpecFunc.PI_SQRT6 = _func.cvar.SpecFunc_PI_SQRT6
SpecFunc.EULERSQRT6_PI = _func.cvar.SpecFunc_EULERSQRT6_PI
SpecFunc.PI2_3 = _func.cvar.SpecFunc_PI2_3
SpecFunc.SQRT3_PI = _func.cvar.SpecFunc_SQRT3_PI
SpecFunc.PI_SQRT3 = _func.cvar.SpecFunc_PI_SQRT3
SpecFunc.ZETA3 = _func.cvar.SpecFunc_ZETA3
SpecFunc.MaximumIteration = _func.cvar.SpecFunc_MaximumIteration
SpecFunc.Precision = _func.cvar.SpecFunc_Precision
SpecFunc.MinNumericalScalar = _func.cvar.SpecFunc_MinNumericalScalar
SpecFunc.LogMinNumericalScalar = _func.cvar.SpecFunc_LogMinNumericalScalar
SpecFunc.MaxNumericalScalar = _func.cvar.SpecFunc_MaxNumericalScalar
SpecFunc.LogMaxNumericalScalar = _func.cvar.SpecFunc_LogMaxNumericalScalar
SpecFunc.NumericalScalarEpsilon = _func.cvar.SpecFunc_NumericalScalarEpsilon

def SpecFunc_IsNaN(*args):
  return _func.SpecFunc_IsNaN(*args)
SpecFunc_IsNaN = _func.SpecFunc_IsNaN

def SpecFunc_IsInf(*args):
  return _func.SpecFunc_IsInf(*args)
SpecFunc_IsInf = _func.SpecFunc_IsInf

def SpecFunc_IsNormal(*args):
  return _func.SpecFunc_IsNormal(*args)
SpecFunc_IsNormal = _func.SpecFunc_IsNormal

def SpecFunc_BesselI0(*args):
  return _func.SpecFunc_BesselI0(*args)
SpecFunc_BesselI0 = _func.SpecFunc_BesselI0

def SpecFunc_LogBesselI0(*args):
  return _func.SpecFunc_LogBesselI0(*args)
SpecFunc_LogBesselI0 = _func.SpecFunc_LogBesselI0

def SpecFunc_BesselI1(*args):
  return _func.SpecFunc_BesselI1(*args)
SpecFunc_BesselI1 = _func.SpecFunc_BesselI1

def SpecFunc_LogBesselI1(*args):
  return _func.SpecFunc_LogBesselI1(*args)
SpecFunc_LogBesselI1 = _func.SpecFunc_LogBesselI1

def SpecFunc_LargeCaseDeltaLogBesselI10(*args):
  return _func.SpecFunc_LargeCaseDeltaLogBesselI10(*args)
SpecFunc_LargeCaseDeltaLogBesselI10 = _func.SpecFunc_LargeCaseDeltaLogBesselI10

def SpecFunc_DeltaLogBesselI10(*args):
  return _func.SpecFunc_DeltaLogBesselI10(*args)
SpecFunc_DeltaLogBesselI10 = _func.SpecFunc_DeltaLogBesselI10

def SpecFunc_LogBesselK(*args):
  return _func.SpecFunc_LogBesselK(*args)
SpecFunc_LogBesselK = _func.SpecFunc_LogBesselK

def SpecFunc_BesselK(*args):
  return _func.SpecFunc_BesselK(*args)
SpecFunc_BesselK = _func.SpecFunc_BesselK

def SpecFunc_BesselKDerivative(*args):
  return _func.SpecFunc_BesselKDerivative(*args)
SpecFunc_BesselKDerivative = _func.SpecFunc_BesselKDerivative

def SpecFunc_Beta(*args):
  return _func.SpecFunc_Beta(*args)
SpecFunc_Beta = _func.SpecFunc_Beta

def SpecFunc_IncompleteBeta(*args):
  return _func.SpecFunc_IncompleteBeta(*args)
SpecFunc_IncompleteBeta = _func.SpecFunc_IncompleteBeta

def SpecFunc_IncompleteBetaInverse(*args):
  return _func.SpecFunc_IncompleteBetaInverse(*args)
SpecFunc_IncompleteBetaInverse = _func.SpecFunc_IncompleteBetaInverse

def SpecFunc_RegularizedIncompleteBeta(*args):
  return _func.SpecFunc_RegularizedIncompleteBeta(*args)
SpecFunc_RegularizedIncompleteBeta = _func.SpecFunc_RegularizedIncompleteBeta

def SpecFunc_RegularizedIncompleteBetaInverse(*args):
  return _func.SpecFunc_RegularizedIncompleteBetaInverse(*args)
SpecFunc_RegularizedIncompleteBetaInverse = _func.SpecFunc_RegularizedIncompleteBetaInverse

def SpecFunc_LnBeta(*args):
  return _func.SpecFunc_LnBeta(*args)
SpecFunc_LnBeta = _func.SpecFunc_LnBeta

def SpecFunc_LogBeta(*args):
  return _func.SpecFunc_LogBeta(*args)
SpecFunc_LogBeta = _func.SpecFunc_LogBeta

def SpecFunc_Dawson(*args):
  return _func.SpecFunc_Dawson(*args)
SpecFunc_Dawson = _func.SpecFunc_Dawson

def SpecFunc_Debye(*args):
  return _func.SpecFunc_Debye(*args)
SpecFunc_Debye = _func.SpecFunc_Debye

def SpecFunc_DiLog(*args):
  return _func.SpecFunc_DiLog(*args)
SpecFunc_DiLog = _func.SpecFunc_DiLog

def SpecFunc_Faddeeva(*args):
  return _func.SpecFunc_Faddeeva(*args)
SpecFunc_Faddeeva = _func.SpecFunc_Faddeeva

def SpecFunc_FaddeevaIm(*args):
  return _func.SpecFunc_FaddeevaIm(*args)
SpecFunc_FaddeevaIm = _func.SpecFunc_FaddeevaIm

def SpecFunc_IGamma1pm1(*args):
  return _func.SpecFunc_IGamma1pm1(*args)
SpecFunc_IGamma1pm1 = _func.SpecFunc_IGamma1pm1

def SpecFunc_GammaCorrection(*args):
  return _func.SpecFunc_GammaCorrection(*args)
SpecFunc_GammaCorrection = _func.SpecFunc_GammaCorrection

def SpecFunc_Gamma(*args):
  return _func.SpecFunc_Gamma(*args)
SpecFunc_Gamma = _func.SpecFunc_Gamma

def SpecFunc_LnGamma(*args):
  return _func.SpecFunc_LnGamma(*args)
SpecFunc_LnGamma = _func.SpecFunc_LnGamma

def SpecFunc_LogGamma1p(*args):
  return _func.SpecFunc_LogGamma1p(*args)
SpecFunc_LogGamma1p = _func.SpecFunc_LogGamma1p

def SpecFunc_LogGamma(*args):
  return _func.SpecFunc_LogGamma(*args)
SpecFunc_LogGamma = _func.SpecFunc_LogGamma

def SpecFunc_IncompleteGamma(*args):
  return _func.SpecFunc_IncompleteGamma(*args)
SpecFunc_IncompleteGamma = _func.SpecFunc_IncompleteGamma

def SpecFunc_IncompleteGammaInverse(*args):
  return _func.SpecFunc_IncompleteGammaInverse(*args)
SpecFunc_IncompleteGammaInverse = _func.SpecFunc_IncompleteGammaInverse

def SpecFunc_RegularizedIncompleteGamma(*args):
  return _func.SpecFunc_RegularizedIncompleteGamma(*args)
SpecFunc_RegularizedIncompleteGamma = _func.SpecFunc_RegularizedIncompleteGamma

def SpecFunc_RegularizedIncompleteGammaInverse(*args):
  return _func.SpecFunc_RegularizedIncompleteGammaInverse(*args)
SpecFunc_RegularizedIncompleteGammaInverse = _func.SpecFunc_RegularizedIncompleteGammaInverse

def SpecFunc_DiGamma(*args):
  return _func.SpecFunc_DiGamma(*args)
SpecFunc_DiGamma = _func.SpecFunc_DiGamma

def SpecFunc_Psi(*args):
  return _func.SpecFunc_Psi(*args)
SpecFunc_Psi = _func.SpecFunc_Psi

def SpecFunc_DiGammaInv(*args):
  return _func.SpecFunc_DiGammaInv(*args)
SpecFunc_DiGammaInv = _func.SpecFunc_DiGammaInv

def SpecFunc_TriGamma(*args):
  return _func.SpecFunc_TriGamma(*args)
SpecFunc_TriGamma = _func.SpecFunc_TriGamma

def SpecFunc_HyperGeom_1_1(*args):
  return _func.SpecFunc_HyperGeom_1_1(*args)
SpecFunc_HyperGeom_1_1 = _func.SpecFunc_HyperGeom_1_1

def SpecFunc_HyperGeom_2_1(*args):
  return _func.SpecFunc_HyperGeom_2_1(*args)
SpecFunc_HyperGeom_2_1 = _func.SpecFunc_HyperGeom_2_1

def SpecFunc_HyperGeom_2_2(*args):
  return _func.SpecFunc_HyperGeom_2_2(*args)
SpecFunc_HyperGeom_2_2 = _func.SpecFunc_HyperGeom_2_2

def SpecFunc_Erf(*args):
  return _func.SpecFunc_Erf(*args)
SpecFunc_Erf = _func.SpecFunc_Erf

def SpecFunc_ErfI(*args):
  return _func.SpecFunc_ErfI(*args)
SpecFunc_ErfI = _func.SpecFunc_ErfI

def SpecFunc_ErfC(*args):
  return _func.SpecFunc_ErfC(*args)
SpecFunc_ErfC = _func.SpecFunc_ErfC

def SpecFunc_ErfCX(*args):
  return _func.SpecFunc_ErfCX(*args)
SpecFunc_ErfCX = _func.SpecFunc_ErfCX

def SpecFunc_ErfInverse(*args):
  return _func.SpecFunc_ErfInverse(*args)
SpecFunc_ErfInverse = _func.SpecFunc_ErfInverse

def SpecFunc_LambertW(*args):
  return _func.SpecFunc_LambertW(*args)
SpecFunc_LambertW = _func.SpecFunc_LambertW

def SpecFunc_Log1p(*args):
  return _func.SpecFunc_Log1p(*args)
SpecFunc_Log1p = _func.SpecFunc_Log1p

def SpecFunc_Expm1(*args):
  return _func.SpecFunc_Expm1(*args)
SpecFunc_Expm1 = _func.SpecFunc_Expm1

def SpecFunc_Log1MExp(*args):
  return _func.SpecFunc_Log1MExp(*args)
SpecFunc_Log1MExp = _func.SpecFunc_Log1MExp

def SpecFunc_NextPowerOfTwo(*args):
  return _func.SpecFunc_NextPowerOfTwo(*args)
SpecFunc_NextPowerOfTwo = _func.SpecFunc_NextPowerOfTwo

def SpecFunc_Acosh(*args):
  return _func.SpecFunc_Acosh(*args)
SpecFunc_Acosh = _func.SpecFunc_Acosh

def SpecFunc_Asinh(*args):
  return _func.SpecFunc_Asinh(*args)
SpecFunc_Asinh = _func.SpecFunc_Asinh

def SpecFunc_Atanh(*args):
  return _func.SpecFunc_Atanh(*args)
SpecFunc_Atanh = _func.SpecFunc_Atanh

def SpecFunc_Cbrt(*args):
  return _func.SpecFunc_Cbrt(*args)
SpecFunc_Cbrt = _func.SpecFunc_Cbrt

class NumericalMathEvaluationImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.NumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathEvaluationImplementation___str__(self, offset)
    def setDescription(self, *args): return _func.NumericalMathEvaluationImplementation_setDescription(self, *args)
    def getDescription(self): return _func.NumericalMathEvaluationImplementation_getDescription(self)
    def getInputDescription(self): return _func.NumericalMathEvaluationImplementation_getInputDescription(self)
    def setInputDescription(self, *args): return _func.NumericalMathEvaluationImplementation_setInputDescription(self, *args)
    def getOutputDescription(self): return _func.NumericalMathEvaluationImplementation_getOutputDescription(self)
    def setOutputDescription(self, *args): return _func.NumericalMathEvaluationImplementation_setOutputDescription(self, *args)
    def enableHistory(self): return _func.NumericalMathEvaluationImplementation_enableHistory(self)
    def disableHistory(self): return _func.NumericalMathEvaluationImplementation_disableHistory(self)
    def isHistoryEnabled(self): return _func.NumericalMathEvaluationImplementation_isHistoryEnabled(self)
    def clearHistory(self): return _func.NumericalMathEvaluationImplementation_clearHistory(self)
    def getHistoryInput(self): return _func.NumericalMathEvaluationImplementation_getHistoryInput(self)
    def getInputHistory(self): return _func.NumericalMathEvaluationImplementation_getInputHistory(self)
    def getHistoryOutput(self): return _func.NumericalMathEvaluationImplementation_getHistoryOutput(self)
    def getOutputHistory(self): return _func.NumericalMathEvaluationImplementation_getOutputHistory(self)
    def enableCache(self): return _func.NumericalMathEvaluationImplementation_enableCache(self)
    def disableCache(self): return _func.NumericalMathEvaluationImplementation_disableCache(self)
    def isCacheEnabled(self): return _func.NumericalMathEvaluationImplementation_isCacheEnabled(self)
    def getCacheHits(self): return _func.NumericalMathEvaluationImplementation_getCacheHits(self)
    def addCacheContent(self, *args): return _func.NumericalMathEvaluationImplementation_addCacheContent(self, *args)
    def getCacheInput(self): return _func.NumericalMathEvaluationImplementation_getCacheInput(self)
    def getCacheOutput(self): return _func.NumericalMathEvaluationImplementation_getCacheOutput(self)
    def clearCache(self): return _func.NumericalMathEvaluationImplementation_clearCache(self)
    def isActualImplementation(self): return _func.NumericalMathEvaluationImplementation_isActualImplementation(self)
    def __call__(self, *args): return _func.NumericalMathEvaluationImplementation___call__(self, *args)
    def getParameterDimension(self): return _func.NumericalMathEvaluationImplementation_getParameterDimension(self)
    def getInputDimension(self): return _func.NumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathEvaluationImplementation_getOutputDimension(self)
    def getParametersDimension(self): return _func.NumericalMathEvaluationImplementation_getParametersDimension(self)
    def getMarginal(self, *args): return _func.NumericalMathEvaluationImplementation_getMarginal(self, *args)
    def parametersGradient(self, *args): return _func.NumericalMathEvaluationImplementation_parametersGradient(self, *args)
    def getParameters(self): return _func.NumericalMathEvaluationImplementation_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathEvaluationImplementation_setParameters(self, *args)
    def getCallsNumber(self): return _func.NumericalMathEvaluationImplementation_getCallsNumber(self)
    def draw(self, *args): return _func.NumericalMathEvaluationImplementation_draw(self, *args)
    def __init__(self, *args): 
        this = _func.new_NumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathEvaluationImplementation
    __del__ = lambda self : None;
NumericalMathEvaluationImplementation_swigregister = _func.NumericalMathEvaluationImplementation_swigregister
NumericalMathEvaluationImplementation_swigregister(NumericalMathEvaluationImplementation)

class NumericalMathGradientImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathGradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.NumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathGradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathGradientImplementation___str__(self, offset)
    def getMarginal(self, *args): return _func.NumericalMathGradientImplementation_getMarginal(self, *args)
    def isActualImplementation(self): return _func.NumericalMathGradientImplementation_isActualImplementation(self)
    def gradient(self, *args): return _func.NumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.NumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathGradientImplementation_getOutputDimension(self)
    def getParameters(self): return _func.NumericalMathGradientImplementation_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathGradientImplementation_setParameters(self, *args)
    def getCallsNumber(self): return _func.NumericalMathGradientImplementation_getCallsNumber(self)
    def __init__(self, *args): 
        this = _func.new_NumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathGradientImplementation
    __del__ = lambda self : None;
NumericalMathGradientImplementation_swigregister = _func.NumericalMathGradientImplementation_swigregister
NumericalMathGradientImplementation_swigregister(NumericalMathGradientImplementation)

class NumericalMathHessianImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathHessianImplementation_getClassName(self)

    def __eq__(self, *args): return _func.NumericalMathHessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathHessianImplementation___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathHessianImplementation___str__(self, offset)
    def isActualImplementation(self): return _func.NumericalMathHessianImplementation_isActualImplementation(self)
    def getMarginal(self, *args): return _func.NumericalMathHessianImplementation_getMarginal(self, *args)
    def hessian(self, *args): return _func.NumericalMathHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.NumericalMathHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathHessianImplementation_getOutputDimension(self)
    def getParameters(self): return _func.NumericalMathHessianImplementation_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathHessianImplementation_setParameters(self, *args)
    def getCallsNumber(self): return _func.NumericalMathHessianImplementation_getCallsNumber(self)
    def __init__(self, *args): 
        this = _func.new_NumericalMathHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathHessianImplementation
    __del__ = lambda self : None;
NumericalMathHessianImplementation_swigregister = _func.NumericalMathHessianImplementation_swigregister
NumericalMathHessianImplementation_swigregister(NumericalMathHessianImplementation)

class NoNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NoNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NoNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NoNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.NoNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.NoNumericalMathEvaluationImplementation___repr__(self)
    def isActualImplementation(self): return _func.NoNumericalMathEvaluationImplementation_isActualImplementation(self)
    def __call__(self, *args): return _func.NoNumericalMathEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.NoNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.NoNumericalMathEvaluationImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_NoNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NoNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
NoNumericalMathEvaluationImplementation_swigregister = _func.NoNumericalMathEvaluationImplementation_swigregister
NoNumericalMathEvaluationImplementation_swigregister(NoNumericalMathEvaluationImplementation)

class NoNumericalMathGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NoNumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NoNumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NoNumericalMathGradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.NoNumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.NoNumericalMathGradientImplementation___repr__(self)
    def gradient(self, *args): return _func.NoNumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.NoNumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.NoNumericalMathGradientImplementation_getOutputDimension(self)
    def isActualImplementation(self): return _func.NoNumericalMathGradientImplementation_isActualImplementation(self)
    def __init__(self, *args): 
        this = _func.new_NoNumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NoNumericalMathGradientImplementation
    __del__ = lambda self : None;
NoNumericalMathGradientImplementation_swigregister = _func.NoNumericalMathGradientImplementation_swigregister
NoNumericalMathGradientImplementation_swigregister(NoNumericalMathGradientImplementation)

class NoNumericalMathHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NoNumericalMathHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NoNumericalMathHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NoNumericalMathHessianImplementation_getClassName(self)

    def __eq__(self, *args): return _func.NoNumericalMathHessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.NoNumericalMathHessianImplementation___repr__(self)
    def isActualImplementation(self): return _func.NoNumericalMathHessianImplementation_isActualImplementation(self)
    def hessian(self, *args): return _func.NoNumericalMathHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.NoNumericalMathHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.NoNumericalMathHessianImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_NoNumericalMathHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NoNumericalMathHessianImplementation
    __del__ = lambda self : None;
NoNumericalMathHessianImplementation_swigregister = _func.NoNumericalMathHessianImplementation_swigregister
NoNumericalMathHessianImplementation_swigregister(NoNumericalMathHessianImplementation)

class LinearNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.LinearNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.LinearNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.LinearNumericalMathEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.LinearNumericalMathEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.LinearNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.LinearNumericalMathEvaluationImplementation_getOutputDimension(self)
    def getCenter(self): return _func.LinearNumericalMathEvaluationImplementation_getCenter(self)
    def getConstant(self): return _func.LinearNumericalMathEvaluationImplementation_getConstant(self)
    def getLinear(self): return _func.LinearNumericalMathEvaluationImplementation_getLinear(self)
    def __init__(self, *args): 
        this = _func.new_LinearNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
LinearNumericalMathEvaluationImplementation_swigregister = _func.LinearNumericalMathEvaluationImplementation_swigregister
LinearNumericalMathEvaluationImplementation_swigregister(LinearNumericalMathEvaluationImplementation)

class LinearNumericalMathGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearNumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearNumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearNumericalMathGradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.LinearNumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.LinearNumericalMathGradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.LinearNumericalMathGradientImplementation___str__(self, offset)
    def gradient(self, *args): return _func.LinearNumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.LinearNumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.LinearNumericalMathGradientImplementation_getOutputDimension(self)
    def getCenter(self): return _func.LinearNumericalMathGradientImplementation_getCenter(self)
    def getConstant(self): return _func.LinearNumericalMathGradientImplementation_getConstant(self)
    def getLinear(self): return _func.LinearNumericalMathGradientImplementation_getLinear(self)
    def __init__(self, *args): 
        this = _func.new_LinearNumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearNumericalMathGradientImplementation
    __del__ = lambda self : None;
LinearNumericalMathGradientImplementation_swigregister = _func.LinearNumericalMathGradientImplementation_swigregister
LinearNumericalMathGradientImplementation_swigregister(LinearNumericalMathGradientImplementation)

class QuadraticNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, QuadraticNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, QuadraticNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.QuadraticNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.QuadraticNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.QuadraticNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.QuadraticNumericalMathEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.QuadraticNumericalMathEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.QuadraticNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.QuadraticNumericalMathEvaluationImplementation_getOutputDimension(self)
    def getCenter(self): return _func.QuadraticNumericalMathEvaluationImplementation_getCenter(self)
    def getConstant(self): return _func.QuadraticNumericalMathEvaluationImplementation_getConstant(self)
    def getLinear(self): return _func.QuadraticNumericalMathEvaluationImplementation_getLinear(self)
    def getQuadratic(self): return _func.QuadraticNumericalMathEvaluationImplementation_getQuadratic(self)
    def __init__(self, *args): 
        this = _func.new_QuadraticNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_QuadraticNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
QuadraticNumericalMathEvaluationImplementation_swigregister = _func.QuadraticNumericalMathEvaluationImplementation_swigregister
QuadraticNumericalMathEvaluationImplementation_swigregister(QuadraticNumericalMathEvaluationImplementation)

class ConstantNumericalMathGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConstantNumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ConstantNumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ConstantNumericalMathGradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ConstantNumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.ConstantNumericalMathGradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ConstantNumericalMathGradientImplementation___str__(self, offset)
    def gradient(self, *args): return _func.ConstantNumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.ConstantNumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ConstantNumericalMathGradientImplementation_getOutputDimension(self)
    def getConstant(self): return _func.ConstantNumericalMathGradientImplementation_getConstant(self)
    def __init__(self, *args): 
        this = _func.new_ConstantNumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ConstantNumericalMathGradientImplementation
    __del__ = lambda self : None;
ConstantNumericalMathGradientImplementation_swigregister = _func.ConstantNumericalMathGradientImplementation_swigregister
ConstantNumericalMathGradientImplementation_swigregister(ConstantNumericalMathGradientImplementation)

class ConstantNumericalMathHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConstantNumericalMathHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ConstantNumericalMathHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ConstantNumericalMathHessianImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ConstantNumericalMathHessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.ConstantNumericalMathHessianImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ConstantNumericalMathHessianImplementation___str__(self, offset)
    def hessian(self, *args): return _func.ConstantNumericalMathHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.ConstantNumericalMathHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ConstantNumericalMathHessianImplementation_getOutputDimension(self)
    def getConstant(self): return _func.ConstantNumericalMathHessianImplementation_getConstant(self)
    def __init__(self, *args): 
        this = _func.new_ConstantNumericalMathHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ConstantNumericalMathHessianImplementation
    __del__ = lambda self : None;
ConstantNumericalMathHessianImplementation_swigregister = _func.ConstantNumericalMathHessianImplementation_swigregister
ConstantNumericalMathHessianImplementation_swigregister(ConstantNumericalMathHessianImplementation)

class ComputedNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ComputedNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ComputedNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ComputedNumericalMathEvaluationImplementation_getClassName(self)

    def __init__(self, *args): 
        this = _func.new_ComputedNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ComputedNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
    def __eq__(self, *args): return _func.ComputedNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.ComputedNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ComputedNumericalMathEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.ComputedNumericalMathEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.ComputedNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ComputedNumericalMathEvaluationImplementation_getOutputDimension(self)
    def getDescription(self): return _func.ComputedNumericalMathEvaluationImplementation_getDescription(self)
ComputedNumericalMathEvaluationImplementation_swigregister = _func.ComputedNumericalMathEvaluationImplementation_swigregister
ComputedNumericalMathEvaluationImplementation_swigregister(ComputedNumericalMathEvaluationImplementation)

class ComputedNumericalMathGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ComputedNumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ComputedNumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ComputedNumericalMathGradientImplementation_getClassName(self)

    def __init__(self, *args): 
        this = _func.new_ComputedNumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ComputedNumericalMathGradientImplementation
    __del__ = lambda self : None;
    def __eq__(self, *args): return _func.ComputedNumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.ComputedNumericalMathGradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ComputedNumericalMathGradientImplementation___str__(self, offset)
    def gradient(self, *args): return _func.ComputedNumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.ComputedNumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ComputedNumericalMathGradientImplementation_getOutputDimension(self)
ComputedNumericalMathGradientImplementation_swigregister = _func.ComputedNumericalMathGradientImplementation_swigregister
ComputedNumericalMathGradientImplementation_swigregister(ComputedNumericalMathGradientImplementation)

class ComputedNumericalMathHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ComputedNumericalMathHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ComputedNumericalMathHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ComputedNumericalMathHessianImplementation_getClassName(self)

    def __init__(self, *args): 
        this = _func.new_ComputedNumericalMathHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ComputedNumericalMathHessianImplementation
    __del__ = lambda self : None;
    def __eq__(self, *args): return _func.ComputedNumericalMathHessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.ComputedNumericalMathHessianImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ComputedNumericalMathHessianImplementation___str__(self, offset)
    def hessian(self, *args): return _func.ComputedNumericalMathHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.ComputedNumericalMathHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ComputedNumericalMathHessianImplementation_getOutputDimension(self)
ComputedNumericalMathHessianImplementation_swigregister = _func.ComputedNumericalMathHessianImplementation_swigregister
ComputedNumericalMathHessianImplementation_swigregister(ComputedNumericalMathHessianImplementation)

class ComposedNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ComposedNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ComposedNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ComposedNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ComposedNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.ComposedNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ComposedNumericalMathEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.ComposedNumericalMathEvaluationImplementation___call__(self, *args)
    def getParameters(self): return _func.ComposedNumericalMathEvaluationImplementation_getParameters(self)
    def setParameters(self, *args): return _func.ComposedNumericalMathEvaluationImplementation_setParameters(self, *args)
    def getInputDimension(self): return _func.ComposedNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ComposedNumericalMathEvaluationImplementation_getOutputDimension(self)
    def getMarginal(self, *args): return _func.ComposedNumericalMathEvaluationImplementation_getMarginal(self, *args)
    def getLeftEvaluationImplementation(self): return _func.ComposedNumericalMathEvaluationImplementation_getLeftEvaluationImplementation(self)
    def getRightEvaluationImplementation(self): return _func.ComposedNumericalMathEvaluationImplementation_getRightEvaluationImplementation(self)
    def __init__(self, *args): 
        this = _func.new_ComposedNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ComposedNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
ComposedNumericalMathEvaluationImplementation_swigregister = _func.ComposedNumericalMathEvaluationImplementation_swigregister
ComposedNumericalMathEvaluationImplementation_swigregister(ComposedNumericalMathEvaluationImplementation)

class ComposedNumericalMathGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ComposedNumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ComposedNumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ComposedNumericalMathGradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ComposedNumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.ComposedNumericalMathGradientImplementation___repr__(self)
    def gradient(self, *args): return _func.ComposedNumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.ComposedNumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ComposedNumericalMathGradientImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_ComposedNumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ComposedNumericalMathGradientImplementation
    __del__ = lambda self : None;
ComposedNumericalMathGradientImplementation_swigregister = _func.ComposedNumericalMathGradientImplementation_swigregister
ComposedNumericalMathGradientImplementation_swigregister(ComposedNumericalMathGradientImplementation)

class ComposedNumericalMathHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ComposedNumericalMathHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ComposedNumericalMathHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ComposedNumericalMathHessianImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ComposedNumericalMathHessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.ComposedNumericalMathHessianImplementation___repr__(self)
    def hessian(self, *args): return _func.ComposedNumericalMathHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.ComposedNumericalMathHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ComposedNumericalMathHessianImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_ComposedNumericalMathHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ComposedNumericalMathHessianImplementation
    __del__ = lambda self : None;
ComposedNumericalMathHessianImplementation_swigregister = _func.ComposedNumericalMathHessianImplementation_swigregister
ComposedNumericalMathHessianImplementation_swigregister(ComposedNumericalMathHessianImplementation)

class ProductNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProductNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProductNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ProductNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ProductNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.ProductNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ProductNumericalMathEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.ProductNumericalMathEvaluationImplementation___call__(self, *args)
    def getParameters(self): return _func.ProductNumericalMathEvaluationImplementation_getParameters(self)
    def setParameters(self, *args): return _func.ProductNumericalMathEvaluationImplementation_setParameters(self, *args)
    def getInputDimension(self): return _func.ProductNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ProductNumericalMathEvaluationImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_ProductNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ProductNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
ProductNumericalMathEvaluationImplementation_swigregister = _func.ProductNumericalMathEvaluationImplementation_swigregister
ProductNumericalMathEvaluationImplementation_swigregister(ProductNumericalMathEvaluationImplementation)

class ProductNumericalMathGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProductNumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProductNumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ProductNumericalMathGradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ProductNumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.ProductNumericalMathGradientImplementation___repr__(self)
    def gradient(self, *args): return _func.ProductNumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.ProductNumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ProductNumericalMathGradientImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_ProductNumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ProductNumericalMathGradientImplementation
    __del__ = lambda self : None;
ProductNumericalMathGradientImplementation_swigregister = _func.ProductNumericalMathGradientImplementation_swigregister
ProductNumericalMathGradientImplementation_swigregister(ProductNumericalMathGradientImplementation)

class ProductNumericalMathHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProductNumericalMathHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProductNumericalMathHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ProductNumericalMathHessianImplementation_getClassName(self)

    def __eq__(self, *args): return _func.ProductNumericalMathHessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.ProductNumericalMathHessianImplementation___repr__(self)
    def hessian(self, *args): return _func.ProductNumericalMathHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.ProductNumericalMathHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ProductNumericalMathHessianImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_ProductNumericalMathHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ProductNumericalMathHessianImplementation
    __del__ = lambda self : None;
ProductNumericalMathHessianImplementation_swigregister = _func.ProductNumericalMathHessianImplementation_swigregister
ProductNumericalMathHessianImplementation_swigregister(ProductNumericalMathHessianImplementation)

class EvaluationImplementation(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, EvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, EvaluationImplementation, name)
    __swig_setmethods__["ptr_"] = _func.EvaluationImplementation_ptr__set
    __swig_getmethods__["ptr_"] = _func.EvaluationImplementation_ptr__get
    if _newclass:ptr_ = _swig_property(_func.EvaluationImplementation_ptr__get, _func.EvaluationImplementation_ptr__set)
    def __init__(self, *args): 
        this = _func.new_EvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_EvaluationImplementation
    __del__ = lambda self : None;
    def reset(self): return _func.EvaluationImplementation_reset(self)
    def __ref__(self, *args): return _func.EvaluationImplementation___ref__(self, *args)
    def __deref__(self): return _func.EvaluationImplementation___deref__(self)
    def isNull(self): return _func.EvaluationImplementation_isNull(self)
    def __nonzero__(self):
        return _func.EvaluationImplementation___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.EvaluationImplementation_get(self)
    def getImplementation(self): return _func.EvaluationImplementation_getImplementation(self)
    def unique(self): return _func.EvaluationImplementation_unique(self)
    def use_count(self): return _func.EvaluationImplementation_use_count(self)
    def swap(self, *args): return _func.EvaluationImplementation_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.EvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.EvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.EvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.EvaluationImplementation___str__(self, offset)
    def setDescription(self, *args): return _func.EvaluationImplementation_setDescription(self, *args)
    def getDescription(self): return _func.EvaluationImplementation_getDescription(self)
    def getInputDescription(self): return _func.EvaluationImplementation_getInputDescription(self)
    def setInputDescription(self, *args): return _func.EvaluationImplementation_setInputDescription(self, *args)
    def getOutputDescription(self): return _func.EvaluationImplementation_getOutputDescription(self)
    def setOutputDescription(self, *args): return _func.EvaluationImplementation_setOutputDescription(self, *args)
    def enableHistory(self): return _func.EvaluationImplementation_enableHistory(self)
    def disableHistory(self): return _func.EvaluationImplementation_disableHistory(self)
    def isHistoryEnabled(self): return _func.EvaluationImplementation_isHistoryEnabled(self)
    def clearHistory(self): return _func.EvaluationImplementation_clearHistory(self)
    def getHistoryInput(self): return _func.EvaluationImplementation_getHistoryInput(self)
    def getInputHistory(self): return _func.EvaluationImplementation_getInputHistory(self)
    def getHistoryOutput(self): return _func.EvaluationImplementation_getHistoryOutput(self)
    def getOutputHistory(self): return _func.EvaluationImplementation_getOutputHistory(self)
    def enableCache(self): return _func.EvaluationImplementation_enableCache(self)
    def disableCache(self): return _func.EvaluationImplementation_disableCache(self)
    def isCacheEnabled(self): return _func.EvaluationImplementation_isCacheEnabled(self)
    def getCacheHits(self): return _func.EvaluationImplementation_getCacheHits(self)
    def addCacheContent(self, *args): return _func.EvaluationImplementation_addCacheContent(self, *args)
    def getCacheInput(self): return _func.EvaluationImplementation_getCacheInput(self)
    def getCacheOutput(self): return _func.EvaluationImplementation_getCacheOutput(self)
    def clearCache(self): return _func.EvaluationImplementation_clearCache(self)
    def isActualImplementation(self): return _func.EvaluationImplementation_isActualImplementation(self)
    def __call__(self, *args): return _func.EvaluationImplementation___call__(self, *args)
    def getParameterDimension(self): return _func.EvaluationImplementation_getParameterDimension(self)
    def getInputDimension(self): return _func.EvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.EvaluationImplementation_getOutputDimension(self)
    def getParametersDimension(self): return _func.EvaluationImplementation_getParametersDimension(self)
    def getMarginal(self, *args): return _func.EvaluationImplementation_getMarginal(self, *args)
    def parametersGradient(self, *args): return _func.EvaluationImplementation_parametersGradient(self, *args)
    def getParameters(self): return _func.EvaluationImplementation_getParameters(self)
    def setParameters(self, *args): return _func.EvaluationImplementation_setParameters(self, *args)
    def getCallsNumber(self): return _func.EvaluationImplementation_getCallsNumber(self)
    def draw(self, *args): return _func.EvaluationImplementation_draw(self, *args)
    def __ne__(self, *args): return _func.EvaluationImplementation___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.EvaluationImplementation_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.EvaluationImplementation_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.EvaluationImplementation_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.EvaluationImplementation_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.EvaluationImplementation_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.EvaluationImplementation_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.EvaluationImplementation_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.EvaluationImplementation_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.EvaluationImplementation_setName(self, *args)

EvaluationImplementation_swigregister = _func.EvaluationImplementation_swigregister
EvaluationImplementation_swigregister(EvaluationImplementation)

class GradientImplementation(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, GradientImplementation, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, GradientImplementation, name)
    __swig_setmethods__["ptr_"] = _func.GradientImplementation_ptr__set
    __swig_getmethods__["ptr_"] = _func.GradientImplementation_ptr__get
    if _newclass:ptr_ = _swig_property(_func.GradientImplementation_ptr__get, _func.GradientImplementation_ptr__set)
    def __init__(self, *args): 
        this = _func.new_GradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_GradientImplementation
    __del__ = lambda self : None;
    def reset(self): return _func.GradientImplementation_reset(self)
    def __ref__(self, *args): return _func.GradientImplementation___ref__(self, *args)
    def __deref__(self): return _func.GradientImplementation___deref__(self)
    def isNull(self): return _func.GradientImplementation_isNull(self)
    def __nonzero__(self):
        return _func.GradientImplementation___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.GradientImplementation_get(self)
    def getImplementation(self): return _func.GradientImplementation_getImplementation(self)
    def unique(self): return _func.GradientImplementation_unique(self)
    def use_count(self): return _func.GradientImplementation_use_count(self)
    def swap(self, *args): return _func.GradientImplementation_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.GradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.GradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.GradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.GradientImplementation___str__(self, offset)
    def getMarginal(self, *args): return _func.GradientImplementation_getMarginal(self, *args)
    def isActualImplementation(self): return _func.GradientImplementation_isActualImplementation(self)
    def gradient(self, *args): return _func.GradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.GradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.GradientImplementation_getOutputDimension(self)
    def getParameters(self): return _func.GradientImplementation_getParameters(self)
    def setParameters(self, *args): return _func.GradientImplementation_setParameters(self, *args)
    def getCallsNumber(self): return _func.GradientImplementation_getCallsNumber(self)
    def __ne__(self, *args): return _func.GradientImplementation___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.GradientImplementation_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.GradientImplementation_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.GradientImplementation_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.GradientImplementation_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.GradientImplementation_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.GradientImplementation_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.GradientImplementation_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.GradientImplementation_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.GradientImplementation_setName(self, *args)

GradientImplementation_swigregister = _func.GradientImplementation_swigregister
GradientImplementation_swigregister(GradientImplementation)

class HessianImplementation(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, HessianImplementation, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, HessianImplementation, name)
    __swig_setmethods__["ptr_"] = _func.HessianImplementation_ptr__set
    __swig_getmethods__["ptr_"] = _func.HessianImplementation_ptr__get
    if _newclass:ptr_ = _swig_property(_func.HessianImplementation_ptr__get, _func.HessianImplementation_ptr__set)
    def __init__(self, *args): 
        this = _func.new_HessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_HessianImplementation
    __del__ = lambda self : None;
    def reset(self): return _func.HessianImplementation_reset(self)
    def __ref__(self, *args): return _func.HessianImplementation___ref__(self, *args)
    def __deref__(self): return _func.HessianImplementation___deref__(self)
    def isNull(self): return _func.HessianImplementation_isNull(self)
    def __nonzero__(self):
        return _func.HessianImplementation___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.HessianImplementation_get(self)
    def getImplementation(self): return _func.HessianImplementation_getImplementation(self)
    def unique(self): return _func.HessianImplementation_unique(self)
    def use_count(self): return _func.HessianImplementation_use_count(self)
    def swap(self, *args): return _func.HessianImplementation_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.HessianImplementation_getClassName(self)

    def __eq__(self, *args): return _func.HessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.HessianImplementation___repr__(self)
    def __str__(self, offset=""): return _func.HessianImplementation___str__(self, offset)
    def isActualImplementation(self): return _func.HessianImplementation_isActualImplementation(self)
    def getMarginal(self, *args): return _func.HessianImplementation_getMarginal(self, *args)
    def hessian(self, *args): return _func.HessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.HessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.HessianImplementation_getOutputDimension(self)
    def getParameters(self): return _func.HessianImplementation_getParameters(self)
    def setParameters(self, *args): return _func.HessianImplementation_setParameters(self, *args)
    def getCallsNumber(self): return _func.HessianImplementation_getCallsNumber(self)
    def __ne__(self, *args): return _func.HessianImplementation___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.HessianImplementation_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.HessianImplementation_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.HessianImplementation_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.HessianImplementation_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.HessianImplementation_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.HessianImplementation_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.HessianImplementation_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.HessianImplementation_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.HessianImplementation_setName(self, *args)

HessianImplementation_swigregister = _func.HessianImplementation_swigregister
HessianImplementation_swigregister(HessianImplementation)

class NumericalMathFunctionImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathFunctionImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathFunctionImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathFunctionImplementation_getClassName(self)

    __swig_getmethods__["GetValidConstants"] = lambda x: _func.NumericalMathFunctionImplementation_GetValidConstants
    if _newclass:GetValidConstants = staticmethod(_func.NumericalMathFunctionImplementation_GetValidConstants)
    __swig_getmethods__["GetValidFunctions"] = lambda x: _func.NumericalMathFunctionImplementation_GetValidFunctions
    if _newclass:GetValidFunctions = staticmethod(_func.NumericalMathFunctionImplementation_GetValidFunctions)
    __swig_getmethods__["GetValidOperators"] = lambda x: _func.NumericalMathFunctionImplementation_GetValidOperators
    if _newclass:GetValidOperators = staticmethod(_func.NumericalMathFunctionImplementation_GetValidOperators)
    def __mul__(self, *args): return _func.NumericalMathFunctionImplementation___mul__(self, *args)
    def __eq__(self, *args): return _func.NumericalMathFunctionImplementation___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathFunctionImplementation___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathFunctionImplementation___str__(self, offset)
    def enableCache(self): return _func.NumericalMathFunctionImplementation_enableCache(self)
    def disableCache(self): return _func.NumericalMathFunctionImplementation_disableCache(self)
    def isCacheEnabled(self): return _func.NumericalMathFunctionImplementation_isCacheEnabled(self)
    def getCacheHits(self): return _func.NumericalMathFunctionImplementation_getCacheHits(self)
    def addCacheContent(self, *args): return _func.NumericalMathFunctionImplementation_addCacheContent(self, *args)
    def getCacheInput(self): return _func.NumericalMathFunctionImplementation_getCacheInput(self)
    def getCacheOutput(self): return _func.NumericalMathFunctionImplementation_getCacheOutput(self)
    def clearCache(self): return _func.NumericalMathFunctionImplementation_clearCache(self)
    def enableHistory(self): return _func.NumericalMathFunctionImplementation_enableHistory(self)
    def disableHistory(self): return _func.NumericalMathFunctionImplementation_disableHistory(self)
    def isHistoryEnabled(self): return _func.NumericalMathFunctionImplementation_isHistoryEnabled(self)
    def clearHistory(self): return _func.NumericalMathFunctionImplementation_clearHistory(self)
    def getHistoryInput(self): return _func.NumericalMathFunctionImplementation_getHistoryInput(self)
    def getInputHistory(self): return _func.NumericalMathFunctionImplementation_getInputHistory(self)
    def getHistoryOutput(self): return _func.NumericalMathFunctionImplementation_getHistoryOutput(self)
    def getOutputHistory(self): return _func.NumericalMathFunctionImplementation_getOutputHistory(self)
    def setEvaluation(self, *args): return _func.NumericalMathFunctionImplementation_setEvaluation(self, *args)
    def getEvaluation(self): return _func.NumericalMathFunctionImplementation_getEvaluation(self)
    def setEvaluationImplementation(self, *args): return _func.NumericalMathFunctionImplementation_setEvaluationImplementation(self, *args)
    def getEvaluationImplementation(self): return _func.NumericalMathFunctionImplementation_getEvaluationImplementation(self)
    def setGradient(self, *args): return _func.NumericalMathFunctionImplementation_setGradient(self, *args)
    def getGradient(self): return _func.NumericalMathFunctionImplementation_getGradient(self)
    def setGradientImplementation(self, *args): return _func.NumericalMathFunctionImplementation_setGradientImplementation(self, *args)
    def getGradientImplementation(self): return _func.NumericalMathFunctionImplementation_getGradientImplementation(self)
    def setHessian(self, *args): return _func.NumericalMathFunctionImplementation_setHessian(self, *args)
    def getHessian(self): return _func.NumericalMathFunctionImplementation_getHessian(self)
    def setHessianImplementation(self, *args): return _func.NumericalMathFunctionImplementation_setHessianImplementation(self, *args)
    def getHessianImplementation(self): return _func.NumericalMathFunctionImplementation_getHessianImplementation(self)
    def getInitialEvaluationImplementation(self): return _func.NumericalMathFunctionImplementation_getInitialEvaluationImplementation(self)
    def getInitialGradientImplementation(self): return _func.NumericalMathFunctionImplementation_getInitialGradientImplementation(self)
    def getInitialHessianImplementation(self): return _func.NumericalMathFunctionImplementation_getInitialHessianImplementation(self)
    def getUseDefaultGradientImplementation(self): return _func.NumericalMathFunctionImplementation_getUseDefaultGradientImplementation(self)
    def setUseDefaultGradientImplementation(self, *args): return _func.NumericalMathFunctionImplementation_setUseDefaultGradientImplementation(self, *args)
    def getUseDefaultHessianImplementation(self): return _func.NumericalMathFunctionImplementation_getUseDefaultHessianImplementation(self)
    def setUseDefaultHessianImplementation(self, *args): return _func.NumericalMathFunctionImplementation_setUseDefaultHessianImplementation(self, *args)
    def __call__(self, *args): return _func.NumericalMathFunctionImplementation___call__(self, *args)
    def gradient(self, *args): return _func.NumericalMathFunctionImplementation_gradient(self, *args)
    def hessian(self, *args): return _func.NumericalMathFunctionImplementation_hessian(self, *args)
    def parametersGradient(self, *args): return _func.NumericalMathFunctionImplementation_parametersGradient(self, *args)
    def getParameters(self): return _func.NumericalMathFunctionImplementation_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathFunctionImplementation_setParameters(self, *args)
    def getParameterDimension(self): return _func.NumericalMathFunctionImplementation_getParameterDimension(self)
    def getInputDimension(self): return _func.NumericalMathFunctionImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathFunctionImplementation_getOutputDimension(self)
    def setDescription(self, *args): return _func.NumericalMathFunctionImplementation_setDescription(self, *args)
    def getDescription(self): return _func.NumericalMathFunctionImplementation_getDescription(self)
    def getInputDescription(self): return _func.NumericalMathFunctionImplementation_getInputDescription(self)
    def getOutputDescription(self): return _func.NumericalMathFunctionImplementation_getOutputDescription(self)
    def getMarginal(self, *args): return _func.NumericalMathFunctionImplementation_getMarginal(self, *args)
    def getEvaluationCallsNumber(self): return _func.NumericalMathFunctionImplementation_getEvaluationCallsNumber(self)
    def getGradientCallsNumber(self): return _func.NumericalMathFunctionImplementation_getGradientCallsNumber(self)
    def getHessianCallsNumber(self): return _func.NumericalMathFunctionImplementation_getHessianCallsNumber(self)
    def draw(self, *args): return _func.NumericalMathFunctionImplementation_draw(self, *args)
    def __init__(self, *args): 
        this = _func.new_NumericalMathFunctionImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathFunctionImplementation
    __del__ = lambda self : None;
NumericalMathFunctionImplementation_swigregister = _func.NumericalMathFunctionImplementation_swigregister
NumericalMathFunctionImplementation_swigregister(NumericalMathFunctionImplementation)

def NumericalMathFunctionImplementation_GetValidConstants():
  return _func.NumericalMathFunctionImplementation_GetValidConstants()
NumericalMathFunctionImplementation_GetValidConstants = _func.NumericalMathFunctionImplementation_GetValidConstants

def NumericalMathFunctionImplementation_GetValidFunctions():
  return _func.NumericalMathFunctionImplementation_GetValidFunctions()
NumericalMathFunctionImplementation_GetValidFunctions = _func.NumericalMathFunctionImplementation_GetValidFunctions

def NumericalMathFunctionImplementation_GetValidOperators():
  return _func.NumericalMathFunctionImplementation_GetValidOperators()
NumericalMathFunctionImplementation_GetValidOperators = _func.NumericalMathFunctionImplementation_GetValidOperators

class ProductNumericalMathFunction(NumericalMathFunctionImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathFunctionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProductNumericalMathFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathFunctionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProductNumericalMathFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ProductNumericalMathFunction_getClassName(self)

    def __eq__(self, *args): return _func.ProductNumericalMathFunction___eq__(self, *args)
    def __repr__(self): return _func.ProductNumericalMathFunction___repr__(self)
    def __str__(self, offset=""): return _func.ProductNumericalMathFunction___str__(self, offset)
    def parametersGradient(self, *args): return _func.ProductNumericalMathFunction_parametersGradient(self, *args)
    def __init__(self, *args): 
        this = _func.new_ProductNumericalMathFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ProductNumericalMathFunction
    __del__ = lambda self : None;
ProductNumericalMathFunction_swigregister = _func.ProductNumericalMathFunction_swigregister
ProductNumericalMathFunction_swigregister(ProductNumericalMathFunction)

class NumericalMathFunctionImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathFunctionImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathFunctionImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_NumericalMathFunctionImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.NumericalMathFunctionImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.NumericalMathFunctionImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.NumericalMathFunctionImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.NumericalMathFunctionImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_NumericalMathFunctionImplementationTypedInterfaceObject
    __del__ = lambda self : None;
NumericalMathFunctionImplementationTypedInterfaceObject_swigregister = _func.NumericalMathFunctionImplementationTypedInterfaceObject_swigregister
NumericalMathFunctionImplementationTypedInterfaceObject_swigregister(NumericalMathFunctionImplementationTypedInterfaceObject)

class NumericalMathFunctionCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathFunctionCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathFunctionCollection, name)
    __swig_destroy__ = _func.delete_NumericalMathFunctionCollection
    __del__ = lambda self : None;
    def clear(self): return _func.NumericalMathFunctionCollection_clear(self)
    def __len__(self): return _func.NumericalMathFunctionCollection___len__(self)
    def __eq__(self, *args): return _func.NumericalMathFunctionCollection___eq__(self, *args)
    def __contains__(self, *args): return _func.NumericalMathFunctionCollection___contains__(self, *args)
    def __getitem__(self, *args): return _func.NumericalMathFunctionCollection___getitem__(self, *args)
    def __setitem__(self, *args): return _func.NumericalMathFunctionCollection___setitem__(self, *args)
    def __delitem__(self, *args): return _func.NumericalMathFunctionCollection___delitem__(self, *args)
    def at(self, *args): return _func.NumericalMathFunctionCollection_at(self, *args)
    def add(self, *args): return _func.NumericalMathFunctionCollection_add(self, *args)
    def getSize(self): return _func.NumericalMathFunctionCollection_getSize(self)
    def resize(self, *args): return _func.NumericalMathFunctionCollection_resize(self, *args)
    def isEmpty(self): return _func.NumericalMathFunctionCollection_isEmpty(self)
    def __repr__(self): return _func.NumericalMathFunctionCollection___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathFunctionCollection___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_NumericalMathFunctionCollection(*args)
        try: self.this.append(this)
        except: self.this = this
NumericalMathFunctionCollection_swigregister = _func.NumericalMathFunctionCollection_swigregister
NumericalMathFunctionCollection_swigregister(NumericalMathFunctionCollection)

class NumericalMathFunctionPersistentCollection(openturns.common.PersistentObject,NumericalMathFunctionCollection):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject,NumericalMathFunctionCollection]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathFunctionPersistentCollection, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject,NumericalMathFunctionCollection]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathFunctionPersistentCollection, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathFunctionPersistentCollection_getClassName(self)

    def __init__(self, *args): 
        this = _func.new_NumericalMathFunctionPersistentCollection(*args)
        try: self.this.append(this)
        except: self.this = this
    def __repr__(self): return _func.NumericalMathFunctionPersistentCollection___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathFunctionPersistentCollection___str__(self, offset)
    __swig_destroy__ = _func.delete_NumericalMathFunctionPersistentCollection
    __del__ = lambda self : None;
NumericalMathFunctionPersistentCollection_swigregister = _func.NumericalMathFunctionPersistentCollection_swigregister
NumericalMathFunctionPersistentCollection_swigregister(NumericalMathFunctionPersistentCollection)

class NumericalMathFunction(NumericalMathFunctionImplementationTypedInterfaceObject):
    """
    Function.

    Available constructors:
        NumericalMathFunction(*filename*)

        NumericalMathFunction(*inputs, outputs, formulas*)

        NumericalMathFunction(*inputs, formulas*)

        NumericalMathFunction(*inputString, formulaString, outputString = 'outputVariable'*)

        NumericalMathFunction(*f, g*)

        NumericalMathFunction(*functionCollection*)

        NumericalMathFunction(*functionCollection, scalarCoefficientColl*)

        NumericalMathFunction(*scalarFunctionCollection, vectorCoefficientColl*)

        NumericalMathFunction(*function, comparisonOperator, threshold*)

        NumericalMathFunction(*function, indices, parametersSet=True*)

        NumericalMathFunction(*function, indices, referencePoint, parametersSet=True*)

        NumericalMathFunction(*inputSample, outputSample*)

    Parameters
    ----------
    fileName : String or :class:`~openturns.WrapperFile`
        A string to name the XML file (without the extension '.xml') which contains
        the implementation of the considered function.
    inputs : list of strings
        Ordered list of input variables names of the *NumericalMathFunction*.
    outputs : list of strings
        Ordered list of output variables names of the *NumericalMathFunction*.
        If it is not specified, default names are created for the output variables.
    formulas : list of strings
        Ordered list of analytical formulas between the inputs and the outputs.
        The *NumericalMathFunction* is defined by *ouputs = formulas(inputs)*.
    inputString : String
        Description of the *NumericalMathFunction*'s input.
    outputString : String
        Description of the *NumericalMathFunction*'s output.
    formulaString : String
        Analytical formula of the *NumericalMathFunction*.
        The *NumericalMathFunction* is defined by
        *ouputString = formulaString(inputString)*.
    f,g : two :class:`~openturns.NumericalMathFunction`
        The *NumericalMathFunction* is the composition function :math:`f\\circ g`.
    functionCollection : list of :class:`~openturns.NumericalMathFunction`
        Collection of several *NumericalMathFunction*.
    scalarCoefficientColl : float sequence
        Collection of scalar weights.
    scalarFunctionCollection : list of :class:`~openturns.NumericalMathFunction`
        Collection of several scalar *NumericalMathFunction*.
    vectorCoefficientColl : 2D float sequence
        Collection of vectorial weights.
    function : :class:`~openturns.NumericalMathFunction`
        Function from which another function is created.
    comparisonOperator : :class:`~openturns.ComparisonOperator`
        Comparison operator.
    threshold : float
        Threshold from which values are compared.
    indices : list of ints
        Indices of the set variables.
        If *referencePoint* is not mentioned, the variables are set to a null
        value. Otherwise, the variables are set to the *referencePoint*'s values.
    parametersSet : bool
        If *True*, the set variables are the ones referenced in *indices*.
        Otherwise, the variables are the ones referenced in the complementary
        vector of *indices*.
    referencePoint : float sequence
        If not *referencePoint* take a null vector.
    inputSample : 2D float sequence
        Values of the inputs.
    outputSample : 2D float sequence
        Values of the outputs.

    Examples
    --------
    Create a *NumericalMathFunction* from a list of analytical formulas and
    descriptions of the inputs and the outputs :

    >>> import openturns as ot
    >>> f = ot.NumericalMathFunction(['x0', 'x1'], ['y0', 'y1'],
    ...                              ['x0 + x1', 'x0 - x1'])
    >>> print(f([1, 2]))
    [3,-1]


    Create a *NumericalMathFunction* from strings:

    >>> import openturns as ot
    >>> f = ot.NumericalMathFunction('x', '2.0*sqrt(x)', 'y')
    >>> print(f(([16],[4])))
        [ y ]
    0 : [ 8 ]
    1 : [ 4 ]


    Create a *NumericalMathFunction* from a Python function:

    >>> def a_function(X):
    ...     return [X[0] + X[1]]
    >>> f = ot.PythonFunction(2, 1, a_function)
    >>> print(f(((10, 5),(6, 7))))
        [ y0 ]
    0 : [ 15 ]
    1 : [ 13 ]


    See :class:`~openturns.PythonFunction` for further details.

    Create a *NumericalMathFunction* from another *NumericalMathFunction*:

    >>> f = ot.NumericalMathFunction(ot.Description.BuildDefault(4, 'x'),
    ...                              ['x0', 'x0 + x1', 'x0 + x2 + x3'])

    Then create another function by setting x1=0 and x3=0:

    >>> g = ot.NumericalMathFunction(f, [3, 1], True)
    >>> print(g.getInputDescription())
    [x0,x2]
    >>> print(g.getOutputDescription())
    [y0,y1,y2]
    >>> print(g((1, 2)))
    [1,1,3]

    Or by setting x1=4 and x3=10:

    >>> g = ot.NumericalMathFunction(f, [3, 1], [6, 4, 5, 10], True)
    >>> print(g((1, 2)))
    [1,5,13]

    Or by setting x0=6 and x2=5:

    >>> g = ot.NumericalMathFunction(f, [3, 1], [6, 4, 5, 10], False)
    >>> print(g.getInputDescription())
    [x3,x1]
    >>> print(g((1, 2)))
    [6,8,12]


    Create a *NumericalMathFunction* from another *NumericalMathFunction*
    and by using a comparison operator:

    >>> analytical = ot.NumericalMathFunction(['x0','x1'], ['y'], ['x0 + x1'])
    >>> indicator = ot.NumericalMathFunction(analytical, ot.Less(), 0.0)
    >>> print(indicator([2, 3]))
    [0]
    >>> print(indicator([2, -3]))
    [1]

    Create a *NumericalMathFunction* from a collection of functions:

    >>> functions = list()
    >>> functions.append(ot.NumericalMathFunction(['x1', 'x2', 'x3'], ['y1', 'y2'],
    ...                                      ['x1^2 + x2', 'x1 + x2 + x3']))
    >>> functions.append(ot.NumericalMathFunction(['x1', 'x2', 'x3'], ['y1', 'y2'],
    ...                                      ['x1 + 2 * x2 + x3', 'x1 + x2 - x3']))
    >>> myFunction = ot.NumericalMathFunction(functions)
    >>> print(myFunction([1., 2., 3.]))
    [3,6,8,0]

    Create a *NumericalMathFunction* which is the linear combination *linComb*
    of the functions defined in  *functionCollection* with scalar weights
    defined in *scalarCoefficientColl*:

    :math:`functionCollection  = (f_1, \\hdots, f_N)`
    where :math:`\\forall 1 \\leq i \\leq N, \\,     f_i: \\Rset^n \\rightarrow \\Rset^{p}`
    and :math:`scalarCoefficientColl = (c_1, \\hdots, c_N) \\in \\Rset^N`
    then the linear combination is:

    .. math::

        linComb: \\left|\\begin{array}{rcl}
                      \\Rset^n & \\rightarrow & \\Rset^{p} \\\\
                      \\vect{X} & \\mapsto & \\displaystyle \\sum_i c_if_i (\\vect{X})
                  \\end{array}\\right.

    >>> myFunction2 = ot.NumericalMathFunction(functions, [2., 4.])
    >>> print(myFunction2([1., 2., 3.]))
    [38,12]


    Create a *NumericalMathFunction* which is the linear combination
    *vectLinComb* of the scalar functions defined in
    *scalarFunctionCollection* with vectorial weights defined in
    *vectorCoefficientColl*:

    If :math:`scalarFunctionCollection = (f_1, \\hdots, f_N)`
    where :math:`\\forall 1 \\leq i \\leq N, \\,    f_i: \\Rset^n \\rightarrow \\Rset`
    and :math:`vectorCoefficientColl = (\\vect{c}_1, \\hdots, \\vect{c}_N)`
    where :math:`\\forall 1 \\leq i \\leq N, \\,   \\vect{c}_i \\in \\Rset^p`

    .. math::

        vectLinComb: \\left|\\begin{array}{rcl}
                         \\Rset^n & \\rightarrow & \\Rset^{p} \\\\
                         \\vect{X} & \\mapsto & \\displaystyle \\sum_i \\vect{c}_if_i (\\vect{X})
                     \\end{array}\\right.

    >>> functions=list()
    >>> functions.append(ot.NumericalMathFunction(['x1', 'x2', 'x3'], ['y1'],
    ...                                           ['x1 + 2 * x2 + x3']))
    >>> functions.append(ot.NumericalMathFunction(['x1', 'x2', 'x3'], ['y1'],
    ...                                           ['x1^2 + x2']))
    >>> myFunction2 = ot.NumericalMathFunction(functions, [[2., 4.], [3., 1.]])
    >>> print(myFunction2([1, 2, 3]))
    [25,35]


    Create a *NumericalMathFunction* from values of the inputs and the outputs:

    >>> inputSample = [[1.0, 1.0], [2.0, 2.0]]
    >>> outputSample = [[4.0], [5.0]]
    >>> database = ot.NumericalMathFunction(inputSample, outputSample)
    >>> x = [1.8]*database.getInputDimension()
    >>> print(database(x))
    [5]


    Create a *NumericalMathFunction* which is the composition function
    :math:`f\\circ g`:

    >>> g = ot.NumericalMathFunction(['x1', 'x2'], ['y1', 'y2'],
    ...                              ['x1 + x2','3 * x1 * x2'])
    >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'], ['2 * x1 - x2'])
    >>> composed = ot.NumericalMathFunction(f, g)
    >>> print(composed([3, 4]))
    [-22]
    """
    __swig_setmethods__ = {}
    for _s in [NumericalMathFunctionImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathFunctionImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathFunction_getClassName(self)

    def __eq__(self, *args): return _func.NumericalMathFunction___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathFunction___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathFunction___str__(self, offset)
    def enableCache(self):
        """Enable the cache mechanism."""
        return _func.NumericalMathFunction_enableCache(self)

    def disableCache(self):
        """Disable the cache mechanism."""
        return _func.NumericalMathFunction_disableCache(self)

    def isCacheEnabled(self):
        """
        Test whether the cache mechanism is enabled or not.

        Returns
        -------
        isCacheEnabled : bool
            Flag telling whether the cache mechanism is enabled.
            It is disabled by default.
        """
        return _func.NumericalMathFunction_isCacheEnabled(self)

    def getCacheHits(self):
        """
        Accessor to the number of computations saved thanks to the cache mecanism.

        Returns
        -------
        cacheHits : int
            Integer that counts the number of computations saved thanks to the cache
            mecanism.
        """
        return _func.NumericalMathFunction_getCacheHits(self)

    def addCacheContent(self, *args):
        """
        Add input numerical points and associated output to the cache.

        Parameters
        ----------
        input_sample : 2D float sequence
            Input numerical points to be added to the cache.
        output_sample : 2D float sequence
            Output numerical points associated with the input_sample to be added to the
            cache.
        """
        return _func.NumericalMathFunction_addCacheContent(self, *args)

    def getCacheInput(self):
        """
        Accessor to all the input numerical points stored in the cache mecanism.

        Returns
        -------
        cacheInput : 2D float sequence
            All the input numerical points stored in the cache mecanism.
        """
        return _func.NumericalMathFunction_getCacheInput(self)

    def getCacheOutput(self):
        """
        Accessor to all the output numerical points stored in the cache mecanism.

        Returns
        -------
        cacheInput : 2D float sequence
            All the output numerical points stored in the cache mecanism.
        """
        return _func.NumericalMathFunction_getCacheOutput(self)

    def clearCache(self):
        """Empty the content of the cache."""
        return _func.NumericalMathFunction_clearCache(self)

    def enableHistory(self):
        """Enable the history mechanism."""
        return _func.NumericalMathFunction_enableHistory(self)

    def disableHistory(self):
        """Disable the history mechanism."""
        return _func.NumericalMathFunction_disableHistory(self)

    def isHistoryEnabled(self):
        """
        Test whether the history mechanism is enabled or not.

        Returns
        -------
        isHistoryEnabled : bool
            Flag telling whether the history mechanism is enabled.
            It is disabled by default.
        """
        return _func.NumericalMathFunction_isHistoryEnabled(self)

    def clearHistory(self):
        """Empty the content of the history."""
        return _func.NumericalMathFunction_clearHistory(self)

    def getHistoryInput(self):
        """
        Accessor to the history of the input values.

        Returns
        -------
        input_history : 2D float sequence
            All the input numerical points stored in the history mecanism.
        """
        return _func.NumericalMathFunction_getHistoryInput(self)

    def getInputHistory(self): return _func.NumericalMathFunction_getInputHistory(self)
    def getHistoryOutput(self):
        """
        Accessor to the history of the output values.

        Returns
        -------
        output_history : 2D float sequence
            All the output numerical points stored in the history mecanism.
        """
        return _func.NumericalMathFunction_getHistoryOutput(self)

    def getOutputHistory(self): return _func.NumericalMathFunction_getOutputHistory(self)
    def setEvaluation(self, *args): return _func.NumericalMathFunction_setEvaluation(self, *args)
    def getEvaluation(self):
        """
        Accessor to the evaluation function.

        Returns
        -------
        function : :class:`~openturns.NumericalMathEvaluationImplementation`
            The evaluation function.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getEvaluation())
        [x1,x2]->[2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6]
        """
        return _func.NumericalMathFunction_getEvaluation(self)

    def setEvaluationImplementation(self, *args):
        """
        Accessor to the evaluation function.

        Parameters
        ----------
        function : :class:`~openturns.NumericalMathEvaluationImplementation`
            The evaluation function.
        """
        return _func.NumericalMathFunction_setEvaluationImplementation(self, *args)

    def getEvaluationImplementation(self): return _func.NumericalMathFunction_getEvaluationImplementation(self)
    def setGradient(self, *args):
        """
        Accessor to the gradient function.

        Parameters
        ----------
        gradient_function : :class:`~openturns.NumericalMathGradientImplementation`
            The gradient function.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> f.setGradient(ot.CenteredFiniteDifferenceGradient(
        ...  ot.ResourceMap.GetAsNumericalScalar('CenteredFiniteDifferenceGradient-DefaultEpsilon'),
        ...  f.getEvaluation()))
        """
        return _func.NumericalMathFunction_setGradient(self, *args)

    def getGradient(self):
        """
        Accessor to the gradient function.

        Returns
        -------
        gradient : :class:`~openturns.NumericalMathGradientImplementation`
            The gradient function.
        """
        return _func.NumericalMathFunction_getGradient(self)

    def setGradientImplementation(self, *args): return _func.NumericalMathFunction_setGradientImplementation(self, *args)
    def getGradientImplementation(self): return _func.NumericalMathFunction_getGradientImplementation(self)
    def setHessian(self, *args): return _func.NumericalMathFunction_setHessian(self, *args)
    def getHessian(self): return _func.NumericalMathFunction_getHessian(self)
    def setHessianImplementation(self, *args):
        """
        Accessor to the hessian function.

        Parameters
        ----------
        hessian_function : :class:`~openturns.NumericalMathHessianImplementation`
            The hessian function.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> f.setHessian(ot.CenteredFiniteDifferenceHessian(
        ...  ot.ResourceMap.GetAsNumericalScalar('CenteredFiniteDifferenceHessian-DefaultEpsilon'),
        ...  f.getEvaluation()))
        """
        return _func.NumericalMathFunction_setHessianImplementation(self, *args)

    def getHessianImplementation(self):
        """
        Accessor to the hessian function.

        Returns
        -------
        hessian : :class:`~openturns.NumericalMathHessianImplementation`
            The hessian function.
        """
        return _func.NumericalMathFunction_getHessianImplementation(self)

    def getInitialEvaluationImplementation(self):
        """
        Accessor to the initial evaluation function.

        Returns
        -------
        function : :class:`~openturns.NumericalMathEvaluationImplementation`
            The initial evaluation function.
        """
        return _func.NumericalMathFunction_getInitialEvaluationImplementation(self)

    def getInitialGradientImplementation(self):
        """
        Accessor to the initial gradient function.

        Returns
        -------
        gradient : :class:`~openturns.NumericalMathGradientImplementation`
            The initial gradient function.
        """
        return _func.NumericalMathFunction_getInitialGradientImplementation(self)

    def getInitialHessianImplementation(self):
        """
        Accessor to the initial hessian function.

        Returns
        -------
        hessian : :class:`~openturns.NumericalMathHessianImplementation`
            The initial hessian function.
        """
        return _func.NumericalMathFunction_getInitialHessianImplementation(self)

    def getUseDefaultGradientImplementation(self):
        """**(ditch me?)**"""
        return _func.NumericalMathFunction_getUseDefaultGradientImplementation(self)

    def setUseDefaultGradientImplementation(self, *args):
        """**(ditch me?)**"""
        return _func.NumericalMathFunction_setUseDefaultGradientImplementation(self, *args)

    def getUseDefaultHessianImplementation(self):
        """**(ditch me?)**"""
        return _func.NumericalMathFunction_getUseDefaultHessianImplementation(self)

    def setUseDefaultHessianImplementation(self, *args):
        """**(ditch me?)**"""
        return _func.NumericalMathFunction_setUseDefaultHessianImplementation(self, *args)

    def __mul__(self, *args): return _func.NumericalMathFunction___mul__(self, *args)
    def __add__(self, *args): return _func.NumericalMathFunction___add__(self, *args)
    def __sub__(self, *args): return _func.NumericalMathFunction___sub__(self, *args)
    def __call__(self, *args): return _func.NumericalMathFunction___call__(self, *args)
    def gradient(self, *args):
        """
        Return the Jacobian transposed matrix of the function at point.

        Parameters
        ----------
        point : float sequence
            Point where the Jacobian transposed matrix is calculated.

        Returns
        -------
        gradient : :class:`~openturns.Matrix`
            The Jacobian transposed matrix of the function at point.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y','z'],
        ...                ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6','x1 + x2'])
        >>> print(f.gradient([3.14, 4]))
        [[ 13.5345   1       ]
         [  4.00001  1       ]]
        """
        return _func.NumericalMathFunction_gradient(self, *args)

    def hessian(self, *args):
        """
        Return the symmetric tensor of the function at point.

        Parameters
        ----------
        point : float sequence
            Point where the symmetric tensor of the function is calculated.

        Returns
        -------
        hessian : :class:`~openturns.SymmetricTensor`
            Symmetric tensor of the function at point.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y','z'],
        ...                ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6','x1 + x2'])
        >>> print(f.hessian([3.14, 4]))
        sheet #0
        [[ 20          -0.00637061 ]
         [ -0.00637061  0          ]]
        sheet #1
        [[  0           0          ]
         [  0           0          ]]
        """
        return _func.NumericalMathFunction_hessian(self, *args)

    def parametersGradient(self, *args):
        """**(ditch me?)**"""
        return _func.NumericalMathFunction_parametersGradient(self, *args)

    def getParameters(self):
        """**(ditch me?)**"""
        return _func.NumericalMathFunction_getParameters(self)

    def setParameters(self, *args):
        """**(ditch me?)**"""
        return _func.NumericalMathFunction_setParameters(self, *args)

    def getParameterDimension(self): return _func.NumericalMathFunction_getParameterDimension(self)
    def getInputDimension(self):
        """
        Accessor to the number of the inputs.

        Returns
        -------
        number_inputs : int
            Number of inputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getInputDimension())
        2
        """
        return _func.NumericalMathFunction_getInputDimension(self)

    def getOutputDimension(self):
        """
        Accessor to the number of the outputs.

        Returns
        -------
        number_outputs : int
            Number of outputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getOutputDimension())
        1
        """
        return _func.NumericalMathFunction_getOutputDimension(self)

    def setDescription(self, *args):
        """
        Accessor to the description of the inputs and outputs.

        Parameters
        ----------
        description : list of strings
            Description of the inputs and the outputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getDescription())
        [x1,x2,y]
        >>> f.setDescription(['a','b','y'])
        >>> print(f.getDescription())
        [a,b,y]
        """
        return _func.NumericalMathFunction_setDescription(self, *args)

    def getDescription(self):
        """
        Accessor to the description of the inputs and outputs.

        Returns
        -------
        description : list of strings
            Description of the inputs and the outputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getDescription())
        [x1,x2,y]
        """
        return _func.NumericalMathFunction_getDescription(self)

    def getInputDescription(self):
        """
        Accessor to the description of the inputs.

        Returns
        -------
        description : list of strings
            Description of the inputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getInputDescription())
        [x1,x2]
        """
        return _func.NumericalMathFunction_getInputDescription(self)

    def getOutputDescription(self):
        """
        Accessor to the description of the outputs.

        Returns
        -------
        description : list of strings
            Description of the outputs.

        Examples
        --------
        >>> import openturns as ot
        >>> f = ot.NumericalMathFunction(['x1', 'x2'], ['y'],
        ...                          ['2 * x1^2 + x1 + 8 * x2 + 4 * cos(x1) * x2 + 6'])
        >>> print(f.getOutputDescription())
        [y]
        """
        return _func.NumericalMathFunction_getOutputDescription(self)

    def getMarginal(self, *args):
        """
        Accessor to marginal.

        Parameters
        ----------
        indices : int or list of ints
            Set of indices for which the marginal is extracted.

        Returns
        -------
        marginal : :class:`~openturns.NumericalMathFunction`
            Function corresponding to either :math:`f_i` or
            :math:`(f_i)_{i \\in indices}`, with :math:`f:\\Rset^n \\rightarrow \\Rset^p`
            and :math:`f=(f_0 , \\dots, f_{p-1})`.
        """
        return _func.NumericalMathFunction_getMarginal(self, *args)

    def getCallsNumber(self):
        """
        Accessor to the number of times the function has been called.

        Returns
        -------
        calls_number : int
            Integer that counts the number of times the function has been called
            since its creation.
        """
        return _func.NumericalMathFunction_getCallsNumber(self)

    def getEvaluationCallsNumber(self):
        """
        Accessor to the number of times the function has been called.

        Returns
        -------
        evaluation_calls_number : int
            Integer that counts the number of times the function has been called
            since its creation.
        """
        return _func.NumericalMathFunction_getEvaluationCallsNumber(self)

    def getGradientCallsNumber(self):
        """
        Accessor to the number of times the gradient of the function has been called.

        Returns
        -------
        gradient_calls_number : int
            Integer that counts the number of times the gradient of the
            NumericalMathFunction has been called since its creation.
            Note that if the gradient is implemented by a finite difference method,
            the gradient calls number is equal to 0 and the different calls are
            counted in the evaluation calls number.
        """
        return _func.NumericalMathFunction_getGradientCallsNumber(self)

    def getHessianCallsNumber(self):
        """
        Accessor to the number of times the hessian of the function has been called.

        Returns
        -------
        hessian_calls_number : int
            Integer that counts the number of times the hessian of the
            NumericalMathFunction has been called since its creation.
            Note that if the hessian is implemented by a finite difference method,
            the hessian calls number is equal to 0 and the different calls are counted
            in the evaluation calls number.
        """
        return _func.NumericalMathFunction_getHessianCallsNumber(self)

    def draw(self, *args):
        """
        Draw the output of function as a :class:`~openturns.Graph`.

        Available usages:
            draw(*inputMarg, outputMarg, CP, xiMin, xiMax, ptNb*)

            draw(*firstInputMarg, secondInputMarg, outputMarg, CP, xiMin_xjMin, xiMax_xjMax, ptNbs*)

            draw(*xiMin, xiMax, ptNb*)

            draw(*xiMin_xjMin, xiMax_xjMax, ptNbs*)

        Parameters
        ----------
        outputMarg, inputMarg : int, :math:`outputMarg, inputMarg \\geq 0`
            *outputMarg* is the index of the marginal to draw as a function of the marginal
            with index *inputMarg*.
        firstInputMarg, secondInputMarg : int, :math:`firstInputMarg, secondInputMarg \\geq 0`
            In the 2D case, the marginal *outputMarg* is drawn as a function of the
            two marginals with indexes *firstInputMarg* and *secondInputMarg*.
        CP : float sequence
            Central point.
        xiMin, xiMax : float
            Define the interval where the curve is plotted.
        xiMin_xjMin, xiMax_xjMax : float sequences of dimension 2.
            In the 2D case, define the intervals where the curves are plotted.
        ptNb : int :math:`ptNb > 0` or list of ints of dimension 2 :math:`ptNb_k > 0, k=1,2`
            The number of points to draw the curves.

        Notes
        -----
        We note :math:`f: \\Rset^n \\rightarrow \\Rset^p`
        where :math:`\\vect{x} = (x_1, \\dots, x_n)` and
        :math:`f(\\vect{x}) = (f_1(\\vect{x}), \\dots,f_p(\\vect{x}))`,
        with :math:`n\\geq 1` and :math:`p\\geq 1`.

        - In the first usage:

        Draws graph of the given 1D *outputMarg* marginal
        :math:`f_k: \\Rset^n \\rightarrow \\Rset` as a function of the given 1D *inputMarg*
        marginal with respect to the variation of :math:`x_i` in the interval
        :math:`[x_i^{min}, x_i^{max}]`, when all the other components of
        :math:`\\vect{x}` are fixed to the corresponding ones of the central point *CP*.
        Then OpenTURNS draws the graph:
        :math:`t\\in [x_i^{min}, x_i^{max}] \\mapsto f_k(CP_1, \\dots, CP_{i-1}, t,  CP_{i+1} \\dots, CP_n)`.

        - In the second usage:

        Draws the iso-curves of the given *outputMarg* marginal :math:`f_k` as a
        function of the given 2D *firstInputMarg* and *secondInputMarg* marginals
        with respect to the variation of :math:`(x_i, x_j)` in the interval
        :math:`[x_i^{min}, x_i^{max}] \\times [x_j^{min}, x_j^{max}]`, when all the
        other components of :math:`\\vect{x}` are fixed to the corresponding ones of the
        central point *CP*. Then OpenTURNS draws the graph:
        :math:`(t,u) \\in [x_i^{min}, x_i^{max}] \\times [x_j^{min}, x_j^{max}] \\mapsto f_k(CP_1, \\dots, CP_{i-1}, t, CP_{i+1}, \\dots, CP_{j-1}, u,  CP_{j+1} \\dots, CP_n)`.

        - In the third usage:

        The same as the first usage but only for function :math:`f: \\Rset \\rightarrow \\Rset`.

        - In the fourth usage:

        The same as the second usage but only for function :math:`f: \\Rset^2 \\rightarrow \\Rset`.


        Examples
        --------
        >>> import openturns as ot
        >>> from openturns.viewer import View
        >>> f = ot.NumericalMathFunction('x', 'sin(2*_pi*x)*exp(-x^2/2)', 'y')
        >>> graph = f.draw(-1.2, 1.2, 100)
        >>> View(graph).show()
        """
        return _func.NumericalMathFunction_draw(self, *args)

    def GetValidConstants():
        """
        Return the list of valid constants.

        Returns
        -------
        list_constants : list of strings
            List of the constants we can use within OpenTURNS.

        Examples
        --------
        >>> import openturns as ot
        >>> print(ot.NumericalMathFunction().GetValidConstants()[0:2])
        [_e -> Euler's constant (2.71828...),_pi -> Pi constant (3.14159...)]
        """
        return _func.NumericalMathFunction_GetValidConstants()

    if _newclass:GetValidConstants = staticmethod(GetValidConstants)
    __swig_getmethods__["GetValidConstants"] = lambda x: GetValidConstants
    def GetValidFunctions():
        """
        Return the list of valid functions.

        Returns
        -------
        list_functions : list of strings
            List of the functions we can use within OpenTURNS.

        Examples
        --------
        >>> import openturns as ot
        >>> print(ot.NumericalMathFunction().GetValidFunctions()[0:2])
        [sin(arg) -> sine function,cos(arg) -> cosine function]
        """
        return _func.NumericalMathFunction_GetValidFunctions()

    if _newclass:GetValidFunctions = staticmethod(GetValidFunctions)
    __swig_getmethods__["GetValidFunctions"] = lambda x: GetValidFunctions
    def GetValidOperators():
        """
        Return the list of valid operators.

        Returns
        -------
        list_operators : list of strings
            List of the operators we can use within OpenTURNS.

        Examples
        --------
        >>> import openturns as ot
        >>> print(ot.NumericalMathFunction().GetValidOperators()[0:2])
        [= -> assignement, can only be applied to variable names (priority -1),and -> logical and (priority 1)]
        """
        return _func.NumericalMathFunction_GetValidOperators()

    if _newclass:GetValidOperators = staticmethod(GetValidOperators)
    __swig_getmethods__["GetValidOperators"] = lambda x: GetValidOperators
    def __init__(self, *args): 
        this = _func.new_NumericalMathFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathFunction
    __del__ = lambda self : None;
NumericalMathFunction_swigregister = _func.NumericalMathFunction_swigregister
NumericalMathFunction_swigregister(NumericalMathFunction)

def NumericalMathFunction_GetValidConstants():
  """
    Return the list of valid constants.

    Returns
    -------
    list_constants : list of strings
        List of the constants we can use within OpenTURNS.

    Examples
    --------
    >>> import openturns as ot
    >>> print(ot.NumericalMathFunction().GetValidConstants()[0:2])
    [_e -> Euler's constant (2.71828...),_pi -> Pi constant (3.14159...)]
    """
  return _func.NumericalMathFunction_GetValidConstants()

def NumericalMathFunction_GetValidFunctions():
  """
    Return the list of valid functions.

    Returns
    -------
    list_functions : list of strings
        List of the functions we can use within OpenTURNS.

    Examples
    --------
    >>> import openturns as ot
    >>> print(ot.NumericalMathFunction().GetValidFunctions()[0:2])
    [sin(arg) -> sine function,cos(arg) -> cosine function]
    """
  return _func.NumericalMathFunction_GetValidFunctions()

def NumericalMathFunction_GetValidOperators():
  """
    Return the list of valid operators.

    Returns
    -------
    list_operators : list of strings
        List of the operators we can use within OpenTURNS.

    Examples
    --------
    >>> import openturns as ot
    >>> print(ot.NumericalMathFunction().GetValidOperators()[0:2])
    [= -> assignement, can only be applied to variable names (priority -1),and -> logical and (priority 1)]
    """
  return _func.NumericalMathFunction_GetValidOperators()

# We have to make sure the submodule is loaded with absolute path
import openturns.typ

class OpenTURNSPythonFunction(object):
    """
    Override NumericalMathFunction from Python.

    Parameters
    ----------
    n : positive int
        the input dimension
    p : positive int
        the output dimension

    Notes
    -----
    You have to overload the function:
        _exec(X): single evaluation, X is a sequence of float,
        returns a sequence of float
    You can also optionally override these functions:
        _exec_sample(X): multiple evaluations, X is a 2-d float sequence,
        returns a 2-d sequence of float
        _gradient(X): gradient, X is a sequence of float,
        returns a 2-d float sequence
        _hessian(X): hessian, X is a sequence of float,
        returns a 3-d float sequence
    """
    def __init__(self, n=0, p=0):
        try:
            self.__n = int(n)
        except:
            raise TypeError('n argument is not an integer.')
        try:
            self.__p = int(p)
        except:
            raise TypeError('p argument is not an integer.')
        self.__descIn = list(map(lambda i: 'x' + str(i), range(n)))
        self.__descOut = list(map(lambda i: 'y' + str(i), range(p)))

    def setInputDescription(self, descIn):
        if (len(descIn) != self.__n):
            raise ValueError('Input description size does NOT match input dimension')
        self.__descIn = descIn

    def getInputDescription(self):
        return self.__descIn

    def setOutputDescription(self, descOut):
        if (len(descOut) != self.__p):
            raise ValueError('Output description size does NOT match output dimension')
        self.__descOut = descOut

    def getOutputDescription(self):
        return self.__descOut

    def getInputDimension(self):
        return self.__n

    def getOutputDimension(self):
        return self.__p

    def __str__(self):
        return 'OpenTURNSPythonFunction( %s #%d ) -> %s #%d' % (self.__descIn, self.__n, self.__descOut, self.__p)

    def __repr__(self):
        return self.__str__()

    def __call__(self, X):
        Y = None
        try:
            pt = openturns.typ.NumericalPoint(X)
        except TypeError:
            try:
                ns = openturns.typ.NumericalSample(X)
            except TypeError:
                raise TypeError('Expect a 1-d or 2-d float sequence as argument')
            else:
                Y = self._exec_sample(ns)
        else:
            Y = self._exec(pt)
        return Y

    def _exec(self, X):
        raise RuntimeError('You must define a method _exec(X) -> Y, where X and Y are 1-d float sequence objects')

    def _exec_sample(self, X):
        res = list()
        for point in X:
            res.append(self._exec(point))
        return res

    def _exec_point_on_exec_sample(self, X):
        """Implement exec from exec_sample."""
        return self._exec_sample([X])[0]


class PythonFunction(NumericalMathFunction):
    """
    Override NumericalMathFunction from Python.

    Parameters
    ----------
    n : positive int
        the input dimension
    p : positive int
        the output dimension
    func : a callable python object
        called on a single point
        Default is None.
    func_sample : a callable python object
        called on multiple points at once
        Default is None.
    gradient : a callable python objects
        returns the gradient as a 2-d float sequence
        Default is None (uses finite-difference).
    hessian : a callable python object
        returns the hessian as a 3-d float sequence
        Default is None (uses finite-difference).

    Notes
    -----
    You may provide either one of func or func_sample arguments
    """
    def __new__(self, n, p, func=None, func_sample=None, gradient=None, hessian=None):
        if func == None and func_sample == None:
            raise RuntimeError('no func nor func_sample given.')
        instance = OpenTURNSPythonFunction(n, p)
        import collections
        if func != None:
            if not isinstance(func, collections.Callable):
                raise RuntimeError('func argument is not callable.')
            instance._exec = func
        if func_sample != None:
            if not isinstance(func_sample, collections.Callable):
                raise RuntimeError('func_sample argument is not callable.')
            instance._exec_sample = func_sample
            if func == None:
                instance._exec = instance._exec_point_on_exec_sample
        if gradient != None:
            if not isinstance(gradient, collections.Callable):
                raise RuntimeError('gradient argument is not callable.')
            instance._gradient = gradient
        if hessian != None:
            if not isinstance(hessian, collections.Callable):
                raise RuntimeError('hessian argument is not callable.')
            instance._hessian = hessian 
        return NumericalMathFunction(instance)

class DynamicalFunctionImplementation(openturns.common.PersistentObject):
    """
    Dynamical function.

    Available constructors:
        DynamicalFunction(*meshDimension=1*)

        DynamicalFunction(*function, meshDimension=1*)

    Parameters
    ----------
    function : :class:`~openturns.NumericalMathFunction`
        Function :math:`g: \\Rset^d \\mapsto \\Rset^q` used to define a
        :class:`~openturns.SpatialFunction` object.
    meshDimension : int, :math:`n \\geq 0`
        Dimension of the mesh :math:`\\cM`.

    Notes
    -----
    Dynamical functions are functions being able to act on fields. OpenTURNS
    defines two particular dynamical functions:
    the :class:`spatial function <openturns.SpatialFunction>` and
    the :class:`temporal function <openturns.TemporalFunction>`.


    A dynamical function
    :math:`f_{dyn}:\\cD \\times \\Rset^d \\mapsto \\cD' \\times \\Rset^q`
    where :math:`\\cD \\in \\Rset^n` and :math:`\\cD' \\in \\Rset^p` is defined by:

    .. math::

        f_{dyn}(\\vect{t}, \\vect{x}) = (t'(\\vect{t}), v'(\\vect{t}, \\vect{x}))

    with :math:`t': \\cD \\mapsto \\cD'` and
    :math:`v': \\cD \\times \\Rset^d \\mapsto \\Rset^q`.

    A dynamical function :math:`f_{dyn}` transforms a multivariate stochastic
    process:

    .. math::

        X: \\Omega \\times \\cD \\mapsto \\Rset^d

    where :math:`\\cD \\in \\Rset^n` is discretized according to the mesh :math:`\\cM`
    into the multivariate stochastic process:

    .. math::

        Y=f_{dyn}(X)

    such that:

    .. math::

        Y: \\Omega \\times \\cD' \\mapsto \\Rset^q

    where the mesh :math:`\\cD' \\in \\Rset^p`  is discretized according to the
    :math:`\\cM'`.

    A dynamical function :math:`f_{dyn}` also acts on fields and produces fields of
    possibly different dimension (:math:`q\\neq d`) and mesh (:math:`\\cD \\neq \\cD'`
    or :math:`\\cM \\neq \\cM'`).

    OpenTURNS only proposes dynamical functions where :math:`\\cD'=\\cD` and
    :math:`\\cM'=\\cM` which means that :math:`t'=Id` through the *spatial function*
    and the *temporal function*. It follows that the process :math:`Y` shares the
    same mesh with :math:`X`, only its values have changed.
    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicalFunctionImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicalFunctionImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.DynamicalFunctionImplementation_getClassName(self)

    def __eq__(self, *args): return _func.DynamicalFunctionImplementation___eq__(self, *args)
    def __repr__(self): return _func.DynamicalFunctionImplementation___repr__(self)
    def __str__(self, offset=""): return _func.DynamicalFunctionImplementation___str__(self, offset)
    def __call__(self, *args): return _func.DynamicalFunctionImplementation___call__(self, *args)
    def getSpatialDimension(self):
        """
        Get the dimension of the mesh.

        Returns
        -------
        spatialDimension : int, :math:`n \\geq 0`
            Dimension of the mesh :math:`\\cM`.
        """
        return _func.DynamicalFunctionImplementation_getSpatialDimension(self)

    def getInputDimension(self):
        """
        Get the dimension of the input.

        Returns
        -------
        d : int
            Input dimension :math:`d` of the dynamical function.
        """
        return _func.DynamicalFunctionImplementation_getInputDimension(self)

    def getOutputDimension(self):
        """
        Get the dimension of the output.

        Returns
        -------
        q : int
            Output dimension :math:`q` of the dynamical function.
        """
        return _func.DynamicalFunctionImplementation_getOutputDimension(self)

    def setInputDescription(self, *args):
        """
        Set the description of the inputs.

        Parameters
        ----------
        inputDescription : list of strings
            Describes the inputs of the dynamical function.
        """
        return _func.DynamicalFunctionImplementation_setInputDescription(self, *args)

    def getInputDescription(self):
        """
        Get the description of the inputs.

        Returns
        -------
        inputDescription : list of strings
            Describes the inputs of the dynamical function.
        """
        return _func.DynamicalFunctionImplementation_getInputDescription(self)

    def setOutputDescription(self, *args):
        """
        Set the description of the outputs.

        Parameters
        ----------
        outputDescription : list of strings
            Describes the outputs of the dynamical function.
        """
        return _func.DynamicalFunctionImplementation_setOutputDescription(self, *args)

    def getOutputDescription(self):
        """
        Get the description of the outputs.

        Returns
        -------
        outputDescription : list of strings
            Describes the outputs of the dynamical function.
        """
        return _func.DynamicalFunctionImplementation_getOutputDescription(self)

    def getMarginal(self, *args):
        """
        Get the marginal(s) at given indice(s).

        Parameters
        ----------
        i : int or list of ints, :math:`0 \\leq i < d`
            Indice(s) of the marginal(s) needed. :math:`d` is the dimension of the
            DynamicalFunction.

        Returns
        -------
        dynamicalFunction : :class:`~openturns.DynamicalFunction`
            DynamicalFunction restricted to the concerned marginal(s) at the indice(s)
            :math:`i` of the dynamical function :math:`f_{dyn}`.
        """
        return _func.DynamicalFunctionImplementation_getMarginal(self, *args)

    def getCallsNumber(self):
        """
        Get the number of calls of a DynamicalFunction.

        Returns
        -------
        callsNumber : int
            Counts the number of times the DynamicalFunction has been called since its
            creation.
        """
        return _func.DynamicalFunctionImplementation_getCallsNumber(self)

    def __init__(self, *args): 
        this = _func.new_DynamicalFunctionImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_DynamicalFunctionImplementation
    __del__ = lambda self : None;
DynamicalFunctionImplementation_swigregister = _func.DynamicalFunctionImplementation_swigregister
DynamicalFunctionImplementation_swigregister(DynamicalFunctionImplementation)

class DynamicalFunctionImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicalFunctionImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicalFunctionImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_DynamicalFunctionImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.DynamicalFunctionImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.DynamicalFunctionImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.DynamicalFunctionImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.DynamicalFunctionImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_DynamicalFunctionImplementationTypedInterfaceObject
    __del__ = lambda self : None;
DynamicalFunctionImplementationTypedInterfaceObject_swigregister = _func.DynamicalFunctionImplementationTypedInterfaceObject_swigregister
DynamicalFunctionImplementationTypedInterfaceObject_swigregister(DynamicalFunctionImplementationTypedInterfaceObject)

class DynamicalFunction(DynamicalFunctionImplementationTypedInterfaceObject):
    """
    Dynamical function.

    Available constructors:
        DynamicalFunction(*meshDimension=1*)

        DynamicalFunction(*function, meshDimension=1*)

    Parameters
    ----------
    function : :class:`~openturns.NumericalMathFunction`
        Function :math:`g: \\Rset^d \\mapsto \\Rset^q` used to define a
        :class:`~openturns.SpatialFunction` object.
    meshDimension : int, :math:`n \\geq 0`
        Dimension of the mesh :math:`\\cM`.

    Notes
    -----
    Dynamical functions are functions being able to act on fields. OpenTURNS
    defines two particular dynamical functions:
    the :class:`spatial function <openturns.SpatialFunction>` and
    the :class:`temporal function <openturns.TemporalFunction>`.


    A dynamical function
    :math:`f_{dyn}:\\cD \\times \\Rset^d \\mapsto \\cD' \\times \\Rset^q`
    where :math:`\\cD \\in \\Rset^n` and :math:`\\cD' \\in \\Rset^p` is defined by:

    .. math::

        f_{dyn}(\\vect{t}, \\vect{x}) = (t'(\\vect{t}), v'(\\vect{t}, \\vect{x}))

    with :math:`t': \\cD \\mapsto \\cD'` and
    :math:`v': \\cD \\times \\Rset^d \\mapsto \\Rset^q`.

    A dynamical function :math:`f_{dyn}` transforms a multivariate stochastic
    process:

    .. math::

        X: \\Omega \\times \\cD \\mapsto \\Rset^d

    where :math:`\\cD \\in \\Rset^n` is discretized according to the mesh :math:`\\cM`
    into the multivariate stochastic process:

    .. math::

        Y=f_{dyn}(X)

    such that:

    .. math::

        Y: \\Omega \\times \\cD' \\mapsto \\Rset^q

    where the mesh :math:`\\cD' \\in \\Rset^p`  is discretized according to the
    :math:`\\cM'`.

    A dynamical function :math:`f_{dyn}` also acts on fields and produces fields of
    possibly different dimension (:math:`q\\neq d`) and mesh (:math:`\\cD \\neq \\cD'`
    or :math:`\\cM \\neq \\cM'`).

    OpenTURNS only proposes dynamical functions where :math:`\\cD'=\\cD` and
    :math:`\\cM'=\\cM` which means that :math:`t'=Id` through the *spatial function*
    and the *temporal function*. It follows that the process :math:`Y` shares the
    same mesh with :math:`X`, only its values have changed.
    """
    __swig_setmethods__ = {}
    for _s in [DynamicalFunctionImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DynamicalFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [DynamicalFunctionImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DynamicalFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.DynamicalFunction_getClassName(self)

    def __eq__(self, *args): return _func.DynamicalFunction___eq__(self, *args)
    def __repr__(self): return _func.DynamicalFunction___repr__(self)
    def __str__(self, offset=""): return _func.DynamicalFunction___str__(self, offset)
    def __call__(self, *args): return _func.DynamicalFunction___call__(self, *args)
    def getMarginal(self, *args):
        """
        Get the marginal(s) at given indice(s).

        Parameters
        ----------
        i : int or list of ints, :math:`0 \\leq i < d`
            Indice(s) of the marginal(s) needed. :math:`d` is the dimension of the
            DynamicalFunction.

        Returns
        -------
        dynamicalFunction : :class:`~openturns.DynamicalFunction`
            DynamicalFunction restricted to the concerned marginal(s) at the indice(s)
            :math:`i` of the dynamical function :math:`f_{dyn}`.
        """
        return _func.DynamicalFunction_getMarginal(self, *args)

    def getSpatialDimension(self):
        """
        Get the dimension of the mesh.

        Returns
        -------
        spatialDimension : int, :math:`n \\geq 0`
            Dimension of the mesh :math:`\\cM`.
        """
        return _func.DynamicalFunction_getSpatialDimension(self)

    def getInputDimension(self):
        """
        Get the dimension of the input.

        Returns
        -------
        d : int
            Input dimension :math:`d` of the dynamical function.
        """
        return _func.DynamicalFunction_getInputDimension(self)

    def getOutputDimension(self):
        """
        Get the dimension of the output.

        Returns
        -------
        q : int
            Output dimension :math:`q` of the dynamical function.
        """
        return _func.DynamicalFunction_getOutputDimension(self)

    def getInputDescription(self):
        """
        Get the description of the inputs.

        Returns
        -------
        inputDescription : list of strings
            Describes the inputs of the dynamical function.
        """
        return _func.DynamicalFunction_getInputDescription(self)

    def getOutputDescription(self):
        """
        Get the description of the outputs.

        Returns
        -------
        outputDescription : list of strings
            Describes the outputs of the dynamical function.
        """
        return _func.DynamicalFunction_getOutputDescription(self)

    def getCallsNumber(self):
        """
        Get the number of calls of a DynamicalFunction.

        Returns
        -------
        callsNumber : int
            Counts the number of times the DynamicalFunction has been called since its
            creation.
        """
        return _func.DynamicalFunction_getCallsNumber(self)

    def __init__(self, *args): 
        this = _func.new_DynamicalFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_DynamicalFunction
    __del__ = lambda self : None;
DynamicalFunction_swigregister = _func.DynamicalFunction_swigregister
DynamicalFunction_swigregister(DynamicalFunction)

# We have to make sure the submodule is loaded with absolute path
import openturns.typ

class OpenTURNSPythonDynamicalFunction(object):
    """
    Override DynamicalFunction from Python.

    Parameters
    ----------
    n : positive int
        the input dimension
    p : positive int
        the output dimension
    s : positive integer
        the spatial dimension

    Notes
    -----
    You have to overload the function:
        _exec(X): single evaluation, X is a :class:`~openturns.Field`,
        returns a :class:`~openturns.Field`
    """
    def __init__(self, n=0, p=0, s=0):
        try:
            self.__n = int(n)
        except:
            raise TypeError('n argument is not an integer.')
        try:
            self.__p = int(p)
        except:
            raise TypeError('p argument is not an integer.')
        try:
            self.__s = int(s)
        except:
            raise TypeError('s argument is not an integer.')
        self.__descIn = list(map(lambda i: 'x' + str(i), range(n)))
        self.__descOut = list(map(lambda i: 'y' + str(i), range(p)))

    def setInputDescription(self, descIn):
        if (len(descIn) != self.__n):
            raise ValueError('Input description size does NOT match input dimension')
        self.__descIn = descIn

    def getInputDescription(self):
        return self.__descIn

    def setOutputDescription(self, descOut):
        if (len(descOut) != self.__p):
            raise ValueError('Output description size does NOT match output dimension')
        self.__descOut = descOut

    def getOutputDescription(self):
        return self.__descOut

    def getInputDimension(self):
        return self.__n

    def getOutputDimension(self):
        return self.__p

    def getSpatialDimension(self):
        return self.__s

    def __str__(self):
        return 'OpenTURNSPythonDynamicalFunction( %s #%d ) -> %s #%d' % (self.__descIn, self.__n, self.__descOut, self.__p)

    def __repr__(self):
        return self.__str__()

    def __call__(self, X):
        Y = self._exec(X)
        return Y

    def _exec(self, X):
        raise RuntimeError('You must define a method _exec(X) -> Y, where X and Y are Fields objects')

class PythonDynamicalFunction(DynamicalFunction):
    """
    Override DynamicalFunction from Python.

    Parameters
    ----------
    n : positive int
        the input dimension
    p : positive int
        the output dimension
    s : positive int
        the spatial dimension
    func : a callable python object
        called on a :class:`~openturns.Field` object.
        Returns a :class:`~openturns.Field`.
        Default is None.

    Notes
    -----
    func 
    """
    def __new__(self, n, p, s, func=None):
        if func == None:
            raise RuntimeError('func not provided.')
        instance = OpenTURNSPythonDynamicalFunction(n, p, s)
        import collections
        if func != None:
            if not isinstance(func, collections.Callable):
                raise RuntimeError('func argument is not callable.')
            instance._exec = func
        return DynamicalFunction(instance)

class SpatialFunction(DynamicalFunctionImplementation):
    """
    Spatial function.

    Available constructors:
        SpatialFunction(*meshDimension=1*)

        SpatialFunction(*g, meshDimension=1*)

    Parameters
    ----------
    g : :class:`~openturns.NumericalMathFunction`
        Function :math:`g: \\Rset^d \\mapsto \\Rset^q`.
    meshDimension : int, :math:`n \\geq 0`
        Dimension of the vertices of the mesh :math:`\\cM`. This data is required
        for tests on the compatibility of dimension when a composite process is
        created using the spatial function.

    Notes
    -----
    A spatial function
    :math:`f_{spat}: \\cD \\times \\Rset^d \\mapsto \\cD \\times \\Rset^q`, with
    :math:`\\cD \\in \\Rset^n`, is a particular
    :class:`dynamical function <openturns.DynamicalFunction>` that lets invariant
    the mesh of a field and defined by a function
    :math:`g : \\Rset^d  \\mapsto \\Rset^q` such that:

    .. math::

        f_{spat}(\\vect{t}, \\vect{x})=(\\vect{t}, g(\\vect{x}))

    Let's note that the input dimension of :math:`f_{spat}` still designs the
    dimension of :math:`\\vect{x}`: :math:`d`. Its output dimension is equal to
    :math:`q`.

    See also
    --------
    TemporalFunction

    Examples
    --------
    >>> import openturns as ot

    Create a function :math:`g : \\Rset^d \\mapsto \\Rset^q` such as:

    .. math::

        g: \\left|\\begin{array}{rcl}
                    \\Rset & \\rightarrow & \\Rset \\\\
                    x & \\mapsto & x^2
                \\end{array}\\right.

    >>> g = ot.NumericalMathFunction('x', 'x^2')

    Convert :math:`g` into a spatial function with :math:`n` the dimension of the
    mesh of the field on which :math:`g` will be applied:

    >>> n = 1
    >>> mySpatialFunction = ot.SpatialFunction(g, n)
    >>> # Create a TimeSeries
    >>> tg = ot.RegularGrid(0.0, 0.2, 6)
    >>> data = ot.NumericalSample(tg.getN(), g.getInputDimension())
    >>> for i in range(data.getSize()):
    ...     for j in range(data.getDimension()):
    ...         data[i, j] = i * data.getDimension() + j
    >>> ts = ot.TimeSeries(tg, data)
    >>> print(ts)
    0 : [ 0   0   ]
    1 : [ 0.2 1   ]
    2 : [ 0.4 2   ]
    3 : [ 0.6 3   ]
    4 : [ 0.8 4   ]
    5 : [ 1   5   ]
    >>> print(mySpatialFunction(ts))
        [                outputVariable ]
    0 : [  0              0             ]
    1 : [  0.2            1             ]
    2 : [  0.4            4             ]
    3 : [  0.6            9             ]
    4 : [  0.8           16             ]
    5 : [  1             25             ]
    """
    __swig_setmethods__ = {}
    for _s in [DynamicalFunctionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpatialFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [DynamicalFunctionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpatialFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.SpatialFunction_getClassName(self)

    def __eq__(self, *args): return _func.SpatialFunction___eq__(self, *args)
    def __repr__(self): return _func.SpatialFunction___repr__(self)
    def __str__(self, offset=""): return _func.SpatialFunction___str__(self, offset)
    def __call__(self, *args): return _func.SpatialFunction___call__(self, *args)
    def getMarginal(self, *args):
        """
        Get the marginal(s) at given indice(s).

        Parameters
        ----------
        i : int or list of ints, :math:`0 \\leq i < d`
            Indice(s) of the marginal(s) needed. :math:`d` is the dimension of the
            DynamicalFunction.

        Returns
        -------
        dynamicalFunction : :class:`~openturns.DynamicalFunction`
            DynamicalFunction restricted to the concerned marginal(s) at the indice(s)
            :math:`i` of the dynamical function :math:`f_{dyn}`.
        """
        return _func.SpatialFunction_getMarginal(self, *args)

    def getEvaluation(self):
        """
        Get the evaluation function of :math:`g`.

        Returns
        -------
        g : :class:`~openturns.NumericalMathEvaluationImplementation`
            Evaluation function of :math:`g: \\Rset^d \\mapsto \\Rset^q`.

        Examples
        --------
        >>> import openturns as ot
        >>> g = ot.NumericalMathFunction('x', 'x^2')
        >>> n = 1
        >>> mySpatialFunction = ot.SpatialFunction(g, n)
        >>> print(mySpatialFunction.getEvaluation())
        [x]->[x^2]
        """
        return _func.SpatialFunction_getEvaluation(self)

    def __init__(self, *args): 
        this = _func.new_SpatialFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_SpatialFunction
    __del__ = lambda self : None;
SpatialFunction_swigregister = _func.SpatialFunction_swigregister
SpatialFunction_swigregister(SpatialFunction)

class TemporalFunction(DynamicalFunctionImplementation):
    """
    Temporal function.

    Available constructors:
        TemporalFunction(*meshDimension=1*)

        TemporalFunction(*h, meshDimension=1*)

    Parameters
    ----------
    h : :class:`~openturns.NumericalMathFunction`
        Function :math:`h: \\Rset^n \\times \\Rset^d \\mapsto \\Rset^q`.
    meshDimension : int, :math:`n \\geq 0`
        Dimension of the vertices of the mesh :math:`\\cM`. This data is required
        for tests on the compatibility of dimension when a composite process is
        created using the temporal function.

    Notes
    -----
    A temporal function
    :math:`f_{temp}: \\cD \\times \\Rset^d \\mapsto \\cD \\times \\Rset^q`, with
    :math:`\\cD \\in \\Rset^n`, is a particular
    :class:`dynamical function <openturns.DynamicalFunction>` that lets invariant
    the mesh of a field and defined by a function
    :math:`h : \\Rset^n \\times \\Rset^d \\mapsto \\Rset^q` such that:

    .. math::

      f_{temp}(\\vect{t}, \\vect{x})=(\\vect{t}, h(\\vect{t},\\vect{x}))

    Let's note that the input dimension of :math:`f_{temp}` still design the
    dimension of :math:`\\vect{x}`: :math:`d`. Its output dimension is equal to
    :math:`q`.

    See also
    --------
    SpatialFunction

    Examples
    --------
    >>> import openturns as ot

    Create a function :math:`h : \\Rset^n \\times \\Rset^d \\mapsto \\Rset^q` such as:

    .. math::

        h: \\left|\\begin{array}{rcl}
                    \\Rset \\times \\Rset & \\rightarrow & \\Rset \\\\
                    (t, x) & \\mapsto & (x + t^2)
                \\end{array}\\right.

    >>> h = ot.NumericalMathFunction(['t', 'x'], ['x + t^2'])

    Convert :math:`h` into a temporal function with :math:`n` the dimension of the
    mesh of the field on which :math:`h` will be applied:

    >>> n = 1
    >>> myTemporalFunction = ot.TemporalFunction(h, n)
    >>> # Create a TimeSeries
    >>> tg = ot.RegularGrid(0.0, 0.2, 6)
    >>> data = ot.NumericalSample(tg.getN(), h.getInputDimension()-1)
    >>> for i in range(data.getSize()):
    ...     for j in range(data.getDimension()):
    ...         data[i, j] = i * data.getDimension() + j
    >>> ts = ot.TimeSeries(tg, data)
    >>> print(ts)
    0 : [ 0   0   ]
    1 : [ 0.2 1   ]
    2 : [ 0.4 2   ]
    3 : [ 0.6 3   ]
    4 : [ 0.8 4   ]
    5 : [ 1   5   ]
    >>> print(myTemporalFunction(ts))
        [      y0   ]
    0 : [ 0    0    ]
    1 : [ 0.2  1.04 ]
    2 : [ 0.4  2.16 ]
    3 : [ 0.6  3.36 ]
    4 : [ 0.8  4.64 ]
    5 : [ 1    6    ]
    """
    __swig_setmethods__ = {}
    for _s in [DynamicalFunctionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TemporalFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [DynamicalFunctionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TemporalFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.TemporalFunction_getClassName(self)

    def __eq__(self, *args): return _func.TemporalFunction___eq__(self, *args)
    def __repr__(self): return _func.TemporalFunction___repr__(self)
    def __str__(self, offset=""): return _func.TemporalFunction___str__(self, offset)
    def __call__(self, *args): return _func.TemporalFunction___call__(self, *args)
    def getMarginal(self, *args):
        """
        Get the marginal(s) at given indice(s).

        Parameters
        ----------
        i : int or list of ints, :math:`0 \\leq i < d`
            Indice(s) of the marginal(s) needed. :math:`d` is the dimension of the
            DynamicalFunction.

        Returns
        -------
        dynamicalFunction : :class:`~openturns.DynamicalFunction`
            DynamicalFunction restricted to the concerned marginal(s) at the indice(s)
            :math:`i` of the dynamical function :math:`f_{dyn}`.
        """
        return _func.TemporalFunction_getMarginal(self, *args)

    def getEvaluation(self):
        """
        Get the evaluation function of :math:`h`.

        Returns
        -------
        h : :class:`~openturns.NumericalMathEvaluationImplementation`
            Evaluation function of
            :math:`h: \\Rset^n \\times \\Rset^d \\mapsto \\Rset^q`.

        Examples
        --------
        >>> import openturns as ot
        >>> h = ot.NumericalMathFunction(['t', 'x'], ['x + t^2'])
        >>> n = 1
        >>> myTemporalFunction = ot.SpatialFunction(h, n)
        >>> print(myTemporalFunction.getEvaluation())
        [t,x]->[x + t^2]
        """
        return _func.TemporalFunction_getEvaluation(self)

    def __init__(self, *args): 
        this = _func.new_TemporalFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_TemporalFunction
    __del__ = lambda self : None;
TemporalFunction_swigregister = _func.TemporalFunction_swigregister
TemporalFunction_swigregister(TemporalFunction)

class ComposedNumericalMathFunction(NumericalMathFunctionImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathFunctionImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ComposedNumericalMathFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathFunctionImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ComposedNumericalMathFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ComposedNumericalMathFunction_getClassName(self)

    def __eq__(self, *args): return _func.ComposedNumericalMathFunction___eq__(self, *args)
    def __repr__(self): return _func.ComposedNumericalMathFunction___repr__(self)
    def parametersGradient(self, *args): return _func.ComposedNumericalMathFunction_parametersGradient(self, *args)
    def __init__(self, *args): 
        this = _func.new_ComposedNumericalMathFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ComposedNumericalMathFunction
    __del__ = lambda self : None;
ComposedNumericalMathFunction_swigregister = _func.ComposedNumericalMathFunction_swigregister
ComposedNumericalMathFunction_swigregister(ComposedNumericalMathFunction)

class DualLinearCombinationEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DualLinearCombinationEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DualLinearCombinationEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.DualLinearCombinationEvaluationImplementation_getClassName(self)

    def setDescription(self, *args): return _func.DualLinearCombinationEvaluationImplementation_setDescription(self, *args)
    def __repr__(self): return _func.DualLinearCombinationEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.DualLinearCombinationEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.DualLinearCombinationEvaluationImplementation___call__(self, *args)
    def getCoefficients(self): return _func.DualLinearCombinationEvaluationImplementation_getCoefficients(self)
    def getFunctionsCollection(self): return _func.DualLinearCombinationEvaluationImplementation_getFunctionsCollection(self)
    def setFunctionsCollectionAndCoefficients(self, *args): return _func.DualLinearCombinationEvaluationImplementation_setFunctionsCollectionAndCoefficients(self, *args)
    def getInputDimension(self): return _func.DualLinearCombinationEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.DualLinearCombinationEvaluationImplementation_getOutputDimension(self)
    def parametersGradient(self, *args): return _func.DualLinearCombinationEvaluationImplementation_parametersGradient(self, *args)
    def getParameters(self): return _func.DualLinearCombinationEvaluationImplementation_getParameters(self)
    def getMarginal(self, *args): return _func.DualLinearCombinationEvaluationImplementation_getMarginal(self, *args)
    def __init__(self, *args): 
        this = _func.new_DualLinearCombinationEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_DualLinearCombinationEvaluationImplementation
    __del__ = lambda self : None;
DualLinearCombinationEvaluationImplementation_swigregister = _func.DualLinearCombinationEvaluationImplementation_swigregister
DualLinearCombinationEvaluationImplementation_swigregister(DualLinearCombinationEvaluationImplementation)

class DualLinearCombinationGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DualLinearCombinationGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DualLinearCombinationGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.DualLinearCombinationGradientImplementation_getClassName(self)

    def gradient(self, *args): return _func.DualLinearCombinationGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.DualLinearCombinationGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.DualLinearCombinationGradientImplementation_getOutputDimension(self)
    def __repr__(self): return _func.DualLinearCombinationGradientImplementation___repr__(self)
    def __init__(self, *args): 
        this = _func.new_DualLinearCombinationGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_DualLinearCombinationGradientImplementation
    __del__ = lambda self : None;
DualLinearCombinationGradientImplementation_swigregister = _func.DualLinearCombinationGradientImplementation_swigregister
DualLinearCombinationGradientImplementation_swigregister(DualLinearCombinationGradientImplementation)

class DualLinearCombinationHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DualLinearCombinationHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DualLinearCombinationHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.DualLinearCombinationHessianImplementation_getClassName(self)

    def hessian(self, *args): return _func.DualLinearCombinationHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.DualLinearCombinationHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.DualLinearCombinationHessianImplementation_getOutputDimension(self)
    def __repr__(self): return _func.DualLinearCombinationHessianImplementation___repr__(self)
    def __init__(self, *args): 
        this = _func.new_DualLinearCombinationHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_DualLinearCombinationHessianImplementation
    __del__ = lambda self : None;
DualLinearCombinationHessianImplementation_swigregister = _func.DualLinearCombinationHessianImplementation_swigregister
DualLinearCombinationHessianImplementation_swigregister(DualLinearCombinationHessianImplementation)

class LinearCombinationEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearCombinationEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearCombinationEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearCombinationEvaluationImplementation_getClassName(self)

    def __repr__(self): return _func.LinearCombinationEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.LinearCombinationEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.LinearCombinationEvaluationImplementation___call__(self, *args)
    def getCoefficients(self): return _func.LinearCombinationEvaluationImplementation_getCoefficients(self)
    def getFunctionsCollection(self): return _func.LinearCombinationEvaluationImplementation_getFunctionsCollection(self)
    def setFunctionsCollectionAndCoefficients(self, *args): return _func.LinearCombinationEvaluationImplementation_setFunctionsCollectionAndCoefficients(self, *args)
    def getInputDimension(self): return _func.LinearCombinationEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.LinearCombinationEvaluationImplementation_getOutputDimension(self)
    def parametersGradient(self, *args): return _func.LinearCombinationEvaluationImplementation_parametersGradient(self, *args)
    def getParameters(self): return _func.LinearCombinationEvaluationImplementation_getParameters(self)
    def getMarginal(self, *args): return _func.LinearCombinationEvaluationImplementation_getMarginal(self, *args)
    def __init__(self, *args): 
        this = _func.new_LinearCombinationEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearCombinationEvaluationImplementation
    __del__ = lambda self : None;
LinearCombinationEvaluationImplementation_swigregister = _func.LinearCombinationEvaluationImplementation_swigregister
LinearCombinationEvaluationImplementation_swigregister(LinearCombinationEvaluationImplementation)

class LinearCombinationGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearCombinationGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearCombinationGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearCombinationGradientImplementation_getClassName(self)

    def gradient(self, *args): return _func.LinearCombinationGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.LinearCombinationGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.LinearCombinationGradientImplementation_getOutputDimension(self)
    def __repr__(self): return _func.LinearCombinationGradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.LinearCombinationGradientImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_LinearCombinationGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearCombinationGradientImplementation
    __del__ = lambda self : None;
LinearCombinationGradientImplementation_swigregister = _func.LinearCombinationGradientImplementation_swigregister
LinearCombinationGradientImplementation_swigregister(LinearCombinationGradientImplementation)

class LinearCombinationHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearCombinationHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearCombinationHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearCombinationHessianImplementation_getClassName(self)

    def hessian(self, *args): return _func.LinearCombinationHessianImplementation_hessian(self, *args)
    def getInputDimension(self): return _func.LinearCombinationHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.LinearCombinationHessianImplementation_getOutputDimension(self)
    def __repr__(self): return _func.LinearCombinationHessianImplementation___repr__(self)
    def __str__(self, offset=""): return _func.LinearCombinationHessianImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_LinearCombinationHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearCombinationHessianImplementation
    __del__ = lambda self : None;
LinearCombinationHessianImplementation_swigregister = _func.LinearCombinationHessianImplementation_swigregister
LinearCombinationHessianImplementation_swigregister(LinearCombinationHessianImplementation)

class LinearNumericalMathFunction(NumericalMathFunction):
    __swig_setmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearNumericalMathFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearNumericalMathFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearNumericalMathFunction_getClassName(self)

    def __eq__(self, *args): return _func.LinearNumericalMathFunction___eq__(self, *args)
    def __repr__(self): return _func.LinearNumericalMathFunction___repr__(self)
    def __str__(self, offset=""): return _func.LinearNumericalMathFunction___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_LinearNumericalMathFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearNumericalMathFunction
    __del__ = lambda self : None;
LinearNumericalMathFunction_swigregister = _func.LinearNumericalMathFunction_swigregister
LinearNumericalMathFunction_swigregister(LinearNumericalMathFunction)

class QuadraticNumericalMathFunction(NumericalMathFunction):
    __swig_setmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, QuadraticNumericalMathFunction, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, QuadraticNumericalMathFunction, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.QuadraticNumericalMathFunction_getClassName(self)

    def __eq__(self, *args): return _func.QuadraticNumericalMathFunction___eq__(self, *args)
    def __repr__(self): return _func.QuadraticNumericalMathFunction___repr__(self)
    def __str__(self, offset=""): return _func.QuadraticNumericalMathFunction___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_QuadraticNumericalMathFunction(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_QuadraticNumericalMathFunction
    __del__ = lambda self : None;
QuadraticNumericalMathFunction_swigregister = _func.QuadraticNumericalMathFunction_swigregister
QuadraticNumericalMathFunction_swigregister(QuadraticNumericalMathFunction)

class UniVariatePolynomialImplementation(openturns.common.PersistentObject):
    """
    Base class for univariate polynomials.

    Parameters
    ----------
    coefficients : :class:`~openturns.NumericalPoint` or 1d array, list or tuple
        Polynomial coefficients in increasing polynomial order.

    Examples
    --------
    >>> import openturns as ot

    Create a univariate polynomial from a list of coefficients:

    >>> P = ot.UniVariatePolynomial([1., 2., 3.])
    >>> print(P)
    1 + 2 * X + 3 * X^2

    Univariate polynomials are of course callable:

    >>> print(P(1.))
    6.0

    Addition, subtraction and multiplication of univariate polynomials:

    >>> P = ot.UniVariatePolynomial([1., 2., 3.])
    >>> Q = ot.UniVariatePolynomial([1., 2.])
    >>> print('(%s) + (%s) = %s' % (P, Q, P + Q))
    (1 + 2 * X + 3 * X^2) + (1 + 2 * X) = 2 + 4 * X + 3 * X^2
    >>> print('(%s) - (%s) = %s' % (P, Q, P - Q))
    (1 + 2 * X + 3 * X^2) - (1 + 2 * X) = 3 * X^2
    >>> print('(%s) * (%s) = %s' % (P, Q, P * Q))
    (1 + 2 * X + 3 * X^2) * (1 + 2 * X) = 1 + 4 * X + 7 * X^2 + 6 * X^3
    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UniVariatePolynomialImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UniVariatePolynomialImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.UniVariatePolynomialImplementation_getClassName(self)

    def __repr__(self): return _func.UniVariatePolynomialImplementation___repr__(self)
    def __str__(self, *args): return _func.UniVariatePolynomialImplementation___str__(self, *args)
    def __call__(self, *args): return _func.UniVariatePolynomialImplementation___call__(self, *args)
    def derivative(self, *args):
        """
        Compute the first-order derivative polynomial at point :math:`x`.

        Parameters
        ----------
        x : float
            Polynomial input.

        Returns
        -------
        derivative_value : float
            The value of the polynomial's first-order derivative at point :math:`x`.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.derivative(1.))
        8.0
        """
        return _func.UniVariatePolynomialImplementation_derivative(self, *args)

    def derivate(self):
        """
        Build the first-order derivative polynomial.

        Returns
        -------
        derivated_polynomial : :class:`~openturns.Univariate`
            The first-order derivated polynomial.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.derivate())
        2 + 6 * X
        """
        return _func.UniVariatePolynomialImplementation_derivate(self)

    def __mul__(self, *args): return _func.UniVariatePolynomialImplementation___mul__(self, *args)
    def incrementDegree(self, degree=1):
        """
        Multiply the polynomial by :math:`x^k`.

        Parameters
        ----------
        degree : int, optional
            The incremented degree :math:`k`.
            Default uses :math:`k = 1`.

        Returns
        -------
        incremented_degree_polynomial : :class:`~openturns.UniVariatePolynomial`
            Polynomial with incremented degree.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.incrementDegree())
        X + 2 * X^2 + 3 * X^3
        >>> print(P.incrementDegree(2))
        X^2 + 2 * X^3 + 3 * X^4
        """
        return _func.UniVariatePolynomialImplementation_incrementDegree(self, degree)

    def __add__(self, *args): return _func.UniVariatePolynomialImplementation___add__(self, *args)
    def __sub__(self, *args): return _func.UniVariatePolynomialImplementation___sub__(self, *args)
    def setCoefficients(self, *args):
        """
        Accessor to the polynomials's coefficients.

        Parameters
        ----------
        coefficients : :class:`~openturns.NumericalPoint`, 1d array, tuple or list
            Polynomial coefficients in increasing polynomial order.

        See Also
        --------
        getCoefficients

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> P.setCoefficients([4., 2., 1.])
        >>> print(P)
        4 + 2 * X + X^2
        """
        return _func.UniVariatePolynomialImplementation_setCoefficients(self, *args)

    def getCoefficients(self):
        """
        Accessor to the polynomials's coefficients.

        Returns
        -------
        coefficients : :class:`~openturns.NumericalPoint`
            Polynomial coefficients in increasing polynomial order.

        See Also
        --------
        setCoefficients

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getCoefficients())
        [1,2,3]
        """
        return _func.UniVariatePolynomialImplementation_getCoefficients(self)

    def getDegree(self):
        """
        Accessor to the polynomials's degree.

        Returns
        -------
        degree : int
            Polynomial's degree.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getDegree())
        2
        """
        return _func.UniVariatePolynomialImplementation_getDegree(self)

    def getRoots(self):
        """
        Compute the roots of the polynomial.

        Returns
        -------
        roots : list of complex values
            Polynomial's roots.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getRoots())
        [(-0.333333,0.471405),(-0.333333,-0.471405)]
        """
        return _func.UniVariatePolynomialImplementation_getRoots(self)

    def draw(self, *args):
        """
        Draw the polynomial.

        Parameters
        ----------
        x_min : float, optional
            The starting value that is used for meshing the x-axis.
        x_max : float, optional, :math:`x_{\\max} > x_{\\min}`
            The ending value that is used for meshing the x-axis.
        n_points : int, optional
            The number of points that is used for meshing the x-axis.

        Examples
        --------
        >>> import openturns as ot
        >>> from openturns.viewer import View
        >>> P = ot.UniVariatePolynomial([1., 2., -3., 5.])
        >>> View(P.draw(-10., 10., 100)).show()
        """
        return _func.UniVariatePolynomialImplementation_draw(self, *args)

    def __init__(self, *args): 
        this = _func.new_UniVariatePolynomialImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_UniVariatePolynomialImplementation
    __del__ = lambda self : None;
UniVariatePolynomialImplementation_swigregister = _func.UniVariatePolynomialImplementation_swigregister
UniVariatePolynomialImplementation_swigregister(UniVariatePolynomialImplementation)

class UniVariatePolynomialImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UniVariatePolynomialImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UniVariatePolynomialImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_UniVariatePolynomialImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.UniVariatePolynomialImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.UniVariatePolynomialImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.UniVariatePolynomialImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.UniVariatePolynomialImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_UniVariatePolynomialImplementationTypedInterfaceObject
    __del__ = lambda self : None;
UniVariatePolynomialImplementationTypedInterfaceObject_swigregister = _func.UniVariatePolynomialImplementationTypedInterfaceObject_swigregister
UniVariatePolynomialImplementationTypedInterfaceObject_swigregister(UniVariatePolynomialImplementationTypedInterfaceObject)

class UniVariatePolynomial(UniVariatePolynomialImplementationTypedInterfaceObject):
    """
    Base class for univariate polynomials.

    Parameters
    ----------
    coefficients : :class:`~openturns.NumericalPoint` or 1d array, list or tuple
        Polynomial coefficients in increasing polynomial order.

    Examples
    --------
    >>> import openturns as ot

    Create a univariate polynomial from a list of coefficients:

    >>> P = ot.UniVariatePolynomial([1., 2., 3.])
    >>> print(P)
    1 + 2 * X + 3 * X^2

    Univariate polynomials are of course callable:

    >>> print(P(1.))
    6.0

    Addition, subtraction and multiplication of univariate polynomials:

    >>> P = ot.UniVariatePolynomial([1., 2., 3.])
    >>> Q = ot.UniVariatePolynomial([1., 2.])
    >>> print('(%s) + (%s) = %s' % (P, Q, P + Q))
    (1 + 2 * X + 3 * X^2) + (1 + 2 * X) = 2 + 4 * X + 3 * X^2
    >>> print('(%s) - (%s) = %s' % (P, Q, P - Q))
    (1 + 2 * X + 3 * X^2) - (1 + 2 * X) = 3 * X^2
    >>> print('(%s) * (%s) = %s' % (P, Q, P * Q))
    (1 + 2 * X + 3 * X^2) * (1 + 2 * X) = 1 + 4 * X + 7 * X^2 + 6 * X^3
    """
    __swig_setmethods__ = {}
    for _s in [UniVariatePolynomialImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UniVariatePolynomial, name, value)
    __swig_getmethods__ = {}
    for _s in [UniVariatePolynomialImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UniVariatePolynomial, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.UniVariatePolynomial_getClassName(self)

    def __repr__(self): return _func.UniVariatePolynomial___repr__(self)
    def __str__(self, *args): return _func.UniVariatePolynomial___str__(self, *args)
    def __call__(self, *args): return _func.UniVariatePolynomial___call__(self, *args)
    def derivative(self, *args):
        """
        Compute the first-order derivative polynomial at point :math:`x`.

        Parameters
        ----------
        x : float
            Polynomial input.

        Returns
        -------
        derivative_value : float
            The value of the polynomial's first-order derivative at point :math:`x`.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.derivative(1.))
        8.0
        """
        return _func.UniVariatePolynomial_derivative(self, *args)

    def derivate(self):
        """
        Build the first-order derivative polynomial.

        Returns
        -------
        derivated_polynomial : :class:`~openturns.Univariate`
            The first-order derivated polynomial.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.derivate())
        2 + 6 * X
        """
        return _func.UniVariatePolynomial_derivate(self)

    def __mul__(self, *args): return _func.UniVariatePolynomial___mul__(self, *args)
    def incrementDegree(self, degree=1):
        """
        Multiply the polynomial by :math:`x^k`.

        Parameters
        ----------
        degree : int, optional
            The incremented degree :math:`k`.
            Default uses :math:`k = 1`.

        Returns
        -------
        incremented_degree_polynomial : :class:`~openturns.UniVariatePolynomial`
            Polynomial with incremented degree.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.incrementDegree())
        X + 2 * X^2 + 3 * X^3
        >>> print(P.incrementDegree(2))
        X^2 + 2 * X^3 + 3 * X^4
        """
        return _func.UniVariatePolynomial_incrementDegree(self, degree)

    def __add__(self, *args): return _func.UniVariatePolynomial___add__(self, *args)
    def __sub__(self, *args): return _func.UniVariatePolynomial___sub__(self, *args)
    def setCoefficients(self, *args):
        """
        Accessor to the polynomials's coefficients.

        Parameters
        ----------
        coefficients : :class:`~openturns.NumericalPoint`, 1d array, tuple or list
            Polynomial coefficients in increasing polynomial order.

        See Also
        --------
        getCoefficients

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> P.setCoefficients([4., 2., 1.])
        >>> print(P)
        4 + 2 * X + X^2
        """
        return _func.UniVariatePolynomial_setCoefficients(self, *args)

    def getCoefficients(self):
        """
        Accessor to the polynomials's coefficients.

        Returns
        -------
        coefficients : :class:`~openturns.NumericalPoint`
            Polynomial coefficients in increasing polynomial order.

        See Also
        --------
        setCoefficients

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getCoefficients())
        [1,2,3]
        """
        return _func.UniVariatePolynomial_getCoefficients(self)

    def getDegree(self):
        """
        Accessor to the polynomials's degree.

        Returns
        -------
        degree : int
            Polynomial's degree.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getDegree())
        2
        """
        return _func.UniVariatePolynomial_getDegree(self)

    def getRoots(self):
        """
        Compute the roots of the polynomial.

        Returns
        -------
        roots : list of complex values
            Polynomial's roots.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getRoots())
        [(-0.333333,0.471405),(-0.333333,-0.471405)]
        """
        return _func.UniVariatePolynomial_getRoots(self)

    def draw(self, *args):
        """
        Draw the polynomial.

        Parameters
        ----------
        x_min : float, optional
            The starting value that is used for meshing the x-axis.
        x_max : float, optional, :math:`x_{\\max} > x_{\\min}`
            The ending value that is used for meshing the x-axis.
        n_points : int, optional
            The number of points that is used for meshing the x-axis.

        Examples
        --------
        >>> import openturns as ot
        >>> from openturns.viewer import View
        >>> P = ot.UniVariatePolynomial([1., 2., -3., 5.])
        >>> View(P.draw(-10., 10., 100)).show()
        """
        return _func.UniVariatePolynomial_draw(self, *args)

    def __init__(self, *args): 
        this = _func.new_UniVariatePolynomial(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_UniVariatePolynomial
    __del__ = lambda self : None;
UniVariatePolynomial_swigregister = _func.UniVariatePolynomial_swigregister
UniVariatePolynomial_swigregister(UniVariatePolynomial)

class AggregatedNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AggregatedNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AggregatedNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.AggregatedNumericalMathEvaluationImplementation_getClassName(self)

    def __repr__(self): return _func.AggregatedNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.AggregatedNumericalMathEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.AggregatedNumericalMathEvaluationImplementation___call__(self, *args)
    def getFunctionsCollection(self): return _func.AggregatedNumericalMathEvaluationImplementation_getFunctionsCollection(self)
    def setFunctionsCollection(self, *args): return _func.AggregatedNumericalMathEvaluationImplementation_setFunctionsCollection(self, *args)
    def getMarginal(self, *args): return _func.AggregatedNumericalMathEvaluationImplementation_getMarginal(self, *args)
    def getInputDimension(self): return _func.AggregatedNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.AggregatedNumericalMathEvaluationImplementation_getOutputDimension(self)
    def parametersGradient(self, *args): return _func.AggregatedNumericalMathEvaluationImplementation_parametersGradient(self, *args)
    def getParameters(self): return _func.AggregatedNumericalMathEvaluationImplementation_getParameters(self)
    def __init__(self, *args): 
        this = _func.new_AggregatedNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_AggregatedNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
AggregatedNumericalMathEvaluationImplementation_swigregister = _func.AggregatedNumericalMathEvaluationImplementation_swigregister
AggregatedNumericalMathEvaluationImplementation_swigregister(AggregatedNumericalMathEvaluationImplementation)

class PiecewiseLinearEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PiecewiseLinearEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PiecewiseLinearEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.PiecewiseLinearEvaluationImplementation_getClassName(self)

    def __repr__(self): return _func.PiecewiseLinearEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.PiecewiseLinearEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.PiecewiseLinearEvaluationImplementation___call__(self, *args)
    def getLocations(self): return _func.PiecewiseLinearEvaluationImplementation_getLocations(self)
    def setLocations(self, *args): return _func.PiecewiseLinearEvaluationImplementation_setLocations(self, *args)
    def getValues(self): return _func.PiecewiseLinearEvaluationImplementation_getValues(self)
    def setValues(self, *args): return _func.PiecewiseLinearEvaluationImplementation_setValues(self, *args)
    def setLocationsAndValues(self, *args): return _func.PiecewiseLinearEvaluationImplementation_setLocationsAndValues(self, *args)
    def getInputDimension(self): return _func.PiecewiseLinearEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.PiecewiseLinearEvaluationImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_PiecewiseLinearEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_PiecewiseLinearEvaluationImplementation
    __del__ = lambda self : None;
PiecewiseLinearEvaluationImplementation_swigregister = _func.PiecewiseLinearEvaluationImplementation_swigregister
PiecewiseLinearEvaluationImplementation_swigregister(PiecewiseLinearEvaluationImplementation)

class PiecewiseHermiteEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PiecewiseHermiteEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PiecewiseHermiteEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.PiecewiseHermiteEvaluationImplementation_getClassName(self)

    def __repr__(self): return _func.PiecewiseHermiteEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.PiecewiseHermiteEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.PiecewiseHermiteEvaluationImplementation___call__(self, *args)
    def derivate(self, *args): return _func.PiecewiseHermiteEvaluationImplementation_derivate(self, *args)
    def getLocations(self): return _func.PiecewiseHermiteEvaluationImplementation_getLocations(self)
    def setLocations(self, *args): return _func.PiecewiseHermiteEvaluationImplementation_setLocations(self, *args)
    def getValues(self): return _func.PiecewiseHermiteEvaluationImplementation_getValues(self)
    def setValues(self, *args): return _func.PiecewiseHermiteEvaluationImplementation_setValues(self, *args)
    def getDerivatives(self): return _func.PiecewiseHermiteEvaluationImplementation_getDerivatives(self)
    def setDerivatives(self, *args): return _func.PiecewiseHermiteEvaluationImplementation_setDerivatives(self, *args)
    def setLocationsValuesAndDerivatives(self, *args): return _func.PiecewiseHermiteEvaluationImplementation_setLocationsValuesAndDerivatives(self, *args)
    def getInputDimension(self): return _func.PiecewiseHermiteEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.PiecewiseHermiteEvaluationImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_PiecewiseHermiteEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_PiecewiseHermiteEvaluationImplementation
    __del__ = lambda self : None;
PiecewiseHermiteEvaluationImplementation_swigregister = _func.PiecewiseHermiteEvaluationImplementation_swigregister
PiecewiseHermiteEvaluationImplementation_swigregister(PiecewiseHermiteEvaluationImplementation)

class AnalyticalNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AnalyticalNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AnalyticalNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.AnalyticalNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.AnalyticalNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.AnalyticalNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.AnalyticalNumericalMathEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.AnalyticalNumericalMathEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.AnalyticalNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.AnalyticalNumericalMathEvaluationImplementation_getOutputDimension(self)
    def getMarginal(self, *args): return _func.AnalyticalNumericalMathEvaluationImplementation_getMarginal(self, *args)
    def getInputVariablesNames(self): return _func.AnalyticalNumericalMathEvaluationImplementation_getInputVariablesNames(self)
    def getOutputVariablesNames(self): return _func.AnalyticalNumericalMathEvaluationImplementation_getOutputVariablesNames(self)
    def getFormulas(self): return _func.AnalyticalNumericalMathEvaluationImplementation_getFormulas(self)
    def __init__(self, *args): 
        this = _func.new_AnalyticalNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_AnalyticalNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
AnalyticalNumericalMathEvaluationImplementation_swigregister = _func.AnalyticalNumericalMathEvaluationImplementation_swigregister
AnalyticalNumericalMathEvaluationImplementation_swigregister(AnalyticalNumericalMathEvaluationImplementation)

class AnalyticalNumericalMathGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AnalyticalNumericalMathGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AnalyticalNumericalMathGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.AnalyticalNumericalMathGradientImplementation_getClassName(self)

    def __eq__(self, *args): return _func.AnalyticalNumericalMathGradientImplementation___eq__(self, *args)
    def __repr__(self): return _func.AnalyticalNumericalMathGradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.AnalyticalNumericalMathGradientImplementation___str__(self, offset)
    def gradient(self, *args): return _func.AnalyticalNumericalMathGradientImplementation_gradient(self, *args)
    def getInputDimension(self): return _func.AnalyticalNumericalMathGradientImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.AnalyticalNumericalMathGradientImplementation_getOutputDimension(self)
    def getFormula(self, *args): return _func.AnalyticalNumericalMathGradientImplementation_getFormula(self, *args)
    def getMarginal(self, *args): return _func.AnalyticalNumericalMathGradientImplementation_getMarginal(self, *args)
    def __init__(self, *args): 
        this = _func.new_AnalyticalNumericalMathGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_AnalyticalNumericalMathGradientImplementation
    __del__ = lambda self : None;
AnalyticalNumericalMathGradientImplementation_swigregister = _func.AnalyticalNumericalMathGradientImplementation_swigregister
AnalyticalNumericalMathGradientImplementation_swigregister(AnalyticalNumericalMathGradientImplementation)

class AnalyticalNumericalMathHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AnalyticalNumericalMathHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AnalyticalNumericalMathHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.AnalyticalNumericalMathHessianImplementation_getClassName(self)

    def __eq__(self, *args): return _func.AnalyticalNumericalMathHessianImplementation___eq__(self, *args)
    def __repr__(self): return _func.AnalyticalNumericalMathHessianImplementation___repr__(self)
    def __str__(self, offset=""): return _func.AnalyticalNumericalMathHessianImplementation___str__(self, offset)
    def hessian(self, *args): return _func.AnalyticalNumericalMathHessianImplementation_hessian(self, *args)
    def getFormula(self, *args): return _func.AnalyticalNumericalMathHessianImplementation_getFormula(self, *args)
    def getInputDimension(self): return _func.AnalyticalNumericalMathHessianImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.AnalyticalNumericalMathHessianImplementation_getOutputDimension(self)
    def getMarginal(self, *args): return _func.AnalyticalNumericalMathHessianImplementation_getMarginal(self, *args)
    def __init__(self, *args): 
        this = _func.new_AnalyticalNumericalMathHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_AnalyticalNumericalMathHessianImplementation
    __del__ = lambda self : None;
AnalyticalNumericalMathHessianImplementation_swigregister = _func.AnalyticalNumericalMathHessianImplementation_swigregister
AnalyticalNumericalMathHessianImplementation_swigregister(AnalyticalNumericalMathHessianImplementation)

class DatabaseNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DatabaseNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DatabaseNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.DatabaseNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.DatabaseNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.DatabaseNumericalMathEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.DatabaseNumericalMathEvaluationImplementation___str__(self, offset)
    def setInputSample(self, *args): return _func.DatabaseNumericalMathEvaluationImplementation_setInputSample(self, *args)
    def getInputSample(self): return _func.DatabaseNumericalMathEvaluationImplementation_getInputSample(self)
    def setOutputSample(self, *args): return _func.DatabaseNumericalMathEvaluationImplementation_setOutputSample(self, *args)
    def getOutputSample(self): return _func.DatabaseNumericalMathEvaluationImplementation_getOutputSample(self)
    def __call__(self, *args): return _func.DatabaseNumericalMathEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.DatabaseNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.DatabaseNumericalMathEvaluationImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_DatabaseNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_DatabaseNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
DatabaseNumericalMathEvaluationImplementation_swigregister = _func.DatabaseNumericalMathEvaluationImplementation_swigregister
DatabaseNumericalMathEvaluationImplementation_swigregister(DatabaseNumericalMathEvaluationImplementation)

class IndicatorNumericalMathEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IndicatorNumericalMathEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IndicatorNumericalMathEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.IndicatorNumericalMathEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.IndicatorNumericalMathEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.IndicatorNumericalMathEvaluationImplementation___repr__(self)
    def __call__(self, *args): return _func.IndicatorNumericalMathEvaluationImplementation___call__(self, *args)
    def getEvaluation(self): return _func.IndicatorNumericalMathEvaluationImplementation_getEvaluation(self)
    def setEvaluation(self, *args): return _func.IndicatorNumericalMathEvaluationImplementation_setEvaluation(self, *args)
    def getComparisonOperator(self): return _func.IndicatorNumericalMathEvaluationImplementation_getComparisonOperator(self)
    def setComparisonOperator(self, *args): return _func.IndicatorNumericalMathEvaluationImplementation_setComparisonOperator(self, *args)
    def getThreshold(self): return _func.IndicatorNumericalMathEvaluationImplementation_getThreshold(self)
    def setThreshold(self, *args): return _func.IndicatorNumericalMathEvaluationImplementation_setThreshold(self, *args)
    def getInputDimension(self): return _func.IndicatorNumericalMathEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.IndicatorNumericalMathEvaluationImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_IndicatorNumericalMathEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_IndicatorNumericalMathEvaluationImplementation
    __del__ = lambda self : None;
IndicatorNumericalMathEvaluationImplementation_swigregister = _func.IndicatorNumericalMathEvaluationImplementation_swigregister
IndicatorNumericalMathEvaluationImplementation_swigregister(IndicatorNumericalMathEvaluationImplementation)

class PolynomialCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolynomialCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, PolynomialCollection, name)
    __swig_destroy__ = _func.delete_PolynomialCollection
    __del__ = lambda self : None;
    def clear(self): return _func.PolynomialCollection_clear(self)
    def __len__(self): return _func.PolynomialCollection___len__(self)
    def __eq__(self, *args): return _func.PolynomialCollection___eq__(self, *args)
    def __contains__(self, *args): return _func.PolynomialCollection___contains__(self, *args)
    def __getitem__(self, *args): return _func.PolynomialCollection___getitem__(self, *args)
    def __setitem__(self, *args): return _func.PolynomialCollection___setitem__(self, *args)
    def __delitem__(self, *args): return _func.PolynomialCollection___delitem__(self, *args)
    def at(self, *args): return _func.PolynomialCollection_at(self, *args)
    def add(self, *args): return _func.PolynomialCollection_add(self, *args)
    def getSize(self): return _func.PolynomialCollection_getSize(self)
    def resize(self, *args): return _func.PolynomialCollection_resize(self, *args)
    def isEmpty(self): return _func.PolynomialCollection_isEmpty(self)
    def __repr__(self): return _func.PolynomialCollection___repr__(self)
    def __str__(self, offset=""): return _func.PolynomialCollection___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_PolynomialCollection(*args)
        try: self.this.append(this)
        except: self.this = this
PolynomialCollection_swigregister = _func.PolynomialCollection_swigregister
PolynomialCollection_swigregister(PolynomialCollection)

class PolynomialPersistentCollection(openturns.common.PersistentObject,PolynomialCollection):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject,PolynomialCollection]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, PolynomialPersistentCollection, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject,PolynomialCollection]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, PolynomialPersistentCollection, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.PolynomialPersistentCollection_getClassName(self)

    def __init__(self, *args): 
        this = _func.new_PolynomialPersistentCollection(*args)
        try: self.this.append(this)
        except: self.this = this
    def __repr__(self): return _func.PolynomialPersistentCollection___repr__(self)
    def __str__(self, offset=""): return _func.PolynomialPersistentCollection___str__(self, offset)
    __swig_destroy__ = _func.delete_PolynomialPersistentCollection
    __del__ = lambda self : None;
PolynomialPersistentCollection_swigregister = _func.PolynomialPersistentCollection_swigregister
PolynomialPersistentCollection_swigregister(PolynomialPersistentCollection)

class ProductPolynomialEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProductPolynomialEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProductPolynomialEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ProductPolynomialEvaluationImplementation_getClassName(self)

    def __repr__(self): return _func.ProductPolynomialEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ProductPolynomialEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.ProductPolynomialEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.ProductPolynomialEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.ProductPolynomialEvaluationImplementation_getOutputDimension(self)
    def __init__(self, *args): 
        this = _func.new_ProductPolynomialEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ProductPolynomialEvaluationImplementation
    __del__ = lambda self : None;
ProductPolynomialEvaluationImplementation_swigregister = _func.ProductPolynomialEvaluationImplementation_swigregister
ProductPolynomialEvaluationImplementation_swigregister(ProductPolynomialEvaluationImplementation)

class ParametricEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParametricEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ParametricEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ParametricEvaluationImplementation_getClassName(self)

    def __call__(self, *args): return _func.ParametricEvaluationImplementation___call__(self, *args)
    def getParametersPositions(self): return _func.ParametricEvaluationImplementation_getParametersPositions(self)
    def getInputPositions(self): return _func.ParametricEvaluationImplementation_getInputPositions(self)
    def getFunction(self): return _func.ParametricEvaluationImplementation_getFunction(self)
    def getInputDimension(self): return _func.ParametricEvaluationImplementation_getInputDimension(self)
    def getParametersDimension(self): return _func.ParametricEvaluationImplementation_getParametersDimension(self)
    def getOutputDimension(self): return _func.ParametricEvaluationImplementation_getOutputDimension(self)
    def setParameters(self, *args): return _func.ParametricEvaluationImplementation_setParameters(self, *args)
    def __repr__(self): return _func.ParametricEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ParametricEvaluationImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_ParametricEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ParametricEvaluationImplementation
    __del__ = lambda self : None;
ParametricEvaluationImplementation_swigregister = _func.ParametricEvaluationImplementation_swigregister
ParametricEvaluationImplementation_swigregister(ParametricEvaluationImplementation)

class ParametricGradientImplementation(NumericalMathGradientImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParametricGradientImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathGradientImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ParametricGradientImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ParametricGradientImplementation_getClassName(self)

    def gradient(self, *args): return _func.ParametricGradientImplementation_gradient(self, *args)
    def getEvaluation(self): return _func.ParametricGradientImplementation_getEvaluation(self)
    def getInputDimension(self): return _func.ParametricGradientImplementation_getInputDimension(self)
    def getParametersDimension(self): return _func.ParametricGradientImplementation_getParametersDimension(self)
    def getOutputDimension(self): return _func.ParametricGradientImplementation_getOutputDimension(self)
    def __repr__(self): return _func.ParametricGradientImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ParametricGradientImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_ParametricGradientImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ParametricGradientImplementation
    __del__ = lambda self : None;
ParametricGradientImplementation_swigregister = _func.ParametricGradientImplementation_swigregister
ParametricGradientImplementation_swigregister(ParametricGradientImplementation)

class ParametricHessianImplementation(NumericalMathHessianImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParametricHessianImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathHessianImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ParametricHessianImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ParametricHessianImplementation_getClassName(self)

    def hessian(self, *args): return _func.ParametricHessianImplementation_hessian(self, *args)
    def getEvaluation(self): return _func.ParametricHessianImplementation_getEvaluation(self)
    def getInputDimension(self): return _func.ParametricHessianImplementation_getInputDimension(self)
    def getParametersDimension(self): return _func.ParametricHessianImplementation_getParametersDimension(self)
    def getOutputDimension(self): return _func.ParametricHessianImplementation_getOutputDimension(self)
    def __repr__(self): return _func.ParametricHessianImplementation___repr__(self)
    def __str__(self, offset=""): return _func.ParametricHessianImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_ParametricHessianImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ParametricHessianImplementation
    __del__ = lambda self : None;
ParametricHessianImplementation_swigregister = _func.ParametricHessianImplementation_swigregister
ParametricHessianImplementation_swigregister(ParametricHessianImplementation)

class BasisImplementation(openturns.common.PersistentObject):
    """
    Basis.

    Available constructors:
        Basis(*functionsColl*)

        Basis(*size*)

    Parameters
    ----------
    functionsColl : list of :class:`~openturns.NumericalMathFunction`
        Functions constituting the Basis.
    size : int
        Size of the Basis.

    Examples
    --------
    >>> import openturns as ot
    >>> dimension = 3
    >>> input = ['x0', 'x1', 'x2']
    >>> functions = []
    >>> for i in range(dimension):
    ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
    >>> basis = ot.Basis(functions)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BasisImplementation_getClassName(self)

    def build(self, *args):
        """
        Build the element of the given index.

        Parameters
        ----------
        index : int, :math:`index \\geq 0`
            Index of an element of the Basis.

        Returns
        -------
        function : :class:`~openturns.NumericalMathFunction`
            The function at the index *index* of the Basis.

        Examples
        --------
        >>> import openturns as ot
        >>> dimension = 3
        >>> input = ['x0', 'x1', 'x2']
        >>> functions = []
        >>> for i in range(dimension):
        ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
        >>> basis = ot.Basis(functions)
        >>> print(basis.build(0).getEvaluationImplementation())
        [x0,x1,x2]->[x0]
        """
        return _func.BasisImplementation_build(self, *args)

    def getSubBasis(self, *args):
        """
        Get a sub-basis of the Basis.

        Parameters
        ----------
        indices : list of int
            Indices of the terms of the Basis put in the sub-basis.

        Returns
        -------
        subBasis : list of :class:`~openturns.NumericalMathFunction`
            Functions defining a sub-basis.

        Examples
        --------
        >>> import openturns as ot
        >>> dimension = 3
        >>> input = ['x0', 'x1', 'x2']
        >>> functions = []
        >>> for i in range(dimension):
        ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
        >>> basis = ot.Basis(functions)
        >>> subbasis = basis.getSubBasis([1])
        >>> print(subbasis[0].getEvaluationImplementation())
        [x0,x1,x2]->[x1]
        """
        return _func.BasisImplementation_getSubBasis(self, *args)

    def __repr__(self): return _func.BasisImplementation___repr__(self)
    def getDimension(self):
        """
        Get the dimension of the Basis.

        Returns
        -------
        dimension : int
            Dimension of the Basis.
        """
        return _func.BasisImplementation_getDimension(self)

    def getSize(self):
        """
        Get the size of the Basis.

        Returns
        -------
        size : int
            Size of the Basis.
        """
        return _func.BasisImplementation_getSize(self)

    def isOrthogonal(self):
        """
        Tell whether the basis is orthogonal.

        Returns
        -------
        isOrthogonal : Bool
            `True` if the basis is orthogonal.
        """
        return _func.BasisImplementation_isOrthogonal(self)

    def isFunctional(self):
        """
        Tell whether the basis is functional.

        Returns
        -------
        isOrthogonal : Bool
            `True` if the basis is functional i.e. if its terms are a solution
            to an equation (e.g. a basis made up of Legendre functions).
        """
        return _func.BasisImplementation_isFunctional(self)

    def add(self, *args):
        """
        Add an element in the Basis.

        Parameters
        ----------
        function : :class:`~openturns.NumericalMathFunction`
            Function added in the Basis.

        Examples
        --------
        >>> import openturns as ot
        >>> dimension = 3
        >>> input = ['x0', 'x1', 'x2']
        >>> functions = []
        >>> for i in range(2):
        ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
        >>> basis = ot.Basis(functions)
        >>> basis.add(ot.NumericalMathFunction(input, ['y'], [input[2]]))
        """
        return _func.BasisImplementation_add(self, *args)

    def __init__(self, *args): 
        this = _func.new_BasisImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BasisImplementation
    __del__ = lambda self : None;
BasisImplementation_swigregister = _func.BasisImplementation_swigregister
BasisImplementation_swigregister(BasisImplementation)

class BasisImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_BasisImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.BasisImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.BasisImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.BasisImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.BasisImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_BasisImplementationTypedInterfaceObject
    __del__ = lambda self : None;
BasisImplementationTypedInterfaceObject_swigregister = _func.BasisImplementationTypedInterfaceObject_swigregister
BasisImplementationTypedInterfaceObject_swigregister(BasisImplementationTypedInterfaceObject)

class Basis(BasisImplementationTypedInterfaceObject):
    """
    Basis.

    Available constructors:
        Basis(*functionsColl*)

        Basis(*size*)

    Parameters
    ----------
    functionsColl : list of :class:`~openturns.NumericalMathFunction`
        Functions constituting the Basis.
    size : int
        Size of the Basis.

    Examples
    --------
    >>> import openturns as ot
    >>> dimension = 3
    >>> input = ['x0', 'x1', 'x2']
    >>> functions = []
    >>> for i in range(dimension):
    ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
    >>> basis = ot.Basis(functions)
    """
    __swig_setmethods__ = {}
    for _s in [BasisImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Basis, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Basis, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.Basis_getClassName(self)

    def build(self, *args):
        """
        Build the element of the given index.

        Parameters
        ----------
        index : int, :math:`index \\geq 0`
            Index of an element of the Basis.

        Returns
        -------
        function : :class:`~openturns.NumericalMathFunction`
            The function at the index *index* of the Basis.

        Examples
        --------
        >>> import openturns as ot
        >>> dimension = 3
        >>> input = ['x0', 'x1', 'x2']
        >>> functions = []
        >>> for i in range(dimension):
        ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
        >>> basis = ot.Basis(functions)
        >>> print(basis.build(0).getEvaluationImplementation())
        [x0,x1,x2]->[x0]
        """
        return _func.Basis_build(self, *args)

    def getSubBasis(self, *args):
        """
        Get a sub-basis of the Basis.

        Parameters
        ----------
        indices : list of int
            Indices of the terms of the Basis put in the sub-basis.

        Returns
        -------
        subBasis : list of :class:`~openturns.NumericalMathFunction`
            Functions defining a sub-basis.

        Examples
        --------
        >>> import openturns as ot
        >>> dimension = 3
        >>> input = ['x0', 'x1', 'x2']
        >>> functions = []
        >>> for i in range(dimension):
        ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
        >>> basis = ot.Basis(functions)
        >>> subbasis = basis.getSubBasis([1])
        >>> print(subbasis[0].getEvaluationImplementation())
        [x0,x1,x2]->[x1]
        """
        return _func.Basis_getSubBasis(self, *args)

    def getDimension(self):
        """
        Get the dimension of the Basis.

        Returns
        -------
        dimension : int
            Dimension of the Basis.
        """
        return _func.Basis_getDimension(self)

    def getSize(self):
        """
        Get the size of the Basis.

        Returns
        -------
        size : int
            Size of the Basis.
        """
        return _func.Basis_getSize(self)

    def add(self, *args):
        """
        Add an element in the Basis.

        Parameters
        ----------
        function : :class:`~openturns.NumericalMathFunction`
            Function added in the Basis.

        Examples
        --------
        >>> import openturns as ot
        >>> dimension = 3
        >>> input = ['x0', 'x1', 'x2']
        >>> functions = []
        >>> for i in range(2):
        ...     functions.append(ot.NumericalMathFunction(input, ['y'], [input[i]]))
        >>> basis = ot.Basis(functions)
        >>> basis.add(ot.NumericalMathFunction(input, ['y'], [input[2]]))
        """
        return _func.Basis_add(self, *args)

    def isFunctional(self):
        """
        Tell whether the basis is functional.

        Returns
        -------
        isOrthogonal : Bool
            `True` if the basis is functional i.e. if its terms are a solution
            to an equation (e.g. a basis made up of Legendre functions).
        """
        return _func.Basis_isFunctional(self)

    def isOrthogonal(self):
        """
        Tell whether the basis is orthogonal.

        Returns
        -------
        isOrthogonal : Bool
            `True` if the basis is orthogonal.
        """
        return _func.Basis_isOrthogonal(self)

    def __repr__(self): return _func.Basis___repr__(self)
    def __str__(self, offset=""): return _func.Basis___str__(self, offset)
    def __len__(self): return _func.Basis___len__(self)
    def __init__(self, *args): 
        this = _func.new_Basis(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_Basis
    __del__ = lambda self : None;
Basis_swigregister = _func.Basis_swigregister
Basis_swigregister(Basis)

class IndicesCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, IndicesCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, IndicesCollection, name)
    __swig_destroy__ = _func.delete_IndicesCollection
    __del__ = lambda self : None;
    def clear(self): return _func.IndicesCollection_clear(self)
    def __len__(self): return _func.IndicesCollection___len__(self)
    def __eq__(self, *args): return _func.IndicesCollection___eq__(self, *args)
    def __contains__(self, *args): return _func.IndicesCollection___contains__(self, *args)
    def __getitem__(self, *args): return _func.IndicesCollection___getitem__(self, *args)
    def __setitem__(self, *args): return _func.IndicesCollection___setitem__(self, *args)
    def __delitem__(self, *args): return _func.IndicesCollection___delitem__(self, *args)
    def at(self, *args): return _func.IndicesCollection_at(self, *args)
    def add(self, *args): return _func.IndicesCollection_add(self, *args)
    def getSize(self): return _func.IndicesCollection_getSize(self)
    def resize(self, *args): return _func.IndicesCollection_resize(self, *args)
    def isEmpty(self): return _func.IndicesCollection_isEmpty(self)
    def __repr__(self): return _func.IndicesCollection___repr__(self)
    def __str__(self, offset=""): return _func.IndicesCollection___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_IndicesCollection(*args)
        try: self.this.append(this)
        except: self.this = this
IndicesCollection_swigregister = _func.IndicesCollection_swigregister
IndicesCollection_swigregister(IndicesCollection)

class IndicesPersistentCollection(openturns.common.PersistentObject,IndicesCollection):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject,IndicesCollection]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, IndicesPersistentCollection, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject,IndicesCollection]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, IndicesPersistentCollection, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.IndicesPersistentCollection_getClassName(self)

    def __init__(self, *args): 
        this = _func.new_IndicesPersistentCollection(*args)
        try: self.this.append(this)
        except: self.this = this
    def __repr__(self): return _func.IndicesPersistentCollection___repr__(self)
    def __str__(self, offset=""): return _func.IndicesPersistentCollection___str__(self, offset)
    __swig_destroy__ = _func.delete_IndicesPersistentCollection
    __del__ = lambda self : None;
IndicesPersistentCollection_swigregister = _func.IndicesPersistentCollection_swigregister
IndicesPersistentCollection_swigregister(IndicesPersistentCollection)

class BasisSequenceImplementation(IndicesPersistentCollection):
    __swig_setmethods__ = {}
    for _s in [IndicesPersistentCollection]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisSequenceImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [IndicesPersistentCollection]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisSequenceImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BasisSequenceImplementation_getClassName(self)

    def __repr__(self): return _func.BasisSequenceImplementation___repr__(self)
    def __str__(self, offset=""): return _func.BasisSequenceImplementation___str__(self, offset)
    def getDimension(self): return _func.BasisSequenceImplementation_getDimension(self)
    def getMasterBasis(self): return _func.BasisSequenceImplementation_getMasterBasis(self)
    def getBasis(self, *args): return _func.BasisSequenceImplementation_getBasis(self, *args)
    def getIndices(self, *args): return _func.BasisSequenceImplementation_getIndices(self, *args)
    def __init__(self, *args): 
        this = _func.new_BasisSequenceImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BasisSequenceImplementation
    __del__ = lambda self : None;
BasisSequenceImplementation_swigregister = _func.BasisSequenceImplementation_swigregister
BasisSequenceImplementation_swigregister(BasisSequenceImplementation)

class BasisSequenceImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisSequenceImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisSequenceImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_BasisSequenceImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.BasisSequenceImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.BasisSequenceImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.BasisSequenceImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.BasisSequenceImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_BasisSequenceImplementationTypedInterfaceObject
    __del__ = lambda self : None;
BasisSequenceImplementationTypedInterfaceObject_swigregister = _func.BasisSequenceImplementationTypedInterfaceObject_swigregister
BasisSequenceImplementationTypedInterfaceObject_swigregister(BasisSequenceImplementationTypedInterfaceObject)

class BasisSequenceImplementationTypedCollectionInterfaceObject(BasisSequenceImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [BasisSequenceImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisSequenceImplementationTypedCollectionInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisSequenceImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisSequenceImplementationTypedCollectionInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_BasisSequenceImplementationTypedCollectionInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def __getitem__(self, *args): return _func.BasisSequenceImplementationTypedCollectionInterfaceObject___getitem__(self, *args)
    def __setitem__(self, *args): return _func.BasisSequenceImplementationTypedCollectionInterfaceObject___setitem__(self, *args)
    def add(self, *args): return _func.BasisSequenceImplementationTypedCollectionInterfaceObject_add(self, *args)
    def getSize(self): return _func.BasisSequenceImplementationTypedCollectionInterfaceObject_getSize(self)
    def getDimension(self): return _func.BasisSequenceImplementationTypedCollectionInterfaceObject_getDimension(self)
    def isEmpty(self): return _func.BasisSequenceImplementationTypedCollectionInterfaceObject_isEmpty(self)
    def erase(self, *args): return _func.BasisSequenceImplementationTypedCollectionInterfaceObject_erase(self, *args)
    __swig_destroy__ = _func.delete_BasisSequenceImplementationTypedCollectionInterfaceObject
    __del__ = lambda self : None;
BasisSequenceImplementationTypedCollectionInterfaceObject_swigregister = _func.BasisSequenceImplementationTypedCollectionInterfaceObject_swigregister
BasisSequenceImplementationTypedCollectionInterfaceObject_swigregister(BasisSequenceImplementationTypedCollectionInterfaceObject)

class BasisSequence(BasisSequenceImplementationTypedCollectionInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [BasisSequenceImplementationTypedCollectionInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisSequence, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisSequenceImplementationTypedCollectionInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisSequence, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BasisSequence_getClassName(self)

    def getDimension(self): return _func.BasisSequence_getDimension(self)
    def getMasterBasis(self): return _func.BasisSequence_getMasterBasis(self)
    def getBasis(self, *args): return _func.BasisSequence_getBasis(self, *args)
    def getIndices(self, *args): return _func.BasisSequence_getIndices(self, *args)
    def __repr__(self): return _func.BasisSequence___repr__(self)
    def __str__(self, offset=""): return _func.BasisSequence___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_BasisSequence(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BasisSequence
    __del__ = lambda self : None;
BasisSequence_swigregister = _func.BasisSequence_swigregister
BasisSequence_swigregister(BasisSequence)

class FunctionalBasisImplementation(BasisImplementation):
    __swig_setmethods__ = {}
    for _s in [BasisImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FunctionalBasisImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FunctionalBasisImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.FunctionalBasisImplementation_getClassName(self)

    def isFunctional(self):
        """
        Tell whether the basis is functional.

        Returns
        -------
        isOrthogonal : Bool
            `True` if the basis is functional i.e. if its terms are a solution
            to an equation (e.g. a basis made up of Legendre functions).
        """
        return _func.FunctionalBasisImplementation_isFunctional(self)

    def __repr__(self): return _func.FunctionalBasisImplementation___repr__(self)
    def __init__(self, *args): 
        this = _func.new_FunctionalBasisImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_FunctionalBasisImplementation
    __del__ = lambda self : None;
FunctionalBasisImplementation_swigregister = _func.FunctionalBasisImplementation_swigregister
FunctionalBasisImplementation_swigregister(FunctionalBasisImplementation)

class FunctionalBasisImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FunctionalBasisImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FunctionalBasisImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_FunctionalBasisImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.FunctionalBasisImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.FunctionalBasisImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.FunctionalBasisImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.FunctionalBasisImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_FunctionalBasisImplementationTypedInterfaceObject
    __del__ = lambda self : None;
FunctionalBasisImplementationTypedInterfaceObject_swigregister = _func.FunctionalBasisImplementationTypedInterfaceObject_swigregister
FunctionalBasisImplementationTypedInterfaceObject_swigregister(FunctionalBasisImplementationTypedInterfaceObject)

class FunctionalBasis(FunctionalBasisImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [FunctionalBasisImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FunctionalBasis, name, value)
    __swig_getmethods__ = {}
    for _s in [FunctionalBasisImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FunctionalBasis, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.FunctionalBasis_getClassName(self)

    def build(self, *args): return _func.FunctionalBasis_build(self, *args)
    def isOrthogonal(self): return _func.FunctionalBasis_isOrthogonal(self)
    def __repr__(self): return _func.FunctionalBasis___repr__(self)
    def __init__(self, *args): 
        this = _func.new_FunctionalBasis(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_FunctionalBasis
    __del__ = lambda self : None;
FunctionalBasis_swigregister = _func.FunctionalBasis_swigregister
FunctionalBasis_swigregister(FunctionalBasis)

class BasisSequenceFactoryImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisSequenceFactoryImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisSequenceFactoryImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BasisSequenceFactoryImplementation_getClassName(self)

    def setVerbose(self, *args): return _func.BasisSequenceFactoryImplementation_setVerbose(self, *args)
    def getVerbose(self): return _func.BasisSequenceFactoryImplementation_getVerbose(self)
    def build(self, *args): return _func.BasisSequenceFactoryImplementation_build(self, *args)
    def setMaximumRelativeConvergence(self, *args): return _func.BasisSequenceFactoryImplementation_setMaximumRelativeConvergence(self, *args)
    def getMaximumRelativeConvergence(self): return _func.BasisSequenceFactoryImplementation_getMaximumRelativeConvergence(self)
    def __repr__(self): return _func.BasisSequenceFactoryImplementation___repr__(self)
    def __str__(self, offset=""): return _func.BasisSequenceFactoryImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_BasisSequenceFactoryImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BasisSequenceFactoryImplementation
    __del__ = lambda self : None;
BasisSequenceFactoryImplementation_swigregister = _func.BasisSequenceFactoryImplementation_swigregister
BasisSequenceFactoryImplementation_swigregister(BasisSequenceFactoryImplementation)

class BasisSequenceFactoryImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisSequenceFactoryImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisSequenceFactoryImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _func.new_BasisSequenceFactoryImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _func.BasisSequenceFactoryImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.BasisSequenceFactoryImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.BasisSequenceFactoryImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _func.BasisSequenceFactoryImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _func.delete_BasisSequenceFactoryImplementationTypedInterfaceObject
    __del__ = lambda self : None;
BasisSequenceFactoryImplementationTypedInterfaceObject_swigregister = _func.BasisSequenceFactoryImplementationTypedInterfaceObject_swigregister
BasisSequenceFactoryImplementationTypedInterfaceObject_swigregister(BasisSequenceFactoryImplementationTypedInterfaceObject)

class BasisSequenceFactory(BasisSequenceFactoryImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [BasisSequenceFactoryImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisSequenceFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisSequenceFactoryImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisSequenceFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BasisSequenceFactory_getClassName(self)

    def __repr__(self): return _func.BasisSequenceFactory___repr__(self)
    def __str__(self, offset=""): return _func.BasisSequenceFactory___str__(self, offset)
    def setVerbose(self, *args): return _func.BasisSequenceFactory_setVerbose(self, *args)
    def getVerbose(self): return _func.BasisSequenceFactory_getVerbose(self)
    def build(self, *args): return _func.BasisSequenceFactory_build(self, *args)
    def setMaximumRelativeConvergence(self, *args): return _func.BasisSequenceFactory_setMaximumRelativeConvergence(self, *args)
    def getMaximumRelativeConvergence(self): return _func.BasisSequenceFactory_getMaximumRelativeConvergence(self)
    def __init__(self, *args): 
        this = _func.new_BasisSequenceFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BasisSequenceFactory
    __del__ = lambda self : None;
BasisSequenceFactory_swigregister = _func.BasisSequenceFactory_swigregister
BasisSequenceFactory_swigregister(BasisSequenceFactory)

class LAR(BasisSequenceFactoryImplementation):
    __swig_setmethods__ = {}
    for _s in [BasisSequenceFactoryImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LAR, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisSequenceFactoryImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LAR, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LAR_getClassName(self)

    def build(self, *args): return _func.LAR_build(self, *args)
    def __repr__(self): return _func.LAR___repr__(self)
    def __str__(self, offset=""): return _func.LAR___str__(self, offset)
    def __init__(self, *args): 
        this = _func.new_LAR(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LAR
    __del__ = lambda self : None;
LAR_swigregister = _func.LAR_swigregister
LAR_swigregister(LAR)

class BoxCoxEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoxCoxEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BoxCoxEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BoxCoxEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.BoxCoxEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.BoxCoxEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.BoxCoxEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.BoxCoxEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.BoxCoxEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.BoxCoxEvaluationImplementation_getOutputDimension(self)
    def getLambda(self): return _func.BoxCoxEvaluationImplementation_getLambda(self)
    def getShift(self): return _func.BoxCoxEvaluationImplementation_getShift(self)
    def __init__(self, *args): 
        this = _func.new_BoxCoxEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BoxCoxEvaluationImplementation
    __del__ = lambda self : None;
BoxCoxEvaluationImplementation_swigregister = _func.BoxCoxEvaluationImplementation_swigregister
BoxCoxEvaluationImplementation_swigregister(BoxCoxEvaluationImplementation)

class BoxCoxTransform(NumericalMathFunction):
    __swig_setmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BoxCoxTransform, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BoxCoxTransform, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BoxCoxTransform_getClassName(self)

    def getLambda(self): return _func.BoxCoxTransform_getLambda(self)
    def getShift(self): return _func.BoxCoxTransform_getShift(self)
    def getInverse(self): return _func.BoxCoxTransform_getInverse(self)
    def __init__(self, *args): 
        this = _func.new_BoxCoxTransform(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BoxCoxTransform
    __del__ = lambda self : None;
BoxCoxTransform_swigregister = _func.BoxCoxTransform_swigregister
BoxCoxTransform_swigregister(BoxCoxTransform)

class InverseBoxCoxEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InverseBoxCoxEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, InverseBoxCoxEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.InverseBoxCoxEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.InverseBoxCoxEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.InverseBoxCoxEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.InverseBoxCoxEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.InverseBoxCoxEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.InverseBoxCoxEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.InverseBoxCoxEvaluationImplementation_getOutputDimension(self)
    def getLambda(self): return _func.InverseBoxCoxEvaluationImplementation_getLambda(self)
    def getShift(self): return _func.InverseBoxCoxEvaluationImplementation_getShift(self)
    def __init__(self, *args): 
        this = _func.new_InverseBoxCoxEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_InverseBoxCoxEvaluationImplementation
    __del__ = lambda self : None;
InverseBoxCoxEvaluationImplementation_swigregister = _func.InverseBoxCoxEvaluationImplementation_swigregister
InverseBoxCoxEvaluationImplementation_swigregister(InverseBoxCoxEvaluationImplementation)

class InverseBoxCoxTransform(NumericalMathFunction):
    __swig_setmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InverseBoxCoxTransform, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathFunction]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, InverseBoxCoxTransform, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.InverseBoxCoxTransform_getClassName(self)

    def getLambda(self): return _func.InverseBoxCoxTransform_getLambda(self)
    def getShift(self): return _func.InverseBoxCoxTransform_getShift(self)
    def getInverse(self): return _func.InverseBoxCoxTransform_getInverse(self)
    def __init__(self, *args): 
        this = _func.new_InverseBoxCoxTransform(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_InverseBoxCoxTransform
    __del__ = lambda self : None;
InverseBoxCoxTransform_swigregister = _func.InverseBoxCoxTransform_swigregister
InverseBoxCoxTransform_swigregister(InverseBoxCoxTransform)

class TrendEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TrendEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TrendEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.TrendEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.TrendEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.TrendEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.TrendEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.TrendEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.TrendEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.TrendEvaluationImplementation_getOutputDimension(self)
    def getFunction(self): return _func.TrendEvaluationImplementation_getFunction(self)
    def __init__(self, *args): 
        this = _func.new_TrendEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_TrendEvaluationImplementation
    __del__ = lambda self : None;
TrendEvaluationImplementation_swigregister = _func.TrendEvaluationImplementation_swigregister
TrendEvaluationImplementation_swigregister(TrendEvaluationImplementation)

class TrendTransform(TemporalFunction):
    __swig_setmethods__ = {}
    for _s in [TemporalFunction]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TrendTransform, name, value)
    __swig_getmethods__ = {}
    for _s in [TemporalFunction]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TrendTransform, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.TrendTransform_getClassName(self)

    def __eq__(self, *args): return _func.TrendTransform___eq__(self, *args)
    def __repr__(self): return _func.TrendTransform___repr__(self)
    def __str__(self, offset=""): return _func.TrendTransform___str__(self, offset)
    def __call__(self, *args): return _func.TrendTransform___call__(self, *args)
    def getInverse(self): return _func.TrendTransform_getInverse(self)
    def __init__(self, *args): 
        this = _func.new_TrendTransform(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_TrendTransform
    __del__ = lambda self : None;
TrendTransform_swigregister = _func.TrendTransform_swigregister
TrendTransform_swigregister(TrendTransform)

class InverseTrendEvaluationImplementation(NumericalMathEvaluationImplementation):
    __swig_setmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InverseTrendEvaluationImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [NumericalMathEvaluationImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, InverseTrendEvaluationImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.InverseTrendEvaluationImplementation_getClassName(self)

    def __eq__(self, *args): return _func.InverseTrendEvaluationImplementation___eq__(self, *args)
    def __repr__(self): return _func.InverseTrendEvaluationImplementation___repr__(self)
    def __str__(self, offset=""): return _func.InverseTrendEvaluationImplementation___str__(self, offset)
    def __call__(self, *args): return _func.InverseTrendEvaluationImplementation___call__(self, *args)
    def getInputDimension(self): return _func.InverseTrendEvaluationImplementation_getInputDimension(self)
    def getOutputDimension(self): return _func.InverseTrendEvaluationImplementation_getOutputDimension(self)
    def getFunction(self): return _func.InverseTrendEvaluationImplementation_getFunction(self)
    def __init__(self, *args): 
        this = _func.new_InverseTrendEvaluationImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_InverseTrendEvaluationImplementation
    __del__ = lambda self : None;
InverseTrendEvaluationImplementation_swigregister = _func.InverseTrendEvaluationImplementation_swigregister
InverseTrendEvaluationImplementation_swigregister(InverseTrendEvaluationImplementation)

class InverseTrendTransform(TemporalFunction):
    __swig_setmethods__ = {}
    for _s in [TemporalFunction]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InverseTrendTransform, name, value)
    __swig_getmethods__ = {}
    for _s in [TemporalFunction]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, InverseTrendTransform, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.InverseTrendTransform_getClassName(self)

    def getInverse(self): return _func.InverseTrendTransform_getInverse(self)
    def __eq__(self, *args): return _func.InverseTrendTransform___eq__(self, *args)
    def __repr__(self): return _func.InverseTrendTransform___repr__(self)
    def __str__(self, offset=""): return _func.InverseTrendTransform___str__(self, offset)
    def __call__(self, *args): return _func.InverseTrendTransform___call__(self, *args)
    def __init__(self, *args): 
        this = _func.new_InverseTrendTransform(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_InverseTrendTransform
    __del__ = lambda self : None;
InverseTrendTransform_swigregister = _func.InverseTrendTransform_swigregister
InverseTrendTransform_swigregister(InverseTrendTransform)

class BasisFactory(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasisFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasisFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.BasisFactory_getClassName(self)

    def __repr__(self): return _func.BasisFactory___repr__(self)
    def build(self): return _func.BasisFactory_build(self)
    def __init__(self, *args): 
        this = _func.new_BasisFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_BasisFactory
    __del__ = lambda self : None;
BasisFactory_swigregister = _func.BasisFactory_swigregister
BasisFactory_swigregister(BasisFactory)

class ConstantBasisFactory(BasisFactory):
    __swig_setmethods__ = {}
    for _s in [BasisFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConstantBasisFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ConstantBasisFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.ConstantBasisFactory_getClassName(self)

    def __repr__(self): return _func.ConstantBasisFactory___repr__(self)
    def build(self): return _func.ConstantBasisFactory_build(self)
    def save(self, *args): return _func.ConstantBasisFactory_save(self, *args)
    def load(self, *args): return _func.ConstantBasisFactory_load(self, *args)
    def __init__(self, *args): 
        this = _func.new_ConstantBasisFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_ConstantBasisFactory
    __del__ = lambda self : None;
ConstantBasisFactory_swigregister = _func.ConstantBasisFactory_swigregister
ConstantBasisFactory_swigregister(ConstantBasisFactory)

class LinearBasisFactory(BasisFactory):
    __swig_setmethods__ = {}
    for _s in [BasisFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearBasisFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearBasisFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.LinearBasisFactory_getClassName(self)

    def __repr__(self): return _func.LinearBasisFactory___repr__(self)
    def build(self): return _func.LinearBasisFactory_build(self)
    def save(self, *args): return _func.LinearBasisFactory_save(self, *args)
    def load(self, *args): return _func.LinearBasisFactory_load(self, *args)
    def __init__(self, *args): 
        this = _func.new_LinearBasisFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_LinearBasisFactory
    __del__ = lambda self : None;
LinearBasisFactory_swigregister = _func.LinearBasisFactory_swigregister
LinearBasisFactory_swigregister(LinearBasisFactory)

class QuadraticBasisFactory(BasisFactory):
    __swig_setmethods__ = {}
    for _s in [BasisFactory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, QuadraticBasisFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [BasisFactory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, QuadraticBasisFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.QuadraticBasisFactory_getClassName(self)

    def __repr__(self): return _func.QuadraticBasisFactory___repr__(self)
    def build(self): return _func.QuadraticBasisFactory_build(self)
    def save(self, *args): return _func.QuadraticBasisFactory_save(self, *args)
    def load(self, *args): return _func.QuadraticBasisFactory_load(self, *args)
    def __init__(self, *args): 
        this = _func.new_QuadraticBasisFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_QuadraticBasisFactory
    __del__ = lambda self : None;
QuadraticBasisFactory_swigregister = _func.QuadraticBasisFactory_swigregister
QuadraticBasisFactory_swigregister(QuadraticBasisFactory)

class NumericalMathEvaluationImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathEvaluationImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathEvaluationImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _func.NumericalMathEvaluationImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _func.NumericalMathEvaluationImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_func.NumericalMathEvaluationImplementationPointer_ptr__get, _func.NumericalMathEvaluationImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _func.new_NumericalMathEvaluationImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathEvaluationImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _func.NumericalMathEvaluationImplementationPointer_reset(self)
    def __ref__(self, *args): return _func.NumericalMathEvaluationImplementationPointer___ref__(self, *args)
    def __deref__(self): return _func.NumericalMathEvaluationImplementationPointer___deref__(self)
    def isNull(self): return _func.NumericalMathEvaluationImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _func.NumericalMathEvaluationImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.NumericalMathEvaluationImplementationPointer_get(self)
    def getImplementation(self): return _func.NumericalMathEvaluationImplementationPointer_getImplementation(self)
    def unique(self): return _func.NumericalMathEvaluationImplementationPointer_unique(self)
    def use_count(self): return _func.NumericalMathEvaluationImplementationPointer_use_count(self)
    def swap(self, *args): return _func.NumericalMathEvaluationImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathEvaluationImplementationPointer_getClassName(self)

    def __eq__(self, *args): return _func.NumericalMathEvaluationImplementationPointer___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathEvaluationImplementationPointer___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathEvaluationImplementationPointer___str__(self, offset)
    def setDescription(self, *args): return _func.NumericalMathEvaluationImplementationPointer_setDescription(self, *args)
    def getDescription(self): return _func.NumericalMathEvaluationImplementationPointer_getDescription(self)
    def getInputDescription(self): return _func.NumericalMathEvaluationImplementationPointer_getInputDescription(self)
    def setInputDescription(self, *args): return _func.NumericalMathEvaluationImplementationPointer_setInputDescription(self, *args)
    def getOutputDescription(self): return _func.NumericalMathEvaluationImplementationPointer_getOutputDescription(self)
    def setOutputDescription(self, *args): return _func.NumericalMathEvaluationImplementationPointer_setOutputDescription(self, *args)
    def enableHistory(self): return _func.NumericalMathEvaluationImplementationPointer_enableHistory(self)
    def disableHistory(self): return _func.NumericalMathEvaluationImplementationPointer_disableHistory(self)
    def isHistoryEnabled(self): return _func.NumericalMathEvaluationImplementationPointer_isHistoryEnabled(self)
    def clearHistory(self): return _func.NumericalMathEvaluationImplementationPointer_clearHistory(self)
    def getHistoryInput(self): return _func.NumericalMathEvaluationImplementationPointer_getHistoryInput(self)
    def getInputHistory(self): return _func.NumericalMathEvaluationImplementationPointer_getInputHistory(self)
    def getHistoryOutput(self): return _func.NumericalMathEvaluationImplementationPointer_getHistoryOutput(self)
    def getOutputHistory(self): return _func.NumericalMathEvaluationImplementationPointer_getOutputHistory(self)
    def enableCache(self): return _func.NumericalMathEvaluationImplementationPointer_enableCache(self)
    def disableCache(self): return _func.NumericalMathEvaluationImplementationPointer_disableCache(self)
    def isCacheEnabled(self): return _func.NumericalMathEvaluationImplementationPointer_isCacheEnabled(self)
    def getCacheHits(self): return _func.NumericalMathEvaluationImplementationPointer_getCacheHits(self)
    def addCacheContent(self, *args): return _func.NumericalMathEvaluationImplementationPointer_addCacheContent(self, *args)
    def getCacheInput(self): return _func.NumericalMathEvaluationImplementationPointer_getCacheInput(self)
    def getCacheOutput(self): return _func.NumericalMathEvaluationImplementationPointer_getCacheOutput(self)
    def clearCache(self): return _func.NumericalMathEvaluationImplementationPointer_clearCache(self)
    def isActualImplementation(self): return _func.NumericalMathEvaluationImplementationPointer_isActualImplementation(self)
    def __call__(self, *args): return _func.NumericalMathEvaluationImplementationPointer___call__(self, *args)
    def getParameterDimension(self): return _func.NumericalMathEvaluationImplementationPointer_getParameterDimension(self)
    def getInputDimension(self): return _func.NumericalMathEvaluationImplementationPointer_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathEvaluationImplementationPointer_getOutputDimension(self)
    def getParametersDimension(self): return _func.NumericalMathEvaluationImplementationPointer_getParametersDimension(self)
    def getMarginal(self, *args): return _func.NumericalMathEvaluationImplementationPointer_getMarginal(self, *args)
    def parametersGradient(self, *args): return _func.NumericalMathEvaluationImplementationPointer_parametersGradient(self, *args)
    def getParameters(self): return _func.NumericalMathEvaluationImplementationPointer_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathEvaluationImplementationPointer_setParameters(self, *args)
    def getCallsNumber(self): return _func.NumericalMathEvaluationImplementationPointer_getCallsNumber(self)
    def draw(self, *args): return _func.NumericalMathEvaluationImplementationPointer_draw(self, *args)
    def __ne__(self, *args): return _func.NumericalMathEvaluationImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.NumericalMathEvaluationImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathEvaluationImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathEvaluationImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathEvaluationImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathEvaluationImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.NumericalMathEvaluationImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.NumericalMathEvaluationImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.NumericalMathEvaluationImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.NumericalMathEvaluationImplementationPointer_setName(self, *args)

NumericalMathEvaluationImplementationPointer_swigregister = _func.NumericalMathEvaluationImplementationPointer_swigregister
NumericalMathEvaluationImplementationPointer_swigregister(NumericalMathEvaluationImplementationPointer)

class NumericalMathFunctionImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathFunctionImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathFunctionImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _func.NumericalMathFunctionImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _func.NumericalMathFunctionImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_func.NumericalMathFunctionImplementationPointer_ptr__get, _func.NumericalMathFunctionImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _func.new_NumericalMathFunctionImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathFunctionImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _func.NumericalMathFunctionImplementationPointer_reset(self)
    def __ref__(self, *args): return _func.NumericalMathFunctionImplementationPointer___ref__(self, *args)
    def __deref__(self): return _func.NumericalMathFunctionImplementationPointer___deref__(self)
    def isNull(self): return _func.NumericalMathFunctionImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _func.NumericalMathFunctionImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.NumericalMathFunctionImplementationPointer_get(self)
    def getImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getImplementation(self)
    def unique(self): return _func.NumericalMathFunctionImplementationPointer_unique(self)
    def use_count(self): return _func.NumericalMathFunctionImplementationPointer_use_count(self)
    def swap(self, *args): return _func.NumericalMathFunctionImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathFunctionImplementationPointer_getClassName(self)

    def GetValidConstants(self): return _func.NumericalMathFunctionImplementationPointer_GetValidConstants(self)
    def GetValidFunctions(self): return _func.NumericalMathFunctionImplementationPointer_GetValidFunctions(self)
    def GetValidOperators(self): return _func.NumericalMathFunctionImplementationPointer_GetValidOperators(self)
    def __mul__(self, *args): return _func.NumericalMathFunctionImplementationPointer___mul__(self, *args)
    def __eq__(self, *args): return _func.NumericalMathFunctionImplementationPointer___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathFunctionImplementationPointer___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathFunctionImplementationPointer___str__(self, offset)
    def enableCache(self): return _func.NumericalMathFunctionImplementationPointer_enableCache(self)
    def disableCache(self): return _func.NumericalMathFunctionImplementationPointer_disableCache(self)
    def isCacheEnabled(self): return _func.NumericalMathFunctionImplementationPointer_isCacheEnabled(self)
    def getCacheHits(self): return _func.NumericalMathFunctionImplementationPointer_getCacheHits(self)
    def addCacheContent(self, *args): return _func.NumericalMathFunctionImplementationPointer_addCacheContent(self, *args)
    def getCacheInput(self): return _func.NumericalMathFunctionImplementationPointer_getCacheInput(self)
    def getCacheOutput(self): return _func.NumericalMathFunctionImplementationPointer_getCacheOutput(self)
    def clearCache(self): return _func.NumericalMathFunctionImplementationPointer_clearCache(self)
    def enableHistory(self): return _func.NumericalMathFunctionImplementationPointer_enableHistory(self)
    def disableHistory(self): return _func.NumericalMathFunctionImplementationPointer_disableHistory(self)
    def isHistoryEnabled(self): return _func.NumericalMathFunctionImplementationPointer_isHistoryEnabled(self)
    def clearHistory(self): return _func.NumericalMathFunctionImplementationPointer_clearHistory(self)
    def getHistoryInput(self): return _func.NumericalMathFunctionImplementationPointer_getHistoryInput(self)
    def getInputHistory(self): return _func.NumericalMathFunctionImplementationPointer_getInputHistory(self)
    def getHistoryOutput(self): return _func.NumericalMathFunctionImplementationPointer_getHistoryOutput(self)
    def getOutputHistory(self): return _func.NumericalMathFunctionImplementationPointer_getOutputHistory(self)
    def setEvaluation(self, *args): return _func.NumericalMathFunctionImplementationPointer_setEvaluation(self, *args)
    def getEvaluation(self): return _func.NumericalMathFunctionImplementationPointer_getEvaluation(self)
    def setEvaluationImplementation(self, *args): return _func.NumericalMathFunctionImplementationPointer_setEvaluationImplementation(self, *args)
    def getEvaluationImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getEvaluationImplementation(self)
    def setGradient(self, *args): return _func.NumericalMathFunctionImplementationPointer_setGradient(self, *args)
    def getGradient(self): return _func.NumericalMathFunctionImplementationPointer_getGradient(self)
    def setGradientImplementation(self, *args): return _func.NumericalMathFunctionImplementationPointer_setGradientImplementation(self, *args)
    def getGradientImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getGradientImplementation(self)
    def setHessian(self, *args): return _func.NumericalMathFunctionImplementationPointer_setHessian(self, *args)
    def getHessian(self): return _func.NumericalMathFunctionImplementationPointer_getHessian(self)
    def setHessianImplementation(self, *args): return _func.NumericalMathFunctionImplementationPointer_setHessianImplementation(self, *args)
    def getHessianImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getHessianImplementation(self)
    def getInitialEvaluationImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getInitialEvaluationImplementation(self)
    def getInitialGradientImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getInitialGradientImplementation(self)
    def getInitialHessianImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getInitialHessianImplementation(self)
    def getUseDefaultGradientImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getUseDefaultGradientImplementation(self)
    def setUseDefaultGradientImplementation(self, *args): return _func.NumericalMathFunctionImplementationPointer_setUseDefaultGradientImplementation(self, *args)
    def getUseDefaultHessianImplementation(self): return _func.NumericalMathFunctionImplementationPointer_getUseDefaultHessianImplementation(self)
    def setUseDefaultHessianImplementation(self, *args): return _func.NumericalMathFunctionImplementationPointer_setUseDefaultHessianImplementation(self, *args)
    def __call__(self, *args): return _func.NumericalMathFunctionImplementationPointer___call__(self, *args)
    def gradient(self, *args): return _func.NumericalMathFunctionImplementationPointer_gradient(self, *args)
    def hessian(self, *args): return _func.NumericalMathFunctionImplementationPointer_hessian(self, *args)
    def parametersGradient(self, *args): return _func.NumericalMathFunctionImplementationPointer_parametersGradient(self, *args)
    def getParameters(self): return _func.NumericalMathFunctionImplementationPointer_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathFunctionImplementationPointer_setParameters(self, *args)
    def getParameterDimension(self): return _func.NumericalMathFunctionImplementationPointer_getParameterDimension(self)
    def getInputDimension(self): return _func.NumericalMathFunctionImplementationPointer_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathFunctionImplementationPointer_getOutputDimension(self)
    def setDescription(self, *args): return _func.NumericalMathFunctionImplementationPointer_setDescription(self, *args)
    def getDescription(self): return _func.NumericalMathFunctionImplementationPointer_getDescription(self)
    def getInputDescription(self): return _func.NumericalMathFunctionImplementationPointer_getInputDescription(self)
    def getOutputDescription(self): return _func.NumericalMathFunctionImplementationPointer_getOutputDescription(self)
    def getMarginal(self, *args): return _func.NumericalMathFunctionImplementationPointer_getMarginal(self, *args)
    def getEvaluationCallsNumber(self): return _func.NumericalMathFunctionImplementationPointer_getEvaluationCallsNumber(self)
    def getGradientCallsNumber(self): return _func.NumericalMathFunctionImplementationPointer_getGradientCallsNumber(self)
    def getHessianCallsNumber(self): return _func.NumericalMathFunctionImplementationPointer_getHessianCallsNumber(self)
    def draw(self, *args): return _func.NumericalMathFunctionImplementationPointer_draw(self, *args)
    def __ne__(self, *args): return _func.NumericalMathFunctionImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.NumericalMathFunctionImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathFunctionImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathFunctionImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathFunctionImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathFunctionImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.NumericalMathFunctionImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.NumericalMathFunctionImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.NumericalMathFunctionImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.NumericalMathFunctionImplementationPointer_setName(self, *args)

NumericalMathFunctionImplementationPointer_swigregister = _func.NumericalMathFunctionImplementationPointer_swigregister
NumericalMathFunctionImplementationPointer_swigregister(NumericalMathFunctionImplementationPointer)

class NumericalMathGradientImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathGradientImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathGradientImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _func.NumericalMathGradientImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _func.NumericalMathGradientImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_func.NumericalMathGradientImplementationPointer_ptr__get, _func.NumericalMathGradientImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _func.new_NumericalMathGradientImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathGradientImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _func.NumericalMathGradientImplementationPointer_reset(self)
    def __ref__(self, *args): return _func.NumericalMathGradientImplementationPointer___ref__(self, *args)
    def __deref__(self): return _func.NumericalMathGradientImplementationPointer___deref__(self)
    def isNull(self): return _func.NumericalMathGradientImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _func.NumericalMathGradientImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.NumericalMathGradientImplementationPointer_get(self)
    def getImplementation(self): return _func.NumericalMathGradientImplementationPointer_getImplementation(self)
    def unique(self): return _func.NumericalMathGradientImplementationPointer_unique(self)
    def use_count(self): return _func.NumericalMathGradientImplementationPointer_use_count(self)
    def swap(self, *args): return _func.NumericalMathGradientImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathGradientImplementationPointer_getClassName(self)

    def __eq__(self, *args): return _func.NumericalMathGradientImplementationPointer___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathGradientImplementationPointer___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathGradientImplementationPointer___str__(self, offset)
    def getMarginal(self, *args): return _func.NumericalMathGradientImplementationPointer_getMarginal(self, *args)
    def isActualImplementation(self): return _func.NumericalMathGradientImplementationPointer_isActualImplementation(self)
    def gradient(self, *args): return _func.NumericalMathGradientImplementationPointer_gradient(self, *args)
    def getInputDimension(self): return _func.NumericalMathGradientImplementationPointer_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathGradientImplementationPointer_getOutputDimension(self)
    def getParameters(self): return _func.NumericalMathGradientImplementationPointer_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathGradientImplementationPointer_setParameters(self, *args)
    def getCallsNumber(self): return _func.NumericalMathGradientImplementationPointer_getCallsNumber(self)
    def __ne__(self, *args): return _func.NumericalMathGradientImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.NumericalMathGradientImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathGradientImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathGradientImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathGradientImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathGradientImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.NumericalMathGradientImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.NumericalMathGradientImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.NumericalMathGradientImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.NumericalMathGradientImplementationPointer_setName(self, *args)

NumericalMathGradientImplementationPointer_swigregister = _func.NumericalMathGradientImplementationPointer_swigregister
NumericalMathGradientImplementationPointer_swigregister(NumericalMathGradientImplementationPointer)

class NumericalMathHessianImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMathHessianImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMathHessianImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _func.NumericalMathHessianImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _func.NumericalMathHessianImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_func.NumericalMathHessianImplementationPointer_ptr__get, _func.NumericalMathHessianImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _func.new_NumericalMathHessianImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_NumericalMathHessianImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _func.NumericalMathHessianImplementationPointer_reset(self)
    def __ref__(self, *args): return _func.NumericalMathHessianImplementationPointer___ref__(self, *args)
    def __deref__(self): return _func.NumericalMathHessianImplementationPointer___deref__(self)
    def isNull(self): return _func.NumericalMathHessianImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _func.NumericalMathHessianImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.NumericalMathHessianImplementationPointer_get(self)
    def getImplementation(self): return _func.NumericalMathHessianImplementationPointer_getImplementation(self)
    def unique(self): return _func.NumericalMathHessianImplementationPointer_unique(self)
    def use_count(self): return _func.NumericalMathHessianImplementationPointer_use_count(self)
    def swap(self, *args): return _func.NumericalMathHessianImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.NumericalMathHessianImplementationPointer_getClassName(self)

    def __eq__(self, *args): return _func.NumericalMathHessianImplementationPointer___eq__(self, *args)
    def __repr__(self): return _func.NumericalMathHessianImplementationPointer___repr__(self)
    def __str__(self, offset=""): return _func.NumericalMathHessianImplementationPointer___str__(self, offset)
    def isActualImplementation(self): return _func.NumericalMathHessianImplementationPointer_isActualImplementation(self)
    def getMarginal(self, *args): return _func.NumericalMathHessianImplementationPointer_getMarginal(self, *args)
    def hessian(self, *args): return _func.NumericalMathHessianImplementationPointer_hessian(self, *args)
    def getInputDimension(self): return _func.NumericalMathHessianImplementationPointer_getInputDimension(self)
    def getOutputDimension(self): return _func.NumericalMathHessianImplementationPointer_getOutputDimension(self)
    def getParameters(self): return _func.NumericalMathHessianImplementationPointer_getParameters(self)
    def setParameters(self, *args): return _func.NumericalMathHessianImplementationPointer_setParameters(self, *args)
    def getCallsNumber(self): return _func.NumericalMathHessianImplementationPointer_getCallsNumber(self)
    def __ne__(self, *args): return _func.NumericalMathHessianImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.NumericalMathHessianImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathHessianImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.NumericalMathHessianImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathHessianImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.NumericalMathHessianImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.NumericalMathHessianImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.NumericalMathHessianImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.NumericalMathHessianImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.NumericalMathHessianImplementationPointer_setName(self, *args)

NumericalMathHessianImplementationPointer_swigregister = _func.NumericalMathHessianImplementationPointer_swigregister
NumericalMathHessianImplementationPointer_swigregister(NumericalMathHessianImplementationPointer)

class UniVariatePolynomialImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, UniVariatePolynomialImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, UniVariatePolynomialImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _func.UniVariatePolynomialImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _func.UniVariatePolynomialImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_func.UniVariatePolynomialImplementationPointer_ptr__get, _func.UniVariatePolynomialImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _func.new_UniVariatePolynomialImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _func.delete_UniVariatePolynomialImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _func.UniVariatePolynomialImplementationPointer_reset(self)
    def __ref__(self, *args): return _func.UniVariatePolynomialImplementationPointer___ref__(self, *args)
    def __deref__(self): return _func.UniVariatePolynomialImplementationPointer___deref__(self)
    def isNull(self): return _func.UniVariatePolynomialImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _func.UniVariatePolynomialImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _func.UniVariatePolynomialImplementationPointer_get(self)
    def getImplementation(self): return _func.UniVariatePolynomialImplementationPointer_getImplementation(self)
    def unique(self): return _func.UniVariatePolynomialImplementationPointer_unique(self)
    def use_count(self): return _func.UniVariatePolynomialImplementationPointer_use_count(self)
    def swap(self, *args): return _func.UniVariatePolynomialImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _func.UniVariatePolynomialImplementationPointer_getClassName(self)

    def __repr__(self): return _func.UniVariatePolynomialImplementationPointer___repr__(self)
    def __str__(self, *args): return _func.UniVariatePolynomialImplementationPointer___str__(self, *args)
    def __call__(self, *args): return _func.UniVariatePolynomialImplementationPointer___call__(self, *args)
    def derivative(self, *args):
        """
        Compute the first-order derivative polynomial at point :math:`x`.

        Parameters
        ----------
        x : float
            Polynomial input.

        Returns
        -------
        derivative_value : float
            The value of the polynomial's first-order derivative at point :math:`x`.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.derivative(1.))
        8.0
        """
        return _func.UniVariatePolynomialImplementationPointer_derivative(self, *args)

    def derivate(self):
        """
        Build the first-order derivative polynomial.

        Returns
        -------
        derivated_polynomial : :class:`~openturns.Univariate`
            The first-order derivated polynomial.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.derivate())
        2 + 6 * X
        """
        return _func.UniVariatePolynomialImplementationPointer_derivate(self)

    def __mul__(self, *args): return _func.UniVariatePolynomialImplementationPointer___mul__(self, *args)
    def incrementDegree(self, degree=1):
        """
        Multiply the polynomial by :math:`x^k`.

        Parameters
        ----------
        degree : int, optional
            The incremented degree :math:`k`.
            Default uses :math:`k = 1`.

        Returns
        -------
        incremented_degree_polynomial : :class:`~openturns.UniVariatePolynomial`
            Polynomial with incremented degree.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.incrementDegree())
        X + 2 * X^2 + 3 * X^3
        >>> print(P.incrementDegree(2))
        X^2 + 2 * X^3 + 3 * X^4
        """
        return _func.UniVariatePolynomialImplementationPointer_incrementDegree(self, degree)

    def __add__(self, *args): return _func.UniVariatePolynomialImplementationPointer___add__(self, *args)
    def __sub__(self, *args): return _func.UniVariatePolynomialImplementationPointer___sub__(self, *args)
    def setCoefficients(self, *args):
        """
        Accessor to the polynomials's coefficients.

        Parameters
        ----------
        coefficients : :class:`~openturns.NumericalPoint`, 1d array, tuple or list
            Polynomial coefficients in increasing polynomial order.

        See Also
        --------
        getCoefficients

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> P.setCoefficients([4., 2., 1.])
        >>> print(P)
        4 + 2 * X + X^2
        """
        return _func.UniVariatePolynomialImplementationPointer_setCoefficients(self, *args)

    def getCoefficients(self):
        """
        Accessor to the polynomials's coefficients.

        Returns
        -------
        coefficients : :class:`~openturns.NumericalPoint`
            Polynomial coefficients in increasing polynomial order.

        See Also
        --------
        setCoefficients

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getCoefficients())
        [1,2,3]
        """
        return _func.UniVariatePolynomialImplementationPointer_getCoefficients(self)

    def getDegree(self):
        """
        Accessor to the polynomials's degree.

        Returns
        -------
        degree : int
            Polynomial's degree.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getDegree())
        2
        """
        return _func.UniVariatePolynomialImplementationPointer_getDegree(self)

    def getRoots(self):
        """
        Compute the roots of the polynomial.

        Returns
        -------
        roots : list of complex values
            Polynomial's roots.

        Examples
        --------
        >>> import openturns as ot
        >>> P = ot.UniVariatePolynomial([1., 2., 3.])
        >>> print(P.getRoots())
        [(-0.333333,0.471405),(-0.333333,-0.471405)]
        """
        return _func.UniVariatePolynomialImplementationPointer_getRoots(self)

    def draw(self, *args):
        """
        Draw the polynomial.

        Parameters
        ----------
        x_min : float, optional
            The starting value that is used for meshing the x-axis.
        x_max : float, optional, :math:`x_{\\max} > x_{\\min}`
            The ending value that is used for meshing the x-axis.
        n_points : int, optional
            The number of points that is used for meshing the x-axis.

        Examples
        --------
        >>> import openturns as ot
        >>> from openturns.viewer import View
        >>> P = ot.UniVariatePolynomial([1., 2., -3., 5.])
        >>> View(P.draw(-10., 10., 100)).show()
        """
        return _func.UniVariatePolynomialImplementationPointer_draw(self, *args)

    def __eq__(self, *args): return _func.UniVariatePolynomialImplementationPointer___eq__(self, *args)
    def __ne__(self, *args): return _func.UniVariatePolynomialImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _func.UniVariatePolynomialImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _func.UniVariatePolynomialImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _func.UniVariatePolynomialImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _func.UniVariatePolynomialImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _func.UniVariatePolynomialImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _func.UniVariatePolynomialImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _func.UniVariatePolynomialImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _func.UniVariatePolynomialImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _func.UniVariatePolynomialImplementationPointer_setName(self, *args)

UniVariatePolynomialImplementationPointer_swigregister = _func.UniVariatePolynomialImplementationPointer_swigregister
UniVariatePolynomialImplementationPointer_swigregister(UniVariatePolynomialImplementationPointer)

# This file is compatible with both classic and new-style classes.


