# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""
Statistical classes.
"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_statistics', [dirname(__file__)])
        except ImportError:
            import _statistics
            return _statistics
        if fp is not None:
            try:
                _mod = imp.load_module('_statistics', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _statistics = swig_import_helper()
    del swig_import_helper
else:
    import _statistics
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _statistics.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self): return _statistics.SwigPyIterator_value(self)
    def incr(self, n=1): return _statistics.SwigPyIterator_incr(self, n)
    def decr(self, n=1): return _statistics.SwigPyIterator_decr(self, n)
    def distance(self, *args): return _statistics.SwigPyIterator_distance(self, *args)
    def equal(self, *args): return _statistics.SwigPyIterator_equal(self, *args)
    def copy(self): return _statistics.SwigPyIterator_copy(self)
    def next(self): return _statistics.SwigPyIterator_next(self)
    def __next__(self): return _statistics.SwigPyIterator___next__(self)
    def previous(self): return _statistics.SwigPyIterator_previous(self)
    def advance(self, *args): return _statistics.SwigPyIterator_advance(self, *args)
    def __eq__(self, *args): return _statistics.SwigPyIterator___eq__(self, *args)
    def __ne__(self, *args): return _statistics.SwigPyIterator___ne__(self, *args)
    def __iadd__(self, *args): return _statistics.SwigPyIterator___iadd__(self, *args)
    def __isub__(self, *args): return _statistics.SwigPyIterator___isub__(self, *args)
    def __add__(self, *args): return _statistics.SwigPyIterator___add__(self, *args)
    def __sub__(self, *args): return _statistics.SwigPyIterator___sub__(self, *args)
    def __iter__(self): return self
SwigPyIterator_swigregister = _statistics.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

GCC_VERSION = _statistics.GCC_VERSION
class TestFailed:
    """TestFailed is used to raise an uniform exception in tests."""

    __type = "TestFailed"

    def __init__(self, reason=""):
        self.reason = reason

    def type(self):
        return TestFailed.__type

    def what(self):
        return self.reason

    def __str__(self):
        return TestFailed.__type + ": " + self.reason

    def __lshift__(self, ch):
        self.reason += ch
        return self

import openturns.common
import openturns.wrapper
import openturns.typ
import openturns.graph
import openturns.func
import openturns.geom
class LevelSet(openturns.typ.DomainImplementation):
    """
    Level set.

    Available constructors:
        LevelSet(*dim=1*)

        LevelSet(*function=ot.NumericalMathFunction('x', '1.'), level=0.*)

    Parameters
    ----------
    dim : int, :math:`dim \\geq 0`
        Dimension of the LevelSet.
    function : :class:`~openturns.NumericalMathFunction`
        A function such that: :math:`f: \\Rset^{dim} \\mapsto \\Rset` defining the
        LevelSet.
    level : float
        Level :math:`s` defining the LevelSet.

    Notes
    -----
    A LevelSet is a :class:`~openturns.Domain` defined as follows:

    .. math::

        \\{ \\vect{x} \\in \\Rset^{dim} \\, | \\, f(\\vect{x}) \\leq s \\}

    Examples
    --------
    >>> import openturns as ot
    >>> function = ot.NumericalMathFunction(['x1', 'x2'], ['x1^4 + x2^4'])
    >>> s = 1.0
    >>> levelSet = ot.LevelSet(function, s)
    """
    __swig_setmethods__ = {}
    for _s in [openturns.typ.DomainImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LevelSet, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.typ.DomainImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LevelSet, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.LevelSet_getClassName(self)

    def contains(self, *args):
        """
        Check if the given point is inside of the domain.

        Parameters
        ----------
        point : float sequence
            Point with the same dimension as the current domain's dimension.

        Returns
        -------
        isInside : Bool
            Flag telling whether the given point is inside of the domain.
        """
        return _statistics.LevelSet_contains(self, *args)

    def intersect(self, *args):
        """
        Return the levelSet equals to the intersection between the LevelSet and another one.

        Parameters
        ----------
        otherLevelSet :
            A LevelSet defined by :math:`(f_2, s_2)`.

        Returns
        -------
        levelSet : :class:`~openturns.LevelSet`
            *levelSet* equals to the intersection between the LevelSet and
            *otherLevelSet* i.e. *levelSet* is defined by:
            :math:`\\{\\vect{x} \\in \\Rset^{dim} | f(\\vect{x}) \\leq s \\, \\mbox{and} \\, f_2(\\vect{x}) \\leq s_2\\}`.

        Examples
        --------
        >>> import openturns as ot
        >>> # First level set
        >>> function = ot.NumericalMathFunction(['x'], ['3*x-1'])
        >>> levelSet1 = ot.LevelSet(function, 0.5)
        >>> # Second level set
        >>> function = ot.NumericalMathFunction(['x'], ['x'])
        >>> levelSet2 = ot.LevelSet(function, 0.5)
        >>> # Intersection between levelSet1 and levelSet2
        >>> intersection = levelSet1.intersect(levelSet2)
        >>> # Tests
        >>> print(intersection.contains([1.]))
        False
        >>> print(intersection.contains([0.25]))
        True
        """
        return _statistics.LevelSet_intersect(self, *args)

    def join(self, *args):
        """
        Return the levelSet equals to the union between the LevelSet and another one.

        Parameters
        ----------
        otherLevelSet :
            A LevelSet defined by :math:`(f_2, s_2)`.

        Returns
        -------
        levelSet : :class:`~openturns.LevelSet`
            *levelSet* equals to the union between the LevelSet and *otherLevelSet*
            i.e. *levelSet* is defined by:
            :math:`\\{\\vect{x} \\in \\Rset^{dim} | f(\\vect{x}) \\leq s \\, \\mbox{or} \\, f_2(\\vect{x}) \\leq s_2\\}`.

        Examples
        --------
        >>> import openturns as ot
        >>> # First level set
        >>> function = ot.NumericalMathFunction(['x'], ['3*x-1'])
        >>> levelSet1 = ot.LevelSet(function, 0.)
        >>> # Second level set
        >>> function = ot.NumericalMathFunction(['x'], ['x'])
        >>> levelSet2 = ot.LevelSet(function, 0.)
        >>> # Union between levelSet1 and levelSet2
        >>> join = levelSet1.join(levelSet2)
        >>> # Tests
        >>> print(join.contains([0.5]))
        False
        >>> print(join.contains([0.25]))
        True
        """
        return _statistics.LevelSet_join(self, *args)

    def __eq__(self, *args): return _statistics.LevelSet___eq__(self, *args)
    def getFunction(self):
        """
        Get the function defining the level set.

        Returns
        -------
        function : :class:`~openturns.NumericalMathFunction`
            A function such that: :math:`f: \\Rset^{dim} \\mapsto \\Rset` defining the
            LevelSet.

        Examples
        --------
        >>> import openturns as ot
        >>> function = ot.NumericalMathFunction(['x'], ['3*x-1'])
        >>> levelSet = ot.LevelSet(function, 0.)
        >>> print(levelSet.getFunction().getEvaluationImplementation())
        [x]->[3*x-1]
        """
        return _statistics.LevelSet_getFunction(self)

    def setFunction(self, *args):
        """
        Set the function defining the level set.

        Parameters
        ----------
        function : :class:`~openturns.NumericalMathFunction`
            A function such that: :math:`f: \\Rset^{dim} \\mapsto \\Rset` defining the
            LevelSet.

        Examples
        --------
        >>> import openturns as ot
        >>> levelSet = ot.LevelSet()
        >>> function = ot.NumericalMathFunction(['x'], ['3*x-1'])
        >>> levelSet.setFunction(function)
        """
        return _statistics.LevelSet_setFunction(self, *args)

    def getLevel(self):
        """
        Get the level defining the level set.

        Returns
        -------
        level : float
            Level :math:`s` defining the LevelSet.

        Examples
        --------
        >>> import openturns as ot
        >>> function = ot.NumericalMathFunction(['x'], ['3*x-1'])
        >>> levelSet = ot.LevelSet(function, 0.)
        >>> print(levelSet.getLevel())
        0.0
        """
        return _statistics.LevelSet_getLevel(self)

    def setLevel(self, *args):
        """
        Set the level defining the level set.

        Parameters
        ----------
        level : float
            Level :math:`s` defining the LevelSet.

        Examples
        --------
        >>> import openturns as ot
        >>> levelSet = ot.LevelSet()
        >>> levelSet.setLevel(3.)
        """
        return _statistics.LevelSet_setLevel(self, *args)

    def __repr__(self): return _statistics.LevelSet___repr__(self)
    def __str__(self, offset=""): return _statistics.LevelSet___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_LevelSet(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_LevelSet
    __del__ = lambda self : None;
LevelSet_swigregister = _statistics.LevelSet_swigregister
LevelSet_swigregister(LevelSet)

class Compact(openturns.typ.HistoryStrategyImplementation):
    __swig_setmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Compact, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Compact, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.Compact_getClassName(self)

    def store(self, *args): return _statistics.Compact_store(self, *args)
    def getSample(self): return _statistics.Compact_getSample(self)
    def getHalfMaximumSize(self): return _statistics.Compact_getHalfMaximumSize(self)
    def getIndex(self): return _statistics.Compact_getIndex(self)
    def __repr__(self): return _statistics.Compact___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_Compact(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_Compact
    __del__ = lambda self : None;
Compact_swigregister = _statistics.Compact_swigregister
Compact_swigregister(Compact)

class Full(openturns.typ.HistoryStrategyImplementation):
    __swig_setmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Full, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Full, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.Full_getClassName(self)

    def store(self, *args): return _statistics.Full_store(self, *args)
    def __repr__(self): return _statistics.Full___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_Full(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_Full
    __del__ = lambda self : None;
Full_swigregister = _statistics.Full_swigregister
Full_swigregister(Full)

class Last(openturns.typ.HistoryStrategyImplementation):
    __swig_setmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Last, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Last, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.Last_getClassName(self)

    def store(self, *args): return _statistics.Last_store(self, *args)
    def getSample(self): return _statistics.Last_getSample(self)
    def getMaximumSize(self): return _statistics.Last_getMaximumSize(self)
    def getIndex(self): return _statistics.Last_getIndex(self)
    def getHasWrapped(self): return _statistics.Last_getHasWrapped(self)
    def __repr__(self): return _statistics.Last___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_Last(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_Last
    __del__ = lambda self : None;
Last_swigregister = _statistics.Last_swigregister
Last_swigregister(Last)

class Null(openturns.typ.HistoryStrategyImplementation):
    __swig_setmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Null, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.typ.HistoryStrategyImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Null, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.Null_getClassName(self)

    def store(self, *args): return _statistics.Null_store(self, *args)
    def __repr__(self): return _statistics.Null___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_Null(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_Null
    __del__ = lambda self : None;
Null_swigregister = _statistics.Null_swigregister
Null_swigregister(Null)

class ConfidenceInterval(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConfidenceInterval, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ConfidenceInterval, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.ConfidenceInterval_getClassName(self)

    def setDescription(self, *args): return _statistics.ConfidenceInterval_setDescription(self, *args)
    def getDescription(self): return _statistics.ConfidenceInterval_getDescription(self)
    def __repr__(self): return _statistics.ConfidenceInterval___repr__(self)
    def setValues(self, *args): return _statistics.ConfidenceInterval_setValues(self, *args)
    def getFirst(self): return _statistics.ConfidenceInterval_getFirst(self)
    def getLast(self): return _statistics.ConfidenceInterval_getLast(self)
    def __eq__(self, *args): return _statistics.ConfidenceInterval___eq__(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_ConfidenceInterval(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_ConfidenceInterval
    __del__ = lambda self : None;
ConfidenceInterval_swigregister = _statistics.ConfidenceInterval_swigregister
ConfidenceInterval_swigregister(ConfidenceInterval)

class ConfidenceIntervalCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ConfidenceIntervalCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ConfidenceIntervalCollection, name)
    __swig_destroy__ = _statistics.delete_ConfidenceIntervalCollection
    __del__ = lambda self : None;
    def clear(self): return _statistics.ConfidenceIntervalCollection_clear(self)
    def __len__(self): return _statistics.ConfidenceIntervalCollection___len__(self)
    def __eq__(self, *args): return _statistics.ConfidenceIntervalCollection___eq__(self, *args)
    def __contains__(self, *args): return _statistics.ConfidenceIntervalCollection___contains__(self, *args)
    def __getitem__(self, *args): return _statistics.ConfidenceIntervalCollection___getitem__(self, *args)
    def __setitem__(self, *args): return _statistics.ConfidenceIntervalCollection___setitem__(self, *args)
    def __delitem__(self, *args): return _statistics.ConfidenceIntervalCollection___delitem__(self, *args)
    def at(self, *args): return _statistics.ConfidenceIntervalCollection_at(self, *args)
    def add(self, *args): return _statistics.ConfidenceIntervalCollection_add(self, *args)
    def getSize(self): return _statistics.ConfidenceIntervalCollection_getSize(self)
    def resize(self, *args): return _statistics.ConfidenceIntervalCollection_resize(self, *args)
    def isEmpty(self): return _statistics.ConfidenceIntervalCollection_isEmpty(self)
    def __repr__(self): return _statistics.ConfidenceIntervalCollection___repr__(self)
    def __str__(self, offset=""): return _statistics.ConfidenceIntervalCollection___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_ConfidenceIntervalCollection(*args)
        try: self.this.append(this)
        except: self.this = this
ConfidenceIntervalCollection_swigregister = _statistics.ConfidenceIntervalCollection_swigregister
ConfidenceIntervalCollection_swigregister(ConfidenceIntervalCollection)

class LinearModel(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearModel, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.LinearModel_getClassName(self)

    def __repr__(self): return _statistics.LinearModel___repr__(self)
    def __str__(self, offset=""): return _statistics.LinearModel___str__(self, offset)
    def getRegression(self): return _statistics.LinearModel_getRegression(self)
    def getConfidenceIntervals(self): return _statistics.LinearModel_getConfidenceIntervals(self)
    def getPValues(self): return _statistics.LinearModel_getPValues(self)
    def getPredicted(self, *args): return _statistics.LinearModel_getPredicted(self, *args)
    def getResidual(self, *args): return _statistics.LinearModel_getResidual(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_LinearModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_LinearModel
    __del__ = lambda self : None;
LinearModel_swigregister = _statistics.LinearModel_swigregister
LinearModel_swigregister(LinearModel)


def LinearModel_operator___eq__(*args):
  return _statistics.LinearModel_operator___eq__(*args)
LinearModel_operator___eq__ = _statistics.LinearModel_operator___eq__
class LinearModelFactory(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearModelFactory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LinearModelFactory, name)
    __repr__ = _swig_repr
    def build(self, *args): return _statistics.LinearModelFactory_build(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_LinearModelFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_LinearModelFactory
    __del__ = lambda self : None;
LinearModelFactory_swigregister = _statistics.LinearModelFactory_swigregister
LinearModelFactory_swigregister(LinearModelFactory)

class TestResultCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, TestResultCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, TestResultCollection, name)
    __swig_destroy__ = _statistics.delete_TestResultCollection
    __del__ = lambda self : None;
    def clear(self): return _statistics.TestResultCollection_clear(self)
    def __len__(self): return _statistics.TestResultCollection___len__(self)
    def __eq__(self, *args): return _statistics.TestResultCollection___eq__(self, *args)
    def __contains__(self, *args): return _statistics.TestResultCollection___contains__(self, *args)
    def __getitem__(self, *args): return _statistics.TestResultCollection___getitem__(self, *args)
    def __setitem__(self, *args): return _statistics.TestResultCollection___setitem__(self, *args)
    def __delitem__(self, *args): return _statistics.TestResultCollection___delitem__(self, *args)
    def at(self, *args): return _statistics.TestResultCollection_at(self, *args)
    def add(self, *args): return _statistics.TestResultCollection_add(self, *args)
    def getSize(self): return _statistics.TestResultCollection_getSize(self)
    def resize(self, *args): return _statistics.TestResultCollection_resize(self, *args)
    def isEmpty(self): return _statistics.TestResultCollection_isEmpty(self)
    def __repr__(self): return _statistics.TestResultCollection___repr__(self)
    def __str__(self, offset=""): return _statistics.TestResultCollection___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_TestResultCollection(*args)
        try: self.this.append(this)
        except: self.this = this
TestResultCollection_swigregister = _statistics.TestResultCollection_swigregister
TestResultCollection_swigregister(TestResultCollection)

class TestResult(openturns.common.PersistentObject):
    """
    Test result data structure.

    .. warning::

        Tests results are not intended to be created manually. They are returned
        by the statistical tests implemented in the :mod:`~openturns.stattests`
        subpackage. Constructor is therefore intentionally not documented.

    Notes
    -----
    The p-value of a test can be seen as the probability of observing a sample
    having a worst or equal statistic than the one that has been calculated on the
    tested sample, under the null hypothesis. This is the metric that is used for
    concluding the test with respect to the given accepted risk of committing a
    Type I error, that is an incorrect rejection of a true null hypothesis.

    Examples
    --------
    >>> import openturns as ot
    >>> ot.RandomGenerator.SetSeed(0)
    >>> distribution = ot.Normal()
    >>> sample = distribution.getSample(30)
    >>> test_result = ot.FittingTest_Kolmogorov(sample, ot.NormalFactory(), .99)
    >>> print(test_result.getPValue())
    0.846896...
    >>> print(test_result.getThreshold())
    0.01...
    >>> print(test_result.getBinaryQualityMeasure())
    True
    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TestResult, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TestResult, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.TestResult_getClassName(self)

    def setDescription(self, *args): return _statistics.TestResult_setDescription(self, *args)
    def getDescription(self): return _statistics.TestResult_getDescription(self)
    def __repr__(self): return _statistics.TestResult___repr__(self)
    def getBinaryQualityMeasure(self):
        """
        Accessor to the test's binary conclusion.

        Returns
        -------
        binary_measure : bool, optional
            Test conclusion: `False` if it can reject the null hypothesis, `True` if
            it cannot.
        """
        return _statistics.TestResult_getBinaryQualityMeasure(self)

    def getPValue(self):
        """
        Accessor to the test's p-value.

        Returns
        -------
        p_value : float, :math:`0 \\leq p \\leq 1`
            The test's p-value.
        """
        return _statistics.TestResult_getPValue(self)

    def getThreshold(self):
        """
        Accessor to the accepted risk of committing a Type I error.

        Returns
        -------
        threshold : float, :math:`0 \\leq \\alpha \\leq 1`
            Accepted risk of committing a Type I error.
        """
        return _statistics.TestResult_getThreshold(self)

    def getTestType(self): return _statistics.TestResult_getTestType(self)
    def __eq__(self, *args): return _statistics.TestResult___eq__(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_TestResult(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_TestResult
    __del__ = lambda self : None;
TestResult_swigregister = _statistics.TestResult_swigregister
TestResult_swigregister(TestResult)

class RandomGeneratorState(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RandomGeneratorState, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RandomGeneratorState, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.RandomGeneratorState_getClassName(self)

    def __repr__(self): return _statistics.RandomGeneratorState___repr__(self)
    def __str__(self, offset=""): return _statistics.RandomGeneratorState___str__(self, offset)
    def getBuffer(self): return _statistics.RandomGeneratorState_getBuffer(self)
    def getIndex(self): return _statistics.RandomGeneratorState_getIndex(self)
    def __init__(self, *args): 
        this = _statistics.new_RandomGeneratorState(*args)
        try: self.this.append(this)
        except: self.this = this
    def __eq__(self, *args): return _statistics.RandomGeneratorState___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_RandomGeneratorState
    __del__ = lambda self : None;
RandomGeneratorState_swigregister = _statistics.RandomGeneratorState_swigregister
RandomGeneratorState_swigregister(RandomGeneratorState)

class RandomGenerator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, RandomGenerator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, RandomGenerator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_getmethods__["SetSeed"] = lambda x: _statistics.RandomGenerator_SetSeed
    if _newclass:SetSeed = staticmethod(_statistics.RandomGenerator_SetSeed)
    __swig_getmethods__["SetState"] = lambda x: _statistics.RandomGenerator_SetState
    if _newclass:SetState = staticmethod(_statistics.RandomGenerator_SetState)
    __swig_getmethods__["GetState"] = lambda x: _statistics.RandomGenerator_GetState
    if _newclass:GetState = staticmethod(_statistics.RandomGenerator_GetState)
    __swig_getmethods__["Generate"] = lambda x: _statistics.RandomGenerator_Generate
    if _newclass:Generate = staticmethod(_statistics.RandomGenerator_Generate)
    __swig_getmethods__["IntegerGenerate"] = lambda x: _statistics.RandomGenerator_IntegerGenerate
    if _newclass:IntegerGenerate = staticmethod(_statistics.RandomGenerator_IntegerGenerate)
    __swig_destroy__ = _statistics.delete_RandomGenerator
    __del__ = lambda self : None;
RandomGenerator_swigregister = _statistics.RandomGenerator_swigregister
RandomGenerator_swigregister(RandomGenerator)

def RandomGenerator_SetSeed(*args):
  return _statistics.RandomGenerator_SetSeed(*args)
RandomGenerator_SetSeed = _statistics.RandomGenerator_SetSeed

def RandomGenerator_SetState(*args):
  return _statistics.RandomGenerator_SetState(*args)
RandomGenerator_SetState = _statistics.RandomGenerator_SetState

def RandomGenerator_GetState():
  return _statistics.RandomGenerator_GetState()
RandomGenerator_GetState = _statistics.RandomGenerator_GetState

def RandomGenerator_Generate(*args):
  return _statistics.RandomGenerator_Generate(*args)
RandomGenerator_Generate = _statistics.RandomGenerator_Generate

def RandomGenerator_IntegerGenerate(*args):
  return _statistics.RandomGenerator_IntegerGenerate(*args)
RandomGenerator_IntegerGenerate = _statistics.RandomGenerator_IntegerGenerate

class LowDiscrepancySequenceImplementation(openturns.common.PersistentObject):
    """
    Base class to generate low discrepancy sequences.

    Available constructors:
        LowDiscrepancySequence(*dimension=1*)

    Parameters
    ----------
    dimension : int
        Dimension of the points of the low discrepancy sequence.

    Notes
    -----
    The low discrepancy sequences, also called 'quasi-random' sequences, are a
    deterministic alternative to random sequences for use in Monte Carlo methods.
    These sequences are sets of equidistributed points which the error in uniformity
    is measured by its discrepancy.

    The **discrepancy** of a set :math:`P = \\{x_1, \\hdots, x_N\\}` is defined,
    using Niederreiter's notation, as:

    .. math::

        D_N(P) = \\sup_{B\\in J} \\left| \\frac{A(B;P)}{N} - \\lambda_s(B) \\right|

    where :math:`\\lambda_s` is the s-dimensional Lebesgue measure, :math:`A(B;P)`
    is the number of points in :math:`P` that fall into :math:`B`, and :math:`J` is
    the set of s-dimensional intervals or boxes of the form:

    .. math::

        \\prod_{i=1}^s [a_i, b_i) = \\{ \\mathbf{x} \\in \\mathbf{R}^s : a_i \\le x_i < b_i \\} \\,

    where :math:`0 \\le a_i < b_i \\le 1`.

    The star-discrepancy :math:`D_N^*(P)` is defined similarly, except that the
    supremum is taken over the set :math:`J^*` of intervals of the form:

    .. math::

        \\prod_{i=1}^s [0, u_i)

    where :math:`u_i` is in the half-open interval :math:`[0, 1)`.

    A low-discrepancy sequence can be generated only through the derived classes of
    LowDiscrepancySequence. OpenTURNS proposes the
    :class:`Faure <openturns.FaureSequence>`,
    :class:`Halton <openturns.HaltonSequence>`,
    :class:`Reverse Halton <openturns.ReverseHaltonSequence>`,
    :class:`Haselgrove <openturns.HaselgroveSequence>` and
    :class:`Sobol <openturns.SobolSequence>` sequences.

    Examples
    --------
    >>> import openturns as ot
    >>> # Create a sequence of 3 points of 2 dimensions
    >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
    >>> print(sequence.generate(3))
    0 : [ 0.5  0.5  ]
    1 : [ 0.75 0.25 ]
    2 : [ 0.25 0.75 ]
    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LowDiscrepancySequenceImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LowDiscrepancySequenceImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.LowDiscrepancySequenceImplementation_getClassName(self)

    def initialize(self, *args):
        """
        Initialize the sequence.

        Parameters
        ----------
        dimension : int
            Dimension of the points of the low discrepancy sequence.

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        >>> print(sequence.generate(3))
        0 : [ 0.375 0.375 ]
        1 : [ 0.875 0.875 ]
        2 : [ 0.625 0.125 ]
        >>> sequence.initialize(2)
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.LowDiscrepancySequenceImplementation_initialize(self, *args)

    def getDimension(self):
        """
        Accessor to the dimension of the points of the low discrepancy sequence.

        Returns
        -------
        dimension : int
            Dimension of the points of the low discrepancy sequence.
        """
        return _statistics.LowDiscrepancySequenceImplementation_getDimension(self)

    def generate(self, *args):
        """
        Generate a sample of pseudo-random vectors of numbers uniformly distributed over [0, 1).

        Parameters
        ----------
        size : int
            Number of points to be generated. Default is 1.

        Returns
        -------
        sample : 2D float sequence
            Sample of pseudo-random vectors of numbers uniformly distributed over
            [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.LowDiscrepancySequenceImplementation_generate(self, *args)

    def ComputeStarDiscrepancy(*args):
        """
        Compute the star discrepancy of a sample uniformly distributed over [0, 1).

        Parameters
        ----------
        sample : 2D float sequence

        Returns
        -------
        starDiscrepancy : float
            Star discrepancy of a sample uniformly distributed over [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> sample = sequence.generate(16)
        >>> print(sequence.computeStarDiscrepancy(sample))
        0.12890625
        >>> sample = sequence.generate(64)
        >>> print(sequence.computeStarDiscrepancy(sample))
        0.0537109375
        """
        return _statistics.LowDiscrepancySequenceImplementation_ComputeStarDiscrepancy(*args)

    if _newclass:ComputeStarDiscrepancy = staticmethod(ComputeStarDiscrepancy)
    __swig_getmethods__["ComputeStarDiscrepancy"] = lambda x: ComputeStarDiscrepancy
    def __repr__(self): return _statistics.LowDiscrepancySequenceImplementation___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_LowDiscrepancySequenceImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_LowDiscrepancySequenceImplementation
    __del__ = lambda self : None;
LowDiscrepancySequenceImplementation_swigregister = _statistics.LowDiscrepancySequenceImplementation_swigregister
LowDiscrepancySequenceImplementation_swigregister(LowDiscrepancySequenceImplementation)

def LowDiscrepancySequenceImplementation_ComputeStarDiscrepancy(*args):
  """
    Compute the star discrepancy of a sample uniformly distributed over [0, 1).

    Parameters
    ----------
    sample : 2D float sequence

    Returns
    -------
    starDiscrepancy : float
        Star discrepancy of a sample uniformly distributed over [0, 1).

    Examples
    --------
    >>> import openturns as ot
    >>> # Create a sequence of 3 points of 2 dimensions
    >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
    >>> sample = sequence.generate(16)
    >>> print(sequence.computeStarDiscrepancy(sample))
    0.12890625
    >>> sample = sequence.generate(64)
    >>> print(sequence.computeStarDiscrepancy(sample))
    0.0537109375
    """
  return _statistics.LowDiscrepancySequenceImplementation_ComputeStarDiscrepancy(*args)

class LowDiscrepancySequenceImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LowDiscrepancySequenceImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LowDiscrepancySequenceImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_LowDiscrepancySequenceImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.LowDiscrepancySequenceImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.LowDiscrepancySequenceImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.LowDiscrepancySequenceImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.LowDiscrepancySequenceImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_LowDiscrepancySequenceImplementationTypedInterfaceObject
    __del__ = lambda self : None;
LowDiscrepancySequenceImplementationTypedInterfaceObject_swigregister = _statistics.LowDiscrepancySequenceImplementationTypedInterfaceObject_swigregister
LowDiscrepancySequenceImplementationTypedInterfaceObject_swigregister(LowDiscrepancySequenceImplementationTypedInterfaceObject)

class LowDiscrepancySequence(LowDiscrepancySequenceImplementationTypedInterfaceObject):
    """
    Base class to generate low discrepancy sequences.

    Available constructors:
        LowDiscrepancySequence(*dimension=1*)

    Parameters
    ----------
    dimension : int
        Dimension of the points of the low discrepancy sequence.

    Notes
    -----
    The low discrepancy sequences, also called 'quasi-random' sequences, are a
    deterministic alternative to random sequences for use in Monte Carlo methods.
    These sequences are sets of equidistributed points which the error in uniformity
    is measured by its discrepancy.

    The **discrepancy** of a set :math:`P = \\{x_1, \\hdots, x_N\\}` is defined,
    using Niederreiter's notation, as:

    .. math::

        D_N(P) = \\sup_{B\\in J} \\left| \\frac{A(B;P)}{N} - \\lambda_s(B) \\right|

    where :math:`\\lambda_s` is the s-dimensional Lebesgue measure, :math:`A(B;P)`
    is the number of points in :math:`P` that fall into :math:`B`, and :math:`J` is
    the set of s-dimensional intervals or boxes of the form:

    .. math::

        \\prod_{i=1}^s [a_i, b_i) = \\{ \\mathbf{x} \\in \\mathbf{R}^s : a_i \\le x_i < b_i \\} \\,

    where :math:`0 \\le a_i < b_i \\le 1`.

    The star-discrepancy :math:`D_N^*(P)` is defined similarly, except that the
    supremum is taken over the set :math:`J^*` of intervals of the form:

    .. math::

        \\prod_{i=1}^s [0, u_i)

    where :math:`u_i` is in the half-open interval :math:`[0, 1)`.

    A low-discrepancy sequence can be generated only through the derived classes of
    LowDiscrepancySequence. OpenTURNS proposes the
    :class:`Faure <openturns.FaureSequence>`,
    :class:`Halton <openturns.HaltonSequence>`,
    :class:`Reverse Halton <openturns.ReverseHaltonSequence>`,
    :class:`Haselgrove <openturns.HaselgroveSequence>` and
    :class:`Sobol <openturns.SobolSequence>` sequences.

    Examples
    --------
    >>> import openturns as ot
    >>> # Create a sequence of 3 points of 2 dimensions
    >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
    >>> print(sequence.generate(3))
    0 : [ 0.5  0.5  ]
    1 : [ 0.75 0.25 ]
    2 : [ 0.25 0.75 ]
    """
    __swig_setmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LowDiscrepancySequence, name, value)
    __swig_getmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LowDiscrepancySequence, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.LowDiscrepancySequence_getClassName(self)

    def initialize(self, *args):
        """
        Initialize the sequence.

        Parameters
        ----------
        dimension : int
            Dimension of the points of the low discrepancy sequence.

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        >>> print(sequence.generate(3))
        0 : [ 0.375 0.375 ]
        1 : [ 0.875 0.875 ]
        2 : [ 0.625 0.125 ]
        >>> sequence.initialize(2)
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.LowDiscrepancySequence_initialize(self, *args)

    def getDimension(self):
        """
        Accessor to the dimension of the points of the low discrepancy sequence.

        Returns
        -------
        dimension : int
            Dimension of the points of the low discrepancy sequence.
        """
        return _statistics.LowDiscrepancySequence_getDimension(self)

    def generate(self, *args):
        """
        Generate a sample of pseudo-random vectors of numbers uniformly distributed over [0, 1).

        Parameters
        ----------
        size : int
            Number of points to be generated. Default is 1.

        Returns
        -------
        sample : 2D float sequence
            Sample of pseudo-random vectors of numbers uniformly distributed over
            [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.LowDiscrepancySequence_generate(self, *args)

    def computeStarDiscrepancy(self, *args):
        """
        Compute the star discrepancy of a sample uniformly distributed over [0, 1).

        Parameters
        ----------
        sample : 2D float sequence

        Returns
        -------
        starDiscrepancy : float
            Star discrepancy of a sample uniformly distributed over [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> sample = sequence.generate(16)
        >>> print(sequence.computeStarDiscrepancy(sample))
        0.12890625
        >>> sample = sequence.generate(64)
        >>> print(sequence.computeStarDiscrepancy(sample))
        0.0537109375
        """
        return _statistics.LowDiscrepancySequence_computeStarDiscrepancy(self, *args)

    def __repr__(self): return _statistics.LowDiscrepancySequence___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_LowDiscrepancySequence(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_LowDiscrepancySequence
    __del__ = lambda self : None;
LowDiscrepancySequence_swigregister = _statistics.LowDiscrepancySequence_swigregister
LowDiscrepancySequence_swigregister(LowDiscrepancySequence)

class SobolSequence(LowDiscrepancySequenceImplementation):
    __swig_setmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SobolSequence, name, value)
    __swig_getmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SobolSequence, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SobolSequence_getClassName(self)

    def initialize(self, *args):
        """
        Initialize the sequence.

        Parameters
        ----------
        dimension : int
            Dimension of the points of the low discrepancy sequence.

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        >>> print(sequence.generate(3))
        0 : [ 0.375 0.375 ]
        1 : [ 0.875 0.875 ]
        2 : [ 0.625 0.125 ]
        >>> sequence.initialize(2)
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.SobolSequence_initialize(self, *args)

    def generate(self, *args):
        """
        Generate a sample of pseudo-random vectors of numbers uniformly distributed over [0, 1).

        Parameters
        ----------
        size : int
            Number of points to be generated. Default is 1.

        Returns
        -------
        sample : 2D float sequence
            Sample of pseudo-random vectors of numbers uniformly distributed over
            [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.SobolSequence_generate(self, *args)

    def __repr__(self): return _statistics.SobolSequence___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_SobolSequence(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SobolSequence
    __del__ = lambda self : None;
SobolSequence_swigregister = _statistics.SobolSequence_swigregister
SobolSequence_swigregister(SobolSequence)
cvar = _statistics.cvar
SobolSequence.MaximumNumberOfDimension = _statistics.cvar.SobolSequence_MaximumNumberOfDimension
SobolSequence.MaximumBase2Logarithm = _statistics.cvar.SobolSequence_MaximumBase2Logarithm
SobolSequence.Epsilon = _statistics.cvar.SobolSequence_Epsilon
SobolSequence.MaximumInitialDegree = _statistics.cvar.SobolSequence_MaximumInitialDegree
SobolSequence.InitialBase = _statistics.cvar.SobolSequence_InitialBase
SobolSequence.PrimitivePolynomial = _statistics.cvar.SobolSequence_PrimitivePolynomial

class FaureSequence(LowDiscrepancySequenceImplementation):
    __swig_setmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FaureSequence, name, value)
    __swig_getmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FaureSequence, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.FaureSequence_getClassName(self)

    def initialize(self, *args):
        """
        Initialize the sequence.

        Parameters
        ----------
        dimension : int
            Dimension of the points of the low discrepancy sequence.

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        >>> print(sequence.generate(3))
        0 : [ 0.375 0.375 ]
        1 : [ 0.875 0.875 ]
        2 : [ 0.625 0.125 ]
        >>> sequence.initialize(2)
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.FaureSequence_initialize(self, *args)

    def generate(self, *args):
        """
        Generate a sample of pseudo-random vectors of numbers uniformly distributed over [0, 1).

        Parameters
        ----------
        size : int
            Number of points to be generated. Default is 1.

        Returns
        -------
        sample : 2D float sequence
            Sample of pseudo-random vectors of numbers uniformly distributed over
            [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.FaureSequence_generate(self, *args)

    def __repr__(self): return _statistics.FaureSequence___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_FaureSequence(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_FaureSequence
    __del__ = lambda self : None;
FaureSequence_swigregister = _statistics.FaureSequence_swigregister
FaureSequence_swigregister(FaureSequence)

class HaltonSequence(LowDiscrepancySequenceImplementation):
    __swig_setmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HaltonSequence, name, value)
    __swig_getmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HaltonSequence, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.HaltonSequence_getClassName(self)

    def initialize(self, *args):
        """
        Initialize the sequence.

        Parameters
        ----------
        dimension : int
            Dimension of the points of the low discrepancy sequence.

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        >>> print(sequence.generate(3))
        0 : [ 0.375 0.375 ]
        1 : [ 0.875 0.875 ]
        2 : [ 0.625 0.125 ]
        >>> sequence.initialize(2)
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.HaltonSequence_initialize(self, *args)

    def generate(self, *args):
        """
        Generate a sample of pseudo-random vectors of numbers uniformly distributed over [0, 1).

        Parameters
        ----------
        size : int
            Number of points to be generated. Default is 1.

        Returns
        -------
        sample : 2D float sequence
            Sample of pseudo-random vectors of numbers uniformly distributed over
            [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.HaltonSequence_generate(self, *args)

    def __repr__(self): return _statistics.HaltonSequence___repr__(self)
    def __str__(self, offset=""): return _statistics.HaltonSequence___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_HaltonSequence(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_HaltonSequence
    __del__ = lambda self : None;
HaltonSequence_swigregister = _statistics.HaltonSequence_swigregister
HaltonSequence_swigregister(HaltonSequence)

class HaselgroveSequence(LowDiscrepancySequenceImplementation):
    __swig_setmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, HaselgroveSequence, name, value)
    __swig_getmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, HaselgroveSequence, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.HaselgroveSequence_getClassName(self)

    def initialize(self, *args):
        """
        Initialize the sequence.

        Parameters
        ----------
        dimension : int
            Dimension of the points of the low discrepancy sequence.

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        >>> print(sequence.generate(3))
        0 : [ 0.375 0.375 ]
        1 : [ 0.875 0.875 ]
        2 : [ 0.625 0.125 ]
        >>> sequence.initialize(2)
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.HaselgroveSequence_initialize(self, *args)

    def generate(self, *args):
        """
        Generate a sample of pseudo-random vectors of numbers uniformly distributed over [0, 1).

        Parameters
        ----------
        size : int
            Number of points to be generated. Default is 1.

        Returns
        -------
        sample : 2D float sequence
            Sample of pseudo-random vectors of numbers uniformly distributed over
            [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.HaselgroveSequence_generate(self, *args)

    def __repr__(self): return _statistics.HaselgroveSequence___repr__(self)
    def __str__(self, offset=""): return _statistics.HaselgroveSequence___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_HaselgroveSequence(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_HaselgroveSequence
    __del__ = lambda self : None;
HaselgroveSequence_swigregister = _statistics.HaselgroveSequence_swigregister
HaselgroveSequence_swigregister(HaselgroveSequence)

class ReverseHaltonSequence(LowDiscrepancySequenceImplementation):
    __swig_setmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ReverseHaltonSequence, name, value)
    __swig_getmethods__ = {}
    for _s in [LowDiscrepancySequenceImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ReverseHaltonSequence, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.ReverseHaltonSequence_getClassName(self)

    def initialize(self, *args):
        """
        Initialize the sequence.

        Parameters
        ----------
        dimension : int
            Dimension of the points of the low discrepancy sequence.

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        >>> print(sequence.generate(3))
        0 : [ 0.375 0.375 ]
        1 : [ 0.875 0.875 ]
        2 : [ 0.625 0.125 ]
        >>> sequence.initialize(2)
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.ReverseHaltonSequence_initialize(self, *args)

    def generate(self, *args):
        """
        Generate a sample of pseudo-random vectors of numbers uniformly distributed over [0, 1).

        Parameters
        ----------
        size : int
            Number of points to be generated. Default is 1.

        Returns
        -------
        sample : 2D float sequence
            Sample of pseudo-random vectors of numbers uniformly distributed over
            [0, 1).

        Examples
        --------
        >>> import openturns as ot
        >>> # Create a sequence of 3 points of 2 dimensions
        >>> sequence = ot.LowDiscrepancySequence(ot.SobolSequence(2))
        >>> print(sequence.generate(3))
        0 : [ 0.5  0.5  ]
        1 : [ 0.75 0.25 ]
        2 : [ 0.25 0.75 ]
        """
        return _statistics.ReverseHaltonSequence_generate(self, *args)

    def __repr__(self): return _statistics.ReverseHaltonSequence___repr__(self)
    def __init__(self, *args): 
        this = _statistics.new_ReverseHaltonSequence(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_ReverseHaltonSequence
    __del__ = lambda self : None;
ReverseHaltonSequence_swigregister = _statistics.ReverseHaltonSequence_swigregister
ReverseHaltonSequence_swigregister(ReverseHaltonSequence)

class CorrelationAnalysis(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CorrelationAnalysis, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CorrelationAnalysis, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_getmethods__["PearsonCorrelation"] = lambda x: _statistics.CorrelationAnalysis_PearsonCorrelation
    if _newclass:PearsonCorrelation = staticmethod(_statistics.CorrelationAnalysis_PearsonCorrelation)
    __swig_getmethods__["SpearmanCorrelation"] = lambda x: _statistics.CorrelationAnalysis_SpearmanCorrelation
    if _newclass:SpearmanCorrelation = staticmethod(_statistics.CorrelationAnalysis_SpearmanCorrelation)
    __swig_getmethods__["SRC"] = lambda x: _statistics.CorrelationAnalysis_SRC
    if _newclass:SRC = staticmethod(_statistics.CorrelationAnalysis_SRC)
    __swig_getmethods__["PCC"] = lambda x: _statistics.CorrelationAnalysis_PCC
    if _newclass:PCC = staticmethod(_statistics.CorrelationAnalysis_PCC)
    __swig_getmethods__["SRRC"] = lambda x: _statistics.CorrelationAnalysis_SRRC
    if _newclass:SRRC = staticmethod(_statistics.CorrelationAnalysis_SRRC)
    __swig_getmethods__["PRCC"] = lambda x: _statistics.CorrelationAnalysis_PRCC
    if _newclass:PRCC = staticmethod(_statistics.CorrelationAnalysis_PRCC)
    __swig_destroy__ = _statistics.delete_CorrelationAnalysis
    __del__ = lambda self : None;
CorrelationAnalysis_swigregister = _statistics.CorrelationAnalysis_swigregister
CorrelationAnalysis_swigregister(CorrelationAnalysis)

def CorrelationAnalysis_PearsonCorrelation(*args):
  return _statistics.CorrelationAnalysis_PearsonCorrelation(*args)
CorrelationAnalysis_PearsonCorrelation = _statistics.CorrelationAnalysis_PearsonCorrelation

def CorrelationAnalysis_SpearmanCorrelation(*args):
  return _statistics.CorrelationAnalysis_SpearmanCorrelation(*args)
CorrelationAnalysis_SpearmanCorrelation = _statistics.CorrelationAnalysis_SpearmanCorrelation

def CorrelationAnalysis_SRC(*args):
  return _statistics.CorrelationAnalysis_SRC(*args)
CorrelationAnalysis_SRC = _statistics.CorrelationAnalysis_SRC

def CorrelationAnalysis_PCC(*args):
  return _statistics.CorrelationAnalysis_PCC(*args)
CorrelationAnalysis_PCC = _statistics.CorrelationAnalysis_PCC

def CorrelationAnalysis_SRRC(*args):
  return _statistics.CorrelationAnalysis_SRRC(*args)
CorrelationAnalysis_SRRC = _statistics.CorrelationAnalysis_SRRC

def CorrelationAnalysis_PRCC(*args):
  return _statistics.CorrelationAnalysis_PRCC(*args)
CorrelationAnalysis_PRCC = _statistics.CorrelationAnalysis_PRCC

class SensitivityAnalysis(openturns.common.Object):
    __swig_setmethods__ = {}
    for _s in [openturns.common.Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SensitivityAnalysis, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SensitivityAnalysis, name)
    __repr__ = _swig_repr
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SensitivityAnalysis_getClassName(self)

    def getFirstOrderIndices(self, marginalIndex=0): return _statistics.SensitivityAnalysis_getFirstOrderIndices(self, marginalIndex)
    def getSecondOrderIndices(self, marginalIndex=0): return _statistics.SensitivityAnalysis_getSecondOrderIndices(self, marginalIndex)
    def getTotalOrderIndices(self, marginalIndex=0): return _statistics.SensitivityAnalysis_getTotalOrderIndices(self, marginalIndex)
    def setBlockSize(self, *args): return _statistics.SensitivityAnalysis_setBlockSize(self, *args)
    def getBlockSize(self): return _statistics.SensitivityAnalysis_getBlockSize(self)
    __swig_getmethods__["DrawImportanceFactors"] = lambda x: _statistics.SensitivityAnalysis_DrawImportanceFactors
    if _newclass:DrawImportanceFactors = staticmethod(_statistics.SensitivityAnalysis_DrawImportanceFactors)
    def __init__(self, *args): 
        this = _statistics.new_SensitivityAnalysis(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SensitivityAnalysis
    __del__ = lambda self : None;
SensitivityAnalysis_swigregister = _statistics.SensitivityAnalysis_swigregister
SensitivityAnalysis_swigregister(SensitivityAnalysis)

def SensitivityAnalysis_DrawImportanceFactors(*args):
  return _statistics.SensitivityAnalysis_DrawImportanceFactors(*args)
SensitivityAnalysis_DrawImportanceFactors = _statistics.SensitivityAnalysis_DrawImportanceFactors

class FilteringWindowsImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FilteringWindowsImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FilteringWindowsImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.FilteringWindowsImplementation_getClassName(self)

    def __call__(self, *args): return _statistics.FilteringWindowsImplementation___call__(self, *args)
    def __repr__(self): return _statistics.FilteringWindowsImplementation___repr__(self)
    def __str__(self, offset=""): return _statistics.FilteringWindowsImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_FilteringWindowsImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_FilteringWindowsImplementation
    __del__ = lambda self : None;
FilteringWindowsImplementation_swigregister = _statistics.FilteringWindowsImplementation_swigregister
FilteringWindowsImplementation_swigregister(FilteringWindowsImplementation)

class FilteringWindowsImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FilteringWindowsImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FilteringWindowsImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_FilteringWindowsImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.FilteringWindowsImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.FilteringWindowsImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.FilteringWindowsImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.FilteringWindowsImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_FilteringWindowsImplementationTypedInterfaceObject
    __del__ = lambda self : None;
FilteringWindowsImplementationTypedInterfaceObject_swigregister = _statistics.FilteringWindowsImplementationTypedInterfaceObject_swigregister
FilteringWindowsImplementationTypedInterfaceObject_swigregister(FilteringWindowsImplementationTypedInterfaceObject)

class FilteringWindows(FilteringWindowsImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [FilteringWindowsImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FilteringWindows, name, value)
    __swig_getmethods__ = {}
    for _s in [FilteringWindowsImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FilteringWindows, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.FilteringWindows_getClassName(self)

    def __repr__(self): return _statistics.FilteringWindows___repr__(self)
    def __str__(self, offset=""): return _statistics.FilteringWindows___str__(self, offset)
    def __call__(self, *args): return _statistics.FilteringWindows___call__(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_FilteringWindows(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_FilteringWindows
    __del__ = lambda self : None;
FilteringWindows_swigregister = _statistics.FilteringWindows_swigregister
FilteringWindows_swigregister(FilteringWindows)

class Hamming(FilteringWindowsImplementation):
    __swig_setmethods__ = {}
    for _s in [FilteringWindowsImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Hamming, name, value)
    __swig_getmethods__ = {}
    for _s in [FilteringWindowsImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Hamming, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.Hamming_getClassName(self)

    def __repr__(self): return _statistics.Hamming___repr__(self)
    def __str__(self, offset=""): return _statistics.Hamming___str__(self, offset)
    def __call__(self, *args): return _statistics.Hamming___call__(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_Hamming(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_Hamming
    __del__ = lambda self : None;
Hamming_swigregister = _statistics.Hamming_swigregister
Hamming_swigregister(Hamming)

class Hanning(FilteringWindowsImplementation):
    __swig_setmethods__ = {}
    for _s in [FilteringWindowsImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Hanning, name, value)
    __swig_getmethods__ = {}
    for _s in [FilteringWindowsImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Hanning, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.Hanning_getClassName(self)

    def __repr__(self): return _statistics.Hanning___repr__(self)
    def __str__(self, offset=""): return _statistics.Hanning___str__(self, offset)
    def __call__(self, *args): return _statistics.Hanning___call__(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_Hanning(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_Hanning
    __del__ = lambda self : None;
Hanning_swigregister = _statistics.Hanning_swigregister
Hanning_swigregister(Hanning)

class FFTImplementation(openturns.common.PersistentObject):
    """
    Base class for Fast Fourier Transform (FFT) and Inverse Fast Fourier Transform (IFFT).

    Notes
    -----
    Perform FFT and IFFT with array of ndim=1,2,3

    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FFTImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FFTImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.FFTImplementation_getClassName(self)

    def transform(self, *args):
        """
        Perform Fast Fourier Transform (fft).

        Parameters
        ----------
        collection : :class:`~openturns.NumericalComplexCollection` or :class:`~openturns.NumericalScalarCollection`, :class:`~openturns.NumericalPoint`, numpy 1d array, list or tuple
          Data to transform.

        Returns
        -------
        collection : :class:`~openturns.NumericalComplexCollection`
          The data in Fourier domain.

        Notes
        -----
        The Fast Fourier Transform writes as following:

        .. math::

            {\\rm y_k} = \\sum_{n=0}^{N-1} x_n exp(-2 \\imath \\pi \\frac{kn}{N})

        where :math:`x` denotes the data to be transformed, of size :math:`N`.


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> result = fft.transform(ot.Normal(8).getRealization())

        """
        return _statistics.FFTImplementation_transform(self, *args)

    def inverseTransform(self, *args):
        """
        Perform Inverse Fast Fourier Transform (fft).

        Parameters
        ----------
        collection : :class:`~openturns.NumericalComplexCollection` or :class:`~openturns.NumericalScalarCollection`, :class:`~openturns.NumericalPoint`, numpy 1d array, list or tuple
          Data to transform.

        Returns
        -------
        collection : :class:`~openturns.NumericalComplexCollection`
            The transformed data.

        Notes
        -----
        The Inverse Fast Fourier Transform writes as following:

        .. math::

            {\\rm y_k} = \\sum_{n=0}^{N-1} \\frac{1}{N} x_n exp(2 \\imath \\pi \\frac{kn}{N})

        where :math:`x` denotes the data, of size :math:`N`, to be transformed.


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> collection = ot.NumericalComplexCollection([1+1j,2-0.3j,5-.3j,6+1j,9+8j,16+8j,0.3])
        >>> result = fft.inverseTransform(collection)

        """
        return _statistics.FFTImplementation_inverseTransform(self, *args)

    def transform2D(self, *args):
        """
        Perform 2D FFT.

        Parameters
        ----------
        matrix : :class:`~openturns.ComplexMatrix`, :class:`~openturns.Matrix`, :class:`~openturns.NumericalSample` or 2d array
          Data to transform.

        Returns
        -------
        result : :class:`~openturns.ComplexMatrix`
          The data in fourier domain.

        Notes
        -----
        The 2D Fast Fourier Transform writes as following:

        .. math::

            {\\rm Z_{k,l}} = \\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1} X_{m,n} exp(-2 \\imath \\pi \\frac{km}{M}) exp(-2 \\imath \\pi \\frac{ln}{N})

        where :math:`X` denotes the data to be transformed with shape (:math:`M`,:math:`N`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.Normal(8).getSample(16)
        >>> result = fft.transform2D(x)

        """
        return _statistics.FFTImplementation_transform2D(self, *args)

    def inverseTransform2D(self, *args):
        """
        Perform 2D IFFT.

        Parameters
        ----------
        matrix : :class:`~openturns.ComplexMatrix`, :class:`~openturns.Matrix`, :class:`~openturns.NumericalSample` or 2d array
          Data to transform.

        Returns
        -------
        result : :class:`~openturns.ComplexMatrix`
          The data transformed.

        Notes
        -----
        The 2D Fast Inverse Fourier Transform writes as following:

        .. math::

            {\\rm Y_{k,l}} = \\frac{1}{M\\times N}\\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1} Z_{m,n} exp(2 \\imath \\pi \\frac{km}{M}) exp(2 \\imath \\pi \\frac{ln}{N})

        where :math:`Z` denotes the data to be transformed with shape (:math:`M`,:math:`N`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.Normal(8).getSample(16)
        >>> result = fft.inverseTransform2D(x)

        """
        return _statistics.FFTImplementation_inverseTransform2D(self, *args)

    def transform3D(self, *args):
        """
        Perform 3D FFT.

        Parameters
        ----------
        tensor : :class:`~openturns.ComplexTensor` or :class:`~openturns.Tensor` or 3d array
          Data to transform.

        Returns
        -------
        result : :class:`~openturns.ComplexTensor`
          The data in fourier domain.

        Notes
        -----
        The 3D Fast Fourier Transform writes as following:

        .. math::

            {\\rm Z_{k,l,r}} = \\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1}\\sum_{p=0}^{P-1} X_{m,n,p} exp(-2 \\imath \\pi \\frac{km}{M}) exp(-2 \\imath \\pi \\frac{ln}{N}) exp(-2 \\imath \\pi \\frac{rp}{P})

        where :math:`X` denotes the data to be transformed with shape (:math:`M`,:math:`N`, :math:`P`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.ComplexTensor(8,8,2)
        >>> y = ot.Normal(8).getSample(8)
        >>> x.setSheet(0,fft.transform2D(y))
        >>> z = ot.Normal(8).getSample(8)
        >>> x.setSheet(1,fft.transform2D(z))
        >>> result = fft.transform3D(x)

        """
        return _statistics.FFTImplementation_transform3D(self, *args)

    def inverseTransform3D(self, *args):
        """
        Perform 3D IFFT.

        Parameters
        ----------
        tensor : :class:`~openturns.ComplexTensor` or :class:`~openturns.Tensor` or 3d array
          The data to be transformed.

        Returns
        -------
        result : :class:`~openturns.ComplexTensor`
          The transformed data.

        Notes
        -----
        The 3D Inverse Fast Fourier Transform writes as following:

        .. math::

            {\\rm Y_{k,l,r}} = \\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1}\\sum_{p=0}^{P-1} \\frac{1}{M\\times N \\times P} Z_{m,n,p} exp(2 \\imath \\pi \\frac{km}{M}) exp(2 \\imath \\pi \\frac{ln}{N}) exp(2 \\imath \\pi \\frac{rp}{P})

        where :math:`Z` denotes the data to be transformed with shape (:math:`M`,:math:`N`, :math:`P`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.ComplexTensor(8,8,2)
        >>> y = ot.Normal(8).getSample(8)
        >>> x.setSheet(0, fft.transform2D(y))
        >>> z = ot.Normal(8).getSample(8)
        >>> x.setSheet(1, fft.transform2D(z))
        >>> result = fft.inverseTransform3D(x)

        """
        return _statistics.FFTImplementation_inverseTransform3D(self, *args)

    def __repr__(self): return _statistics.FFTImplementation___repr__(self)
    def __str__(self, offset=""): return _statistics.FFTImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_FFTImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_FFTImplementation
    __del__ = lambda self : None;
FFTImplementation_swigregister = _statistics.FFTImplementation_swigregister
FFTImplementation_swigregister(FFTImplementation)

class FFTImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FFTImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FFTImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_FFTImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.FFTImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.FFTImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.FFTImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.FFTImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_FFTImplementationTypedInterfaceObject
    __del__ = lambda self : None;
FFTImplementationTypedInterfaceObject_swigregister = _statistics.FFTImplementationTypedInterfaceObject_swigregister
FFTImplementationTypedInterfaceObject_swigregister(FFTImplementationTypedInterfaceObject)

class FFT(FFTImplementationTypedInterfaceObject):
    """
    Base class for Fast Fourier Transform (FFT) and Inverse Fast Fourier Transform (IFFT).

    Notes
    -----
    Perform FFT and IFFT with array of ndim=1,2,3

    """
    __swig_setmethods__ = {}
    for _s in [FFTImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FFT, name, value)
    __swig_getmethods__ = {}
    for _s in [FFTImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FFT, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.FFT_getClassName(self)

    def transform(self, *args):
        """
        Perform Fast Fourier Transform (fft).

        Parameters
        ----------
        collection : :class:`~openturns.NumericalComplexCollection` or :class:`~openturns.NumericalScalarCollection`, :class:`~openturns.NumericalPoint`, numpy 1d array, list or tuple
          Data to transform.

        Returns
        -------
        collection : :class:`~openturns.NumericalComplexCollection`
          The data in Fourier domain.

        Notes
        -----
        The Fast Fourier Transform writes as following:

        .. math::

            {\\rm y_k} = \\sum_{n=0}^{N-1} x_n exp(-2 \\imath \\pi \\frac{kn}{N})

        where :math:`x` denotes the data to be transformed, of size :math:`N`.


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> result = fft.transform(ot.Normal(8).getRealization())

        """
        return _statistics.FFT_transform(self, *args)

    def transform2D(self, *args):
        """
        Perform 2D FFT.

        Parameters
        ----------
        matrix : :class:`~openturns.ComplexMatrix`, :class:`~openturns.Matrix`, :class:`~openturns.NumericalSample` or 2d array
          Data to transform.

        Returns
        -------
        result : :class:`~openturns.ComplexMatrix`
          The data in fourier domain.

        Notes
        -----
        The 2D Fast Fourier Transform writes as following:

        .. math::

            {\\rm Z_{k,l}} = \\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1} X_{m,n} exp(-2 \\imath \\pi \\frac{km}{M}) exp(-2 \\imath \\pi \\frac{ln}{N})

        where :math:`X` denotes the data to be transformed with shape (:math:`M`,:math:`N`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.Normal(8).getSample(16)
        >>> result = fft.transform2D(x)

        """
        return _statistics.FFT_transform2D(self, *args)

    def transform3D(self, *args):
        """
        Perform 3D FFT.

        Parameters
        ----------
        tensor : :class:`~openturns.ComplexTensor` or :class:`~openturns.Tensor` or 3d array
          Data to transform.

        Returns
        -------
        result : :class:`~openturns.ComplexTensor`
          The data in fourier domain.

        Notes
        -----
        The 3D Fast Fourier Transform writes as following:

        .. math::

            {\\rm Z_{k,l,r}} = \\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1}\\sum_{p=0}^{P-1} X_{m,n,p} exp(-2 \\imath \\pi \\frac{km}{M}) exp(-2 \\imath \\pi \\frac{ln}{N}) exp(-2 \\imath \\pi \\frac{rp}{P})

        where :math:`X` denotes the data to be transformed with shape (:math:`M`,:math:`N`, :math:`P`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.ComplexTensor(8,8,2)
        >>> y = ot.Normal(8).getSample(8)
        >>> x.setSheet(0,fft.transform2D(y))
        >>> z = ot.Normal(8).getSample(8)
        >>> x.setSheet(1,fft.transform2D(z))
        >>> result = fft.transform3D(x)

        """
        return _statistics.FFT_transform3D(self, *args)

    def inverseTransform(self, *args):
        """
        Perform Inverse Fast Fourier Transform (fft).

        Parameters
        ----------
        collection : :class:`~openturns.NumericalComplexCollection` or :class:`~openturns.NumericalScalarCollection`, :class:`~openturns.NumericalPoint`, numpy 1d array, list or tuple
          Data to transform.

        Returns
        -------
        collection : :class:`~openturns.NumericalComplexCollection`
            The transformed data.

        Notes
        -----
        The Inverse Fast Fourier Transform writes as following:

        .. math::

            {\\rm y_k} = \\sum_{n=0}^{N-1} \\frac{1}{N} x_n exp(2 \\imath \\pi \\frac{kn}{N})

        where :math:`x` denotes the data, of size :math:`N`, to be transformed.


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> collection = ot.NumericalComplexCollection([1+1j,2-0.3j,5-.3j,6+1j,9+8j,16+8j,0.3])
        >>> result = fft.inverseTransform(collection)

        """
        return _statistics.FFT_inverseTransform(self, *args)

    def inverseTransform2D(self, *args):
        """
        Perform 2D IFFT.

        Parameters
        ----------
        matrix : :class:`~openturns.ComplexMatrix`, :class:`~openturns.Matrix`, :class:`~openturns.NumericalSample` or 2d array
          Data to transform.

        Returns
        -------
        result : :class:`~openturns.ComplexMatrix`
          The data transformed.

        Notes
        -----
        The 2D Fast Inverse Fourier Transform writes as following:

        .. math::

            {\\rm Y_{k,l}} = \\frac{1}{M\\times N}\\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1} Z_{m,n} exp(2 \\imath \\pi \\frac{km}{M}) exp(2 \\imath \\pi \\frac{ln}{N})

        where :math:`Z` denotes the data to be transformed with shape (:math:`M`,:math:`N`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.Normal(8).getSample(16)
        >>> result = fft.inverseTransform2D(x)

        """
        return _statistics.FFT_inverseTransform2D(self, *args)

    def inverseTransform3D(self, *args):
        """
        Perform 3D IFFT.

        Parameters
        ----------
        tensor : :class:`~openturns.ComplexTensor` or :class:`~openturns.Tensor` or 3d array
          The data to be transformed.

        Returns
        -------
        result : :class:`~openturns.ComplexTensor`
          The transformed data.

        Notes
        -----
        The 3D Inverse Fast Fourier Transform writes as following:

        .. math::

            {\\rm Y_{k,l,r}} = \\sum_{m=0}^{M-1}\\sum_{n=0}^{N-1}\\sum_{p=0}^{P-1} \\frac{1}{M\\times N \\times P} Z_{m,n,p} exp(2 \\imath \\pi \\frac{km}{M}) exp(2 \\imath \\pi \\frac{ln}{N}) exp(2 \\imath \\pi \\frac{rp}{P})

        where :math:`Z` denotes the data to be transformed with shape (:math:`M`,:math:`N`, :math:`P`)


        Examples
        --------
        >>> import openturns as ot
        >>> fft = ot.FFT()
        >>> x = ot.ComplexTensor(8,8,2)
        >>> y = ot.Normal(8).getSample(8)
        >>> x.setSheet(0, fft.transform2D(y))
        >>> z = ot.Normal(8).getSample(8)
        >>> x.setSheet(1, fft.transform2D(z))
        >>> result = fft.inverseTransform3D(x)

        """
        return _statistics.FFT_inverseTransform3D(self, *args)

    def __repr__(self): return _statistics.FFT___repr__(self)
    def __str__(self, offset=""): return _statistics.FFT___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_FFT(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_FFT
    __del__ = lambda self : None;
FFT_swigregister = _statistics.FFT_swigregister
FFT_swigregister(FFT)

class SpectralModelImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectralModelImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpectralModelImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SpectralModelImplementation_getClassName(self)

    def getDimension(self): return _statistics.SpectralModelImplementation_getDimension(self)
    def setDimension(self, *args): return _statistics.SpectralModelImplementation_setDimension(self, *args)
    def __call__(self, *args): return _statistics.SpectralModelImplementation___call__(self, *args)
    def getFrequencyGrid(self): return _statistics.SpectralModelImplementation_getFrequencyGrid(self)
    def setFrequencyGrid(self, *args): return _statistics.SpectralModelImplementation_setFrequencyGrid(self, *args)
    def __repr__(self): return _statistics.SpectralModelImplementation___repr__(self)
    def __str__(self, offset=""): return _statistics.SpectralModelImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_SpectralModelImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SpectralModelImplementation
    __del__ = lambda self : None;
SpectralModelImplementation_swigregister = _statistics.SpectralModelImplementation_swigregister
SpectralModelImplementation_swigregister(SpectralModelImplementation)

class SpectralModelImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectralModelImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpectralModelImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_SpectralModelImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.SpectralModelImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.SpectralModelImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.SpectralModelImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.SpectralModelImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_SpectralModelImplementationTypedInterfaceObject
    __del__ = lambda self : None;
SpectralModelImplementationTypedInterfaceObject_swigregister = _statistics.SpectralModelImplementationTypedInterfaceObject_swigregister
SpectralModelImplementationTypedInterfaceObject_swigregister(SpectralModelImplementationTypedInterfaceObject)

class SpectralModel(SpectralModelImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [SpectralModelImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectralModel, name, value)
    __swig_getmethods__ = {}
    for _s in [SpectralModelImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpectralModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SpectralModel_getClassName(self)

    def getDimension(self): return _statistics.SpectralModel_getDimension(self)
    def setDimension(self, *args): return _statistics.SpectralModel_setDimension(self, *args)
    def __call__(self, *args): return _statistics.SpectralModel___call__(self, *args)
    def getFrequencyGrid(self): return _statistics.SpectralModel_getFrequencyGrid(self)
    def setFrequencyGrid(self, *args): return _statistics.SpectralModel_setFrequencyGrid(self, *args)
    def __repr__(self): return _statistics.SpectralModel___repr__(self)
    def __str__(self, offset=""): return _statistics.SpectralModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_SpectralModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SpectralModel
    __del__ = lambda self : None;
SpectralModel_swigregister = _statistics.SpectralModel_swigregister
SpectralModel_swigregister(SpectralModel)

class CovarianceModelImplementation(openturns.common.PersistentObject):
    """
    Covariance model.

    Notes
    -----
    We consider :math:`X: \\Omega \\times\\cD \\mapsto \\Rset^d` a multivariate
    stochastic process of dimension :math:`d`, where :math:`\\omega \\in \\Omega`
    is an event, :math:`\\cD` is a domain of :math:`\\Rset^n`,
    :math:`\\vect{t}\\in \\cD` is a multivariate index and
    :math:`X(\\omega, \\vect{t}) \\in \\Rset^d`.

    We note :math:`X_{\\vect{t}}: \\Omega \\rightarrow \\Rset^d` the random variable at
    index :math:`\\vect{t} \\in \\cD` defined by
    :math:`X_{\\vect{t}}(\\omega)=X(\\omega, \\vect{t})` and
    :math:`X(\\omega): \\cD  \\mapsto \\Rset^d` a realization of the process
    :math:`X`, for a given :math:`\\omega \\in \\Omega` defined by
    :math:`X(\\omega)(\\vect{t})=X(\\omega, \\vect{t})`.

    If the process is a second order process, we note:

    - :math:`m : \\cD \\mapsto  \\Rset^d` its *mean function*, defined by
      :math:`m(\\vect{t})=\\Expect{X_{\\vect{t}}}`,
    - :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` its
      *covariance function*, defined by
      :math:`C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}`,
    - :math:`R : \\cD \\times \\cD \\mapsto  \\mathcal{M}_{d \\times d}(\\Rset)` its
      *correlation function*, defined for all :math:`(\\vect{s}, \\vect{t})`,
      by :math:`R(\\vect{s}, \\vect{t})` such that for all :math:`(i,j)`,
      :math:`R_{ij}(\\vect{s}, \\vect{t})=C_{ij}(\\vect{s}, \\vect{t})/\\sqrt{C_{ii}(\\vect{s}, \\vect{t})C_{jj}(\\vect{s}, \\vect{t})}`.

    A CovarianceModel object can be created only through its derived classes:
    :class:`~openturns.StationaryCovarianceModel`,
    :class:`~openturns.UserDefinedCovarianceModel`,
    :class:`~openturns.GeneralizedExponential`,
    :class:`~openturns.AbsoluteExponential`,
    :class:`~openturns.SquaredExponential`.
    """
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.CovarianceModelImplementation_getClassName(self)

    def getSpatialDimension(self): return _statistics.CovarianceModelImplementation_getSpatialDimension(self)
    def getDimension(self):
        """
        Get the dimension of the *CovarianceModel*.

        Returns
        -------
        dimension : int
            Dimension of the *CovarianceModel*.
        """
        return _statistics.CovarianceModelImplementation_getDimension(self)

    def __call__(self, *args): return _statistics.CovarianceModelImplementation___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.CovarianceModelImplementation_computeAsScalar(self, *args)

    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.CovarianceModelImplementation_partialGradient(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.CovarianceModelImplementation_discretize(self, *args)

    def discretizeRow(self, *args):
        """**(TODO)**"""
        return _statistics.CovarianceModelImplementation_discretizeRow(self, *args)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.CovarianceModelImplementation_isStationary(self)

    def getAmplitude(self): return _statistics.CovarianceModelImplementation_getAmplitude(self)
    def setAmplitude(self, *args): return _statistics.CovarianceModelImplementation_setAmplitude(self, *args)
    def getScale(self): return _statistics.CovarianceModelImplementation_getScale(self)
    def setScale(self, *args): return _statistics.CovarianceModelImplementation_setScale(self, *args)
    def getSpatialCorrelation(self): return _statistics.CovarianceModelImplementation_getSpatialCorrelation(self)
    def setSpatialCorrelation(self, *args): return _statistics.CovarianceModelImplementation_setSpatialCorrelation(self, *args)
    def setNuggetFactor(self, *args): return _statistics.CovarianceModelImplementation_setNuggetFactor(self, *args)
    def getNuggetFactor(self): return _statistics.CovarianceModelImplementation_getNuggetFactor(self)
    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.CovarianceModelImplementation_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.CovarianceModelImplementation_getParameters(self)

    def __repr__(self): return _statistics.CovarianceModelImplementation___repr__(self)
    def __str__(self, offset=""): return _statistics.CovarianceModelImplementation___str__(self, offset)
    def isDiagonal(self): return _statistics.CovarianceModelImplementation_isDiagonal(self)
    def getMarginal(self, *args): return _statistics.CovarianceModelImplementation_getMarginal(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_CovarianceModelImplementation
    __del__ = lambda self : None;
CovarianceModelImplementation_swigregister = _statistics.CovarianceModelImplementation_swigregister
CovarianceModelImplementation_swigregister(CovarianceModelImplementation)

class CovarianceModelImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.CovarianceModelImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.CovarianceModelImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.CovarianceModelImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.CovarianceModelImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_CovarianceModelImplementationTypedInterfaceObject
    __del__ = lambda self : None;
CovarianceModelImplementationTypedInterfaceObject_swigregister = _statistics.CovarianceModelImplementationTypedInterfaceObject_swigregister
CovarianceModelImplementationTypedInterfaceObject_swigregister(CovarianceModelImplementationTypedInterfaceObject)

class CovarianceModel(CovarianceModelImplementationTypedInterfaceObject):
    """
    Covariance model.

    Notes
    -----
    We consider :math:`X: \\Omega \\times\\cD \\mapsto \\Rset^d` a multivariate
    stochastic process of dimension :math:`d`, where :math:`\\omega \\in \\Omega`
    is an event, :math:`\\cD` is a domain of :math:`\\Rset^n`,
    :math:`\\vect{t}\\in \\cD` is a multivariate index and
    :math:`X(\\omega, \\vect{t}) \\in \\Rset^d`.

    We note :math:`X_{\\vect{t}}: \\Omega \\rightarrow \\Rset^d` the random variable at
    index :math:`\\vect{t} \\in \\cD` defined by
    :math:`X_{\\vect{t}}(\\omega)=X(\\omega, \\vect{t})` and
    :math:`X(\\omega): \\cD  \\mapsto \\Rset^d` a realization of the process
    :math:`X`, for a given :math:`\\omega \\in \\Omega` defined by
    :math:`X(\\omega)(\\vect{t})=X(\\omega, \\vect{t})`.

    If the process is a second order process, we note:

    - :math:`m : \\cD \\mapsto  \\Rset^d` its *mean function*, defined by
      :math:`m(\\vect{t})=\\Expect{X_{\\vect{t}}}`,
    - :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` its
      *covariance function*, defined by
      :math:`C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}`,
    - :math:`R : \\cD \\times \\cD \\mapsto  \\mathcal{M}_{d \\times d}(\\Rset)` its
      *correlation function*, defined for all :math:`(\\vect{s}, \\vect{t})`,
      by :math:`R(\\vect{s}, \\vect{t})` such that for all :math:`(i,j)`,
      :math:`R_{ij}(\\vect{s}, \\vect{t})=C_{ij}(\\vect{s}, \\vect{t})/\\sqrt{C_{ii}(\\vect{s}, \\vect{t})C_{jj}(\\vect{s}, \\vect{t})}`.

    A CovarianceModel object can be created only through its derived classes:
    :class:`~openturns.StationaryCovarianceModel`,
    :class:`~openturns.UserDefinedCovarianceModel`,
    :class:`~openturns.GeneralizedExponential`,
    :class:`~openturns.AbsoluteExponential`,
    :class:`~openturns.SquaredExponential`.
    """
    __swig_setmethods__ = {}
    for _s in [CovarianceModelImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModel, name, value)
    __swig_getmethods__ = {}
    for _s in [CovarianceModelImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.CovarianceModel_getClassName(self)

    def getSpatialDimension(self): return _statistics.CovarianceModel_getSpatialDimension(self)
    def getDimension(self):
        """
        Get the dimension of the *CovarianceModel*.

        Returns
        -------
        dimension : int
            Dimension of the *CovarianceModel*.
        """
        return _statistics.CovarianceModel_getDimension(self)

    def __call__(self, *args): return _statistics.CovarianceModel___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.CovarianceModel_computeAsScalar(self, *args)

    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.CovarianceModel_partialGradient(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.CovarianceModel_discretize(self, *args)

    def discretizeRow(self, *args):
        """**(TODO)**"""
        return _statistics.CovarianceModel_discretizeRow(self, *args)

    def getAmplitude(self): return _statistics.CovarianceModel_getAmplitude(self)
    def setAmplitude(self, *args): return _statistics.CovarianceModel_setAmplitude(self, *args)
    def getScale(self): return _statistics.CovarianceModel_getScale(self)
    def setScale(self, *args): return _statistics.CovarianceModel_setScale(self, *args)
    def getSpatialCorrelation(self): return _statistics.CovarianceModel_getSpatialCorrelation(self)
    def setSpatialCorrelation(self, *args): return _statistics.CovarianceModel_setSpatialCorrelation(self, *args)
    def setNuggetFactor(self, *args): return _statistics.CovarianceModel_setNuggetFactor(self, *args)
    def getNuggetFactor(self): return _statistics.CovarianceModel_getNuggetFactor(self)
    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.CovarianceModel_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.CovarianceModel_getParameters(self)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.CovarianceModel_isStationary(self)

    def __repr__(self): return _statistics.CovarianceModel___repr__(self)
    def __str__(self, offset=""): return _statistics.CovarianceModel___str__(self, offset)
    def getMarginal(self, *args): return _statistics.CovarianceModel_getMarginal(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_CovarianceModel
    __del__ = lambda self : None;
CovarianceModel_swigregister = _statistics.CovarianceModel_swigregister
CovarianceModel_swigregister(CovarianceModel)

class StationaryCovarianceModel(CovarianceModelImplementation):
    __swig_setmethods__ = {}
    for _s in [CovarianceModelImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StationaryCovarianceModel, name, value)
    __swig_getmethods__ = {}
    for _s in [CovarianceModelImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StationaryCovarianceModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.StationaryCovarianceModel_getClassName(self)

    def __call__(self, *args): return _statistics.StationaryCovarianceModel___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.StationaryCovarianceModel_computeAsScalar(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.StationaryCovarianceModel_discretize(self, *args)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.StationaryCovarianceModel_isStationary(self)

    def __repr__(self): return _statistics.StationaryCovarianceModel___repr__(self)
    def __str__(self, offset=""): return _statistics.StationaryCovarianceModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_StationaryCovarianceModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_StationaryCovarianceModel
    __del__ = lambda self : None;
StationaryCovarianceModel_swigregister = _statistics.StationaryCovarianceModel_swigregister
StationaryCovarianceModel_swigregister(StationaryCovarianceModel)

class SecondOrderModelImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SecondOrderModelImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SecondOrderModelImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SecondOrderModelImplementation_getClassName(self)

    def getSpatialDimension(self): return _statistics.SecondOrderModelImplementation_getSpatialDimension(self)
    def getDimension(self): return _statistics.SecondOrderModelImplementation_getDimension(self)
    def computeCovariance(self, *args): return _statistics.SecondOrderModelImplementation_computeCovariance(self, *args)
    def getSpectralModel(self): return _statistics.SecondOrderModelImplementation_getSpectralModel(self)
    def getCovarianceModel(self): return _statistics.SecondOrderModelImplementation_getCovarianceModel(self)
    def setModels(self, *args): return _statistics.SecondOrderModelImplementation_setModels(self, *args)
    def discretize(self, *args): return _statistics.SecondOrderModelImplementation_discretize(self, *args)
    def computeSpectralDensity(self, *args): return _statistics.SecondOrderModelImplementation_computeSpectralDensity(self, *args)
    def __repr__(self): return _statistics.SecondOrderModelImplementation___repr__(self)
    def __str__(self, offset=""): return _statistics.SecondOrderModelImplementation___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_SecondOrderModelImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SecondOrderModelImplementation
    __del__ = lambda self : None;
SecondOrderModelImplementation_swigregister = _statistics.SecondOrderModelImplementation_swigregister
SecondOrderModelImplementation_swigregister(SecondOrderModelImplementation)

class ExponentialCauchy(SecondOrderModelImplementation):
    __swig_setmethods__ = {}
    for _s in [SecondOrderModelImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ExponentialCauchy, name, value)
    __swig_getmethods__ = {}
    for _s in [SecondOrderModelImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ExponentialCauchy, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.ExponentialCauchy_getClassName(self)

    def __repr__(self): return _statistics.ExponentialCauchy___repr__(self)
    def __str__(self, offset=""): return _statistics.ExponentialCauchy___str__(self, offset)
    def getAmplitude(self): return _statistics.ExponentialCauchy_getAmplitude(self)
    def getScale(self): return _statistics.ExponentialCauchy_getScale(self)
    def getSpatialCorrelation(self): return _statistics.ExponentialCauchy_getSpatialCorrelation(self)
    def __init__(self, *args): 
        this = _statistics.new_ExponentialCauchy(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_ExponentialCauchy
    __del__ = lambda self : None;
ExponentialCauchy_swigregister = _statistics.ExponentialCauchy_swigregister
ExponentialCauchy_swigregister(ExponentialCauchy)

class SecondOrderModelImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SecondOrderModelImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SecondOrderModelImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_SecondOrderModelImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.SecondOrderModelImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.SecondOrderModelImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.SecondOrderModelImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.SecondOrderModelImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_SecondOrderModelImplementationTypedInterfaceObject
    __del__ = lambda self : None;
SecondOrderModelImplementationTypedInterfaceObject_swigregister = _statistics.SecondOrderModelImplementationTypedInterfaceObject_swigregister
SecondOrderModelImplementationTypedInterfaceObject_swigregister(SecondOrderModelImplementationTypedInterfaceObject)

class SecondOrderModel(SecondOrderModelImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [SecondOrderModelImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SecondOrderModel, name, value)
    __swig_getmethods__ = {}
    for _s in [SecondOrderModelImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SecondOrderModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SecondOrderModel_getClassName(self)

    def getSpatialDimension(self): return _statistics.SecondOrderModel_getSpatialDimension(self)
    def getDimension(self): return _statistics.SecondOrderModel_getDimension(self)
    def getSpectralModel(self): return _statistics.SecondOrderModel_getSpectralModel(self)
    def getCovarianceModel(self): return _statistics.SecondOrderModel_getCovarianceModel(self)
    def setModels(self, *args): return _statistics.SecondOrderModel_setModels(self, *args)
    def computeCovariance(self, *args): return _statistics.SecondOrderModel_computeCovariance(self, *args)
    def computeSpectralDensity(self, *args): return _statistics.SecondOrderModel_computeSpectralDensity(self, *args)
    def discretize(self, *args): return _statistics.SecondOrderModel_discretize(self, *args)
    def __repr__(self): return _statistics.SecondOrderModel___repr__(self)
    def __str__(self, offset=""): return _statistics.SecondOrderModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_SecondOrderModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SecondOrderModel
    __del__ = lambda self : None;
SecondOrderModel_swigregister = _statistics.SecondOrderModel_swigregister
SecondOrderModel_swigregister(SecondOrderModel)

class SpectralModelFactoryImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectralModelFactoryImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpectralModelFactoryImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SpectralModelFactoryImplementation_getClassName(self)

    def getFrequencyGrid(self): return _statistics.SpectralModelFactoryImplementation_getFrequencyGrid(self)
    def setFrequencyGrid(self, *args): return _statistics.SpectralModelFactoryImplementation_setFrequencyGrid(self, *args)
    def getFFTAlgorithm(self): return _statistics.SpectralModelFactoryImplementation_getFFTAlgorithm(self)
    def setFFTAlgorithm(self, *args): return _statistics.SpectralModelFactoryImplementation_setFFTAlgorithm(self, *args)
    def __repr__(self): return _statistics.SpectralModelFactoryImplementation___repr__(self)
    def __str__(self, offset=""): return _statistics.SpectralModelFactoryImplementation___str__(self, offset)
    def build(self, *args): return _statistics.SpectralModelFactoryImplementation_build(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_SpectralModelFactoryImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SpectralModelFactoryImplementation
    __del__ = lambda self : None;
SpectralModelFactoryImplementation_swigregister = _statistics.SpectralModelFactoryImplementation_swigregister
SpectralModelFactoryImplementation_swigregister(SpectralModelFactoryImplementation)

class SpectralModelFactoryImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectralModelFactoryImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpectralModelFactoryImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_SpectralModelFactoryImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.SpectralModelFactoryImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.SpectralModelFactoryImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.SpectralModelFactoryImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.SpectralModelFactoryImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_SpectralModelFactoryImplementationTypedInterfaceObject
    __del__ = lambda self : None;
SpectralModelFactoryImplementationTypedInterfaceObject_swigregister = _statistics.SpectralModelFactoryImplementationTypedInterfaceObject_swigregister
SpectralModelFactoryImplementationTypedInterfaceObject_swigregister(SpectralModelFactoryImplementationTypedInterfaceObject)

class SpectralModelFactory(SpectralModelFactoryImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [SpectralModelFactoryImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectralModelFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [SpectralModelFactoryImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SpectralModelFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SpectralModelFactory_getClassName(self)

    def getFrequencyGrid(self): return _statistics.SpectralModelFactory_getFrequencyGrid(self)
    def setFrequencyGrid(self, *args): return _statistics.SpectralModelFactory_setFrequencyGrid(self, *args)
    def getFFTAlgorithm(self): return _statistics.SpectralModelFactory_getFFTAlgorithm(self)
    def setFFTAlgorithm(self, *args): return _statistics.SpectralModelFactory_setFFTAlgorithm(self, *args)
    def __repr__(self): return _statistics.SpectralModelFactory___repr__(self)
    def __str__(self, offset=""): return _statistics.SpectralModelFactory___str__(self, offset)
    def build(self, *args): return _statistics.SpectralModelFactory_build(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_SpectralModelFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SpectralModelFactory
    __del__ = lambda self : None;
SpectralModelFactory_swigregister = _statistics.SpectralModelFactory_swigregister
SpectralModelFactory_swigregister(SpectralModelFactory)

class UserDefinedSpectralModel(SpectralModelImplementation):
    __swig_setmethods__ = {}
    for _s in [SpectralModelImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UserDefinedSpectralModel, name, value)
    __swig_getmethods__ = {}
    for _s in [SpectralModelImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UserDefinedSpectralModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.UserDefinedSpectralModel_getClassName(self)

    def __call__(self, *args): return _statistics.UserDefinedSpectralModel___call__(self, *args)
    def __repr__(self): return _statistics.UserDefinedSpectralModel___repr__(self)
    def __str__(self, offset=""): return _statistics.UserDefinedSpectralModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_UserDefinedSpectralModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_UserDefinedSpectralModel
    __del__ = lambda self : None;
UserDefinedSpectralModel_swigregister = _statistics.UserDefinedSpectralModel_swigregister
UserDefinedSpectralModel_swigregister(UserDefinedSpectralModel)

class WelchFactory(SpectralModelFactoryImplementation):
    __swig_setmethods__ = {}
    for _s in [SpectralModelFactoryImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, WelchFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [SpectralModelFactoryImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, WelchFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.WelchFactory_getClassName(self)

    def __repr__(self): return _statistics.WelchFactory___repr__(self)
    def __str__(self, offset=""): return _statistics.WelchFactory___str__(self, offset)
    def getFilteringWindows(self): return _statistics.WelchFactory_getFilteringWindows(self)
    def setFilteringWindows(self, *args): return _statistics.WelchFactory_setFilteringWindows(self, *args)
    def getBlockNumber(self): return _statistics.WelchFactory_getBlockNumber(self)
    def setBlockNumber(self, *args): return _statistics.WelchFactory_setBlockNumber(self, *args)
    def getOverlap(self): return _statistics.WelchFactory_getOverlap(self)
    def setOverlap(self, *args): return _statistics.WelchFactory_setOverlap(self, *args)
    def build(self, *args): return _statistics.WelchFactory_build(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_WelchFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_WelchFactory
    __del__ = lambda self : None;
WelchFactory_swigregister = _statistics.WelchFactory_swigregister
WelchFactory_swigregister(WelchFactory)

class ExponentialModel(StationaryCovarianceModel):
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ExponentialModel, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ExponentialModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.ExponentialModel_getClassName(self)

    def __call__(self, *args): return _statistics.ExponentialModel___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.ExponentialModel_computeAsScalar(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.ExponentialModel_discretize(self, *args)

    def __repr__(self): return _statistics.ExponentialModel___repr__(self)
    def __str__(self, offset=""): return _statistics.ExponentialModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_ExponentialModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_ExponentialModel
    __del__ = lambda self : None;
ExponentialModel_swigregister = _statistics.ExponentialModel_swigregister
ExponentialModel_swigregister(ExponentialModel)

class ExponentiallyDampedCosineModel(StationaryCovarianceModel):
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ExponentiallyDampedCosineModel, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ExponentiallyDampedCosineModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.ExponentiallyDampedCosineModel_getClassName(self)

    def __call__(self, *args): return _statistics.ExponentiallyDampedCosineModel___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.ExponentiallyDampedCosineModel_computeAsScalar(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.ExponentiallyDampedCosineModel_discretize(self, *args)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.ExponentiallyDampedCosineModel_isStationary(self)

    def __repr__(self): return _statistics.ExponentiallyDampedCosineModel___repr__(self)
    def __str__(self, offset=""): return _statistics.ExponentiallyDampedCosineModel___str__(self, offset)
    def getFrequency(self): return _statistics.ExponentiallyDampedCosineModel_getFrequency(self)
    def __init__(self, *args): 
        this = _statistics.new_ExponentiallyDampedCosineModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_ExponentiallyDampedCosineModel
    __del__ = lambda self : None;
ExponentiallyDampedCosineModel_swigregister = _statistics.ExponentiallyDampedCosineModel_swigregister
ExponentiallyDampedCosineModel_swigregister(ExponentiallyDampedCosineModel)

class SphericalModel(StationaryCovarianceModel):
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SphericalModel, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SphericalModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SphericalModel_getClassName(self)

    def __call__(self, *args): return _statistics.SphericalModel___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.SphericalModel_computeAsScalar(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.SphericalModel_discretize(self, *args)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.SphericalModel_isStationary(self)

    def __repr__(self): return _statistics.SphericalModel___repr__(self)
    def __str__(self, offset=""): return _statistics.SphericalModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_SphericalModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SphericalModel
    __del__ = lambda self : None;
SphericalModel_swigregister = _statistics.SphericalModel_swigregister
SphericalModel_swigregister(SphericalModel)

class CauchyModel(SpectralModelImplementation):
    __swig_setmethods__ = {}
    for _s in [SpectralModelImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CauchyModel, name, value)
    __swig_getmethods__ = {}
    for _s in [SpectralModelImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CauchyModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.CauchyModel_getClassName(self)

    def __call__(self, *args): return _statistics.CauchyModel___call__(self, *args)
    def __repr__(self): return _statistics.CauchyModel___repr__(self)
    def __str__(self, offset=""): return _statistics.CauchyModel___str__(self, offset)
    def getAmplitude(self): return _statistics.CauchyModel_getAmplitude(self)
    def getScale(self): return _statistics.CauchyModel_getScale(self)
    def getSpatialCorrelation(self): return _statistics.CauchyModel_getSpatialCorrelation(self)
    def __init__(self, *args): 
        this = _statistics.new_CauchyModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_CauchyModel
    __del__ = lambda self : None;
CauchyModel_swigregister = _statistics.CauchyModel_swigregister
CauchyModel_swigregister(CauchyModel)

class CovarianceModelFactoryImplementation(openturns.common.PersistentObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelFactoryImplementation, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelFactoryImplementation, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.CovarianceModelFactoryImplementation_getClassName(self)

    def __repr__(self): return _statistics.CovarianceModelFactoryImplementation___repr__(self)
    def __str__(self, offset=""): return _statistics.CovarianceModelFactoryImplementation___str__(self, offset)
    def build(self, *args): return _statistics.CovarianceModelFactoryImplementation_build(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelFactoryImplementation(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_CovarianceModelFactoryImplementation
    __del__ = lambda self : None;
CovarianceModelFactoryImplementation_swigregister = _statistics.CovarianceModelFactoryImplementation_swigregister
CovarianceModelFactoryImplementation_swigregister(CovarianceModelFactoryImplementation)

class CovarianceModelFactoryImplementationTypedInterfaceObject(openturns.common.InterfaceObject):
    __swig_setmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelFactoryImplementationTypedInterfaceObject, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.InterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelFactoryImplementationTypedInterfaceObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelFactoryImplementationTypedInterfaceObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def getImplementation(self, *args):
        """
        Accessor to the underlying implementation.

        Returns
        -------
        impl : Implementation
            The implementation class.
        """
        return _statistics.CovarianceModelFactoryImplementationTypedInterfaceObject_getImplementation(self, *args)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.CovarianceModelFactoryImplementationTypedInterfaceObject_setName(self, *args)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.CovarianceModelFactoryImplementationTypedInterfaceObject_getName(self)

    def __eq__(self, *args): return _statistics.CovarianceModelFactoryImplementationTypedInterfaceObject___eq__(self, *args)
    __swig_destroy__ = _statistics.delete_CovarianceModelFactoryImplementationTypedInterfaceObject
    __del__ = lambda self : None;
CovarianceModelFactoryImplementationTypedInterfaceObject_swigregister = _statistics.CovarianceModelFactoryImplementationTypedInterfaceObject_swigregister
CovarianceModelFactoryImplementationTypedInterfaceObject_swigregister(CovarianceModelFactoryImplementationTypedInterfaceObject)

class CovarianceModelFactory(CovarianceModelFactoryImplementationTypedInterfaceObject):
    __swig_setmethods__ = {}
    for _s in [CovarianceModelFactoryImplementationTypedInterfaceObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [CovarianceModelFactoryImplementationTypedInterfaceObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.CovarianceModelFactory_getClassName(self)

    def __repr__(self): return _statistics.CovarianceModelFactory___repr__(self)
    def __str__(self, offset=""): return _statistics.CovarianceModelFactory___str__(self, offset)
    def build(self, *args): return _statistics.CovarianceModelFactory_build(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_CovarianceModelFactory
    __del__ = lambda self : None;
CovarianceModelFactory_swigregister = _statistics.CovarianceModelFactory_swigregister
CovarianceModelFactory_swigregister(CovarianceModelFactory)

class UserDefinedCovarianceModel(CovarianceModelImplementation):
    __swig_setmethods__ = {}
    for _s in [CovarianceModelImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UserDefinedCovarianceModel, name, value)
    __swig_getmethods__ = {}
    for _s in [CovarianceModelImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UserDefinedCovarianceModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.UserDefinedCovarianceModel_getClassName(self)

    def __call__(self, *args): return _statistics.UserDefinedCovarianceModel___call__(self, *args)
    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.UserDefinedCovarianceModel_discretize(self, *args)

    def discretizeRow(self, *args):
        """**(TODO)**"""
        return _statistics.UserDefinedCovarianceModel_discretizeRow(self, *args)

    def getMesh(self): return _statistics.UserDefinedCovarianceModel_getMesh(self)
    def getTimeGrid(self): return _statistics.UserDefinedCovarianceModel_getTimeGrid(self)
    def __repr__(self): return _statistics.UserDefinedCovarianceModel___repr__(self)
    def __str__(self, offset=""): return _statistics.UserDefinedCovarianceModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_UserDefinedCovarianceModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_UserDefinedCovarianceModel
    __del__ = lambda self : None;
UserDefinedCovarianceModel_swigregister = _statistics.UserDefinedCovarianceModel_swigregister
UserDefinedCovarianceModel_swigregister(UserDefinedCovarianceModel)

class NonStationaryCovarianceModelFactory(CovarianceModelFactoryImplementation):
    __swig_setmethods__ = {}
    for _s in [CovarianceModelFactoryImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NonStationaryCovarianceModelFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [CovarianceModelFactoryImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, NonStationaryCovarianceModelFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.NonStationaryCovarianceModelFactory_getClassName(self)

    def __repr__(self): return _statistics.NonStationaryCovarianceModelFactory___repr__(self)
    def __str__(self, offset=""): return _statistics.NonStationaryCovarianceModelFactory___str__(self, offset)
    def build(self, *args): return _statistics.NonStationaryCovarianceModelFactory_build(self, *args)
    def buildAsUserDefinedCovarianceModel(self, *args): return _statistics.NonStationaryCovarianceModelFactory_buildAsUserDefinedCovarianceModel(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_NonStationaryCovarianceModelFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_NonStationaryCovarianceModelFactory
    __del__ = lambda self : None;
NonStationaryCovarianceModelFactory_swigregister = _statistics.NonStationaryCovarianceModelFactory_swigregister
NonStationaryCovarianceModelFactory_swigregister(NonStationaryCovarianceModelFactory)

class UserDefinedStationaryCovarianceModel(StationaryCovarianceModel):
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, UserDefinedStationaryCovarianceModel, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, UserDefinedStationaryCovarianceModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.UserDefinedStationaryCovarianceModel_getClassName(self)

    def __call__(self, *args): return _statistics.UserDefinedStationaryCovarianceModel___call__(self, *args)
    def getMesh(self): return _statistics.UserDefinedStationaryCovarianceModel_getMesh(self)
    def getTimeGrid(self): return _statistics.UserDefinedStationaryCovarianceModel_getTimeGrid(self)
    def __repr__(self): return _statistics.UserDefinedStationaryCovarianceModel___repr__(self)
    def __str__(self, offset=""): return _statistics.UserDefinedStationaryCovarianceModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_UserDefinedStationaryCovarianceModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_UserDefinedStationaryCovarianceModel
    __del__ = lambda self : None;
UserDefinedStationaryCovarianceModel_swigregister = _statistics.UserDefinedStationaryCovarianceModel_swigregister
UserDefinedStationaryCovarianceModel_swigregister(UserDefinedStationaryCovarianceModel)

class StationaryCovarianceModelFactory(CovarianceModelFactoryImplementation):
    __swig_setmethods__ = {}
    for _s in [CovarianceModelFactoryImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StationaryCovarianceModelFactory, name, value)
    __swig_getmethods__ = {}
    for _s in [CovarianceModelFactoryImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StationaryCovarianceModelFactory, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.StationaryCovarianceModelFactory_getClassName(self)

    def getSpectralModelFactory(self): return _statistics.StationaryCovarianceModelFactory_getSpectralModelFactory(self)
    def setSpectralModelFactory(self, *args): return _statistics.StationaryCovarianceModelFactory_setSpectralModelFactory(self, *args)
    def __repr__(self): return _statistics.StationaryCovarianceModelFactory___repr__(self)
    def __str__(self, offset=""): return _statistics.StationaryCovarianceModelFactory___str__(self, offset)
    def build(self, *args): return _statistics.StationaryCovarianceModelFactory_build(self, *args)
    def buildAsUserDefinedStationaryCovarianceModel(self, *args): return _statistics.StationaryCovarianceModelFactory_buildAsUserDefinedStationaryCovarianceModel(self, *args)
    def __init__(self, *args): 
        this = _statistics.new_StationaryCovarianceModelFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_StationaryCovarianceModelFactory
    __del__ = lambda self : None;
StationaryCovarianceModelFactory_swigregister = _statistics.StationaryCovarianceModelFactory_swigregister
StationaryCovarianceModelFactory_swigregister(StationaryCovarianceModelFactory)

class SquaredExponential(StationaryCovarianceModel):
    """
    Squared exponential covariance model.

    Available constructors:
        SquaredExponential(*dim=0, theta=0.1*)

    Parameters
    ----------
    dim : int, :math:`dim \\geq 0`
        Input dimension.
    theta : float
        Coefficient :math:`\\theta` of the covariance function.

    Notes
    -----
    The covariance function of input dimension *dim* is:

    .. math::

        C(s, t) = e^{-\\frac{1}{2} \\frac{||s-t||^2}{\\theta^2}}

    See Also
    --------
    CovarianceModel

    Examples
    --------
    >>> import openturns as ot
    >>> covarianceModel = ot.SquaredExponential(2)
    >>> t = [0.1, 0.3]
    >>> s = [0.2, 0.4]
    >>> print(covarianceModel(s, t))
    [[ 0.9999 ]]
    >>> tau = [0.1, 0.3]
    >>> print(covarianceModel(tau))
    [[ 0.9995 ]]
    """
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SquaredExponential, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SquaredExponential, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SquaredExponential_getClassName(self)

    def __call__(self, *args): return _statistics.SquaredExponential___call__(self, *args)
    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.SquaredExponential_partialGradient(self, *args)

    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.SquaredExponential_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.SquaredExponential_getParameters(self)

    def __repr__(self): return _statistics.SquaredExponential___repr__(self)
    def __str__(self, offset=""): return _statistics.SquaredExponential___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_SquaredExponential(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SquaredExponential
    __del__ = lambda self : None;
SquaredExponential_swigregister = _statistics.SquaredExponential_swigregister
SquaredExponential_swigregister(SquaredExponential)

class GeneralizedExponential(StationaryCovarianceModel):
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, GeneralizedExponential, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, GeneralizedExponential, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.GeneralizedExponential_getClassName(self)

    def __call__(self, *args): return _statistics.GeneralizedExponential___call__(self, *args)
    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.GeneralizedExponential_partialGradient(self, *args)

    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.GeneralizedExponential_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.GeneralizedExponential_getParameters(self)

    def __repr__(self): return _statistics.GeneralizedExponential___repr__(self)
    def __str__(self, offset=""): return _statistics.GeneralizedExponential___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_GeneralizedExponential(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_GeneralizedExponential
    __del__ = lambda self : None;
GeneralizedExponential_swigregister = _statistics.GeneralizedExponential_swigregister
GeneralizedExponential_swigregister(GeneralizedExponential)

class AbsoluteExponential(StationaryCovarianceModel):
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AbsoluteExponential, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AbsoluteExponential, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.AbsoluteExponential_getClassName(self)

    def __call__(self, *args): return _statistics.AbsoluteExponential___call__(self, *args)
    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.AbsoluteExponential_partialGradient(self, *args)

    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.AbsoluteExponential_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.AbsoluteExponential_getParameters(self)

    def __repr__(self): return _statistics.AbsoluteExponential___repr__(self)
    def __str__(self, offset=""): return _statistics.AbsoluteExponential___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_AbsoluteExponential(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_AbsoluteExponential
    __del__ = lambda self : None;
AbsoluteExponential_swigregister = _statistics.AbsoluteExponential_swigregister
AbsoluteExponential_swigregister(AbsoluteExponential)

class MaternModel(StationaryCovarianceModel):
    __swig_setmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MaternModel, name, value)
    __swig_getmethods__ = {}
    for _s in [StationaryCovarianceModel]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MaternModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.MaternModel_getClassName(self)

    def __call__(self, *args): return _statistics.MaternModel___call__(self, *args)
    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.MaternModel_partialGradient(self, *args)

    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.MaternModel_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.MaternModel_getParameters(self)

    def __repr__(self): return _statistics.MaternModel___repr__(self)
    def __str__(self, offset=""): return _statistics.MaternModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_MaternModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_MaternModel
    __del__ = lambda self : None;
MaternModel_swigregister = _statistics.MaternModel_swigregister
MaternModel_swigregister(MaternModel)

class CovarianceModelCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelCollection, name)
    __swig_destroy__ = _statistics.delete_CovarianceModelCollection
    __del__ = lambda self : None;
    def clear(self): return _statistics.CovarianceModelCollection_clear(self)
    def __len__(self): return _statistics.CovarianceModelCollection___len__(self)
    def __eq__(self, *args): return _statistics.CovarianceModelCollection___eq__(self, *args)
    def __contains__(self, *args): return _statistics.CovarianceModelCollection___contains__(self, *args)
    def __getitem__(self, *args): return _statistics.CovarianceModelCollection___getitem__(self, *args)
    def __setitem__(self, *args): return _statistics.CovarianceModelCollection___setitem__(self, *args)
    def __delitem__(self, *args): return _statistics.CovarianceModelCollection___delitem__(self, *args)
    def at(self, *args): return _statistics.CovarianceModelCollection_at(self, *args)
    def add(self, *args): return _statistics.CovarianceModelCollection_add(self, *args)
    def getSize(self): return _statistics.CovarianceModelCollection_getSize(self)
    def resize(self, *args): return _statistics.CovarianceModelCollection_resize(self, *args)
    def isEmpty(self): return _statistics.CovarianceModelCollection_isEmpty(self)
    def __repr__(self): return _statistics.CovarianceModelCollection___repr__(self)
    def __str__(self, offset=""): return _statistics.CovarianceModelCollection___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelCollection(*args)
        try: self.this.append(this)
        except: self.this = this
CovarianceModelCollection_swigregister = _statistics.CovarianceModelCollection_swigregister
CovarianceModelCollection_swigregister(CovarianceModelCollection)

class CovarianceModelPersistentCollection(openturns.common.PersistentObject,CovarianceModelCollection):
    __swig_setmethods__ = {}
    for _s in [openturns.common.PersistentObject,CovarianceModelCollection]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelPersistentCollection, name, value)
    __swig_getmethods__ = {}
    for _s in [openturns.common.PersistentObject,CovarianceModelCollection]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelPersistentCollection, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.CovarianceModelPersistentCollection_getClassName(self)

    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelPersistentCollection(*args)
        try: self.this.append(this)
        except: self.this = this
    def __repr__(self): return _statistics.CovarianceModelPersistentCollection___repr__(self)
    def __str__(self, offset=""): return _statistics.CovarianceModelPersistentCollection___str__(self, offset)
    __swig_destroy__ = _statistics.delete_CovarianceModelPersistentCollection
    __del__ = lambda self : None;
CovarianceModelPersistentCollection_swigregister = _statistics.CovarianceModelPersistentCollection_swigregister
CovarianceModelPersistentCollection_swigregister(CovarianceModelPersistentCollection)

class ProductCovarianceModel(CovarianceModelImplementation):
    __swig_setmethods__ = {}
    for _s in [CovarianceModelImplementation]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ProductCovarianceModel, name, value)
    __swig_getmethods__ = {}
    for _s in [CovarianceModelImplementation]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ProductCovarianceModel, name)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.ProductCovarianceModel_getClassName(self)

    def __call__(self, *args): return _statistics.ProductCovarianceModel___call__(self, *args)
    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.ProductCovarianceModel_partialGradient(self, *args)

    def setCollection(self, *args): return _statistics.ProductCovarianceModel_setCollection(self, *args)
    def getCollection(self): return _statistics.ProductCovarianceModel_getCollection(self)
    def getMarginal(self, *args): return _statistics.ProductCovarianceModel_getMarginal(self, *args)
    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.ProductCovarianceModel_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.ProductCovarianceModel_getParameters(self)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.ProductCovarianceModel_isStationary(self)

    def __repr__(self): return _statistics.ProductCovarianceModel___repr__(self)
    def __str__(self, offset=""): return _statistics.ProductCovarianceModel___str__(self, offset)
    def __init__(self, *args): 
        this = _statistics.new_ProductCovarianceModel(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_ProductCovarianceModel
    __del__ = lambda self : None;
ProductCovarianceModel_swigregister = _statistics.ProductCovarianceModel_swigregister
ProductCovarianceModel_swigregister(ProductCovarianceModel)

class CovarianceModelImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceModelImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceModelImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _statistics.CovarianceModelImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _statistics.CovarianceModelImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_statistics.CovarianceModelImplementationPointer_ptr__get, _statistics.CovarianceModelImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _statistics.new_CovarianceModelImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_CovarianceModelImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _statistics.CovarianceModelImplementationPointer_reset(self)
    def __ref__(self, *args): return _statistics.CovarianceModelImplementationPointer___ref__(self, *args)
    def __deref__(self): return _statistics.CovarianceModelImplementationPointer___deref__(self)
    def isNull(self): return _statistics.CovarianceModelImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _statistics.CovarianceModelImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _statistics.CovarianceModelImplementationPointer_get(self)
    def getImplementation(self): return _statistics.CovarianceModelImplementationPointer_getImplementation(self)
    def unique(self): return _statistics.CovarianceModelImplementationPointer_unique(self)
    def use_count(self): return _statistics.CovarianceModelImplementationPointer_use_count(self)
    def swap(self, *args): return _statistics.CovarianceModelImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.CovarianceModelImplementationPointer_getClassName(self)

    def getSpatialDimension(self): return _statistics.CovarianceModelImplementationPointer_getSpatialDimension(self)
    def getDimension(self):
        """
        Get the dimension of the *CovarianceModel*.

        Returns
        -------
        dimension : int
            Dimension of the *CovarianceModel*.
        """
        return _statistics.CovarianceModelImplementationPointer_getDimension(self)

    def __call__(self, *args): return _statistics.CovarianceModelImplementationPointer___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.CovarianceModelImplementationPointer_computeAsScalar(self, *args)

    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.CovarianceModelImplementationPointer_partialGradient(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.CovarianceModelImplementationPointer_discretize(self, *args)

    def discretizeRow(self, *args):
        """**(TODO)**"""
        return _statistics.CovarianceModelImplementationPointer_discretizeRow(self, *args)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.CovarianceModelImplementationPointer_isStationary(self)

    def getAmplitude(self): return _statistics.CovarianceModelImplementationPointer_getAmplitude(self)
    def setAmplitude(self, *args): return _statistics.CovarianceModelImplementationPointer_setAmplitude(self, *args)
    def getScale(self): return _statistics.CovarianceModelImplementationPointer_getScale(self)
    def setScale(self, *args): return _statistics.CovarianceModelImplementationPointer_setScale(self, *args)
    def getSpatialCorrelation(self): return _statistics.CovarianceModelImplementationPointer_getSpatialCorrelation(self)
    def setSpatialCorrelation(self, *args): return _statistics.CovarianceModelImplementationPointer_setSpatialCorrelation(self, *args)
    def setNuggetFactor(self, *args): return _statistics.CovarianceModelImplementationPointer_setNuggetFactor(self, *args)
    def getNuggetFactor(self): return _statistics.CovarianceModelImplementationPointer_getNuggetFactor(self)
    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.CovarianceModelImplementationPointer_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.CovarianceModelImplementationPointer_getParameters(self)

    def __repr__(self): return _statistics.CovarianceModelImplementationPointer___repr__(self)
    def __str__(self, offset=""): return _statistics.CovarianceModelImplementationPointer___str__(self, offset)
    def isDiagonal(self): return _statistics.CovarianceModelImplementationPointer_isDiagonal(self)
    def getMarginal(self, *args): return _statistics.CovarianceModelImplementationPointer_getMarginal(self, *args)
    def __eq__(self, *args): return _statistics.CovarianceModelImplementationPointer___eq__(self, *args)
    def __ne__(self, *args): return _statistics.CovarianceModelImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _statistics.CovarianceModelImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _statistics.CovarianceModelImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _statistics.CovarianceModelImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _statistics.CovarianceModelImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _statistics.CovarianceModelImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _statistics.CovarianceModelImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _statistics.CovarianceModelImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.CovarianceModelImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.CovarianceModelImplementationPointer_setName(self, *args)

CovarianceModelImplementationPointer_swigregister = _statistics.CovarianceModelImplementationPointer_swigregister
CovarianceModelImplementationPointer_swigregister(CovarianceModelImplementationPointer)

class SpectralModelImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SpectralModelImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SpectralModelImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _statistics.SpectralModelImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _statistics.SpectralModelImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_statistics.SpectralModelImplementationPointer_ptr__get, _statistics.SpectralModelImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _statistics.new_SpectralModelImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SpectralModelImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _statistics.SpectralModelImplementationPointer_reset(self)
    def __ref__(self, *args): return _statistics.SpectralModelImplementationPointer___ref__(self, *args)
    def __deref__(self): return _statistics.SpectralModelImplementationPointer___deref__(self)
    def isNull(self): return _statistics.SpectralModelImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _statistics.SpectralModelImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _statistics.SpectralModelImplementationPointer_get(self)
    def getImplementation(self): return _statistics.SpectralModelImplementationPointer_getImplementation(self)
    def unique(self): return _statistics.SpectralModelImplementationPointer_unique(self)
    def use_count(self): return _statistics.SpectralModelImplementationPointer_use_count(self)
    def swap(self, *args): return _statistics.SpectralModelImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SpectralModelImplementationPointer_getClassName(self)

    def getDimension(self): return _statistics.SpectralModelImplementationPointer_getDimension(self)
    def setDimension(self, *args): return _statistics.SpectralModelImplementationPointer_setDimension(self, *args)
    def __call__(self, *args): return _statistics.SpectralModelImplementationPointer___call__(self, *args)
    def getFrequencyGrid(self): return _statistics.SpectralModelImplementationPointer_getFrequencyGrid(self)
    def setFrequencyGrid(self, *args): return _statistics.SpectralModelImplementationPointer_setFrequencyGrid(self, *args)
    def __repr__(self): return _statistics.SpectralModelImplementationPointer___repr__(self)
    def __str__(self, offset=""): return _statistics.SpectralModelImplementationPointer___str__(self, offset)
    def __eq__(self, *args): return _statistics.SpectralModelImplementationPointer___eq__(self, *args)
    def __ne__(self, *args): return _statistics.SpectralModelImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _statistics.SpectralModelImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _statistics.SpectralModelImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _statistics.SpectralModelImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _statistics.SpectralModelImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _statistics.SpectralModelImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _statistics.SpectralModelImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _statistics.SpectralModelImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.SpectralModelImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.SpectralModelImplementationPointer_setName(self, *args)

SpectralModelImplementationPointer_swigregister = _statistics.SpectralModelImplementationPointer_swigregister
SpectralModelImplementationPointer_swigregister(SpectralModelImplementationPointer)

class SecondOrderModelImplementationPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SecondOrderModelImplementationPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SecondOrderModelImplementationPointer, name)
    __swig_setmethods__["ptr_"] = _statistics.SecondOrderModelImplementationPointer_ptr__set
    __swig_getmethods__["ptr_"] = _statistics.SecondOrderModelImplementationPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_statistics.SecondOrderModelImplementationPointer_ptr__get, _statistics.SecondOrderModelImplementationPointer_ptr__set)
    def __init__(self, *args): 
        this = _statistics.new_SecondOrderModelImplementationPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_SecondOrderModelImplementationPointer
    __del__ = lambda self : None;
    def reset(self): return _statistics.SecondOrderModelImplementationPointer_reset(self)
    def __ref__(self, *args): return _statistics.SecondOrderModelImplementationPointer___ref__(self, *args)
    def __deref__(self): return _statistics.SecondOrderModelImplementationPointer___deref__(self)
    def isNull(self): return _statistics.SecondOrderModelImplementationPointer_isNull(self)
    def __nonzero__(self):
        return _statistics.SecondOrderModelImplementationPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _statistics.SecondOrderModelImplementationPointer_get(self)
    def getImplementation(self): return _statistics.SecondOrderModelImplementationPointer_getImplementation(self)
    def unique(self): return _statistics.SecondOrderModelImplementationPointer_unique(self)
    def use_count(self): return _statistics.SecondOrderModelImplementationPointer_use_count(self)
    def swap(self, *args): return _statistics.SecondOrderModelImplementationPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.SecondOrderModelImplementationPointer_getClassName(self)

    def getSpatialDimension(self): return _statistics.SecondOrderModelImplementationPointer_getSpatialDimension(self)
    def getDimension(self): return _statistics.SecondOrderModelImplementationPointer_getDimension(self)
    def computeCovariance(self, *args): return _statistics.SecondOrderModelImplementationPointer_computeCovariance(self, *args)
    def getSpectralModel(self): return _statistics.SecondOrderModelImplementationPointer_getSpectralModel(self)
    def getCovarianceModel(self): return _statistics.SecondOrderModelImplementationPointer_getCovarianceModel(self)
    def setModels(self, *args): return _statistics.SecondOrderModelImplementationPointer_setModels(self, *args)
    def discretize(self, *args): return _statistics.SecondOrderModelImplementationPointer_discretize(self, *args)
    def computeSpectralDensity(self, *args): return _statistics.SecondOrderModelImplementationPointer_computeSpectralDensity(self, *args)
    def __repr__(self): return _statistics.SecondOrderModelImplementationPointer___repr__(self)
    def __str__(self, offset=""): return _statistics.SecondOrderModelImplementationPointer___str__(self, offset)
    def __eq__(self, *args): return _statistics.SecondOrderModelImplementationPointer___eq__(self, *args)
    def __ne__(self, *args): return _statistics.SecondOrderModelImplementationPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _statistics.SecondOrderModelImplementationPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _statistics.SecondOrderModelImplementationPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _statistics.SecondOrderModelImplementationPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _statistics.SecondOrderModelImplementationPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _statistics.SecondOrderModelImplementationPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _statistics.SecondOrderModelImplementationPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _statistics.SecondOrderModelImplementationPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.SecondOrderModelImplementationPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.SecondOrderModelImplementationPointer_setName(self, *args)

SecondOrderModelImplementationPointer_swigregister = _statistics.SecondOrderModelImplementationPointer_swigregister
SecondOrderModelImplementationPointer_swigregister(SecondOrderModelImplementationPointer)

class StationaryCovarianceModelPointer(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, StationaryCovarianceModelPointer, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, StationaryCovarianceModelPointer, name)
    __swig_setmethods__["ptr_"] = _statistics.StationaryCovarianceModelPointer_ptr__set
    __swig_getmethods__["ptr_"] = _statistics.StationaryCovarianceModelPointer_ptr__get
    if _newclass:ptr_ = _swig_property(_statistics.StationaryCovarianceModelPointer_ptr__get, _statistics.StationaryCovarianceModelPointer_ptr__set)
    def __init__(self, *args): 
        this = _statistics.new_StationaryCovarianceModelPointer(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _statistics.delete_StationaryCovarianceModelPointer
    __del__ = lambda self : None;
    def reset(self): return _statistics.StationaryCovarianceModelPointer_reset(self)
    def __ref__(self, *args): return _statistics.StationaryCovarianceModelPointer___ref__(self, *args)
    def __deref__(self): return _statistics.StationaryCovarianceModelPointer___deref__(self)
    def isNull(self): return _statistics.StationaryCovarianceModelPointer_isNull(self)
    def __nonzero__(self):
        return _statistics.StationaryCovarianceModelPointer___nonzero__(self)
    __bool__ = __nonzero__


    def get(self): return _statistics.StationaryCovarianceModelPointer_get(self)
    def getImplementation(self): return _statistics.StationaryCovarianceModelPointer_getImplementation(self)
    def unique(self): return _statistics.StationaryCovarianceModelPointer_unique(self)
    def use_count(self): return _statistics.StationaryCovarianceModelPointer_use_count(self)
    def swap(self, *args): return _statistics.StationaryCovarianceModelPointer_swap(self, *args)
    def getClassName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        class_name : str
            The object class name (`object.__class__.__name__`).
        """
        return _statistics.StationaryCovarianceModelPointer_getClassName(self)

    def __call__(self, *args): return _statistics.StationaryCovarianceModelPointer___call__(self, *args)
    def computeAsScalar(self, *args):
        """
        Compute the covariance function for 1D model.

        Available usages:
            computeAsScalar(s, t)

            computeAsScalar(tau)

        Parameters
        ----------
        s, t : float sequences
            Inputs.
        tau : float sequence
            Input.

        Returns
        -------
        covariance : float
            Covariance.

        Notes
        -----
        *computeAsScalar* evaluates the covariance model
        :math:`C : \\cD \\times \\cD \\mapsto  \\cM_{d \\times d}(\\Rset)` at
        :math:`(s,t)\\in \\Rset^n`:

        .. math::

            C(\\vect{s}, \\vect{t})=\\Expect{(X_{\\vect{s}}-m(\\vect{s}))(X_{\\vect{t}}-m(\\vect{t}))^t}

        In the second usage, the covariance model must be stationary. Then we note
        :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})` as
        this quantity does not depend on :math:`\\vect{s}`.
        """
        return _statistics.StationaryCovarianceModelPointer_computeAsScalar(self, *args)

    def discretize(self, *args):
        """
        Discretize the covariance function on a given RegularGrid/Mesh.

        Parameters
        ----------
        meshOrGrid : :class:`~openturns.Mesh` or :class:`~openturns.RegularGrid`
            Mesh or time grid of size :math:`N` associated with the process.

        Returns
        -------
        covarianceMatrix : :class:`~openturns.CovarianceMatrix`
            Covariance matrix :math:`\\in\\cM_{nd\\times nd}(\\Rset)` (if the process is of
            dimension :math:`d`).

        Notes
        -----
        This method makes a discretization of the model on *meshOrGrid* composed of
        the vertices :math:`(\\vect{t}_1, \\dots, \\vect{t}_{N-1})` and returns the
        covariance matrix:

        .. math ::

            \\mat{C}_{1,\\dots,k} = \\left(
                \\begin{array}{cccc}
                C(\\vect{t}_1, \\vect{t}_1) &C(\\vect{t}_1, \\vect{t}_2) & \\dots & C(\\vect{t}_1, \\vect{t}_{k}) \\\\
                \\dots & C(\\vect{t}_2, \\vect{t}_2)  & \\dots & C(\\vect{t}_2, \\vect{t}_{k}) \\\\
                \\dots & \\dots & \\dots & \\dots \\\\
                \\dots & \\dots & \\dots & C(\\vect{t}_{k}, \\vect{t}_{k})
                \\end{array} \\right)
        """
        return _statistics.StationaryCovarianceModelPointer_discretize(self, *args)

    def isStationary(self):
        """
        Test whether the model is stationary or not.

        Returns
        -------
        isStationary : bool
            *True* if the model is stationary.

        Notes
        -----
        The covariance function :math:`C` is stationary when it is invariant by
        translation:

        .. math::

            \\forall(\\vect{s},\\vect{t},\\vect{h}) \\in \\cD, & \\, \\quad
            C(\\vect{s}, \\vect{s}+\\vect{h}) = C(\\vect{t}, \\vect{t}+\\vect{h})

        We note :math:`C^{stat}(\\vect{\\tau})` for :math:`C(\\vect{s}, \\vect{s}+\\vect{\\tau})`.
        """
        return _statistics.StationaryCovarianceModelPointer_isStationary(self)

    def __repr__(self): return _statistics.StationaryCovarianceModelPointer___repr__(self)
    def __str__(self, offset=""): return _statistics.StationaryCovarianceModelPointer___str__(self, offset)
    def getSpatialDimension(self): return _statistics.StationaryCovarianceModelPointer_getSpatialDimension(self)
    def getDimension(self):
        """
        Get the dimension of the *CovarianceModel*.

        Returns
        -------
        dimension : int
            Dimension of the *CovarianceModel*.
        """
        return _statistics.StationaryCovarianceModelPointer_getDimension(self)

    def partialGradient(self, *args):
        """
        Compute the gradient of the covariance function.

        Parameters
        ----------
        s, t : float sequences
            Inputs.

        Returns
        -------
        gradient : :class:`~openturns.SymmetricTensor`
            Gradient of the covariance function.
        """
        return _statistics.StationaryCovarianceModelPointer_partialGradient(self, *args)

    def discretizeRow(self, *args):
        """**(TODO)**"""
        return _statistics.StationaryCovarianceModelPointer_discretizeRow(self, *args)

    def getAmplitude(self): return _statistics.StationaryCovarianceModelPointer_getAmplitude(self)
    def setAmplitude(self, *args): return _statistics.StationaryCovarianceModelPointer_setAmplitude(self, *args)
    def getScale(self): return _statistics.StationaryCovarianceModelPointer_getScale(self)
    def setScale(self, *args): return _statistics.StationaryCovarianceModelPointer_setScale(self, *args)
    def getSpatialCorrelation(self): return _statistics.StationaryCovarianceModelPointer_getSpatialCorrelation(self)
    def setSpatialCorrelation(self, *args): return _statistics.StationaryCovarianceModelPointer_setSpatialCorrelation(self, *args)
    def setNuggetFactor(self, *args): return _statistics.StationaryCovarianceModelPointer_setNuggetFactor(self, *args)
    def getNuggetFactor(self): return _statistics.StationaryCovarianceModelPointer_getNuggetFactor(self)
    def setParameters(self, *args):
        """
        Set the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.StationaryCovarianceModelPointer_setParameters(self, *args)

    def getParameters(self):
        """
        Get the parameters of the covariance function.

        Returns
        -------
        parameters : float sequence with description
            Parameters of the covariance function.
        """
        return _statistics.StationaryCovarianceModelPointer_getParameters(self)

    def isDiagonal(self): return _statistics.StationaryCovarianceModelPointer_isDiagonal(self)
    def getMarginal(self, *args): return _statistics.StationaryCovarianceModelPointer_getMarginal(self, *args)
    def __eq__(self, *args): return _statistics.StationaryCovarianceModelPointer___eq__(self, *args)
    def __ne__(self, *args): return _statistics.StationaryCovarianceModelPointer___ne__(self, *args)
    def getId(self):
        """
        Accessor to the object's id.

        Returns
        -------
        id : int
           Internal unique identifier.
        """
        return _statistics.StationaryCovarianceModelPointer_getId(self)

    def setShadowedId(self, *args):
        """
        Accessor to the object's shadowed id.

        Parameters
        ----------
        id : int
            Internal unique identifier.
        """
        return _statistics.StationaryCovarianceModelPointer_setShadowedId(self, *args)

    def getShadowedId(self):
        """
        Accessor to the object's shadowed id.

        Returns
        -------
        id : int
            Internal unique identifier.
        """
        return _statistics.StationaryCovarianceModelPointer_getShadowedId(self)

    def setVisibility(self, *args):
        """
        Accessor to the object's visibility state.

        Parameters
        ----------
        visible : bool
            Visibility flag.
        """
        return _statistics.StationaryCovarianceModelPointer_setVisibility(self, *args)

    def getVisibility(self):
        """
        Accessor to the object's visibility state.

        Returns
        -------
        visible : bool
            Visibility flag.
        """
        return _statistics.StationaryCovarianceModelPointer_getVisibility(self)

    def hasName(self):
        """
        Test if the object is named.

        Returns
        -------
        hasName : bool
            True if the name is not empty.
        """
        return _statistics.StationaryCovarianceModelPointer_hasName(self)

    def hasVisibleName(self):
        """
        Test if the object has a distinghishable name.

        Returns
        -------
        hasVisibleName : bool
            True if the name is not empty and not the default one.
        """
        return _statistics.StationaryCovarianceModelPointer_hasVisibleName(self)

    def getName(self):
        """
        Accessor to the object's name.

        Returns
        -------
        name : string
            The name of the object.
        """
        return _statistics.StationaryCovarianceModelPointer_getName(self)

    def setName(self, *args):
        """
        Accessor to the object's name.

        Parameters
        ----------
        name : string
            The name of the object.
        """
        return _statistics.StationaryCovarianceModelPointer_setName(self, *args)

StationaryCovarianceModelPointer_swigregister = _statistics.StationaryCovarianceModelPointer_swigregister
StationaryCovarianceModelPointer_swigregister(StationaryCovarianceModelPointer)

# This file is compatible with both classic and new-style classes.


